/* MainView.c generated by valac 0.56.14, the Vala compiler
 * generated from MainView.vala, do not modify */

/*
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

enum  {
	NETWORK_MAIN_VIEW_0_PROPERTY,
	NETWORK_MAIN_VIEW_STATE_PROPERTY,
	NETWORK_MAIN_VIEW_NUM_PROPERTIES
};
static GParamSpec* network_main_view_properties[NETWORK_MAIN_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _NetworkMainViewPrivate {
	NMDeviceState _state;
	NMDevice* current_device;
	GtkStack* content;
	NetworkWidgetsPage* page;
	NetworkWidgetsDeviceList* device_list;
};

struct _Block2Data {
	int _ref_count_;
	NetworkMainView* self;
	GraniteWidgetsAlertView* no_devices;
	GtkScrolledWindow* scrolled_window;
};

static gint NetworkMainView_private_offset;
static gpointer network_main_view_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void network_main_view_device_removed_cb (NetworkMainView* self,
                                          NMDevice* device);
static void network_main_view_remove_interface (NetworkMainView* self,
                                         NetworkWidgetsPage* widget_interface);
static void network_main_view_update_interfaces_names (NetworkMainView* self);
static gint* _int_dup (gint* self);
static void network_main_view_connection_added_cb (NetworkMainView* self,
                                            GObject* obj);
static void network_main_view_add_connection (NetworkMainView* self,
                                       NMRemoteConnection* connection);
static void network_main_view_connection_removed_cb (NetworkMainView* self,
                                              GObject* obj);
static void network_main_view_remove_connection (NetworkMainView* self,
                                          NMRemoteConnection* connection);
static void network_main_view_device_added_cb (NetworkMainView* self,
                                        NMDevice* device);
static void network_main_view_add_interface (NetworkMainView* self,
                                      NetworkWidgetsPage* widget_interface);
static void network_main_view_update_state (NetworkMainView* self);
static void _network_main_view_update_state_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void network_main_view_update_all (NetworkMainView* self);
static void network_main_view_set_state (NetworkMainView* self,
                                  NMDeviceState value);
static void network_main_view_update_networking_state (NetworkMainView* self);
static void network_main_view_select_first (NetworkMainView* self);
static GObject * network_main_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _network_main_view___lambda50_ (NetworkMainView* self,
                                     GtkListBoxRow* row);
static void __network_main_view___lambda50__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                 GtkListBoxRow* row,
                                                                 gpointer self);
static void _network_main_view___lambda51_ (Block2Data* _data2_,
                                     gboolean show);
static void __network_main_view___lambda51__network_widgets_device_list_show_no_devices (NetworkWidgetsDeviceList* _sender,
                                                                                  gboolean show,
                                                                                  gpointer self);
static void _network_main_view_update_networking_state_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void _network_main_view_connection_added_cb_nm_client_connection_added (NMClient* _sender,
                                                                        NMRemoteConnection* connection,
                                                                        gpointer self);
static void _network_main_view_connection_removed_cb_nm_client_connection_removed (NMClient* _sender,
                                                                            NMRemoteConnection* connection,
                                                                            gpointer self);
static void _network_main_view_device_added_cb_nm_client_device_added (NMClient* _sender,
                                                                NMDevice* device,
                                                                gpointer self);
static void _network_main_view_device_removed_cb_nm_client_device_removed (NMClient* _sender,
                                                                    NMDevice* device,
                                                                    gpointer self);
static void _network_main_view___lambda52_ (NetworkMainView* self,
                                     NMDevice* device);
static void __network_main_view___lambda52__gfunc (gconstpointer data,
                                            gpointer self);
static void _network_main_view___lambda53_ (NetworkMainView* self,
                                     NMRemoteConnection* connection);
static void __network_main_view___lambda53__gfunc (gconstpointer data,
                                            gpointer self);
static void network_main_view_finalize (GObject * obj);
static GType network_main_view_get_type_once (void);
static void _vala_network_main_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_network_main_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
network_main_view_get_instance_private (NetworkMainView* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkMainView_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 21 "../src/MainView.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 152 "MainView.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 21 "../src/MainView.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 160 "MainView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 116 "../src/MainView.vala"
	return self ? g_object_ref (self) : NULL;
#line 168 "MainView.c"
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
#line 5185 "glib-2.0.vapi"
	l = self;
#line 5186 "glib-2.0.vapi"
	while (TRUE) {
#line 182 "MainView.c"
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
#line 5186 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5186 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5186 "glib-2.0.vapi"
			break;
#line 192 "MainView.c"
		}
#line 5187 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5187 "glib-2.0.vapi"
		_tmp2_ = ((GList*) _tmp1_)->data;
#line 5187 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 200 "MainView.c"
			GList* _tmp3_;
			GList* _tmp4_;
#line 5188 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5188 "glib-2.0.vapi"
			_tmp4_ = ((GList*) _tmp3_)->next;
#line 5188 "glib-2.0.vapi"
			l = _tmp4_;
#line 209 "MainView.c"
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
#line 5190 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5190 "glib-2.0.vapi"
			_tmp6_ = ((GList*) _tmp5_)->data;
#line 5190 "glib-2.0.vapi"
			func (_tmp6_);
#line 5191 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5191 "glib-2.0.vapi"
			self = g_list_delete_link (self, (GList*) _tmp7_);
#line 5192 "glib-2.0.vapi"
			break;
#line 226 "MainView.c"
		}
	}
#line 5195 "glib-2.0.vapi"
	result = self;
#line 5195 "glib-2.0.vapi"
	return result;
#line 233 "MainView.c"
}

static void
network_main_view_device_removed_cb (NetworkMainView* self,
                                     NMDevice* device)
{
	GList* _tmp0_;
#line 115 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/MainView.vala"
	g_return_if_fail (device != NULL);
#line 116 "../src/MainView.vala"
	_tmp0_ = self->network_interface;
#line 247 "MainView.c"
	{
		GList* widget_interface_collection = NULL;
		GList* widget_interface_it = NULL;
#line 116 "../src/MainView.vala"
		widget_interface_collection = _tmp0_;
#line 116 "../src/MainView.vala"
		for (widget_interface_it = widget_interface_collection; widget_interface_it != NULL; widget_interface_it = widget_interface_it->next) {
#line 255 "MainView.c"
			NetworkWidgetsPage* _tmp1_;
			NetworkWidgetsPage* widget_interface = NULL;
#line 116 "../src/MainView.vala"
			_tmp1_ = _g_object_ref0 ((NetworkWidgetsPage*) widget_interface_it->data);
#line 116 "../src/MainView.vala"
			widget_interface = _tmp1_;
#line 262 "MainView.c"
			{
				NetworkWidgetsPage* _tmp2_;
				NMDevice* _tmp3_;
				NMDevice* _tmp4_;
#line 117 "../src/MainView.vala"
				_tmp2_ = widget_interface;
#line 117 "../src/MainView.vala"
				_tmp3_ = network_widgets_page_get_device (_tmp2_);
#line 117 "../src/MainView.vala"
				_tmp4_ = _tmp3_;
#line 117 "../src/MainView.vala"
				if (_tmp4_ == device) {
#line 275 "MainView.c"
					NetworkWidgetsPage* _tmp5_;
					NetworkWidgetsPage* _tmp6_;
#line 118 "../src/MainView.vala"
					_tmp5_ = widget_interface;
#line 118 "../src/MainView.vala"
					self->network_interface = vala_g_list_remove_full (self->network_interface, _tmp5_, _g_object_unref0_);
#line 121 "../src/MainView.vala"
					_tmp6_ = widget_interface;
#line 121 "../src/MainView.vala"
					network_main_view_remove_interface (self, _tmp6_);
#line 122 "../src/MainView.vala"
					_g_object_unref0 (widget_interface);
#line 122 "../src/MainView.vala"
					break;
#line 290 "MainView.c"
				}
#line 116 "../src/MainView.vala"
				_g_object_unref0 (widget_interface);
#line 294 "MainView.c"
			}
		}
	}
#line 126 "../src/MainView.vala"
	network_main_view_update_interfaces_names (self);
#line 300 "MainView.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 130 "../src/MainView.vala"
	dup = g_new0 (gint, 1);
#line 130 "../src/MainView.vala"
	memcpy (dup, self, sizeof (gint));
#line 130 "../src/MainView.vala"
	return dup;
#line 313 "MainView.c"
}

static void
network_main_view_update_interfaces_names (NetworkMainView* self)
{
	GeeHashMap* count_type = NULL;
	GeeHashMap* _tmp0_;
	GList* _tmp1_;
	GList* _tmp18_;
#line 129 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/MainView.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_INT, (GBoxedCopyFunc) _int_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 130 "../src/MainView.vala"
	count_type = _tmp0_;
#line 131 "../src/MainView.vala"
	_tmp1_ = self->network_interface;
#line 331 "MainView.c"
	{
		GList* iface_collection = NULL;
		GList* iface_it = NULL;
#line 131 "../src/MainView.vala"
		iface_collection = _tmp1_;
#line 131 "../src/MainView.vala"
		for (iface_it = iface_collection; iface_it != NULL; iface_it = iface_it->next) {
#line 339 "MainView.c"
			NetworkWidgetsPage* _tmp2_;
			NetworkWidgetsPage* iface = NULL;
#line 131 "../src/MainView.vala"
			_tmp2_ = _g_object_ref0 ((NetworkWidgetsPage*) iface_it->data);
#line 131 "../src/MainView.vala"
			iface = _tmp2_;
#line 346 "MainView.c"
			{
				gchar* type = NULL;
				NetworkWidgetsPage* _tmp3_;
				const gchar* _tmp4_;
				gchar* _tmp5_;
				GeeHashMap* _tmp6_;
				const gchar* _tmp7_;
#line 132 "../src/MainView.vala"
				_tmp3_ = iface;
#line 132 "../src/MainView.vala"
				_tmp4_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp3_));
#line 132 "../src/MainView.vala"
				_tmp5_ = g_strdup (_tmp4_);
#line 132 "../src/MainView.vala"
				type = _tmp5_;
#line 133 "../src/MainView.vala"
				_tmp6_ = count_type;
#line 133 "../src/MainView.vala"
				_tmp7_ = type;
#line 133 "../src/MainView.vala"
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, _tmp7_)) {
#line 368 "MainView.c"
					GeeHashMap* _tmp8_;
					const gchar* _tmp9_;
					GeeHashMap* _tmp10_;
					const gchar* _tmp11_;
					gpointer _tmp12_;
					gint* _tmp13_;
					gint _tmp14_;
#line 134 "../src/MainView.vala"
					_tmp8_ = count_type;
#line 134 "../src/MainView.vala"
					_tmp9_ = type;
#line 134 "../src/MainView.vala"
					_tmp10_ = count_type;
#line 134 "../src/MainView.vala"
					_tmp11_ = type;
#line 134 "../src/MainView.vala"
					_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, _tmp11_);
#line 134 "../src/MainView.vala"
					_tmp13_ = (gint*) _tmp12_;
#line 134 "../src/MainView.vala"
					_tmp14_ = (*_tmp13_) + 1;
#line 134 "../src/MainView.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, _tmp9_, &_tmp14_);
#line 134 "../src/MainView.vala"
					_g_free0 (_tmp13_);
#line 394 "MainView.c"
				} else {
					GeeHashMap* _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
#line 136 "../src/MainView.vala"
					_tmp15_ = count_type;
#line 136 "../src/MainView.vala"
					_tmp16_ = type;
#line 136 "../src/MainView.vala"
					_tmp17_ = 1;
#line 136 "../src/MainView.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp16_, &_tmp17_);
#line 407 "MainView.c"
				}
#line 131 "../src/MainView.vala"
				_g_free0 (type);
#line 131 "../src/MainView.vala"
				_g_object_unref0 (iface);
#line 413 "MainView.c"
			}
		}
	}
#line 140 "../src/MainView.vala"
	_tmp18_ = self->network_interface;
#line 419 "MainView.c"
	{
		GList* iface_collection = NULL;
		GList* iface_it = NULL;
#line 140 "../src/MainView.vala"
		iface_collection = _tmp18_;
#line 140 "../src/MainView.vala"
		for (iface_it = iface_collection; iface_it != NULL; iface_it = iface_it->next) {
#line 427 "MainView.c"
			NetworkWidgetsPage* _tmp19_;
			NetworkWidgetsPage* iface = NULL;
#line 140 "../src/MainView.vala"
			_tmp19_ = _g_object_ref0 ((NetworkWidgetsPage*) iface_it->data);
#line 140 "../src/MainView.vala"
			iface = _tmp19_;
#line 434 "MainView.c"
			{
				gchar* type = NULL;
				NetworkWidgetsPage* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				NetworkWidgetsPage* _tmp23_;
				GeeHashMap* _tmp24_;
				const gchar* _tmp25_;
				gpointer _tmp26_;
				gint* _tmp27_;
#line 141 "../src/MainView.vala"
				_tmp20_ = iface;
#line 141 "../src/MainView.vala"
				_tmp21_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp20_));
#line 141 "../src/MainView.vala"
				_tmp22_ = g_strdup (_tmp21_);
#line 141 "../src/MainView.vala"
				type = _tmp22_;
#line 142 "../src/MainView.vala"
				_tmp23_ = iface;
#line 142 "../src/MainView.vala"
				_tmp24_ = count_type;
#line 142 "../src/MainView.vala"
				_tmp25_ = type;
#line 142 "../src/MainView.vala"
				_tmp26_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, _tmp25_);
#line 142 "../src/MainView.vala"
				_tmp27_ = (gint*) _tmp26_;
#line 142 "../src/MainView.vala"
				network_widgets_page_update_name (_tmp23_, *_tmp27_);
#line 142 "../src/MainView.vala"
				_g_free0 (_tmp27_);
#line 140 "../src/MainView.vala"
				_g_free0 (type);
#line 140 "../src/MainView.vala"
				_g_object_unref0 (iface);
#line 471 "MainView.c"
			}
		}
	}
#line 129 "../src/MainView.vala"
	_g_object_unref0 (count_type);
#line 477 "MainView.c"
}

static void
network_main_view_connection_added_cb (NetworkMainView* self,
                                       GObject* obj)
{
	NMRemoteConnection* connection = NULL;
	NMRemoteConnection* _tmp0_;
#line 146 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/MainView.vala"
	g_return_if_fail (obj != NULL);
#line 147 "../src/MainView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_remote_connection_get_type (), NMRemoteConnection));
#line 147 "../src/MainView.vala"
	connection = _tmp0_;
#line 149 "../src/MainView.vala"
	network_main_view_add_connection (self, connection);
#line 146 "../src/MainView.vala"
	_g_object_unref0 (connection);
#line 498 "MainView.c"
}

static void
network_main_view_connection_removed_cb (NetworkMainView* self,
                                         GObject* obj)
{
	NMRemoteConnection* connection = NULL;
	NMRemoteConnection* _tmp0_;
#line 152 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/MainView.vala"
	g_return_if_fail (obj != NULL);
#line 153 "../src/MainView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_remote_connection_get_type (), NMRemoteConnection));
#line 153 "../src/MainView.vala"
	connection = _tmp0_;
#line 155 "../src/MainView.vala"
	network_main_view_remove_connection (self, connection);
#line 152 "../src/MainView.vala"
	_g_object_unref0 (connection);
#line 519 "MainView.c"
}

static void
_network_main_view_update_state_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 187 "../src/MainView.vala"
	network_main_view_update_state ((NetworkMainView*) self);
#line 529 "MainView.c"
}

static void
network_main_view_device_added_cb (NetworkMainView* self,
                                   NMDevice* device)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	NetworkWidgetsPage* widget_interface = NULL;
	NetworkWidgetsPage* hotspot_interface = NULL;
	NetworkWidgetsPage* _tmp11_;
	NetworkWidgetsPage* _tmp16_;
#line 158 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/MainView.vala"
	g_return_if_fail (device != NULL);
#line 159 "../src/MainView.vala"
	_tmp2_ = nm_device_get_iface (device);
#line 159 "../src/MainView.vala"
	if (g_str_has_prefix (_tmp2_, "vmnet")) {
#line 159 "../src/MainView.vala"
		_tmp1_ = TRUE;
#line 553 "MainView.c"
	} else {
		const gchar* _tmp3_;
#line 160 "../src/MainView.vala"
		_tmp3_ = nm_device_get_iface (device);
#line 160 "../src/MainView.vala"
		_tmp1_ = g_str_has_prefix (_tmp3_, "lo");
#line 560 "MainView.c"
	}
#line 159 "../src/MainView.vala"
	if (_tmp1_) {
#line 159 "../src/MainView.vala"
		_tmp0_ = TRUE;
#line 566 "MainView.c"
	} else {
		const gchar* _tmp4_;
#line 161 "../src/MainView.vala"
		_tmp4_ = nm_device_get_iface (device);
#line 161 "../src/MainView.vala"
		_tmp0_ = g_str_has_prefix (_tmp4_, "veth");
#line 573 "MainView.c"
	}
#line 159 "../src/MainView.vala"
	if (_tmp0_) {
#line 162 "../src/MainView.vala"
		return;
#line 579 "MainView.c"
	}
#line 165 "../src/MainView.vala"
	widget_interface = NULL;
#line 166 "../src/MainView.vala"
	hotspot_interface = NULL;
#line 168 "../src/MainView.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (device, nm_device_wifi_get_type ())) {
#line 587 "MainView.c"
		NetworkWifiInterface* _tmp5_;
		NetworkWidgetsPage* _tmp6_;
		NetworkWidgetsHotspotInterface* _tmp7_;
#line 169 "../src/MainView.vala"
		_tmp5_ = network_wifi_interface_new (device);
#line 169 "../src/MainView.vala"
		g_object_ref_sink (_tmp5_);
#line 169 "../src/MainView.vala"
		_g_object_unref0 (widget_interface);
#line 169 "../src/MainView.vala"
		widget_interface = (NetworkWidgetsPage*) _tmp5_;
#line 170 "../src/MainView.vala"
		_tmp6_ = widget_interface;
#line 170 "../src/MainView.vala"
		_tmp7_ = network_widgets_hotspot_interface_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface));
#line 170 "../src/MainView.vala"
		g_object_ref_sink (_tmp7_);
#line 170 "../src/MainView.vala"
		_g_object_unref0 (hotspot_interface);
#line 170 "../src/MainView.vala"
		hotspot_interface = (NetworkWidgetsPage*) _tmp7_;
#line 172 "../src/MainView.vala"
		g_debug ("MainView.vala:172: Wifi interface added");
#line 611 "MainView.c"
	} else {
#line 173 "../src/MainView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (device, nm_device_ethernet_get_type ())) {
#line 615 "MainView.c"
			NetworkWidgetsEtherInterface* _tmp8_;
#line 174 "../src/MainView.vala"
			_tmp8_ = network_widgets_ether_interface_new (device);
#line 174 "../src/MainView.vala"
			g_object_ref_sink (_tmp8_);
#line 174 "../src/MainView.vala"
			_g_object_unref0 (widget_interface);
#line 174 "../src/MainView.vala"
			widget_interface = (NetworkWidgetsPage*) _tmp8_;
#line 175 "../src/MainView.vala"
			g_debug ("MainView.vala:175: Ethernet interface added");
#line 627 "MainView.c"
		} else {
#line 176 "../src/MainView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (device, nm_device_modem_get_type ())) {
#line 631 "MainView.c"
				NetworkWidgetsModemInterface* _tmp9_;
#line 177 "../src/MainView.vala"
				_tmp9_ = network_widgets_modem_interface_new (device);
#line 177 "../src/MainView.vala"
				g_object_ref_sink (_tmp9_);
#line 177 "../src/MainView.vala"
				_g_object_unref0 (widget_interface);
#line 177 "../src/MainView.vala"
				widget_interface = (NetworkWidgetsPage*) _tmp9_;
#line 178 "../src/MainView.vala"
				g_debug ("MainView.vala:178: Modem interface added");
#line 643 "MainView.c"
			} else {
				GEnumValue* _tmp10_;
#line 180 "../src/MainView.vala"
				_tmp10_ = g_enum_get_value (g_type_class_ref (nm_device_type_get_type ()), nm_device_get_device_type (device));
#line 180 "../src/MainView.vala"
				g_debug ("MainView.vala:180: Unknown device: %s\n", (_tmp10_ != NULL) ? _tmp10_->value_name : NULL);
#line 650 "MainView.c"
			}
		}
	}
#line 183 "../src/MainView.vala"
	_tmp11_ = widget_interface;
#line 183 "../src/MainView.vala"
	if (_tmp11_ != NULL) {
#line 658 "MainView.c"
		NetworkWidgetsPage* _tmp12_;
		NetworkWidgetsPage* _tmp13_;
		NetworkWidgetsPage* _tmp14_;
		NetworkWidgetsPage* _tmp15_;
#line 185 "../src/MainView.vala"
		_tmp12_ = widget_interface;
#line 185 "../src/MainView.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 185 "../src/MainView.vala"
		self->network_interface = g_list_append (self->network_interface, _tmp13_);
#line 186 "../src/MainView.vala"
		_tmp14_ = widget_interface;
#line 186 "../src/MainView.vala"
		network_main_view_add_interface (self, _tmp14_);
#line 187 "../src/MainView.vala"
		_tmp15_ = widget_interface;
#line 187 "../src/MainView.vala"
		g_signal_connect_object ((GObject*) _tmp15_, "notify::state", (GCallback) _network_main_view_update_state_g_object_notify, self, 0);
#line 677 "MainView.c"
	}
#line 191 "../src/MainView.vala"
	_tmp16_ = hotspot_interface;
#line 191 "../src/MainView.vala"
	if (_tmp16_ != NULL) {
#line 683 "MainView.c"
		NetworkWidgetsPage* _tmp17_;
		NetworkWidgetsPage* _tmp18_;
		NetworkWidgetsPage* _tmp19_;
		NetworkWidgetsPage* _tmp20_;
#line 193 "../src/MainView.vala"
		_tmp17_ = hotspot_interface;
#line 193 "../src/MainView.vala"
		_tmp18_ = _g_object_ref0 (_tmp17_);
#line 193 "../src/MainView.vala"
		self->network_interface = g_list_append (self->network_interface, _tmp18_);
#line 194 "../src/MainView.vala"
		_tmp19_ = hotspot_interface;
#line 194 "../src/MainView.vala"
		network_main_view_add_interface (self, _tmp19_);
#line 195 "../src/MainView.vala"
		_tmp20_ = hotspot_interface;
#line 195 "../src/MainView.vala"
		g_signal_connect_object ((GObject*) _tmp20_, "notify::state", (GCallback) _network_main_view_update_state_g_object_notify, self, 0);
#line 702 "MainView.c"
	}
#line 198 "../src/MainView.vala"
	network_main_view_update_interfaces_names (self);
#line 199 "../src/MainView.vala"
	network_main_view_update_all (self);
#line 158 "../src/MainView.vala"
	_g_object_unref0 (hotspot_interface);
#line 158 "../src/MainView.vala"
	_g_object_unref0 (widget_interface);
#line 712 "MainView.c"
}

static void
network_main_view_update_all (NetworkMainView* self)
{
	GList* _tmp0_;
#line 202 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/MainView.vala"
	_tmp0_ = self->network_interface;
#line 723 "MainView.c"
	{
		GList* inter_collection = NULL;
		GList* inter_it = NULL;
#line 203 "../src/MainView.vala"
		inter_collection = _tmp0_;
#line 203 "../src/MainView.vala"
		for (inter_it = inter_collection; inter_it != NULL; inter_it = inter_it->next) {
#line 731 "MainView.c"
			NetworkWidgetsPage* _tmp1_;
			NetworkWidgetsPage* inter = NULL;
#line 203 "../src/MainView.vala"
			_tmp1_ = _g_object_ref0 ((NetworkWidgetsPage*) inter_it->data);
#line 203 "../src/MainView.vala"
			inter = _tmp1_;
#line 738 "MainView.c"
			{
				NetworkWidgetsPage* _tmp2_;
#line 204 "../src/MainView.vala"
				_tmp2_ = inter;
#line 204 "../src/MainView.vala"
				network_widgets_page_update (_tmp2_);
#line 203 "../src/MainView.vala"
				_g_object_unref0 (inter);
#line 747 "MainView.c"
			}
		}
	}
}

static void
network_main_view_update_state (NetworkMainView* self)
{
	NMDeviceState next_state = 0;
	GList* _tmp0_;
#line 208 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/MainView.vala"
	next_state = NM_DEVICE_STATE_DISCONNECTED;
#line 210 "../src/MainView.vala"
	_tmp0_ = self->network_interface;
#line 764 "MainView.c"
	{
		GList* inter_collection = NULL;
		GList* inter_it = NULL;
#line 210 "../src/MainView.vala"
		inter_collection = _tmp0_;
#line 210 "../src/MainView.vala"
		for (inter_it = inter_collection; inter_it != NULL; inter_it = inter_it->next) {
#line 772 "MainView.c"
			NetworkWidgetsPage* _tmp1_;
			NetworkWidgetsPage* inter = NULL;
#line 210 "../src/MainView.vala"
			_tmp1_ = _g_object_ref0 ((NetworkWidgetsPage*) inter_it->data);
#line 210 "../src/MainView.vala"
			inter = _tmp1_;
#line 779 "MainView.c"
			{
				NetworkWidgetsPage* _tmp2_;
				NMDeviceState _tmp3_;
				NMDeviceState _tmp4_;
#line 211 "../src/MainView.vala"
				_tmp2_ = inter;
#line 211 "../src/MainView.vala"
				_tmp3_ = network_widgets_page_get_state (_tmp2_);
#line 211 "../src/MainView.vala"
				_tmp4_ = _tmp3_;
#line 211 "../src/MainView.vala"
				if (_tmp4_ != NM_DEVICE_STATE_DISCONNECTED) {
#line 792 "MainView.c"
					NetworkWidgetsPage* _tmp5_;
					NMDeviceState _tmp6_;
					NMDeviceState _tmp7_;
#line 212 "../src/MainView.vala"
					_tmp5_ = inter;
#line 212 "../src/MainView.vala"
					_tmp6_ = network_widgets_page_get_state (_tmp5_);
#line 212 "../src/MainView.vala"
					_tmp7_ = _tmp6_;
#line 212 "../src/MainView.vala"
					next_state = _tmp7_;
#line 804 "MainView.c"
				}
#line 210 "../src/MainView.vala"
				_g_object_unref0 (inter);
#line 808 "MainView.c"
			}
		}
	}
#line 216 "../src/MainView.vala"
	network_main_view_set_state (self, next_state);
#line 814 "MainView.c"
}

static void
network_main_view_add_interface (NetworkMainView* self,
                                 NetworkWidgetsPage* widget_interface)
{
	NetworkWidgetsDeviceList* _tmp0_;
#line 219 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/MainView.vala"
	g_return_if_fail (widget_interface != NULL);
#line 220 "../src/MainView.vala"
	_tmp0_ = self->priv->device_list;
#line 220 "../src/MainView.vala"
	network_widgets_device_list_add_iface_to_list (_tmp0_, widget_interface);
#line 222 "../src/MainView.vala"
	network_main_view_update_networking_state (self);
#line 832 "MainView.c"
}

static void
network_main_view_remove_interface (NetworkMainView* self,
                                    NetworkWidgetsPage* widget_interface)
{
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
#line 225 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/MainView.vala"
	g_return_if_fail (widget_interface != NULL);
#line 226 "../src/MainView.vala"
	_tmp0_ = self->priv->content;
#line 226 "../src/MainView.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 226 "../src/MainView.vala"
	if (_tmp1_ == G_TYPE_CHECK_INSTANCE_CAST (widget_interface, gtk_widget_get_type (), GtkWidget)) {
#line 851 "MainView.c"
		GtkListBoxRow* row = NULL;
		NetworkWidgetsDeviceList* _tmp2_;
		GtkListBoxRow* _tmp3_;
		GtkListBoxRow* _tmp4_;
		gint index = 0;
		NetworkWidgetsDeviceList* _tmp5_;
		GtkListBoxRow* _tmp6_;
		NetworkWidgetsDeviceList* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GtkListBoxRow* _tmp9_;
#line 227 "../src/MainView.vala"
		_tmp2_ = self->priv->device_list;
#line 227 "../src/MainView.vala"
		_tmp3_ = gtk_list_box_get_selected_row ((GtkListBox*) _tmp2_);
#line 227 "../src/MainView.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 227 "../src/MainView.vala"
		row = _tmp4_;
#line 228 "../src/MainView.vala"
		_tmp5_ = self->priv->device_list;
#line 228 "../src/MainView.vala"
		_tmp6_ = gtk_list_box_get_selected_row ((GtkListBox*) _tmp5_);
#line 228 "../src/MainView.vala"
		index = gtk_list_box_row_get_index (_tmp6_);
#line 229 "../src/MainView.vala"
		_tmp7_ = self->priv->device_list;
#line 229 "../src/MainView.vala"
		network_widgets_device_list_remove_iface_from_list (_tmp7_, widget_interface);
#line 231 "../src/MainView.vala"
		_tmp9_ = row;
#line 231 "../src/MainView.vala"
		if (_tmp9_ != NULL) {
#line 884 "MainView.c"
			GtkListBoxRow* _tmp10_;
#line 231 "../src/MainView.vala"
			_tmp10_ = row;
#line 231 "../src/MainView.vala"
			_tmp8_ = gtk_list_box_row_get_index (_tmp10_) >= 0;
#line 890 "MainView.c"
		} else {
#line 231 "../src/MainView.vala"
			_tmp8_ = FALSE;
#line 894 "MainView.c"
		}
#line 231 "../src/MainView.vala"
		if (_tmp8_) {
#line 898 "MainView.c"
			NetworkWidgetsDeviceList* _tmp11_;
			GtkListBoxRow* _tmp12_;
#line 232 "../src/MainView.vala"
			_tmp11_ = self->priv->device_list;
#line 232 "../src/MainView.vala"
			_tmp12_ = gtk_list_box_get_row_at_index ((GtkListBox*) _tmp11_, index);
#line 232 "../src/MainView.vala"
			g_signal_emit_by_name (_tmp12_, "activate");
#line 907 "MainView.c"
		} else {
#line 234 "../src/MainView.vala"
			network_main_view_select_first (self);
#line 911 "MainView.c"
		}
#line 226 "../src/MainView.vala"
		_g_object_unref0 (row);
#line 915 "MainView.c"
	} else {
		NetworkWidgetsDeviceList* _tmp13_;
#line 237 "../src/MainView.vala"
		_tmp13_ = self->priv->device_list;
#line 237 "../src/MainView.vala"
		network_widgets_device_list_remove_iface_from_list (_tmp13_, widget_interface);
#line 922 "MainView.c"
	}
#line 240 "../src/MainView.vala"
	gtk_widget_destroy ((GtkWidget*) widget_interface);
#line 926 "MainView.c"
}

static void
network_main_view_add_connection (NetworkMainView* self,
                                  NMRemoteConnection* connection)
{
	NetworkWidgetsDeviceList* _tmp0_;
#line 243 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/MainView.vala"
	g_return_if_fail (connection != NULL);
#line 244 "../src/MainView.vala"
	_tmp0_ = self->priv->device_list;
#line 244 "../src/MainView.vala"
	network_widgets_device_list_add_connection (_tmp0_, connection);
#line 942 "MainView.c"
}

static void
network_main_view_remove_connection (NetworkMainView* self,
                                     NMRemoteConnection* connection)
{
	NetworkWidgetsDeviceList* _tmp0_;
#line 247 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/MainView.vala"
	g_return_if_fail (connection != NULL);
#line 248 "../src/MainView.vala"
	_tmp0_ = self->priv->device_list;
#line 248 "../src/MainView.vala"
	network_widgets_device_list_remove_connection (_tmp0_, connection);
#line 958 "MainView.c"
}

static void
network_main_view_select_first (NetworkMainView* self)
{
	NetworkWidgetsDeviceList* _tmp0_;
#line 251 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/MainView.vala"
	_tmp0_ = self->priv->device_list;
#line 252 "../src/MainView.vala"
	network_widgets_device_list_select_first_item (_tmp0_);
#line 971 "MainView.c"
}

static void
network_main_view_update_networking_state (NetworkMainView* self)
{
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp0_;
	NetworkNetworkManager* _tmp1_;
	NMClient* _tmp2_;
	NMClient* _tmp3_;
#line 255 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/MainView.vala"
	_tmp0_ = network_network_manager_get_default ();
#line 256 "../src/MainView.vala"
	network_manager = _tmp0_;
#line 257 "../src/MainView.vala"
	_tmp1_ = network_manager;
#line 257 "../src/MainView.vala"
	_tmp2_ = network_network_manager_get_client (_tmp1_);
#line 257 "../src/MainView.vala"
	_tmp3_ = _tmp2_;
#line 257 "../src/MainView.vala"
	if (nm_client_networking_get_enabled (_tmp3_)) {
#line 996 "MainView.c"
		NetworkWidgetsDeviceList* _tmp4_;
		NetworkWidgetsDeviceList* _tmp5_;
#line 258 "../src/MainView.vala"
		_tmp4_ = self->priv->device_list;
#line 258 "../src/MainView.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 259 "../src/MainView.vala"
		_tmp5_ = self->priv->device_list;
#line 259 "../src/MainView.vala"
		network_widgets_device_list_select_first_item (_tmp5_);
#line 1007 "MainView.c"
	} else {
		NetworkWidgetsDeviceList* _tmp6_;
		NetworkWidgetsDeviceList* _tmp7_;
		GtkStack* _tmp8_;
#line 261 "../src/MainView.vala"
		_tmp6_ = self->priv->device_list;
#line 261 "../src/MainView.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 262 "../src/MainView.vala"
		_g_object_unref0 (self->priv->current_device);
#line 262 "../src/MainView.vala"
		self->priv->current_device = NULL;
#line 263 "../src/MainView.vala"
		_tmp7_ = self->priv->device_list;
#line 263 "../src/MainView.vala"
		gtk_list_box_select_row ((GtkListBox*) _tmp7_, NULL);
#line 264 "../src/MainView.vala"
		_tmp8_ = self->priv->content;
#line 264 "../src/MainView.vala"
		gtk_stack_set_visible_child_name (_tmp8_, "airplane-mode-info");
#line 1028 "MainView.c"
	}
}

NetworkMainView*
network_main_view_construct (GType object_type)
{
	NetworkMainView * self = NULL;
#line 20 "../src/MainView.vala"
	self = (NetworkMainView*) g_object_new (object_type, NULL);
#line 20 "../src/MainView.vala"
	return self;
#line 1040 "MainView.c"
}

NetworkMainView*
network_main_view_new (void)
{
#line 20 "../src/MainView.vala"
	return network_main_view_construct (NETWORK_TYPE_MAIN_VIEW);
#line 1048 "MainView.c"
}

NMDeviceState
network_main_view_get_state (NetworkMainView* self)
{
	NMDeviceState result;
#line 23 "../src/MainView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "../src/MainView.vala"
	result = self->priv->_state;
#line 23 "../src/MainView.vala"
	return result;
#line 1061 "MainView.c"
}

static void
network_main_view_set_state (NetworkMainView* self,
                             NMDeviceState value)
{
	NMDeviceState old_value;
#line 23 "../src/MainView.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/MainView.vala"
	old_value = network_main_view_get_state (self);
#line 23 "../src/MainView.vala"
	if (old_value != value) {
#line 23 "../src/MainView.vala"
		self->priv->_state = value;
#line 23 "../src/MainView.vala"
		g_object_notify_by_pspec ((GObject *) self, network_main_view_properties[NETWORK_MAIN_VIEW_STATE_PROPERTY]);
#line 1079 "MainView.c"
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 30 "../src/MainView.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 30 "../src/MainView.vala"
	return _data2_;
#line 1090 "MainView.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 30 "../src/MainView.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1100 "MainView.c"
		NetworkMainView* self;
#line 30 "../src/MainView.vala"
		self = _data2_->self;
#line 30 "../src/MainView.vala"
		_g_object_unref0 (_data2_->scrolled_window);
#line 30 "../src/MainView.vala"
		_g_object_unref0 (_data2_->no_devices);
#line 30 "../src/MainView.vala"
		_g_object_unref0 (self);
#line 30 "../src/MainView.vala"
		g_slice_free (Block2Data, _data2_);
#line 1112 "MainView.c"
	}
}

static void
_network_main_view___lambda50_ (NetworkMainView* self,
                                GtkListBoxRow* row)
{
	NetworkWidgetsPage* page = NULL;
	NetworkWidgetsPage* _tmp0_;
	NetworkWidgetsPage* _tmp1_;
	NetworkWidgetsPage* _tmp2_;
	GtkStack* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	NetworkWidgetsPage* _tmp6_;
	GList* _tmp7_;
	gboolean _tmp8_;
	GtkStack* _tmp11_;
	NetworkWidgetsPage* _tmp12_;
#line 77 "../src/MainView.vala"
	g_return_if_fail (row != NULL);
#line 78 "../src/MainView.vala"
	_tmp0_ = network_widgets_device_item_get_page (G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem));
#line 78 "../src/MainView.vala"
	_tmp1_ = _tmp0_;
#line 78 "../src/MainView.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 78 "../src/MainView.vala"
	page = _tmp2_;
#line 79 "../src/MainView.vala"
	_tmp3_ = self->priv->content;
#line 79 "../src/MainView.vala"
	_tmp4_ = gtk_container_get_children ((GtkContainer*) _tmp3_);
#line 79 "../src/MainView.vala"
	_tmp5_ = _tmp4_;
#line 79 "../src/MainView.vala"
	_tmp6_ = page;
#line 79 "../src/MainView.vala"
	_tmp7_ = g_list_find (_tmp5_, (GtkWidget*) _tmp6_);
#line 79 "../src/MainView.vala"
	_tmp8_ = _tmp7_ == NULL;
#line 79 "../src/MainView.vala"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 79 "../src/MainView.vala"
	if (_tmp8_) {
#line 1158 "MainView.c"
		GtkStack* _tmp9_;
		NetworkWidgetsPage* _tmp10_;
#line 80 "../src/MainView.vala"
		_tmp9_ = self->priv->content;
#line 80 "../src/MainView.vala"
		_tmp10_ = page;
#line 80 "../src/MainView.vala"
		gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 1167 "MainView.c"
	}
#line 83 "../src/MainView.vala"
	_tmp11_ = self->priv->content;
#line 83 "../src/MainView.vala"
	_tmp12_ = page;
#line 83 "../src/MainView.vala"
	gtk_stack_set_visible_child (_tmp11_, (GtkWidget*) _tmp12_);
#line 77 "../src/MainView.vala"
	_g_object_unref0 (page);
#line 1177 "MainView.c"
}

static void
__network_main_view___lambda50__gtk_list_box_row_activated (GtkListBox* _sender,
                                                            GtkListBoxRow* row,
                                                            gpointer self)
{
#line 77 "../src/MainView.vala"
	_network_main_view___lambda50_ ((NetworkMainView*) self, row);
#line 1187 "MainView.c"
}

static void
_network_main_view___lambda51_ (Block2Data* _data2_,
                                gboolean show)
{
	NetworkMainView* self;
	GtkScrolledWindow* _tmp0_;
#line 86 "../src/MainView.vala"
	self = _data2_->self;
#line 87 "../src/MainView.vala"
	_tmp0_ = _data2_->scrolled_window;
#line 87 "../src/MainView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, !show);
#line 88 "../src/MainView.vala"
	if (show) {
#line 1204 "MainView.c"
		GtkStack* _tmp1_;
		GraniteWidgetsAlertView* _tmp2_;
#line 89 "../src/MainView.vala"
		_tmp1_ = self->priv->content;
#line 89 "../src/MainView.vala"
		_tmp2_ = _data2_->no_devices;
#line 89 "../src/MainView.vala"
		gtk_stack_set_visible_child (_tmp1_, (GtkWidget*) _tmp2_);
#line 1213 "MainView.c"
	} else {
		GtkStack* _tmp3_;
		NetworkWidgetsPage* _tmp4_;
#line 91 "../src/MainView.vala"
		_tmp3_ = self->priv->content;
#line 91 "../src/MainView.vala"
		_tmp4_ = self->priv->page;
#line 91 "../src/MainView.vala"
		gtk_stack_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 1223 "MainView.c"
	}
}

static void
__network_main_view___lambda51__network_widgets_device_list_show_no_devices (NetworkWidgetsDeviceList* _sender,
                                                                             gboolean show,
                                                                             gpointer self)
{
#line 86 "../src/MainView.vala"
	_network_main_view___lambda51_ (self, show);
#line 1234 "MainView.c"
}

static void
_network_main_view_update_networking_state_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 96 "../src/MainView.vala"
	network_main_view_update_networking_state ((NetworkMainView*) self);
#line 1244 "MainView.c"
}

static void
_network_main_view_connection_added_cb_nm_client_connection_added (NMClient* _sender,
                                                                   NMRemoteConnection* connection,
                                                                   gpointer self)
{
#line 103 "../src/MainView.vala"
	network_main_view_connection_added_cb ((NetworkMainView*) self, connection);
#line 1254 "MainView.c"
}

static void
_network_main_view_connection_removed_cb_nm_client_connection_removed (NMClient* _sender,
                                                                       NMRemoteConnection* connection,
                                                                       gpointer self)
{
#line 104 "../src/MainView.vala"
	network_main_view_connection_removed_cb ((NetworkMainView*) self, connection);
#line 1264 "MainView.c"
}

static void
_network_main_view_device_added_cb_nm_client_device_added (NMClient* _sender,
                                                           NMDevice* device,
                                                           gpointer self)
{
#line 106 "../src/MainView.vala"
	network_main_view_device_added_cb ((NetworkMainView*) self, device);
#line 1274 "MainView.c"
}

static void
_network_main_view_device_removed_cb_nm_client_device_removed (NMClient* _sender,
                                                               NMDevice* device,
                                                               gpointer self)
{
#line 107 "../src/MainView.vala"
	network_main_view_device_removed_cb ((NetworkMainView*) self, device);
#line 1284 "MainView.c"
}

static void
_network_main_view___lambda52_ (NetworkMainView* self,
                                NMDevice* device)
{
#line 109 "../src/MainView.vala"
	g_return_if_fail (device != NULL);
#line 109 "../src/MainView.vala"
	network_main_view_device_added_cb (self, device);
#line 1295 "MainView.c"
}

static void
__network_main_view___lambda52__gfunc (gconstpointer data,
                                       gpointer self)
{
#line 109 "../src/MainView.vala"
	_network_main_view___lambda52_ ((NetworkMainView*) self, (NMDevice*) data);
#line 1304 "MainView.c"
}

static void
_network_main_view___lambda53_ (NetworkMainView* self,
                                NMRemoteConnection* connection)
{
#line 110 "../src/MainView.vala"
	g_return_if_fail (connection != NULL);
#line 110 "../src/MainView.vala"
	network_main_view_add_connection (self, connection);
#line 1315 "MainView.c"
}

static void
__network_main_view___lambda53__gfunc (gconstpointer data,
                                       gpointer self)
{
#line 110 "../src/MainView.vala"
	_network_main_view___lambda53_ ((NetworkMainView*) self, (NMRemoteConnection*) data);
#line 1324 "MainView.c"
}

static GObject *
network_main_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkMainView * self;
	Block2Data* _data2_;
	NetworkWidgetsDeviceList* _tmp0_;
	NetworkWidgetsFooter* footer = NULL;
	NetworkWidgetsFooter* _tmp1_;
	GraniteWidgetsAlertView* airplane_mode = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GraniteWidgetsAlertView* _tmp6_;
	GraniteWidgetsAlertView* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GraniteWidgetsAlertView* _tmp11_;
	GraniteWidgetsAlertView* _tmp12_;
	GraniteWidgetsAlertView* _tmp13_;
	GtkStack* _tmp14_ = NULL;
	GtkStack* _tmp15_;
	GraniteWidgetsAlertView* _tmp16_;
	GtkStack* _tmp17_;
	GraniteWidgetsAlertView* _tmp18_;
	GtkScrolledWindow* _tmp19_ = NULL;
	GtkScrolledWindow* _tmp20_;
	NetworkWidgetsDeviceList* _tmp21_;
	GtkGrid* sidebar = NULL;
	GtkGrid* _tmp22_ = NULL;
	GtkGrid* _tmp23_;
	GtkScrolledWindow* _tmp24_;
	GtkGrid* _tmp25_;
	NetworkWidgetsFooter* _tmp26_;
	GtkGrid* _tmp27_;
	GtkStack* _tmp28_;
	NetworkWidgetsDeviceList* _tmp29_;
	NetworkWidgetsDeviceList* _tmp30_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp31_;
	NetworkNetworkManager* _tmp32_;
	NMClient* _tmp33_;
	NMClient* _tmp34_;
	NetworkNetworkManager* nm_manager = NULL;
	NetworkNetworkManager* _tmp35_;
	NMClient* nm_client = NULL;
	NetworkNetworkManager* _tmp36_;
	NMClient* _tmp37_;
	NMClient* _tmp38_;
	NMClient* _tmp39_;
	NMClient* _tmp40_;
	NMClient* _tmp41_;
	NMClient* _tmp42_;
	NMClient* _tmp43_;
	GPtrArray* _tmp44_;
	NMClient* _tmp45_;
	GPtrArray* _tmp46_;
#line 30 "../src/MainView.vala"
	parent_class = G_OBJECT_CLASS (network_main_view_parent_class);
#line 30 "../src/MainView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/MainView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_MAIN_VIEW, NetworkMainView);
#line 30 "../src/MainView.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 30 "../src/MainView.vala"
	_data2_->_ref_count_ = 1;
#line 30 "../src/MainView.vala"
	_data2_->self = g_object_ref (self);
#line 31 "../src/MainView.vala"
	(self->network_interface == NULL) ? NULL : (self->network_interface = (_g_list_free__g_object_unref0_ (self->network_interface), NULL));
#line 31 "../src/MainView.vala"
	self->network_interface = NULL;
#line 33 "../src/MainView.vala"
	_tmp0_ = network_widgets_device_list_new ();
#line 33 "../src/MainView.vala"
	g_object_ref_sink (_tmp0_);
#line 33 "../src/MainView.vala"
	_g_object_unref0 (self->priv->device_list);
#line 33 "../src/MainView.vala"
	self->priv->device_list = _tmp0_;
#line 35 "../src/MainView.vala"
	_tmp1_ = network_widgets_footer_new ();
#line 35 "../src/MainView.vala"
	g_object_ref_sink (_tmp1_);
#line 35 "../src/MainView.vala"
	footer = _tmp1_;
#line 37 "../src/MainView.vala"
	_tmp2_ = g_strconcat (_ ("While in Airplane Mode your device's Internet access and any wireless " \
"and ethernet connections, will be suspended.\n" \
"\n"), _ ("You will be unable to browse the web or use applications that require " \
"a network connection or Internet access.\n"), NULL);
#line 37 "../src/MainView.vala"
	_tmp3_ = _tmp2_;
#line 37 "../src/MainView.vala"
	_tmp4_ = g_strconcat (_tmp3_, _ ("Applications and other functions that do not require the Internet will" \
" be unaffected."), NULL);
#line 37 "../src/MainView.vala"
	_tmp5_ = _tmp4_;
#line 37 "../src/MainView.vala"
	_tmp6_ = granite_widgets_alert_view_new (_ ("Airplane Mode Is Enabled"), _tmp5_, "airplane-mode");
#line 37 "../src/MainView.vala"
	g_object_ref_sink (_tmp6_);
#line 37 "../src/MainView.vala"
	_tmp7_ = _tmp6_;
#line 37 "../src/MainView.vala"
	_g_free0 (_tmp5_);
#line 37 "../src/MainView.vala"
	_g_free0 (_tmp3_);
#line 37 "../src/MainView.vala"
	airplane_mode = _tmp7_;
#line 45 "../src/MainView.vala"
	_tmp8_ = airplane_mode;
#line 45 "../src/MainView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
#line 47 "../src/MainView.vala"
	_tmp9_ = g_strconcat (_ ("There are no available Wi-Fi connections or Wi-Fi devices connected to" \
" this computer.\n"), _ ("Please connect at least one device to begin configuring the network."), NULL);
#line 47 "../src/MainView.vala"
	_tmp10_ = _tmp9_;
#line 47 "../src/MainView.vala"
	_tmp11_ = granite_widgets_alert_view_new (_ ("There is nothing to do"), _tmp10_, "dialog-cancel");
#line 47 "../src/MainView.vala"
	g_object_ref_sink (_tmp11_);
#line 47 "../src/MainView.vala"
	_tmp12_ = _tmp11_;
#line 47 "../src/MainView.vala"
	_g_free0 (_tmp10_);
#line 47 "../src/MainView.vala"
	_data2_->no_devices = _tmp12_;
#line 54 "../src/MainView.vala"
	_tmp13_ = _data2_->no_devices;
#line 54 "../src/MainView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp13_);
#line 56 "../src/MainView.vala"
	_tmp14_ = (GtkStack*) gtk_stack_new ();
#line 56 "../src/MainView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
#line 56 "../src/MainView.vala"
	g_object_ref_sink (_tmp14_);
#line 56 "../src/MainView.vala"
	_g_object_unref0 (self->priv->content);
#line 56 "../src/MainView.vala"
	self->priv->content = _tmp14_;
#line 59 "../src/MainView.vala"
	_tmp15_ = self->priv->content;
#line 59 "../src/MainView.vala"
	_tmp16_ = airplane_mode;
#line 59 "../src/MainView.vala"
	gtk_stack_add_named (_tmp15_, (GtkWidget*) _tmp16_, "airplane-mode-info");
#line 60 "../src/MainView.vala"
	_tmp17_ = self->priv->content;
#line 60 "../src/MainView.vala"
	_tmp18_ = _data2_->no_devices;
#line 60 "../src/MainView.vala"
	gtk_stack_add_named (_tmp17_, (GtkWidget*) _tmp18_, "no-devices-info");
#line 62 "../src/MainView.vala"
	_tmp19_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 62 "../src/MainView.vala"
	g_object_set ((GtkWidget*) _tmp19_, "expand", TRUE, NULL);
#line 62 "../src/MainView.vala"
	g_object_ref_sink (_tmp19_);
#line 62 "../src/MainView.vala"
	_data2_->scrolled_window = _tmp19_;
#line 65 "../src/MainView.vala"
	_tmp20_ = _data2_->scrolled_window;
#line 65 "../src/MainView.vala"
	_tmp21_ = self->priv->device_list;
#line 65 "../src/MainView.vala"
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 67 "../src/MainView.vala"
	_tmp22_ = (GtkGrid*) gtk_grid_new ();
#line 67 "../src/MainView.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp22_, GTK_ORIENTATION_VERTICAL);
#line 67 "../src/MainView.vala"
	g_object_ref_sink (_tmp22_);
#line 67 "../src/MainView.vala"
	sidebar = _tmp22_;
#line 70 "../src/MainView.vala"
	_tmp23_ = sidebar;
#line 70 "../src/MainView.vala"
	_tmp24_ = _data2_->scrolled_window;
#line 70 "../src/MainView.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 71 "../src/MainView.vala"
	_tmp25_ = sidebar;
#line 71 "../src/MainView.vala"
	_tmp26_ = footer;
#line 71 "../src/MainView.vala"
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 73 "../src/MainView.vala"
	gtk_paned_set_position ((GtkPaned*) self, 240);
#line 74 "../src/MainView.vala"
	_tmp27_ = sidebar;
#line 74 "../src/MainView.vala"
	gtk_paned_pack1 ((GtkPaned*) self, (GtkWidget*) _tmp27_, FALSE, FALSE);
#line 75 "../src/MainView.vala"
	_tmp28_ = self->priv->content;
#line 75 "../src/MainView.vala"
	gtk_paned_pack2 ((GtkPaned*) self, (GtkWidget*) _tmp28_, TRUE, FALSE);
#line 77 "../src/MainView.vala"
	_tmp29_ = self->priv->device_list;
#line 77 "../src/MainView.vala"
	g_signal_connect_object ((GtkListBox*) _tmp29_, "row-activated", (GCallback) __network_main_view___lambda50__gtk_list_box_row_activated, self, 0);
#line 86 "../src/MainView.vala"
	_tmp30_ = self->priv->device_list;
#line 86 "../src/MainView.vala"
	g_signal_connect_data (_tmp30_, "show-no-devices", (GCallback) __network_main_view___lambda51__network_widgets_device_list_show_no_devices, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 95 "../src/MainView.vala"
	_tmp31_ = network_network_manager_get_default ();
#line 95 "../src/MainView.vala"
	network_manager = _tmp31_;
#line 96 "../src/MainView.vala"
	_tmp32_ = network_manager;
#line 96 "../src/MainView.vala"
	_tmp33_ = network_network_manager_get_client (_tmp32_);
#line 96 "../src/MainView.vala"
	_tmp34_ = _tmp33_;
#line 96 "../src/MainView.vala"
	g_signal_connect_object ((GObject*) _tmp34_, "notify::networking-enabled", (GCallback) _network_main_view_update_networking_state_g_object_notify, self, 0);
#line 98 "../src/MainView.vala"
	network_main_view_update_networking_state (self);
#line 101 "../src/MainView.vala"
	_tmp35_ = network_network_manager_get_default ();
#line 101 "../src/MainView.vala"
	nm_manager = _tmp35_;
#line 102 "../src/MainView.vala"
	_tmp36_ = nm_manager;
#line 102 "../src/MainView.vala"
	_tmp37_ = network_network_manager_get_client (_tmp36_);
#line 102 "../src/MainView.vala"
	_tmp38_ = _tmp37_;
#line 102 "../src/MainView.vala"
	nm_client = _tmp38_;
#line 103 "../src/MainView.vala"
	_tmp39_ = nm_client;
#line 103 "../src/MainView.vala"
	g_signal_connect_object (_tmp39_, "connection-added", (GCallback) _network_main_view_connection_added_cb_nm_client_connection_added, self, 0);
#line 104 "../src/MainView.vala"
	_tmp40_ = nm_client;
#line 104 "../src/MainView.vala"
	g_signal_connect_object (_tmp40_, "connection-removed", (GCallback) _network_main_view_connection_removed_cb_nm_client_connection_removed, self, 0);
#line 106 "../src/MainView.vala"
	_tmp41_ = nm_client;
#line 106 "../src/MainView.vala"
	g_signal_connect_object (_tmp41_, "device-added", (GCallback) _network_main_view_device_added_cb_nm_client_device_added, self, 0);
#line 107 "../src/MainView.vala"
	_tmp42_ = nm_client;
#line 107 "../src/MainView.vala"
	g_signal_connect_object (_tmp42_, "device-removed", (GCallback) _network_main_view_device_removed_cb_nm_client_device_removed, self, 0);
#line 109 "../src/MainView.vala"
	_tmp43_ = nm_client;
#line 109 "../src/MainView.vala"
	_tmp44_ = nm_client_get_devices (_tmp43_);
#line 109 "../src/MainView.vala"
	g_ptr_array_foreach (_tmp44_, __network_main_view___lambda52__gfunc, self);
#line 110 "../src/MainView.vala"
	_tmp45_ = nm_client;
#line 110 "../src/MainView.vala"
	_tmp46_ = nm_client_get_connections (_tmp45_);
#line 110 "../src/MainView.vala"
	g_ptr_array_foreach (_tmp46_, __network_main_view___lambda53__gfunc, self);
#line 112 "../src/MainView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 30 "../src/MainView.vala"
	_g_object_unref0 (sidebar);
#line 30 "../src/MainView.vala"
	_g_object_unref0 (airplane_mode);
#line 30 "../src/MainView.vala"
	_g_object_unref0 (footer);
#line 30 "../src/MainView.vala"
	block2_data_unref (_data2_);
#line 30 "../src/MainView.vala"
	_data2_ = NULL;
#line 30 "../src/MainView.vala"
	return obj;
#line 1603 "MainView.c"
}

static void
network_main_view_class_init (NetworkMainViewClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/MainView.vala"
	network_main_view_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/MainView.vala"
	g_type_class_adjust_private_offset (klass, &NetworkMainView_private_offset);
#line 20 "../src/MainView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_main_view_get_property;
#line 20 "../src/MainView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_main_view_set_property;
#line 20 "../src/MainView.vala"
	G_OBJECT_CLASS (klass)->constructor = network_main_view_constructor;
#line 20 "../src/MainView.vala"
	G_OBJECT_CLASS (klass)->finalize = network_main_view_finalize;
#line 20 "../src/MainView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_MAIN_VIEW_STATE_PROPERTY, network_main_view_properties[NETWORK_MAIN_VIEW_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", nm_device_state_get_type (), NM_DEVICE_STATE_PREPARE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1624 "MainView.c"
}

static void
network_main_view_instance_init (NetworkMainView * self,
                                 gpointer klass)
{
#line 20 "../src/MainView.vala"
	self->priv = network_main_view_get_instance_private (self);
#line 23 "../src/MainView.vala"
	self->priv->_state = NM_DEVICE_STATE_PREPARE;
#line 25 "../src/MainView.vala"
	self->priv->current_device = NULL;
#line 1637 "MainView.c"
}

static void
network_main_view_finalize (GObject * obj)
{
	NetworkMainView * self;
#line 20 "../src/MainView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_MAIN_VIEW, NetworkMainView);
#line 21 "../src/MainView.vala"
	(self->network_interface == NULL) ? NULL : (self->network_interface = (_g_list_free__g_object_unref0_ (self->network_interface), NULL));
#line 25 "../src/MainView.vala"
	_g_object_unref0 (self->priv->current_device);
#line 26 "../src/MainView.vala"
	_g_object_unref0 (self->priv->content);
#line 27 "../src/MainView.vala"
	_g_object_unref0 (self->priv->page);
#line 28 "../src/MainView.vala"
	_g_object_unref0 (self->priv->device_list);
#line 20 "../src/MainView.vala"
	G_OBJECT_CLASS (network_main_view_parent_class)->finalize (obj);
#line 1658 "MainView.c"
}

static GType
network_main_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkMainViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_main_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkMainView), 0, (GInstanceInitFunc) network_main_view_instance_init, NULL };
	GType network_main_view_type_id;
	network_main_view_type_id = g_type_register_static (gtk_paned_get_type (), "NetworkMainView", &g_define_type_info, 0);
	NetworkMainView_private_offset = g_type_add_instance_private (network_main_view_type_id, sizeof (NetworkMainViewPrivate));
	return network_main_view_type_id;
}

GType
network_main_view_get_type (void)
{
	static volatile gsize network_main_view_type_id__once = 0;
	if (g_once_init_enter (&network_main_view_type_id__once)) {
		GType network_main_view_type_id;
		network_main_view_type_id = network_main_view_get_type_once ();
		g_once_init_leave (&network_main_view_type_id__once, network_main_view_type_id);
	}
	return network_main_view_type_id__once;
}

static void
_vala_network_main_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NetworkMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_MAIN_VIEW, NetworkMainView);
#line 20 "../src/MainView.vala"
	switch (property_id) {
#line 20 "../src/MainView.vala"
		case NETWORK_MAIN_VIEW_STATE_PROPERTY:
#line 20 "../src/MainView.vala"
		g_value_set_enum (value, network_main_view_get_state (self));
#line 20 "../src/MainView.vala"
		break;
#line 1699 "MainView.c"
		default:
#line 20 "../src/MainView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/MainView.vala"
		break;
#line 1705 "MainView.c"
	}
}

static void
_vala_network_main_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NetworkMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_MAIN_VIEW, NetworkMainView);
#line 20 "../src/MainView.vala"
	switch (property_id) {
#line 20 "../src/MainView.vala"
		case NETWORK_MAIN_VIEW_STATE_PROPERTY:
#line 20 "../src/MainView.vala"
		network_main_view_set_state (self, g_value_get_enum (value));
#line 20 "../src/MainView.vala"
		break;
#line 1725 "MainView.c"
		default:
#line 20 "../src/MainView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/MainView.vala"
		break;
#line 1731 "MainView.c"
	}
}

