/* Plug.c generated by valac 0.56.14, the Vala compiler
 * generated from Plug.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/* Strings */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "networking.h"
#include <switchboard.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

#define SUFFIX " "

enum  {
	NETWORK_PLUG_0_PROPERTY,
	NETWORK_PLUG_NUM_PROPERTIES
};
static GParamSpec* network_plug_properties[NETWORK_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _NetworkPlugSearchData NetworkPlugSearchData;

struct _NetworkPlugPrivate {
	NetworkMainView* main_view;
};

struct _NetworkPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	NetworkPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
};

static gint NetworkPlug_private_offset;
static gpointer network_plug_parent_class = NULL;
GSettings* network_plug_proxy_settings = NULL;

static GtkWidget* network_plug_real_get_widget (SwitchboardPlug* base);
static void network_plug_real_shown (SwitchboardPlug* base);
static void network_plug_real_hidden (SwitchboardPlug* base);
static void network_plug_real_search_callback (SwitchboardPlug* base,
                                        const gchar* location);
static void network_plug_real_search_data_free (gpointer _data);
static void network_plug_real_search (SwitchboardPlug* base,
                               const gchar* search,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static gboolean network_plug_real_search_co (NetworkPlugSearchData* _data_);
static void network_plug_finalize (GObject * obj);
static GType network_plug_get_type_once (void);

static inline gpointer
network_plug_get_instance_private (NetworkPlug* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkPlug_private_offset);
}

NetworkPlug*
network_plug_construct (GType object_type)
{
	NetworkPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 30 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 31 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 33 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 33 "../src/Plug.vala"
	settings = _tmp0_;
#line 34 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "network", NULL);
#line 35 "../src/Plug.vala"
	self = (NetworkPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_NETWORK, "code-name", "io.elementary.switchboard.network", "display-name", _ ("Network"), "description", _ ("Manage network devices and connectivity"), "icon", "preferences-system-network", "supported-settings", settings, NULL);
#line 29 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 29 "../src/Plug.vala"
	return self;
#line 152 "Plug.c"
}

NetworkPlug*
network_plug_new (void)
{
#line 29 "../src/Plug.vala"
	return network_plug_construct (NETWORK_TYPE_PLUG);
#line 160 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 168 "Plug.c"
}

static GtkWidget*
network_plug_real_get_widget (SwitchboardPlug* base)
{
	NetworkPlug * self;
	NetworkMainView* _tmp0_;
	NetworkMainView* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* result;
#line 47 "../src/Plug.vala"
	self = (NetworkPlug*) base;
#line 48 "../src/Plug.vala"
	_tmp0_ = self->priv->main_view;
#line 48 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 185 "Plug.c"
		NetworkMainView* _tmp1_;
#line 49 "../src/Plug.vala"
		_tmp1_ = network_main_view_new ();
#line 49 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 49 "../src/Plug.vala"
		_g_object_unref0 (self->priv->main_view);
#line 49 "../src/Plug.vala"
		self->priv->main_view = _tmp1_;
#line 195 "Plug.c"
	}
#line 52 "../src/Plug.vala"
	_tmp2_ = self->priv->main_view;
#line 52 "../src/Plug.vala"
	_tmp3_ = _g_object_ref0 ((GtkWidget*) _tmp2_);
#line 52 "../src/Plug.vala"
	result = _tmp3_;
#line 52 "../src/Plug.vala"
	return result;
#line 205 "Plug.c"
}

static void
network_plug_real_shown (SwitchboardPlug* base)
{
	NetworkPlug * self;
#line 55 "../src/Plug.vala"
	self = (NetworkPlug*) base;
#line 214 "Plug.c"
}

static void
network_plug_real_hidden (SwitchboardPlug* base)
{
	NetworkPlug * self;
#line 59 "../src/Plug.vala"
	self = (NetworkPlug*) base;
#line 223 "Plug.c"
}

static void
network_plug_real_search_callback (SwitchboardPlug* base,
                                   const gchar* location)
{
	NetworkPlug * self;
#line 63 "../src/Plug.vala"
	self = (NetworkPlug*) base;
#line 63 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 235 "Plug.c"
}

static void
network_plug_real_search_data_free (gpointer _data)
{
	NetworkPlugSearchData* _data_;
	_data_ = _data;
#line 24 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 24 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Plug.vala"
	g_slice_free (NetworkPlugSearchData, _data_);
#line 251 "Plug.c"
}

static void
network_plug_real_search (SwitchboardPlug* base,
                          const gchar* search,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	NetworkPlug * self;
	NetworkPlugSearchData* _data_;
	NetworkPlug* _tmp0_;
	gchar* _tmp1_;
#line 24 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 24 "../src/Plug.vala"
	self = (NetworkPlug*) base;
#line 24 "../src/Plug.vala"
	_data_ = g_slice_new0 (NetworkPlugSearchData);
#line 24 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, network_plug_real_search_data_free);
#line 24 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 24 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 24 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 24 "../src/Plug.vala"
	network_plug_real_search_co (_data_);
#line 286 "Plug.c"
}

static GeeTreeMap*
network_plug_search_finish (SwitchboardPlug* base,
                            GAsyncResult* _res_)
{
	GeeTreeMap* result;
	NetworkPlugSearchData* _data_;
#line 24 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/Plug.vala"
	result = _data_->result;
#line 24 "../src/Plug.vala"
	_data_->result = NULL;
#line 24 "../src/Plug.vala"
	return result;
#line 303 "Plug.c"
}

static gboolean
network_plug_real_search_co (NetworkPlugSearchData* _data_)
{
#line 68 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 68 "../src/Plug.vala"
		case 0:
#line 313 "Plug.c"
		goto _state_0;
		default:
#line 68 "../src/Plug.vala"
		g_assert_not_reached ();
#line 318 "Plug.c"
	}
	_state_0:
#line 69 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 69 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 69 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 69 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 70 "../src/Plug.vala"
	_data_->_tmp3_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 70 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 70 "../src/Plug.vala"
	_data_->_tmp5_ = g_strdup_printf ("%s → %s", _data_->_tmp4_, _ ("Ethernet"));
#line 70 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 70 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp6_, "");
#line 70 "../src/Plug.vala"
	_g_free0 (_data_->_tmp6_);
#line 71 "../src/Plug.vala"
	_data_->_tmp7_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 71 "../src/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 71 "../src/Plug.vala"
	_data_->_tmp9_ = g_strdup_printf ("%s → %s", _data_->_tmp8_, _ ("LAN"));
#line 71 "../src/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 71 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp10_, "");
#line 71 "../src/Plug.vala"
	_g_free0 (_data_->_tmp10_);
#line 72 "../src/Plug.vala"
	_data_->_tmp11_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 72 "../src/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 72 "../src/Plug.vala"
	_data_->_tmp13_ = g_strdup_printf ("%s → %s", _data_->_tmp12_, _ ("Wireless"));
#line 72 "../src/Plug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 72 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp14_, "");
#line 72 "../src/Plug.vala"
	_g_free0 (_data_->_tmp14_);
#line 73 "../src/Plug.vala"
	_data_->_tmp15_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 73 "../src/Plug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 73 "../src/Plug.vala"
	_data_->_tmp17_ = g_strdup_printf ("%s → %s", _data_->_tmp16_, _ ("Wi-Fi"));
#line 73 "../src/Plug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 73 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp18_, "");
#line 73 "../src/Plug.vala"
	_g_free0 (_data_->_tmp18_);
#line 74 "../src/Plug.vala"
	_data_->_tmp19_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 74 "../src/Plug.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 74 "../src/Plug.vala"
	_data_->_tmp21_ = g_strdup_printf ("%s → %s", _data_->_tmp20_, _ ("WLAN"));
#line 74 "../src/Plug.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 74 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp22_, "");
#line 74 "../src/Plug.vala"
	_g_free0 (_data_->_tmp22_);
#line 75 "../src/Plug.vala"
	_data_->_tmp23_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 75 "../src/Plug.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 75 "../src/Plug.vala"
	_data_->_tmp25_ = g_strdup_printf ("%s → %s", _data_->_tmp24_, _ ("Proxy"));
#line 75 "../src/Plug.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 75 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp26_, "");
#line 75 "../src/Plug.vala"
	_g_free0 (_data_->_tmp26_);
#line 76 "../src/Plug.vala"
	_data_->_tmp27_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 76 "../src/Plug.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 76 "../src/Plug.vala"
	_data_->_tmp29_ = g_strdup_printf ("%s → %s", _data_->_tmp28_, _ ("Airplane Mode"));
#line 76 "../src/Plug.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 76 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp30_, "");
#line 76 "../src/Plug.vala"
	_g_free0 (_data_->_tmp30_);
#line 77 "../src/Plug.vala"
	_data_->_tmp31_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 77 "../src/Plug.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 77 "../src/Plug.vala"
	_data_->_tmp33_ = g_strdup_printf ("%s → %s", _data_->_tmp32_, _ ("IP Address"));
#line 77 "../src/Plug.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 77 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp34_, "");
#line 77 "../src/Plug.vala"
	_g_free0 (_data_->_tmp34_);
#line 78 "../src/Plug.vala"
	_data_->_tmp35_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 78 "../src/Plug.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 78 "../src/Plug.vala"
	_data_->_tmp37_ = g_strdup_printf ("%s → %s", _data_->_tmp36_, _ ("Hotspot"));
#line 78 "../src/Plug.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 78 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp38_, "");
#line 78 "../src/Plug.vala"
	_g_free0 (_data_->_tmp38_);
#line 79 "../src/Plug.vala"
	_data_->_tmp39_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 79 "../src/Plug.vala"
	_data_->_tmp40_ = _data_->_tmp39_;
#line 79 "../src/Plug.vala"
	_data_->_tmp41_ = g_strdup_printf ("%s → %s", _data_->_tmp40_, _ ("VPN"));
#line 79 "../src/Plug.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 79 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp42_, "");
#line 79 "../src/Plug.vala"
	_g_free0 (_data_->_tmp42_);
#line 80 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 80 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 80 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 80 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 80 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 459 "Plug.c"
		}
	}
#line 80 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 80 "../src/Plug.vala"
	return FALSE;
#line 466 "Plug.c"
}

static void
network_plug_class_init (NetworkPlugClass * klass,
                         gpointer klass_data)
{
	GSettings* _tmp0_;
#line 24 "../src/Plug.vala"
	network_plug_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &NetworkPlug_private_offset);
#line 24 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) network_plug_real_get_widget;
#line 24 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) network_plug_real_shown;
#line 24 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) network_plug_real_hidden;
#line 24 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) network_plug_real_search_callback;
#line 24 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) network_plug_real_search;
#line 24 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) network_plug_search_finish;
#line 24 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = network_plug_finalize;
#line 44 "../src/Plug.vala"
	_tmp0_ = g_settings_new ("org.gnome.system.proxy");
#line 44 "../src/Plug.vala"
	_g_object_unref0 (network_plug_proxy_settings);
#line 44 "../src/Plug.vala"
	network_plug_proxy_settings = _tmp0_;
#line 498 "Plug.c"
}

static void
network_plug_instance_init (NetworkPlug * self,
                            gpointer klass)
{
#line 24 "../src/Plug.vala"
	self->priv = network_plug_get_instance_private (self);
#line 25 "../src/Plug.vala"
	self->priv->main_view = NULL;
#line 509 "Plug.c"
}

static void
network_plug_finalize (GObject * obj)
{
	NetworkPlug * self;
#line 24 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_PLUG, NetworkPlug);
#line 25 "../src/Plug.vala"
	_g_object_unref0 (self->priv->main_view);
#line 24 "../src/Plug.vala"
	G_OBJECT_CLASS (network_plug_parent_class)->finalize (obj);
#line 522 "Plug.c"
}

static GType
network_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkPlug), 0, (GInstanceInitFunc) network_plug_instance_init, NULL };
	GType network_plug_type_id;
	network_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "NetworkPlug", &g_define_type_info, 0);
	NetworkPlug_private_offset = g_type_add_instance_private (network_plug_type_id, sizeof (NetworkPlugPrivate));
	return network_plug_type_id;
}

GType
network_plug_get_type (void)
{
	static volatile gsize network_plug_type_id__once = 0;
	if (g_once_init_enter (&network_plug_type_id__once)) {
		GType network_plug_type_id;
		network_plug_type_id = network_plug_get_type_once ();
		g_once_init_leave (&network_plug_type_id__once, network_plug_type_id);
	}
	return network_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	NetworkPlug* plug = NULL;
	NetworkPlug* _tmp0_;
	SwitchboardPlug* result;
#line 85 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 86 "../src/Plug.vala"
	g_debug ("Plug.vala:86: Activating Network plug");
#line 88 "../src/Plug.vala"
	_tmp0_ = network_plug_new ();
#line 88 "../src/Plug.vala"
	plug = _tmp0_;
#line 89 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 89 "../src/Plug.vala"
	return result;
#line 565 "Plug.c"
}

