/* VPNPage.c generated by valac 0.56.14, the Vala compiler
 * generated from VPNPage.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <gee.h>
#include <glib-object.h>
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	NETWORK_VPN_PAGE_0_PROPERTY,
	NETWORK_VPN_PAGE_OWNER_PROPERTY,
	NETWORK_VPN_PAGE_NUM_PROPERTIES
};
static GParamSpec* network_vpn_page_properties[NETWORK_VPN_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;

struct _NetworkVPNPagePrivate {
	NetworkWidgetsDeviceItem* _owner;
	GeeList* active_connections;
	GtkListBox* vpn_list;
	guint timeout_id;
	NetworkVPNMenuItem* sel_row;
	GraniteWidgetsToast* remove_vpn_toast;
};

struct _Block4Data {
	int _ref_count_;
	NetworkVPNPage* self;
	NetworkNetworkManager* network_manager;
};

struct _Block5Data {
	int _ref_count_;
	NetworkVPNPage* self;
	NetworkNetworkManager* network_manager;
};

struct _Block6Data {
	int _ref_count_;
	NetworkVPNPage* self;
	GtkButton* remove_button;
	GtkButton* edit_connection_button;
};

static gint NetworkVPNPage_private_offset;
static gpointer network_vpn_page_parent_class = NULL;

static void network_vpn_page_real_update (NetworkWidgetsPage* base);
static void network_vpn_page_update_active_connections (NetworkVPNPage* self);
static NetworkVPNMenuItem* network_vpn_page_get_item_by_uuid (NetworkVPNPage* self,
                                                       const gchar* uuid);
static void network_vpn_page_real_update_switch (NetworkWidgetsPage* base);
static void network_vpn_page_real_control_switch_activated (NetworkWidgetsPage* base);
static void __lambda25_ (NetworkVPNPage* self,
                  NMActiveConnection* ac);
static void _network_widgets_page_update_nm_vpn_connection_vpn_state_changed (NMVpnConnection* _sender,
                                                                       guint object,
                                                                       guint p0,
                                                                       gpointer self);
static void _network_widgets_page_update_nm_active_connection_state_changed (NMActiveConnection* _sender,
                                                                      guint state,
                                                                      guint reason,
                                                                      gpointer self);
static void ___lambda25__gfunc (gconstpointer data,
                         gpointer self);
static void network_vpn_page_connect_vpn_cb (NetworkVPNPage* self,
                                      NetworkVPNMenuItem* item);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda26_ (Block4Data* _data4_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda26__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void network_vpn_page_disconnect_vpn_cb (NetworkVPNPage* self,
                                         NetworkVPNMenuItem* item);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _____lambda27_ (Block5Data* _data5_,
                     GObject* obj,
                     GAsyncResult* res);
static void ______lambda27__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static void network_vpn_page_remove_button_cb (NetworkVPNPage* self);
static gboolean ____lambda28_ (NetworkVPNPage* self);
static void network_vpn_page_delete_connection (NetworkVPNPage* self);
static gboolean _____lambda28__gsource_func (gpointer self);
static void network_vpn_page_try_connection_editor (NetworkVPNPage* self,
                                             const gchar* args);
static gint network_vpn_page_compare_rows (NetworkVPNMenuItem* row1,
                                    NetworkVPNMenuItem* row2,
                                    NetworkVPNPage* self);
static GObject * network_vpn_page_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _network_vpn_page___lambda29_ (NetworkVPNPage* self);
static void __network_vpn_page___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _network_vpn_page_remove_button_cb_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void _network_vpn_page___lambda30_ (NetworkVPNPage* self);
static void __network_vpn_page___lambda30__granite_widgets_toast_default_action (GraniteWidgetsToast* _sender,
                                                                          gpointer self);
static void _network_vpn_page___lambda31_ (NetworkVPNPage* self);
static void __network_vpn_page___lambda31__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _network_vpn_page___lambda32_ (NetworkVPNPage* self,
                                    GtkListBoxRow* row);
static void __network_vpn_page___lambda32__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                GtkListBoxRow* row,
                                                                gpointer self);
static void _network_vpn_page___lambda33_ (Block6Data* _data6_,
                                    GtkListBoxRow* row);
static void __network_vpn_page___lambda33__gtk_list_box_row_selected (GtkListBox* _sender,
                                                               GtkListBoxRow* row,
                                                               gpointer self);
static void _network_vpn_page_update_active_connections_g_object_notify (GObject* _sender,
                                                                  GParamSpec* pspec,
                                                                  gpointer self);
static void network_vpn_page_finalize (GObject * obj);
static GType network_vpn_page_get_type_once (void);
static void _vala_network_vpn_page_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_network_vpn_page_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
network_vpn_page_get_instance_private (NetworkVPNPage* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVPNPage_private_offset);
}

NetworkVPNPage*
network_vpn_page_construct (GType object_type,
                            NetworkWidgetsDeviceItem* owner)
{
	NetworkVPNPage * self = NULL;
#line 29 "../src/Views/VPNPage.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 30 "../src/Views/VPNPage.vala"
	self = (NetworkVPNPage*) g_object_new (object_type, "owner", owner, "title", _ ("Virtual Private Network"), "icon-name", "network-vpn", NULL);
#line 29 "../src/Views/VPNPage.vala"
	return self;
#line 184 "VPNPage.c"
}

NetworkVPNPage*
network_vpn_page_new (NetworkWidgetsDeviceItem* owner)
{
#line 29 "../src/Views/VPNPage.vala"
	return network_vpn_page_construct (NETWORK_TYPE_VPN_PAGE, owner);
#line 192 "VPNPage.c"
}

static void
network_vpn_page_real_update (NetworkWidgetsPage* base)
{
	NetworkVPNPage * self;
	NetworkVPNMenuItem* item = NULL;
	NetworkWidgetsDeviceItem* _tmp24_;
	NMDeviceState _tmp25_;
	NMDeviceState _tmp26_;
#line 135 "../src/Views/VPNPage.vala"
	self = (NetworkVPNPage*) base;
#line 136 "../src/Views/VPNPage.vala"
	network_vpn_page_update_active_connections (self);
#line 138 "../src/Views/VPNPage.vala"
	item = NULL;
#line 209 "VPNPage.c"
	{
		GeeList* _ac_list = NULL;
		GeeList* _tmp0_;
		gint _ac_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _ac_index = 0;
#line 139 "../src/Views/VPNPage.vala"
		_tmp0_ = self->priv->active_connections;
#line 139 "../src/Views/VPNPage.vala"
		_ac_list = _tmp0_;
#line 139 "../src/Views/VPNPage.vala"
		_tmp1_ = _ac_list;
#line 139 "../src/Views/VPNPage.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 139 "../src/Views/VPNPage.vala"
		_tmp3_ = _tmp2_;
#line 139 "../src/Views/VPNPage.vala"
		_ac_size = _tmp3_;
#line 139 "../src/Views/VPNPage.vala"
		_ac_index = -1;
#line 139 "../src/Views/VPNPage.vala"
		while (TRUE) {
#line 234 "VPNPage.c"
			gint _tmp4_;
			gint _tmp5_;
			NMActiveConnection* ac = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			NMActiveConnection* _tmp8_;
			NetworkVPNMenuItem* _tmp20_;
#line 139 "../src/Views/VPNPage.vala"
			_ac_index = _ac_index + 1;
#line 139 "../src/Views/VPNPage.vala"
			_tmp4_ = _ac_index;
#line 139 "../src/Views/VPNPage.vala"
			_tmp5_ = _ac_size;
#line 139 "../src/Views/VPNPage.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 139 "../src/Views/VPNPage.vala"
				break;
#line 252 "VPNPage.c"
			}
#line 139 "../src/Views/VPNPage.vala"
			_tmp6_ = _ac_list;
#line 139 "../src/Views/VPNPage.vala"
			_tmp7_ = gee_list_get (_tmp6_, _ac_index);
#line 139 "../src/Views/VPNPage.vala"
			ac = (NMActiveConnection*) _tmp7_;
#line 140 "../src/Views/VPNPage.vala"
			_tmp8_ = ac;
#line 140 "../src/Views/VPNPage.vala"
			if (_tmp8_ != NULL) {
#line 264 "VPNPage.c"
				const gchar* connection_type = NULL;
				NMActiveConnection* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				NMActiveConnection* _tmp17_;
				const gchar* _tmp18_;
				NetworkVPNMenuItem* _tmp19_;
#line 141 "../src/Views/VPNPage.vala"
				_tmp9_ = ac;
#line 141 "../src/Views/VPNPage.vala"
				_tmp10_ = nm_active_connection_get_connection_type (_tmp9_);
#line 141 "../src/Views/VPNPage.vala"
				connection_type = _tmp10_;
#line 142 "../src/Views/VPNPage.vala"
				_tmp11_ = connection_type;
#line 142 "../src/Views/VPNPage.vala"
				if (g_strcmp0 (_tmp11_, NM_SETTING_VPN_SETTING_NAME) == 0) {
#line 282 "VPNPage.c"
					NMActiveConnection* _tmp12_;
					NMVpnConnectionState _tmp13_;
					NMVpnConnectionState _tmp14_;
#line 143 "../src/Views/VPNPage.vala"
					_tmp12_ = ac;
#line 143 "../src/Views/VPNPage.vala"
					_tmp13_ = nm_vpn_connection_get_vpn_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, nm_vpn_connection_get_type (), NMVpnConnection));
#line 143 "../src/Views/VPNPage.vala"
					_tmp14_ = _tmp13_;
#line 143 "../src/Views/VPNPage.vala"
					switch (_tmp14_) {
#line 143 "../src/Views/VPNPage.vala"
						case NM_VPN_CONNECTION_STATE_UNKNOWN:
#line 143 "../src/Views/VPNPage.vala"
						case NM_VPN_CONNECTION_STATE_DISCONNECTED:
#line 298 "VPNPage.c"
						{
#line 146 "../src/Views/VPNPage.vala"
							network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_DISCONNECTED);
#line 147 "../src/Views/VPNPage.vala"
							break;
#line 304 "VPNPage.c"
						}
#line 143 "../src/Views/VPNPage.vala"
						case NM_VPN_CONNECTION_STATE_PREPARE:
#line 143 "../src/Views/VPNPage.vala"
						case NM_VPN_CONNECTION_STATE_NEED_AUTH:
#line 143 "../src/Views/VPNPage.vala"
						case NM_VPN_CONNECTION_STATE_IP_CONFIG_GET:
#line 143 "../src/Views/VPNPage.vala"
						case NM_VPN_CONNECTION_STATE_CONNECT:
#line 314 "VPNPage.c"
						{
#line 152 "../src/Views/VPNPage.vala"
							network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_PREPARE);
#line 153 "../src/Views/VPNPage.vala"
							break;
#line 320 "VPNPage.c"
						}
#line 143 "../src/Views/VPNPage.vala"
						case NM_VPN_CONNECTION_STATE_FAILED:
#line 324 "VPNPage.c"
						{
#line 155 "../src/Views/VPNPage.vala"
							network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_FAILED);
#line 156 "../src/Views/VPNPage.vala"
							break;
#line 330 "VPNPage.c"
						}
#line 143 "../src/Views/VPNPage.vala"
						case NM_VPN_CONNECTION_STATE_ACTIVATED:
#line 334 "VPNPage.c"
						{
#line 158 "../src/Views/VPNPage.vala"
							network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_ACTIVATED);
#line 159 "../src/Views/VPNPage.vala"
							break;
#line 340 "VPNPage.c"
						}
						default:
#line 143 "../src/Views/VPNPage.vala"
						break;
#line 345 "VPNPage.c"
					}
				} else {
					const gchar* _tmp15_;
#line 161 "../src/Views/VPNPage.vala"
					_tmp15_ = connection_type;
#line 161 "../src/Views/VPNPage.vala"
					if (g_strcmp0 (_tmp15_, NM_SETTING_WIREGUARD_SETTING_NAME) == 0) {
#line 353 "VPNPage.c"
						NMActiveConnection* _tmp16_;
#line 162 "../src/Views/VPNPage.vala"
						_tmp16_ = ac;
#line 162 "../src/Views/VPNPage.vala"
						switch (nm_active_connection_get_state (_tmp16_)) {
#line 162 "../src/Views/VPNPage.vala"
							case NM_ACTIVE_CONNECTION_STATE_UNKNOWN:
#line 162 "../src/Views/VPNPage.vala"
							case NM_ACTIVE_CONNECTION_STATE_DEACTIVATED:
#line 162 "../src/Views/VPNPage.vala"
							case NM_ACTIVE_CONNECTION_STATE_DEACTIVATING:
#line 365 "VPNPage.c"
							{
#line 166 "../src/Views/VPNPage.vala"
								network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_DISCONNECTED);
#line 167 "../src/Views/VPNPage.vala"
								break;
#line 371 "VPNPage.c"
							}
#line 162 "../src/Views/VPNPage.vala"
							case NM_ACTIVE_CONNECTION_STATE_ACTIVATING:
#line 375 "VPNPage.c"
							{
#line 169 "../src/Views/VPNPage.vala"
								network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_PREPARE);
#line 170 "../src/Views/VPNPage.vala"
								break;
#line 381 "VPNPage.c"
							}
#line 162 "../src/Views/VPNPage.vala"
							case NM_ACTIVE_CONNECTION_STATE_ACTIVATED:
#line 385 "VPNPage.c"
							{
#line 172 "../src/Views/VPNPage.vala"
								network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_ACTIVATED);
#line 173 "../src/Views/VPNPage.vala"
								break;
#line 391 "VPNPage.c"
							}
							default:
#line 162 "../src/Views/VPNPage.vala"
							break;
#line 396 "VPNPage.c"
						}
					}
				}
#line 177 "../src/Views/VPNPage.vala"
				_tmp17_ = ac;
#line 177 "../src/Views/VPNPage.vala"
				_tmp18_ = nm_active_connection_get_uuid (_tmp17_);
#line 177 "../src/Views/VPNPage.vala"
				_tmp19_ = network_vpn_page_get_item_by_uuid (self, _tmp18_);
#line 177 "../src/Views/VPNPage.vala"
				_g_object_unref0 (item);
#line 177 "../src/Views/VPNPage.vala"
				item = _tmp19_;
#line 410 "VPNPage.c"
			} else {
#line 179 "../src/Views/VPNPage.vala"
				network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_DISCONNECTED);
#line 414 "VPNPage.c"
			}
#line 182 "../src/Views/VPNPage.vala"
			_tmp20_ = item;
#line 182 "../src/Views/VPNPage.vala"
			if (_tmp20_ != NULL) {
#line 420 "VPNPage.c"
				NetworkVPNMenuItem* _tmp21_;
				NMDeviceState _tmp22_;
				NMDeviceState _tmp23_;
#line 183 "../src/Views/VPNPage.vala"
				_tmp21_ = item;
#line 183 "../src/Views/VPNPage.vala"
				_tmp22_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
#line 183 "../src/Views/VPNPage.vala"
				_tmp23_ = _tmp22_;
#line 183 "../src/Views/VPNPage.vala"
				network_vpn_menu_item_set_state (_tmp21_, _tmp23_);
#line 432 "VPNPage.c"
			}
#line 139 "../src/Views/VPNPage.vala"
			_g_object_unref0 (ac);
#line 436 "VPNPage.c"
		}
	}
#line 187 "../src/Views/VPNPage.vala"
	_tmp24_ = self->priv->_owner;
#line 187 "../src/Views/VPNPage.vala"
	_tmp25_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
#line 187 "../src/Views/VPNPage.vala"
	_tmp26_ = _tmp25_;
#line 187 "../src/Views/VPNPage.vala"
	network_widgets_device_item_switch_status (_tmp24_, NETWORK_UTILS_CUSTOM_MODE_INVALID, &_tmp26_);
#line 188 "../src/Views/VPNPage.vala"
	network_widgets_page_update_switch ((NetworkWidgetsPage*) self);
#line 135 "../src/Views/VPNPage.vala"
	_g_object_unref0 (item);
#line 451 "VPNPage.c"
}

static void
network_vpn_page_real_update_switch (NetworkWidgetsPage* base)
{
	NetworkVPNPage * self;
#line 191 "../src/Views/VPNPage.vala"
	self = (NetworkVPNPage*) base;
#line 460 "VPNPage.c"
}

static void
network_vpn_page_real_control_switch_activated (NetworkWidgetsPage* base)
{
	NetworkVPNPage * self;
#line 195 "../src/Views/VPNPage.vala"
	self = (NetworkVPNPage*) base;
#line 469 "VPNPage.c"
}

void
network_vpn_page_add_connection (NetworkVPNPage* self,
                                 NMRemoteConnection* connection)
{
	NetworkVPNMenuItem* item = NULL;
	NetworkVPNMenuItem* _tmp0_;
	GtkListBox* _tmp1_;
#line 199 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/Views/VPNPage.vala"
	g_return_if_fail (connection != NULL);
#line 200 "../src/Views/VPNPage.vala"
	_tmp0_ = network_vpn_menu_item_new (connection);
#line 200 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp0_);
#line 200 "../src/Views/VPNPage.vala"
	item = _tmp0_;
#line 202 "../src/Views/VPNPage.vala"
	_tmp1_ = self->priv->vpn_list;
#line 202 "../src/Views/VPNPage.vala"
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) item);
#line 203 "../src/Views/VPNPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 204 "../src/Views/VPNPage.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 199 "../src/Views/VPNPage.vala"
	_g_object_unref0 (item);
#line 499 "VPNPage.c"
}

void
network_vpn_page_remove_connection (NetworkVPNPage* self,
                                    NMRemoteConnection* connection)
{
	NetworkVPNMenuItem* item = NULL;
	const gchar* _tmp0_;
	NetworkVPNMenuItem* _tmp1_;
#line 207 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/Views/VPNPage.vala"
	g_return_if_fail (connection != NULL);
#line 208 "../src/Views/VPNPage.vala"
	_tmp0_ = nm_connection_get_uuid ((NMConnection*) connection);
#line 208 "../src/Views/VPNPage.vala"
	_tmp1_ = network_vpn_page_get_item_by_uuid (self, _tmp0_);
#line 208 "../src/Views/VPNPage.vala"
	item = _tmp1_;
#line 209 "../src/Views/VPNPage.vala"
	gtk_widget_destroy ((GtkWidget*) item);
#line 207 "../src/Views/VPNPage.vala"
	_g_object_unref0 (item);
#line 523 "VPNPage.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 215 "../src/Views/VPNPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 531 "VPNPage.c"
}

static NetworkVPNMenuItem*
network_vpn_page_get_item_by_uuid (NetworkVPNPage* self,
                                   const gchar* uuid)
{
	NetworkVPNMenuItem* item = NULL;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	NetworkVPNMenuItem* result;
#line 212 "../src/Views/VPNPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "../src/Views/VPNPage.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 213 "../src/Views/VPNPage.vala"
	item = NULL;
#line 214 "../src/Views/VPNPage.vala"
	_tmp0_ = self->priv->vpn_list;
#line 214 "../src/Views/VPNPage.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 552 "VPNPage.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 214 "../src/Views/VPNPage.vala"
		child_collection = _tmp1_;
#line 214 "../src/Views/VPNPage.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 560 "VPNPage.c"
			GtkWidget* child = NULL;
#line 214 "../src/Views/VPNPage.vala"
			child = (GtkWidget*) child_it->data;
#line 564 "VPNPage.c"
			{
				NetworkVPNMenuItem* _item = NULL;
				GtkWidget* _tmp2_;
				NetworkVPNMenuItem* _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				NetworkVPNMenuItem* _tmp6_;
				NMRemoteConnection* _tmp7_;
				NMRemoteConnection* _tmp8_;
#line 215 "../src/Views/VPNPage.vala"
				_tmp2_ = child;
#line 215 "../src/Views/VPNPage.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
#line 215 "../src/Views/VPNPage.vala"
				_item = _tmp3_;
#line 216 "../src/Views/VPNPage.vala"
				_tmp6_ = _item;
#line 216 "../src/Views/VPNPage.vala"
				_tmp7_ = network_vpn_menu_item_get_connection (_tmp6_);
#line 216 "../src/Views/VPNPage.vala"
				_tmp8_ = _tmp7_;
#line 216 "../src/Views/VPNPage.vala"
				if (_tmp8_ != NULL) {
#line 588 "VPNPage.c"
					NetworkVPNMenuItem* _tmp9_;
					NMRemoteConnection* _tmp10_;
					NMRemoteConnection* _tmp11_;
					const gchar* _tmp12_;
#line 216 "../src/Views/VPNPage.vala"
					_tmp9_ = _item;
#line 216 "../src/Views/VPNPage.vala"
					_tmp10_ = network_vpn_menu_item_get_connection (_tmp9_);
#line 216 "../src/Views/VPNPage.vala"
					_tmp11_ = _tmp10_;
#line 216 "../src/Views/VPNPage.vala"
					_tmp12_ = nm_connection_get_uuid ((NMConnection*) _tmp11_);
#line 216 "../src/Views/VPNPage.vala"
					_tmp5_ = g_strcmp0 (_tmp12_, uuid) == 0;
#line 603 "VPNPage.c"
				} else {
#line 216 "../src/Views/VPNPage.vala"
					_tmp5_ = FALSE;
#line 607 "VPNPage.c"
				}
#line 216 "../src/Views/VPNPage.vala"
				if (_tmp5_) {
#line 611 "VPNPage.c"
					NetworkVPNMenuItem* _tmp13_;
#line 216 "../src/Views/VPNPage.vala"
					_tmp13_ = item;
#line 216 "../src/Views/VPNPage.vala"
					_tmp4_ = _tmp13_ == NULL;
#line 617 "VPNPage.c"
				} else {
#line 216 "../src/Views/VPNPage.vala"
					_tmp4_ = FALSE;
#line 621 "VPNPage.c"
				}
#line 216 "../src/Views/VPNPage.vala"
				if (_tmp4_) {
#line 625 "VPNPage.c"
					GtkWidget* _tmp14_;
					NetworkVPNMenuItem* _tmp15_;
#line 217 "../src/Views/VPNPage.vala"
					_tmp14_ = child;
#line 217 "../src/Views/VPNPage.vala"
					_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
#line 217 "../src/Views/VPNPage.vala"
					_g_object_unref0 (item);
#line 217 "../src/Views/VPNPage.vala"
					item = _tmp15_;
#line 636 "VPNPage.c"
				}
#line 214 "../src/Views/VPNPage.vala"
				_g_object_unref0 (_item);
#line 640 "VPNPage.c"
			}
		}
#line 214 "../src/Views/VPNPage.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 645 "VPNPage.c"
	}
#line 221 "../src/Views/VPNPage.vala"
	result = item;
#line 221 "../src/Views/VPNPage.vala"
	return result;
#line 651 "VPNPage.c"
}

static void
_network_widgets_page_update_nm_vpn_connection_vpn_state_changed (NMVpnConnection* _sender,
                                                                  guint object,
                                                                  guint p0,
                                                                  gpointer self)
{
#line 238 "../src/Views/VPNPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 662 "VPNPage.c"
}

static void
_network_widgets_page_update_nm_active_connection_state_changed (NMActiveConnection* _sender,
                                                                 guint state,
                                                                 guint reason,
                                                                 gpointer self)
{
#line 241 "../src/Views/VPNPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 673 "VPNPage.c"
}

static void
__lambda25_ (NetworkVPNPage* self,
             NMActiveConnection* ac)
{
	const gchar* connection_type = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GeeList* _tmp8_;
#line 227 "../src/Views/VPNPage.vala"
	g_return_if_fail (ac != NULL);
#line 228 "../src/Views/VPNPage.vala"
	_tmp0_ = nm_active_connection_get_connection_type (ac);
#line 228 "../src/Views/VPNPage.vala"
	connection_type = _tmp0_;
#line 232 "../src/Views/VPNPage.vala"
	_tmp1_ = connection_type;
#line 232 "../src/Views/VPNPage.vala"
	if (g_strcmp0 (_tmp1_, NM_SETTING_VPN_SETTING_NAME) == 0) {
#line 694 "VPNPage.c"
		NMVpnConnection* _connection = NULL;
		NMVpnConnection* _tmp2_;
		NMVpnConnection* _tmp3_;
		guint _tmp4_;
		NMVpnConnection* _tmp5_;
#line 237 "../src/Views/VPNPage.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ac, nm_vpn_connection_get_type (), NMVpnConnection));
#line 237 "../src/Views/VPNPage.vala"
		_connection = _tmp2_;
#line 238 "../src/Views/VPNPage.vala"
		_tmp3_ = _connection;
#line 238 "../src/Views/VPNPage.vala"
		g_signal_parse_name ("vpn-state-changed", nm_vpn_connection_get_type (), &_tmp4_, NULL, FALSE);
#line 238 "../src/Views/VPNPage.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _network_widgets_page_update_nm_vpn_connection_vpn_state_changed, (NetworkWidgetsPage*) self);
#line 239 "../src/Views/VPNPage.vala"
		_tmp5_ = _connection;
#line 239 "../src/Views/VPNPage.vala"
		g_signal_connect_object (_tmp5_, "vpn-state-changed", (GCallback) _network_widgets_page_update_nm_vpn_connection_vpn_state_changed, (NetworkWidgetsPage*) self, 0);
#line 232 "../src/Views/VPNPage.vala"
		_g_object_unref0 (_connection);
#line 716 "VPNPage.c"
	} else {
		const gchar* _tmp6_;
#line 240 "../src/Views/VPNPage.vala"
		_tmp6_ = connection_type;
#line 240 "../src/Views/VPNPage.vala"
		if (g_strcmp0 (_tmp6_, NM_SETTING_WIREGUARD_SETTING_NAME) == 0) {
#line 723 "VPNPage.c"
			guint _tmp7_;
#line 241 "../src/Views/VPNPage.vala"
			g_signal_parse_name ("state-changed", nm_active_connection_get_type (), &_tmp7_, NULL, FALSE);
#line 241 "../src/Views/VPNPage.vala"
			g_signal_handlers_disconnect_matched (ac, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _network_widgets_page_update_nm_active_connection_state_changed, (NetworkWidgetsPage*) self);
#line 242 "../src/Views/VPNPage.vala"
			g_signal_connect_object (ac, "state-changed", (GCallback) _network_widgets_page_update_nm_active_connection_state_changed, (NetworkWidgetsPage*) self, 0);
#line 731 "VPNPage.c"
		} else {
#line 246 "../src/Views/VPNPage.vala"
			return;
#line 735 "VPNPage.c"
		}
	}
#line 249 "../src/Views/VPNPage.vala"
	_tmp8_ = self->priv->active_connections;
#line 249 "../src/Views/VPNPage.vala"
	gee_collection_add ((GeeCollection*) _tmp8_, ac);
#line 742 "VPNPage.c"
}

static void
___lambda25__gfunc (gconstpointer data,
                    gpointer self)
{
#line 227 "../src/Views/VPNPage.vala"
	__lambda25_ ((NetworkVPNPage*) self, (NMActiveConnection*) data);
#line 751 "VPNPage.c"
}

static void
network_vpn_page_update_active_connections (NetworkVPNPage* self)
{
	GeeList* _tmp0_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp1_;
	NMClient* _tmp2_;
	NMClient* _tmp3_;
	GPtrArray* _tmp4_;
#line 224 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/Views/VPNPage.vala"
	_tmp0_ = self->priv->active_connections;
#line 225 "../src/Views/VPNPage.vala"
	gee_collection_clear ((GeeCollection*) _tmp0_);
#line 226 "../src/Views/VPNPage.vala"
	_tmp1_ = network_network_manager_get_default ();
#line 226 "../src/Views/VPNPage.vala"
	network_manager = _tmp1_;
#line 227 "../src/Views/VPNPage.vala"
	_tmp2_ = network_network_manager_get_client (network_manager);
#line 227 "../src/Views/VPNPage.vala"
	_tmp3_ = _tmp2_;
#line 227 "../src/Views/VPNPage.vala"
	_tmp4_ = nm_client_get_active_connections (_tmp3_);
#line 227 "../src/Views/VPNPage.vala"
	g_ptr_array_foreach (_tmp4_, ___lambda25__gfunc, self);
#line 781 "VPNPage.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 253 "../src/Views/VPNPage.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 253 "../src/Views/VPNPage.vala"
	return _data4_;
#line 791 "VPNPage.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 253 "../src/Views/VPNPage.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 801 "VPNPage.c"
		NetworkVPNPage* self;
#line 253 "../src/Views/VPNPage.vala"
		self = _data4_->self;
#line 253 "../src/Views/VPNPage.vala"
		_g_object_unref0 (self);
#line 253 "../src/Views/VPNPage.vala"
		g_slice_free (Block4Data, _data4_);
#line 809 "VPNPage.c"
	}
}

static void
__lambda26_ (Block4Data* _data4_,
             GObject* obj,
             GAsyncResult* res)
{
	NetworkVPNPage* self;
	GError* _inner_error0_ = NULL;
#line 257 "../src/Views/VPNPage.vala"
	self = _data4_->self;
#line 257 "../src/Views/VPNPage.vala"
	g_return_if_fail (res != NULL);
#line 824 "VPNPage.c"
	{
		NMClient* _tmp0_;
		NMClient* _tmp1_;
		NMActiveConnection* _tmp2_;
		NMActiveConnection* _tmp3_;
#line 259 "../src/Views/VPNPage.vala"
		_tmp0_ = network_network_manager_get_client (_data4_->network_manager);
#line 259 "../src/Views/VPNPage.vala"
		_tmp1_ = _tmp0_;
#line 259 "../src/Views/VPNPage.vala"
		_tmp2_ = nm_client_activate_connection_finish (_tmp1_, res, &_inner_error0_);
#line 259 "../src/Views/VPNPage.vala"
		_tmp3_ = _tmp2_;
#line 259 "../src/Views/VPNPage.vala"
		_g_object_unref0 (_tmp3_);
#line 259 "../src/Views/VPNPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 842 "VPNPage.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 258 "../src/Views/VPNPage.vala"
		e = _inner_error0_;
#line 258 "../src/Views/VPNPage.vala"
		_inner_error0_ = NULL;
#line 261 "../src/Views/VPNPage.vala"
		_tmp4_ = e;
#line 261 "../src/Views/VPNPage.vala"
		_tmp5_ = _tmp4_->message;
#line 261 "../src/Views/VPNPage.vala"
		g_warning ("VPNPage.vala:261: %s", _tmp5_);
#line 258 "../src/Views/VPNPage.vala"
		_g_error_free0 (e);
#line 864 "VPNPage.c"
	}
	__finally0:
#line 258 "../src/Views/VPNPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "../src/Views/VPNPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "../src/Views/VPNPage.vala"
		g_clear_error (&_inner_error0_);
#line 258 "../src/Views/VPNPage.vala"
		return;
#line 875 "VPNPage.c"
	}
#line 263 "../src/Views/VPNPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 879 "VPNPage.c"
}

static void
___lambda26__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 255 "../src/Views/VPNPage.vala"
	__lambda26_ (self, source_object, res);
#line 255 "../src/Views/VPNPage.vala"
	block4_data_unref (self);
#line 891 "VPNPage.c"
}

static void
network_vpn_page_connect_vpn_cb (NetworkVPNPage* self,
                                 NetworkVPNMenuItem* item)
{
	Block4Data* _data4_;
	NetworkNetworkManager* _tmp0_;
	NMClient* _tmp1_;
	NMClient* _tmp2_;
	NMRemoteConnection* _tmp3_;
	NMRemoteConnection* _tmp4_;
#line 253 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/Views/VPNPage.vala"
	g_return_if_fail (item != NULL);
#line 253 "../src/Views/VPNPage.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 253 "../src/Views/VPNPage.vala"
	_data4_->_ref_count_ = 1;
#line 253 "../src/Views/VPNPage.vala"
	_data4_->self = g_object_ref (self);
#line 254 "../src/Views/VPNPage.vala"
	_tmp0_ = network_network_manager_get_default ();
#line 254 "../src/Views/VPNPage.vala"
	_data4_->network_manager = _tmp0_;
#line 255 "../src/Views/VPNPage.vala"
	_tmp1_ = network_network_manager_get_client (_data4_->network_manager);
#line 255 "../src/Views/VPNPage.vala"
	_tmp2_ = _tmp1_;
#line 255 "../src/Views/VPNPage.vala"
	_tmp3_ = network_vpn_menu_item_get_connection (item);
#line 255 "../src/Views/VPNPage.vala"
	_tmp4_ = _tmp3_;
#line 255 "../src/Views/VPNPage.vala"
	nm_client_activate_connection_async (_tmp2_, (NMConnection*) _tmp4_, NULL, NULL, NULL, ___lambda26__gasync_ready_callback, block4_data_ref (_data4_));
#line 253 "../src/Views/VPNPage.vala"
	block4_data_unref (_data4_);
#line 253 "../src/Views/VPNPage.vala"
	_data4_ = NULL;
#line 932 "VPNPage.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 268 "../src/Views/VPNPage.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 268 "../src/Views/VPNPage.vala"
	return _data5_;
#line 942 "VPNPage.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 268 "../src/Views/VPNPage.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 952 "VPNPage.c"
		NetworkVPNPage* self;
#line 268 "../src/Views/VPNPage.vala"
		self = _data5_->self;
#line 268 "../src/Views/VPNPage.vala"
		_g_object_unref0 (self);
#line 268 "../src/Views/VPNPage.vala"
		g_slice_free (Block5Data, _data5_);
#line 960 "VPNPage.c"
	}
}

static void
_____lambda27_ (Block5Data* _data5_,
                GObject* obj,
                GAsyncResult* res)
{
	NetworkVPNPage* self;
	GError* _inner_error0_ = NULL;
#line 273 "../src/Views/VPNPage.vala"
	self = _data5_->self;
#line 273 "../src/Views/VPNPage.vala"
	g_return_if_fail (res != NULL);
#line 975 "VPNPage.c"
	{
		NetworkNetworkManager* _tmp0_;
		NMClient* _tmp1_;
		NMClient* _tmp2_;
#line 275 "../src/Views/VPNPage.vala"
		_tmp0_ = _data5_->network_manager;
#line 275 "../src/Views/VPNPage.vala"
		_tmp1_ = network_network_manager_get_client (_tmp0_);
#line 275 "../src/Views/VPNPage.vala"
		_tmp2_ = _tmp1_;
#line 275 "../src/Views/VPNPage.vala"
		nm_client_deactivate_connection_finish (_tmp2_, res, &_inner_error0_);
#line 275 "../src/Views/VPNPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 990 "VPNPage.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 274 "../src/Views/VPNPage.vala"
		e = _inner_error0_;
#line 274 "../src/Views/VPNPage.vala"
		_inner_error0_ = NULL;
#line 277 "../src/Views/VPNPage.vala"
		_tmp3_ = e;
#line 277 "../src/Views/VPNPage.vala"
		_tmp4_ = _tmp3_->message;
#line 277 "../src/Views/VPNPage.vala"
		g_warning ("VPNPage.vala:277: %s", _tmp4_);
#line 274 "../src/Views/VPNPage.vala"
		_g_error_free0 (e);
#line 1012 "VPNPage.c"
	}
	__finally0:
#line 274 "../src/Views/VPNPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 274 "../src/Views/VPNPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 274 "../src/Views/VPNPage.vala"
		g_clear_error (&_inner_error0_);
#line 274 "../src/Views/VPNPage.vala"
		return;
#line 1023 "VPNPage.c"
	}
#line 279 "../src/Views/VPNPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 1027 "VPNPage.c"
}

static void
______lambda27__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 273 "../src/Views/VPNPage.vala"
	_____lambda27_ (self, source_object, res);
#line 273 "../src/Views/VPNPage.vala"
	block5_data_unref (self);
#line 1039 "VPNPage.c"
}

static void
network_vpn_page_disconnect_vpn_cb (NetworkVPNPage* self,
                                    NetworkVPNMenuItem* item)
{
	Block5Data* _data5_;
	NetworkNetworkManager* _tmp0_;
#line 268 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/Views/VPNPage.vala"
	g_return_if_fail (item != NULL);
#line 268 "../src/Views/VPNPage.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 268 "../src/Views/VPNPage.vala"
	_data5_->_ref_count_ = 1;
#line 268 "../src/Views/VPNPage.vala"
	_data5_->self = g_object_ref (self);
#line 269 "../src/Views/VPNPage.vala"
	network_vpn_page_update_active_connections (self);
#line 270 "../src/Views/VPNPage.vala"
	_tmp0_ = network_network_manager_get_default ();
#line 270 "../src/Views/VPNPage.vala"
	_data5_->network_manager = _tmp0_;
#line 1064 "VPNPage.c"
	{
		GeeList* _ac_list = NULL;
		GeeList* _tmp1_;
		gint _ac_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _ac_index = 0;
#line 271 "../src/Views/VPNPage.vala"
		_tmp1_ = self->priv->active_connections;
#line 271 "../src/Views/VPNPage.vala"
		_ac_list = _tmp1_;
#line 271 "../src/Views/VPNPage.vala"
		_tmp2_ = _ac_list;
#line 271 "../src/Views/VPNPage.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 271 "../src/Views/VPNPage.vala"
		_tmp4_ = _tmp3_;
#line 271 "../src/Views/VPNPage.vala"
		_ac_size = _tmp4_;
#line 271 "../src/Views/VPNPage.vala"
		_ac_index = -1;
#line 271 "../src/Views/VPNPage.vala"
		while (TRUE) {
#line 1089 "VPNPage.c"
			gint _tmp5_;
			gint _tmp6_;
			NMActiveConnection* ac = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			NMActiveConnection* _tmp9_;
			NMRemoteConnection* _tmp10_;
			NMRemoteConnection* _tmp11_;
			NMRemoteConnection* _tmp12_;
#line 271 "../src/Views/VPNPage.vala"
			_ac_index = _ac_index + 1;
#line 271 "../src/Views/VPNPage.vala"
			_tmp5_ = _ac_index;
#line 271 "../src/Views/VPNPage.vala"
			_tmp6_ = _ac_size;
#line 271 "../src/Views/VPNPage.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 271 "../src/Views/VPNPage.vala"
				break;
#line 1109 "VPNPage.c"
			}
#line 271 "../src/Views/VPNPage.vala"
			_tmp7_ = _ac_list;
#line 271 "../src/Views/VPNPage.vala"
			_tmp8_ = gee_list_get (_tmp7_, _ac_index);
#line 271 "../src/Views/VPNPage.vala"
			ac = (NMActiveConnection*) _tmp8_;
#line 272 "../src/Views/VPNPage.vala"
			_tmp9_ = ac;
#line 272 "../src/Views/VPNPage.vala"
			_tmp10_ = nm_active_connection_get_connection (_tmp9_);
#line 272 "../src/Views/VPNPage.vala"
			_tmp11_ = network_vpn_menu_item_get_connection (item);
#line 272 "../src/Views/VPNPage.vala"
			_tmp12_ = _tmp11_;
#line 272 "../src/Views/VPNPage.vala"
			if (_tmp10_ == _tmp12_) {
#line 1127 "VPNPage.c"
				NetworkNetworkManager* _tmp13_;
				NMClient* _tmp14_;
				NMClient* _tmp15_;
				NMActiveConnection* _tmp16_;
#line 273 "../src/Views/VPNPage.vala"
				_tmp13_ = _data5_->network_manager;
#line 273 "../src/Views/VPNPage.vala"
				_tmp14_ = network_network_manager_get_client (_tmp13_);
#line 273 "../src/Views/VPNPage.vala"
				_tmp15_ = _tmp14_;
#line 273 "../src/Views/VPNPage.vala"
				_tmp16_ = ac;
#line 273 "../src/Views/VPNPage.vala"
				nm_client_deactivate_connection_async (_tmp15_, _tmp16_, NULL, ______lambda27__gasync_ready_callback, block5_data_ref (_data5_));
#line 281 "../src/Views/VPNPage.vala"
				_g_object_unref0 (ac);
#line 281 "../src/Views/VPNPage.vala"
				break;
#line 1146 "VPNPage.c"
			}
#line 271 "../src/Views/VPNPage.vala"
			_g_object_unref0 (ac);
#line 1150 "VPNPage.c"
		}
	}
#line 268 "../src/Views/VPNPage.vala"
	block5_data_unref (_data5_);
#line 268 "../src/Views/VPNPage.vala"
	_data5_ = NULL;
#line 1157 "VPNPage.c"
}

static gboolean
____lambda28_ (NetworkVPNPage* self)
{
	gboolean result;
#line 307 "../src/Views/VPNPage.vala"
	self->priv->timeout_id = (guint) 0;
#line 308 "../src/Views/VPNPage.vala"
	network_vpn_page_delete_connection (self);
#line 309 "../src/Views/VPNPage.vala"
	result = G_SOURCE_REMOVE;
#line 309 "../src/Views/VPNPage.vala"
	return result;
#line 1172 "VPNPage.c"
}

static gboolean
_____lambda28__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda28_ ((NetworkVPNPage*) self);
#line 306 "../src/Views/VPNPage.vala"
	return result;
#line 1182 "VPNPage.c"
}

static void
network_vpn_page_remove_button_cb (NetworkVPNPage* self)
{
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	NetworkVPNMenuItem* _tmp2_;
	NetworkVPNMenuItem* _tmp3_;
#line 286 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/Views/VPNPage.vala"
	_tmp0_ = self->priv->vpn_list;
#line 287 "../src/Views/VPNPage.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 287 "../src/Views/VPNPage.vala"
	_tmp2_ = _g_object_ref0 (NETWORK_IS_VPN_MENU_ITEM (_tmp1_) ? ((NetworkVPNMenuItem*) _tmp1_) : NULL);
#line 287 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->sel_row);
#line 287 "../src/Views/VPNPage.vala"
	self->priv->sel_row = _tmp2_;
#line 288 "../src/Views/VPNPage.vala"
	_tmp3_ = self->priv->sel_row;
#line 288 "../src/Views/VPNPage.vala"
	if (_tmp3_ != NULL) {
#line 1208 "VPNPage.c"
		gboolean _tmp4_ = FALSE;
		NetworkVPNMenuItem* _tmp5_;
		NMDeviceState _tmp6_;
		NMDeviceState _tmp7_;
#line 289 "../src/Views/VPNPage.vala"
		_tmp5_ = self->priv->sel_row;
#line 289 "../src/Views/VPNPage.vala"
		_tmp6_ = network_vpn_menu_item_get_state (_tmp5_);
#line 289 "../src/Views/VPNPage.vala"
		_tmp7_ = _tmp6_;
#line 289 "../src/Views/VPNPage.vala"
		if (_tmp7_ == NM_DEVICE_STATE_ACTIVATED) {
#line 289 "../src/Views/VPNPage.vala"
			_tmp4_ = TRUE;
#line 1223 "VPNPage.c"
		} else {
			NetworkVPNMenuItem* _tmp8_;
			NMDeviceState _tmp9_;
			NMDeviceState _tmp10_;
#line 290 "../src/Views/VPNPage.vala"
			_tmp8_ = self->priv->sel_row;
#line 290 "../src/Views/VPNPage.vala"
			_tmp9_ = network_vpn_menu_item_get_state (_tmp8_);
#line 290 "../src/Views/VPNPage.vala"
			_tmp10_ = _tmp9_;
#line 290 "../src/Views/VPNPage.vala"
			_tmp4_ = _tmp10_ == NM_DEVICE_STATE_PREPARE;
#line 1236 "VPNPage.c"
		}
#line 289 "../src/Views/VPNPage.vala"
		if (_tmp4_) {
#line 1240 "VPNPage.c"
			GraniteMessageDialog* dialog = NULL;
			GThemedIcon* _tmp11_;
			GThemedIcon* _tmp12_;
			GThemedIcon* _tmp13_;
			GtkWidget* _tmp14_;
			GtkWindow* _tmp15_;
			GraniteMessageDialog* _tmp16_ = NULL;
			GraniteMessageDialog* _tmp17_;
			GraniteMessageDialog* _tmp18_;
			GraniteMessageDialog* _tmp19_;
#line 291 "../src/Views/VPNPage.vala"
			_tmp11_ = (GThemedIcon*) g_themed_icon_new ("network-vpn");
#line 291 "../src/Views/VPNPage.vala"
			_tmp12_ = _tmp11_;
#line 291 "../src/Views/VPNPage.vala"
			_tmp13_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 291 "../src/Views/VPNPage.vala"
			_tmp14_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 291 "../src/Views/VPNPage.vala"
			_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_window_get_type (), GtkWindow));
#line 291 "../src/Views/VPNPage.vala"
			_tmp16_ = granite_message_dialog_new (_ ("Failed to remove VPN connection"), _ ("Cannot remove an active VPN connection."), (GIcon*) _tmp12_, GTK_BUTTONS_CLOSE);
#line 291 "../src/Views/VPNPage.vala"
			granite_message_dialog_set_badge_icon (_tmp16_, (GIcon*) _tmp13_);
#line 291 "../src/Views/VPNPage.vala"
			_g_object_unref0 (_tmp13_);
#line 291 "../src/Views/VPNPage.vala"
			gtk_window_set_transient_for ((GtkWindow*) _tmp16_, _tmp15_);
#line 291 "../src/Views/VPNPage.vala"
			_g_object_unref0 (_tmp15_);
#line 291 "../src/Views/VPNPage.vala"
			g_object_ref_sink (_tmp16_);
#line 291 "../src/Views/VPNPage.vala"
			_tmp17_ = _tmp16_;
#line 291 "../src/Views/VPNPage.vala"
			_g_object_unref0 (_tmp12_);
#line 291 "../src/Views/VPNPage.vala"
			dialog = _tmp17_;
#line 300 "../src/Views/VPNPage.vala"
			_tmp18_ = dialog;
#line 300 "../src/Views/VPNPage.vala"
			gtk_dialog_run ((GtkDialog*) _tmp18_);
#line 301 "../src/Views/VPNPage.vala"
			_tmp19_ = dialog;
#line 301 "../src/Views/VPNPage.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp19_);
#line 302 "../src/Views/VPNPage.vala"
			_g_object_unref0 (dialog);
#line 302 "../src/Views/VPNPage.vala"
			return;
#line 1291 "VPNPage.c"
		} else {
			GraniteWidgetsToast* _tmp20_;
			NetworkVPNMenuItem* _tmp21_;
#line 304 "../src/Views/VPNPage.vala"
			_tmp20_ = self->priv->remove_vpn_toast;
#line 304 "../src/Views/VPNPage.vala"
			granite_widgets_toast_send_notification (_tmp20_);
#line 305 "../src/Views/VPNPage.vala"
			_tmp21_ = self->priv->sel_row;
#line 305 "../src/Views/VPNPage.vala"
			gtk_widget_hide ((GtkWidget*) _tmp21_);
#line 306 "../src/Views/VPNPage.vala"
			self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 3600, _____lambda28__gsource_func, g_object_ref (self), g_object_unref);
#line 1305 "VPNPage.c"
		}
	}
}

static void
network_vpn_page_try_connection_editor (NetworkVPNPage* self,
                                        const gchar* args)
{
	GError* _inner_error0_ = NULL;
#line 315 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 315 "../src/Views/VPNPage.vala"
	g_return_if_fail (args != NULL);
#line 1319 "VPNPage.c"
	{
		GAppInfo* appinfo = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GAppInfo* _tmp2_;
		GAppInfo* _tmp3_;
		GAppInfo* _tmp4_;
#line 317 "../src/Views/VPNPage.vala"
		_tmp0_ = g_strdup_printf ("nm-connection-editor %s", args);
#line 317 "../src/Views/VPNPage.vala"
		_tmp1_ = _tmp0_;
#line 317 "../src/Views/VPNPage.vala"
		_tmp2_ = g_app_info_create_from_commandline (_tmp1_, NULL, G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 317 "../src/Views/VPNPage.vala"
		_tmp3_ = _tmp2_;
#line 317 "../src/Views/VPNPage.vala"
		_g_free0 (_tmp1_);
#line 317 "../src/Views/VPNPage.vala"
		appinfo = _tmp3_;
#line 317 "../src/Views/VPNPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1341 "VPNPage.c"
			goto __catch0_g_error;
		}
#line 322 "../src/Views/VPNPage.vala"
		_tmp4_ = appinfo;
#line 322 "../src/Views/VPNPage.vala"
		g_app_info_launch (_tmp4_, NULL, NULL, &_inner_error0_);
#line 322 "../src/Views/VPNPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 322 "../src/Views/VPNPage.vala"
			_g_object_unref0 (appinfo);
#line 1352 "VPNPage.c"
			goto __catch0_g_error;
		}
#line 316 "../src/Views/VPNPage.vala"
		_g_object_unref0 (appinfo);
#line 1357 "VPNPage.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GraniteMessageDialog* dialog = NULL;
		GThemedIcon* _tmp5_;
		GThemedIcon* _tmp6_;
		GThemedIcon* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWindow* _tmp9_;
		GraniteMessageDialog* _tmp10_ = NULL;
		GraniteMessageDialog* _tmp11_;
		GraniteMessageDialog* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
		GraniteMessageDialog* _tmp15_;
		GraniteMessageDialog* _tmp16_;
#line 316 "../src/Views/VPNPage.vala"
		_error_ = _inner_error0_;
#line 316 "../src/Views/VPNPage.vala"
		_inner_error0_ = NULL;
#line 324 "../src/Views/VPNPage.vala"
		_tmp5_ = (GThemedIcon*) g_themed_icon_new ("network-vpn");
#line 324 "../src/Views/VPNPage.vala"
		_tmp6_ = _tmp5_;
#line 324 "../src/Views/VPNPage.vala"
		_tmp7_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 324 "../src/Views/VPNPage.vala"
		_tmp8_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 324 "../src/Views/VPNPage.vala"
		_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_window_get_type (), GtkWindow));
#line 324 "../src/Views/VPNPage.vala"
		_tmp10_ = granite_message_dialog_new (_ ("Failed to run Connection Editor"), _ ("The program \"nm-connection-editor\" may not be installed."), (GIcon*) _tmp6_, GTK_BUTTONS_CLOSE);
#line 324 "../src/Views/VPNPage.vala"
		granite_message_dialog_set_badge_icon (_tmp10_, (GIcon*) _tmp7_);
#line 324 "../src/Views/VPNPage.vala"
		_g_object_unref0 (_tmp7_);
#line 324 "../src/Views/VPNPage.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp10_, _tmp9_);
#line 324 "../src/Views/VPNPage.vala"
		_g_object_unref0 (_tmp9_);
#line 324 "../src/Views/VPNPage.vala"
		g_object_ref_sink (_tmp10_);
#line 324 "../src/Views/VPNPage.vala"
		_tmp11_ = _tmp10_;
#line 324 "../src/Views/VPNPage.vala"
		_g_object_unref0 (_tmp6_);
#line 324 "../src/Views/VPNPage.vala"
		dialog = _tmp11_;
#line 333 "../src/Views/VPNPage.vala"
		_tmp12_ = dialog;
#line 333 "../src/Views/VPNPage.vala"
		_tmp13_ = _error_;
#line 333 "../src/Views/VPNPage.vala"
		_tmp14_ = _tmp13_->message;
#line 333 "../src/Views/VPNPage.vala"
		granite_message_dialog_show_error_details (_tmp12_, _tmp14_);
#line 334 "../src/Views/VPNPage.vala"
		_tmp15_ = dialog;
#line 334 "../src/Views/VPNPage.vala"
		gtk_dialog_run ((GtkDialog*) _tmp15_);
#line 335 "../src/Views/VPNPage.vala"
		_tmp16_ = dialog;
#line 335 "../src/Views/VPNPage.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp16_);
#line 316 "../src/Views/VPNPage.vala"
		_g_object_unref0 (dialog);
#line 316 "../src/Views/VPNPage.vala"
		_g_error_free0 (_error_);
#line 1428 "VPNPage.c"
	}
	__finally0:
#line 316 "../src/Views/VPNPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 316 "../src/Views/VPNPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 316 "../src/Views/VPNPage.vala"
		g_clear_error (&_inner_error0_);
#line 316 "../src/Views/VPNPage.vala"
		return;
#line 1439 "VPNPage.c"
	}
}

static void
network_vpn_page_delete_connection (NetworkVPNPage* self)
{
	NetworkVPNMenuItem* selected_row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	NetworkVPNMenuItem* _tmp2_;
	gboolean _tmp3_ = FALSE;
	NetworkVPNMenuItem* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 339 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/Views/VPNPage.vala"
	_tmp0_ = self->priv->vpn_list;
#line 340 "../src/Views/VPNPage.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 340 "../src/Views/VPNPage.vala"
	_tmp2_ = _g_object_ref0 (NETWORK_IS_VPN_MENU_ITEM (_tmp1_) ? ((NetworkVPNMenuItem*) _tmp1_) : NULL);
#line 340 "../src/Views/VPNPage.vala"
	selected_row = _tmp2_;
#line 341 "../src/Views/VPNPage.vala"
	_tmp4_ = selected_row;
#line 341 "../src/Views/VPNPage.vala"
	if (_tmp4_ != NULL) {
#line 1467 "VPNPage.c"
		NetworkVPNMenuItem* _tmp5_;
#line 341 "../src/Views/VPNPage.vala"
		_tmp5_ = self->priv->sel_row;
#line 341 "../src/Views/VPNPage.vala"
		_tmp3_ = _tmp5_ != NULL;
#line 1473 "VPNPage.c"
	} else {
#line 341 "../src/Views/VPNPage.vala"
		_tmp3_ = FALSE;
#line 1477 "VPNPage.c"
	}
#line 341 "../src/Views/VPNPage.vala"
	if (_tmp3_) {
#line 1481 "VPNPage.c"
		NetworkVPNMenuItem* _tmp6_;
		NetworkVPNMenuItem* _tmp7_;
#line 342 "../src/Views/VPNPage.vala"
		_tmp6_ = self->priv->sel_row;
#line 342 "../src/Views/VPNPage.vala"
		_tmp7_ = selected_row;
#line 342 "../src/Views/VPNPage.vala"
		if (_tmp6_ == _tmp7_) {
#line 1490 "VPNPage.c"
			{
				NetworkVPNMenuItem* _tmp8_;
				NMRemoteConnection* _tmp9_;
				NMRemoteConnection* _tmp10_;
#line 344 "../src/Views/VPNPage.vala"
				_tmp8_ = selected_row;
#line 344 "../src/Views/VPNPage.vala"
				_tmp9_ = network_vpn_menu_item_get_connection (_tmp8_);
#line 344 "../src/Views/VPNPage.vala"
				_tmp10_ = _tmp9_;
#line 344 "../src/Views/VPNPage.vala"
				nm_remote_connection_delete (_tmp10_, NULL, &_inner_error0_);
#line 344 "../src/Views/VPNPage.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1505 "VPNPage.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp11_;
				const gchar* _tmp12_;
				GraniteMessageDialog* dialog = NULL;
				GThemedIcon* _tmp13_;
				GThemedIcon* _tmp14_;
				GThemedIcon* _tmp15_;
				GtkWidget* _tmp16_;
				GtkWindow* _tmp17_;
				GraniteMessageDialog* _tmp18_ = NULL;
				GraniteMessageDialog* _tmp19_;
				GraniteMessageDialog* _tmp20_;
				GError* _tmp21_;
				const gchar* _tmp22_;
				GraniteMessageDialog* _tmp23_;
				GraniteMessageDialog* _tmp24_;
#line 343 "../src/Views/VPNPage.vala"
				e = _inner_error0_;
#line 343 "../src/Views/VPNPage.vala"
				_inner_error0_ = NULL;
#line 346 "../src/Views/VPNPage.vala"
				_tmp11_ = e;
#line 346 "../src/Views/VPNPage.vala"
				_tmp12_ = _tmp11_->message;
#line 346 "../src/Views/VPNPage.vala"
				g_warning ("VPNPage.vala:346: %s", _tmp12_);
#line 347 "../src/Views/VPNPage.vala"
				_tmp13_ = (GThemedIcon*) g_themed_icon_new ("network-vpn");
#line 347 "../src/Views/VPNPage.vala"
				_tmp14_ = _tmp13_;
#line 347 "../src/Views/VPNPage.vala"
				_tmp15_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 347 "../src/Views/VPNPage.vala"
				_tmp16_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 347 "../src/Views/VPNPage.vala"
				_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_window_get_type (), GtkWindow));
#line 347 "../src/Views/VPNPage.vala"
				_tmp18_ = granite_message_dialog_new (_ ("Failed to remove VPN connection"), "", (GIcon*) _tmp14_, GTK_BUTTONS_CLOSE);
#line 347 "../src/Views/VPNPage.vala"
				granite_message_dialog_set_badge_icon (_tmp18_, (GIcon*) _tmp15_);
#line 347 "../src/Views/VPNPage.vala"
				_g_object_unref0 (_tmp15_);
#line 347 "../src/Views/VPNPage.vala"
				gtk_window_set_transient_for ((GtkWindow*) _tmp18_, _tmp17_);
#line 347 "../src/Views/VPNPage.vala"
				_g_object_unref0 (_tmp17_);
#line 347 "../src/Views/VPNPage.vala"
				g_object_ref_sink (_tmp18_);
#line 347 "../src/Views/VPNPage.vala"
				_tmp19_ = _tmp18_;
#line 347 "../src/Views/VPNPage.vala"
				_g_object_unref0 (_tmp14_);
#line 347 "../src/Views/VPNPage.vala"
				dialog = _tmp19_;
#line 356 "../src/Views/VPNPage.vala"
				_tmp20_ = dialog;
#line 356 "../src/Views/VPNPage.vala"
				_tmp21_ = e;
#line 356 "../src/Views/VPNPage.vala"
				_tmp22_ = _tmp21_->message;
#line 356 "../src/Views/VPNPage.vala"
				granite_message_dialog_show_error_details (_tmp20_, _tmp22_);
#line 357 "../src/Views/VPNPage.vala"
				_tmp23_ = dialog;
#line 357 "../src/Views/VPNPage.vala"
				gtk_dialog_run ((GtkDialog*) _tmp23_);
#line 358 "../src/Views/VPNPage.vala"
				_tmp24_ = dialog;
#line 358 "../src/Views/VPNPage.vala"
				gtk_widget_destroy ((GtkWidget*) _tmp24_);
#line 343 "../src/Views/VPNPage.vala"
				_g_object_unref0 (dialog);
#line 343 "../src/Views/VPNPage.vala"
				_g_error_free0 (e);
#line 1586 "VPNPage.c"
			}
			__finally0:
#line 343 "../src/Views/VPNPage.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 343 "../src/Views/VPNPage.vala"
				_g_object_unref0 (selected_row);
#line 343 "../src/Views/VPNPage.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 343 "../src/Views/VPNPage.vala"
				g_clear_error (&_inner_error0_);
#line 343 "../src/Views/VPNPage.vala"
				return;
#line 1599 "VPNPage.c"
			}
		} else {
			NetworkVPNMenuItem* _tmp25_;
#line 361 "../src/Views/VPNPage.vala"
			g_warning ("VPNPage.vala:361: Row selection changed between operations. Cancelling" \
" removal of VPN.");
#line 362 "../src/Views/VPNPage.vala"
			g_source_remove (self->priv->timeout_id);
#line 363 "../src/Views/VPNPage.vala"
			self->priv->timeout_id = (guint) 0;
#line 364 "../src/Views/VPNPage.vala"
			_tmp25_ = self->priv->sel_row;
#line 364 "../src/Views/VPNPage.vala"
			gtk_widget_show ((GtkWidget*) _tmp25_);
#line 1613 "VPNPage.c"
		}
	}
#line 339 "../src/Views/VPNPage.vala"
	_g_object_unref0 (selected_row);
#line 1618 "VPNPage.c"
}

static gint
network_vpn_page_compare_rows (NetworkVPNMenuItem* row1,
                               NetworkVPNMenuItem* row2,
                               NetworkVPNPage* self)
{
	NMSettingConnection* vpn_menu_item1 = NULL;
	NMRemoteConnection* _tmp0_;
	NMRemoteConnection* _tmp1_;
	NMSettingConnection* _tmp2_;
	NMSettingConnection* vpn_menu_item2 = NULL;
	NMRemoteConnection* _tmp3_;
	NMRemoteConnection* _tmp4_;
	NMSettingConnection* _tmp5_;
	gboolean _tmp6_ = FALSE;
	NMSettingConnection* _tmp7_;
	gint result;
#line 370 "../src/Views/VPNPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 370 "../src/Views/VPNPage.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 370 "../src/Views/VPNPage.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 371 "../src/Views/VPNPage.vala"
	_tmp0_ = network_vpn_menu_item_get_connection (row1);
#line 371 "../src/Views/VPNPage.vala"
	_tmp1_ = _tmp0_;
#line 371 "../src/Views/VPNPage.vala"
	_tmp2_ = nm_connection_get_setting_connection ((NMConnection*) _tmp1_);
#line 371 "../src/Views/VPNPage.vala"
	vpn_menu_item1 = _tmp2_;
#line 372 "../src/Views/VPNPage.vala"
	_tmp3_ = network_vpn_menu_item_get_connection (row2);
#line 372 "../src/Views/VPNPage.vala"
	_tmp4_ = _tmp3_;
#line 372 "../src/Views/VPNPage.vala"
	_tmp5_ = nm_connection_get_setting_connection ((NMConnection*) _tmp4_);
#line 372 "../src/Views/VPNPage.vala"
	vpn_menu_item2 = _tmp5_;
#line 374 "../src/Views/VPNPage.vala"
	_tmp7_ = vpn_menu_item1;
#line 374 "../src/Views/VPNPage.vala"
	if (_tmp7_ != NULL) {
#line 1663 "VPNPage.c"
		NMSettingConnection* _tmp8_;
#line 374 "../src/Views/VPNPage.vala"
		_tmp8_ = vpn_menu_item2;
#line 374 "../src/Views/VPNPage.vala"
		_tmp6_ = _tmp8_ != NULL;
#line 1669 "VPNPage.c"
	} else {
#line 374 "../src/Views/VPNPage.vala"
		_tmp6_ = FALSE;
#line 1673 "VPNPage.c"
	}
#line 374 "../src/Views/VPNPage.vala"
	if (_tmp6_) {
#line 1677 "VPNPage.c"
		NMSettingConnection* _tmp9_;
		NMSettingConnection* _tmp10_;
#line 375 "../src/Views/VPNPage.vala"
		_tmp9_ = vpn_menu_item1;
#line 375 "../src/Views/VPNPage.vala"
		_tmp10_ = vpn_menu_item2;
#line 375 "../src/Views/VPNPage.vala"
		if (nm_setting_connection_get_timestamp (_tmp9_) > nm_setting_connection_get_timestamp (_tmp10_)) {
#line 376 "../src/Views/VPNPage.vala"
			result = -1;
#line 376 "../src/Views/VPNPage.vala"
			return result;
#line 1690 "VPNPage.c"
		}
	}
#line 380 "../src/Views/VPNPage.vala"
	result = 1;
#line 380 "../src/Views/VPNPage.vala"
	return result;
#line 1697 "VPNPage.c"
}

NetworkWidgetsDeviceItem*
network_vpn_page_get_owner (NetworkVPNPage* self)
{
	NetworkWidgetsDeviceItem* result;
	NetworkWidgetsDeviceItem* _tmp0_;
#line 21 "../src/Views/VPNPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Views/VPNPage.vala"
	_tmp0_ = self->priv->_owner;
#line 21 "../src/Views/VPNPage.vala"
	result = _tmp0_;
#line 21 "../src/Views/VPNPage.vala"
	return result;
#line 1713 "VPNPage.c"
}

static void
network_vpn_page_set_owner (NetworkVPNPage* self,
                            NetworkWidgetsDeviceItem* value)
{
	NetworkWidgetsDeviceItem* old_value;
#line 21 "../src/Views/VPNPage.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Views/VPNPage.vala"
	old_value = network_vpn_page_get_owner (self);
#line 21 "../src/Views/VPNPage.vala"
	if (old_value != value) {
#line 1727 "VPNPage.c"
		NetworkWidgetsDeviceItem* _tmp0_;
#line 21 "../src/Views/VPNPage.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/Views/VPNPage.vala"
		_g_object_unref0 (self->priv->_owner);
#line 21 "../src/Views/VPNPage.vala"
		self->priv->_owner = _tmp0_;
#line 21 "../src/Views/VPNPage.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_page_properties[NETWORK_VPN_PAGE_OWNER_PROPERTY]);
#line 1737 "VPNPage.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 37 "../src/Views/VPNPage.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 37 "../src/Views/VPNPage.vala"
	return _data6_;
#line 1748 "VPNPage.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 37 "../src/Views/VPNPage.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 1758 "VPNPage.c"
		NetworkVPNPage* self;
#line 37 "../src/Views/VPNPage.vala"
		self = _data6_->self;
#line 37 "../src/Views/VPNPage.vala"
		_g_object_unref0 (_data6_->edit_connection_button);
#line 37 "../src/Views/VPNPage.vala"
		_g_object_unref0 (_data6_->remove_button);
#line 37 "../src/Views/VPNPage.vala"
		_g_object_unref0 (self);
#line 37 "../src/Views/VPNPage.vala"
		g_slice_free (Block6Data, _data6_);
#line 1770 "VPNPage.c"
	}
}

static void
_network_vpn_page___lambda29_ (NetworkVPNPage* self)
{
#line 64 "../src/Views/VPNPage.vala"
	network_vpn_page_try_connection_editor (self, "--create --type=vpn");
#line 1779 "VPNPage.c"
}

static void
__network_vpn_page___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 63 "../src/Views/VPNPage.vala"
	_network_vpn_page___lambda29_ ((NetworkVPNPage*) self);
#line 1788 "VPNPage.c"
}

static void
_network_vpn_page_remove_button_cb_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 71 "../src/Views/VPNPage.vala"
	network_vpn_page_remove_button_cb ((NetworkVPNPage*) self);
#line 1797 "VPNPage.c"
}

static void
_network_vpn_page___lambda30_ (NetworkVPNPage* self)
{
	NetworkVPNMenuItem* _tmp0_;
#line 74 "../src/Views/VPNPage.vala"
	g_source_remove (self->priv->timeout_id);
#line 75 "../src/Views/VPNPage.vala"
	self->priv->timeout_id = (guint) 0;
#line 76 "../src/Views/VPNPage.vala"
	_tmp0_ = self->priv->sel_row;
#line 76 "../src/Views/VPNPage.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 1812 "VPNPage.c"
}

static void
__network_vpn_page___lambda30__granite_widgets_toast_default_action (GraniteWidgetsToast* _sender,
                                                                     gpointer self)
{
#line 73 "../src/Views/VPNPage.vala"
	_network_vpn_page___lambda30_ ((NetworkVPNPage*) self);
#line 1821 "VPNPage.c"
}

static void
_network_vpn_page___lambda31_ (NetworkVPNPage* self)
{
	NetworkVPNMenuItem* selected_row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	NetworkVPNMenuItem* _tmp2_;
	NetworkVPNMenuItem* _tmp3_;
	NMRemoteConnection* _tmp4_;
	NMRemoteConnection* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 84 "../src/Views/VPNPage.vala"
	_tmp0_ = self->priv->vpn_list;
#line 84 "../src/Views/VPNPage.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 84 "../src/Views/VPNPage.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
#line 84 "../src/Views/VPNPage.vala"
	selected_row = _tmp2_;
#line 85 "../src/Views/VPNPage.vala"
	_tmp3_ = selected_row;
#line 85 "../src/Views/VPNPage.vala"
	_tmp4_ = network_vpn_menu_item_get_connection (_tmp3_);
#line 85 "../src/Views/VPNPage.vala"
	_tmp5_ = _tmp4_;
#line 85 "../src/Views/VPNPage.vala"
	_tmp6_ = nm_connection_get_uuid ((NMConnection*) _tmp5_);
#line 85 "../src/Views/VPNPage.vala"
	_tmp7_ = g_strconcat ("--edit=", _tmp6_, NULL);
#line 85 "../src/Views/VPNPage.vala"
	_tmp8_ = _tmp7_;
#line 85 "../src/Views/VPNPage.vala"
	network_vpn_page_try_connection_editor (self, _tmp8_);
#line 85 "../src/Views/VPNPage.vala"
	_g_free0 (_tmp8_);
#line 83 "../src/Views/VPNPage.vala"
	_g_object_unref0 (selected_row);
#line 1863 "VPNPage.c"
}

static void
__network_vpn_page___lambda31__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 83 "../src/Views/VPNPage.vala"
	_network_vpn_page___lambda31_ ((NetworkVPNPage*) self);
#line 1872 "VPNPage.c"
}

static void
_network_vpn_page___lambda32_ (NetworkVPNPage* self,
                               GtkListBoxRow* row)
{
	NMDeviceState _tmp0_;
	NMDeviceState _tmp1_;
#line 115 "../src/Views/VPNPage.vala"
	g_return_if_fail (row != NULL);
#line 116 "../src/Views/VPNPage.vala"
	_tmp0_ = network_vpn_menu_item_get_state (G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
#line 116 "../src/Views/VPNPage.vala"
	_tmp1_ = _tmp0_;
#line 116 "../src/Views/VPNPage.vala"
	if (_tmp1_ == NM_DEVICE_STATE_ACTIVATED) {
#line 117 "../src/Views/VPNPage.vala"
		network_vpn_page_disconnect_vpn_cb (self, G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
#line 1891 "VPNPage.c"
	} else {
#line 119 "../src/Views/VPNPage.vala"
		network_vpn_page_connect_vpn_cb (self, G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
#line 1895 "VPNPage.c"
	}
}

static void
__network_vpn_page___lambda32__gtk_list_box_row_activated (GtkListBox* _sender,
                                                           GtkListBoxRow* row,
                                                           gpointer self)
{
#line 115 "../src/Views/VPNPage.vala"
	_network_vpn_page___lambda32_ ((NetworkVPNPage*) self, row);
#line 1906 "VPNPage.c"
}

static void
_network_vpn_page___lambda33_ (Block6Data* _data6_,
                               GtkListBoxRow* row)
{
	NetworkVPNPage* self;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 123 "../src/Views/VPNPage.vala"
	self = _data6_->self;
#line 124 "../src/Views/VPNPage.vala"
	_tmp0_ = _data6_->remove_button;
#line 124 "../src/Views/VPNPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, row != NULL);
#line 125 "../src/Views/VPNPage.vala"
	_tmp1_ = _data6_->edit_connection_button;
#line 125 "../src/Views/VPNPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, row != NULL);
#line 1926 "VPNPage.c"
}

static void
__network_vpn_page___lambda33__gtk_list_box_row_selected (GtkListBox* _sender,
                                                          GtkListBoxRow* row,
                                                          gpointer self)
{
#line 123 "../src/Views/VPNPage.vala"
	_network_vpn_page___lambda33_ (self, row);
#line 1936 "VPNPage.c"
}

static void
_network_vpn_page_update_active_connections_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self)
{
#line 132 "../src/Views/VPNPage.vala"
	network_vpn_page_update_active_connections ((NetworkVPNPage*) self);
#line 1946 "VPNPage.c"
}

static GObject *
network_vpn_page_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkVPNPage * self;
	Block6Data* _data6_;
	GraniteWidgetsToast* _tmp0_;
	GraniteWidgetsToast* _tmp1_;
	GraniteWidgetsAlertView* placeholder = NULL;
	GraniteWidgetsAlertView* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	GtkListBox* _tmp4_ = NULL;
	GtkListBox* _tmp5_;
	GraniteWidgetsAlertView* _tmp6_;
	GtkListBox* _tmp7_;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp8_;
	GtkActionBar* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkButton* add_button = NULL;
	gchar* _tmp11_;
	GtkButton* _tmp12_ = NULL;
	GtkButton* _tmp13_;
	gchar* _tmp14_;
	GtkButton* _tmp15_ = NULL;
	GtkButton* _tmp16_;
	GraniteWidgetsToast* _tmp17_;
	gchar* _tmp18_;
	GtkButton* _tmp19_ = NULL;
	GtkButton* _tmp20_;
	GtkActionBar* _tmp21_;
	GtkButton* _tmp22_;
	GtkActionBar* _tmp23_;
	GtkButton* _tmp24_;
	GtkActionBar* _tmp25_;
	GtkButton* _tmp26_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp27_ = NULL;
	GtkScrolledWindow* _tmp28_;
	GtkListBox* _tmp29_;
	GtkGrid* list_root = NULL;
	GtkGrid* _tmp30_;
	GtkGrid* _tmp31_;
	GtkScrolledWindow* _tmp32_;
	GtkGrid* _tmp33_;
	GtkActionBar* _tmp34_;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp35_ = NULL;
	GtkFrame* _tmp36_;
	GtkStyleContext* _tmp37_;
	GtkFrame* _tmp38_;
	GtkGrid* _tmp39_;
	GtkOverlay* main_overlay = NULL;
	GtkOverlay* _tmp40_;
	GtkOverlay* _tmp41_;
	GtkFrame* _tmp42_;
	GtkOverlay* _tmp43_;
	GraniteWidgetsToast* _tmp44_;
	GtkGrid* _tmp45_;
	GtkGrid* _tmp46_;
	GtkOverlay* _tmp47_;
	GtkListBox* _tmp48_;
	GtkListBox* _tmp49_;
	GeeArrayList* _tmp50_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp51_;
	NetworkNetworkManager* _tmp52_;
	NMClient* _tmp53_;
	NMClient* _tmp54_;
#line 37 "../src/Views/VPNPage.vala"
	parent_class = G_OBJECT_CLASS (network_vpn_page_parent_class);
#line 37 "../src/Views/VPNPage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/Views/VPNPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage);
#line 37 "../src/Views/VPNPage.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 37 "../src/Views/VPNPage.vala"
	_data6_->_ref_count_ = 1;
#line 37 "../src/Views/VPNPage.vala"
	_data6_->self = g_object_ref (self);
#line 38 "../src/Views/VPNPage.vala"
	_tmp0_ = granite_widgets_toast_new (_ ("VPN removed"));
#line 38 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp0_);
#line 38 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->remove_vpn_toast);
#line 38 "../src/Views/VPNPage.vala"
	self->priv->remove_vpn_toast = _tmp0_;
#line 39 "../src/Views/VPNPage.vala"
	_tmp1_ = self->priv->remove_vpn_toast;
#line 39 "../src/Views/VPNPage.vala"
	granite_widgets_toast_set_default_action (_tmp1_, _ ("Undo"));
#line 41 "../src/Views/VPNPage.vala"
	_tmp2_ = granite_widgets_alert_view_new (_ ("No VPN Connections"), _ ("Add a new VPN connection to begin."), "");
#line 41 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp2_);
#line 41 "../src/Views/VPNPage.vala"
	placeholder = _tmp2_;
#line 47 "../src/Views/VPNPage.vala"
	_tmp3_ = placeholder;
#line 47 "../src/Views/VPNPage.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 49 "../src/Views/VPNPage.vala"
	_tmp4_ = (GtkListBox*) gtk_list_box_new ();
#line 49 "../src/Views/VPNPage.vala"
	gtk_list_box_set_activate_on_single_click (_tmp4_, FALSE);
#line 49 "../src/Views/VPNPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 49 "../src/Views/VPNPage.vala"
	gtk_list_box_set_selection_mode (_tmp4_, GTK_SELECTION_BROWSE);
#line 49 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp4_);
#line 49 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->vpn_list);
#line 49 "../src/Views/VPNPage.vala"
	self->priv->vpn_list = _tmp4_;
#line 54 "../src/Views/VPNPage.vala"
	_tmp5_ = self->priv->vpn_list;
#line 54 "../src/Views/VPNPage.vala"
	_tmp6_ = placeholder;
#line 54 "../src/Views/VPNPage.vala"
	gtk_list_box_set_placeholder (_tmp5_, (GtkWidget*) _tmp6_);
#line 55 "../src/Views/VPNPage.vala"
	_tmp7_ = self->priv->vpn_list;
#line 55 "../src/Views/VPNPage.vala"
	gtk_list_box_set_sort_func (_tmp7_, (GtkListBoxSortFunc) network_vpn_page_compare_rows, g_object_ref (self), g_object_unref);
#line 57 "../src/Views/VPNPage.vala"
	_tmp8_ = (GtkActionBar*) gtk_action_bar_new ();
#line 57 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp8_);
#line 57 "../src/Views/VPNPage.vala"
	actionbar = _tmp8_;
#line 58 "../src/Views/VPNPage.vala"
	_tmp9_ = actionbar;
#line 58 "../src/Views/VPNPage.vala"
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
#line 58 "../src/Views/VPNPage.vala"
	gtk_style_context_add_class (_tmp10_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
#line 60 "../src/Views/VPNPage.vala"
	_tmp11_ = g_strdup (_ ("Add VPN Connection…"));
#line 60 "../src/Views/VPNPage.vala"
	_tmp12_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 60 "../src/Views/VPNPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _tmp11_);
#line 60 "../src/Views/VPNPage.vala"
	_g_free0 (_tmp11_);
#line 60 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp12_);
#line 60 "../src/Views/VPNPage.vala"
	add_button = _tmp12_;
#line 63 "../src/Views/VPNPage.vala"
	_tmp13_ = add_button;
#line 63 "../src/Views/VPNPage.vala"
	g_signal_connect_object (_tmp13_, "clicked", (GCallback) __network_vpn_page___lambda29__gtk_button_clicked, self, 0);
#line 67 "../src/Views/VPNPage.vala"
	_tmp14_ = g_strdup (_ ("Forget selected VPN…"));
#line 67 "../src/Views/VPNPage.vala"
	_tmp15_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 67 "../src/Views/VPNPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp15_, _tmp14_);
#line 67 "../src/Views/VPNPage.vala"
	_g_free0 (_tmp14_);
#line 67 "../src/Views/VPNPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, FALSE);
#line 67 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp15_);
#line 67 "../src/Views/VPNPage.vala"
	_data6_->remove_button = _tmp15_;
#line 71 "../src/Views/VPNPage.vala"
	_tmp16_ = _data6_->remove_button;
#line 71 "../src/Views/VPNPage.vala"
	g_signal_connect_object (_tmp16_, "clicked", (GCallback) _network_vpn_page_remove_button_cb_gtk_button_clicked, self, 0);
#line 73 "../src/Views/VPNPage.vala"
	_tmp17_ = self->priv->remove_vpn_toast;
#line 73 "../src/Views/VPNPage.vala"
	g_signal_connect_object (_tmp17_, "default-action", (GCallback) __network_vpn_page___lambda30__granite_widgets_toast_default_action, self, 0);
#line 79 "../src/Views/VPNPage.vala"
	_tmp18_ = g_strdup (_ ("Edit VPN connection…"));
#line 79 "../src/Views/VPNPage.vala"
	_tmp19_ = (GtkButton*) gtk_button_new_from_icon_name ("preferences-system-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 79 "../src/Views/VPNPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp19_, _tmp18_);
#line 79 "../src/Views/VPNPage.vala"
	_g_free0 (_tmp18_);
#line 79 "../src/Views/VPNPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, FALSE);
#line 79 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp19_);
#line 79 "../src/Views/VPNPage.vala"
	_data6_->edit_connection_button = _tmp19_;
#line 83 "../src/Views/VPNPage.vala"
	_tmp20_ = _data6_->edit_connection_button;
#line 83 "../src/Views/VPNPage.vala"
	g_signal_connect_object (_tmp20_, "clicked", (GCallback) __network_vpn_page___lambda31__gtk_button_clicked, self, 0);
#line 88 "../src/Views/VPNPage.vala"
	_tmp21_ = actionbar;
#line 88 "../src/Views/VPNPage.vala"
	_tmp22_ = add_button;
#line 88 "../src/Views/VPNPage.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 89 "../src/Views/VPNPage.vala"
	_tmp23_ = actionbar;
#line 89 "../src/Views/VPNPage.vala"
	_tmp24_ = _data6_->remove_button;
#line 89 "../src/Views/VPNPage.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 90 "../src/Views/VPNPage.vala"
	_tmp25_ = actionbar;
#line 90 "../src/Views/VPNPage.vala"
	_tmp26_ = _data6_->edit_connection_button;
#line 90 "../src/Views/VPNPage.vala"
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 92 "../src/Views/VPNPage.vala"
	_tmp27_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 92 "../src/Views/VPNPage.vala"
	g_object_set ((GtkWidget*) _tmp27_, "expand", TRUE, NULL);
#line 92 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp27_);
#line 92 "../src/Views/VPNPage.vala"
	scrolled = _tmp27_;
#line 95 "../src/Views/VPNPage.vala"
	_tmp28_ = scrolled;
#line 95 "../src/Views/VPNPage.vala"
	_tmp29_ = self->priv->vpn_list;
#line 95 "../src/Views/VPNPage.vala"
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
#line 97 "../src/Views/VPNPage.vala"
	_tmp30_ = (GtkGrid*) gtk_grid_new ();
#line 97 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp30_);
#line 97 "../src/Views/VPNPage.vala"
	list_root = _tmp30_;
#line 98 "../src/Views/VPNPage.vala"
	_tmp31_ = list_root;
#line 98 "../src/Views/VPNPage.vala"
	_tmp32_ = scrolled;
#line 98 "../src/Views/VPNPage.vala"
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 0, 0, 1, 1);
#line 99 "../src/Views/VPNPage.vala"
	_tmp33_ = list_root;
#line 99 "../src/Views/VPNPage.vala"
	_tmp34_ = actionbar;
#line 99 "../src/Views/VPNPage.vala"
	gtk_grid_attach (_tmp33_, (GtkWidget*) _tmp34_, 0, 1, 1, 1);
#line 101 "../src/Views/VPNPage.vala"
	_tmp35_ = (GtkFrame*) gtk_frame_new (NULL);
#line 101 "../src/Views/VPNPage.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp35_, TRUE);
#line 101 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp35_);
#line 101 "../src/Views/VPNPage.vala"
	frame = _tmp35_;
#line 104 "../src/Views/VPNPage.vala"
	_tmp36_ = frame;
#line 104 "../src/Views/VPNPage.vala"
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
#line 104 "../src/Views/VPNPage.vala"
	gtk_style_context_add_class (_tmp37_, GTK_STYLE_CLASS_VIEW);
#line 105 "../src/Views/VPNPage.vala"
	_tmp38_ = frame;
#line 105 "../src/Views/VPNPage.vala"
	_tmp39_ = list_root;
#line 105 "../src/Views/VPNPage.vala"
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 107 "../src/Views/VPNPage.vala"
	_tmp40_ = (GtkOverlay*) gtk_overlay_new ();
#line 107 "../src/Views/VPNPage.vala"
	g_object_ref_sink (_tmp40_);
#line 107 "../src/Views/VPNPage.vala"
	main_overlay = _tmp40_;
#line 108 "../src/Views/VPNPage.vala"
	_tmp41_ = main_overlay;
#line 108 "../src/Views/VPNPage.vala"
	_tmp42_ = frame;
#line 108 "../src/Views/VPNPage.vala"
	gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
#line 109 "../src/Views/VPNPage.vala"
	_tmp43_ = main_overlay;
#line 109 "../src/Views/VPNPage.vala"
	_tmp44_ = self->priv->remove_vpn_toast;
#line 109 "../src/Views/VPNPage.vala"
	gtk_overlay_add_overlay (_tmp43_, (GtkWidget*) _tmp44_);
#line 111 "../src/Views/VPNPage.vala"
	_tmp45_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 111 "../src/Views/VPNPage.vala"
	_tmp46_ = _tmp45_;
#line 111 "../src/Views/VPNPage.vala"
	_tmp47_ = main_overlay;
#line 111 "../src/Views/VPNPage.vala"
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
#line 113 "../src/Views/VPNPage.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 115 "../src/Views/VPNPage.vala"
	_tmp48_ = self->priv->vpn_list;
#line 115 "../src/Views/VPNPage.vala"
	g_signal_connect_object (_tmp48_, "row-activated", (GCallback) __network_vpn_page___lambda32__gtk_list_box_row_activated, self, 0);
#line 123 "../src/Views/VPNPage.vala"
	_tmp49_ = self->priv->vpn_list;
#line 123 "../src/Views/VPNPage.vala"
	g_signal_connect_data (_tmp49_, "row-selected", (GCallback) __network_vpn_page___lambda33__gtk_list_box_row_selected, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 128 "../src/Views/VPNPage.vala"
	_tmp50_ = gee_array_list_new (nm_active_connection_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 128 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->active_connections);
#line 128 "../src/Views/VPNPage.vala"
	self->priv->active_connections = (GeeList*) _tmp50_;
#line 130 "../src/Views/VPNPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 131 "../src/Views/VPNPage.vala"
	_tmp51_ = network_network_manager_get_default ();
#line 131 "../src/Views/VPNPage.vala"
	network_manager = _tmp51_;
#line 132 "../src/Views/VPNPage.vala"
	_tmp52_ = network_manager;
#line 132 "../src/Views/VPNPage.vala"
	_tmp53_ = network_network_manager_get_client (_tmp52_);
#line 132 "../src/Views/VPNPage.vala"
	_tmp54_ = _tmp53_;
#line 132 "../src/Views/VPNPage.vala"
	g_signal_connect_object ((GObject*) _tmp54_, "notify::active-connections", (GCallback) _network_vpn_page_update_active_connections_g_object_notify, self, 0);
#line 37 "../src/Views/VPNPage.vala"
	_g_object_unref0 (main_overlay);
#line 37 "../src/Views/VPNPage.vala"
	_g_object_unref0 (frame);
#line 37 "../src/Views/VPNPage.vala"
	_g_object_unref0 (list_root);
#line 37 "../src/Views/VPNPage.vala"
	_g_object_unref0 (scrolled);
#line 37 "../src/Views/VPNPage.vala"
	_g_object_unref0 (add_button);
#line 37 "../src/Views/VPNPage.vala"
	_g_object_unref0 (actionbar);
#line 37 "../src/Views/VPNPage.vala"
	_g_object_unref0 (placeholder);
#line 37 "../src/Views/VPNPage.vala"
	block6_data_unref (_data6_);
#line 37 "../src/Views/VPNPage.vala"
	_data6_ = NULL;
#line 37 "../src/Views/VPNPage.vala"
	return obj;
#line 2293 "VPNPage.c"
}

static void
network_vpn_page_class_init (NetworkVPNPageClass * klass,
                             gpointer klass_data)
{
#line 20 "../src/Views/VPNPage.vala"
	network_vpn_page_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Views/VPNPage.vala"
	g_type_class_adjust_private_offset (klass, &NetworkVPNPage_private_offset);
#line 20 "../src/Views/VPNPage.vala"
	((NetworkWidgetsPageClass *) klass)->update = (void (*) (NetworkWidgetsPage*)) network_vpn_page_real_update;
#line 20 "../src/Views/VPNPage.vala"
	((NetworkWidgetsPageClass *) klass)->update_switch = (void (*) (NetworkWidgetsPage*)) network_vpn_page_real_update_switch;
#line 20 "../src/Views/VPNPage.vala"
	((NetworkWidgetsPageClass *) klass)->control_switch_activated = (void (*) (NetworkWidgetsPage*)) network_vpn_page_real_control_switch_activated;
#line 20 "../src/Views/VPNPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_page_get_property;
#line 20 "../src/Views/VPNPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_page_set_property;
#line 20 "../src/Views/VPNPage.vala"
	G_OBJECT_CLASS (klass)->constructor = network_vpn_page_constructor;
#line 20 "../src/Views/VPNPage.vala"
	G_OBJECT_CLASS (klass)->finalize = network_vpn_page_finalize;
#line 20 "../src/Views/VPNPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_PAGE_OWNER_PROPERTY, network_vpn_page_properties[NETWORK_VPN_PAGE_OWNER_PROPERTY] = g_param_spec_object ("owner", "owner", "owner", NETWORK_WIDGETS_TYPE_DEVICE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2320 "VPNPage.c"
}

static void
network_vpn_page_instance_init (NetworkVPNPage * self,
                                gpointer klass)
{
#line 20 "../src/Views/VPNPage.vala"
	self->priv = network_vpn_page_get_instance_private (self);
#line 25 "../src/Views/VPNPage.vala"
	self->priv->timeout_id = (guint) 0;
#line 2331 "VPNPage.c"
}

static void
network_vpn_page_finalize (GObject * obj)
{
	NetworkVPNPage * self;
#line 20 "../src/Views/VPNPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage);
#line 21 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->_owner);
#line 22 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->active_connections);
#line 24 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->vpn_list);
#line 26 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->sel_row);
#line 27 "../src/Views/VPNPage.vala"
	_g_object_unref0 (self->priv->remove_vpn_toast);
#line 20 "../src/Views/VPNPage.vala"
	G_OBJECT_CLASS (network_vpn_page_parent_class)->finalize (obj);
#line 2352 "VPNPage.c"
}

static GType
network_vpn_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkVPNPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVPNPage), 0, (GInstanceInitFunc) network_vpn_page_instance_init, NULL };
	GType network_vpn_page_type_id;
	network_vpn_page_type_id = g_type_register_static (NETWORK_WIDGETS_TYPE_PAGE, "NetworkVPNPage", &g_define_type_info, 0);
	NetworkVPNPage_private_offset = g_type_add_instance_private (network_vpn_page_type_id, sizeof (NetworkVPNPagePrivate));
	return network_vpn_page_type_id;
}

GType
network_vpn_page_get_type (void)
{
	static volatile gsize network_vpn_page_type_id__once = 0;
	if (g_once_init_enter (&network_vpn_page_type_id__once)) {
		GType network_vpn_page_type_id;
		network_vpn_page_type_id = network_vpn_page_get_type_once ();
		g_once_init_leave (&network_vpn_page_type_id__once, network_vpn_page_type_id);
	}
	return network_vpn_page_type_id__once;
}

static void
_vala_network_vpn_page_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	NetworkVPNPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage);
#line 20 "../src/Views/VPNPage.vala"
	switch (property_id) {
#line 20 "../src/Views/VPNPage.vala"
		case NETWORK_VPN_PAGE_OWNER_PROPERTY:
#line 20 "../src/Views/VPNPage.vala"
		g_value_set_object (value, network_vpn_page_get_owner (self));
#line 20 "../src/Views/VPNPage.vala"
		break;
#line 2393 "VPNPage.c"
		default:
#line 20 "../src/Views/VPNPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Views/VPNPage.vala"
		break;
#line 2399 "VPNPage.c"
	}
}

static void
_vala_network_vpn_page_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	NetworkVPNPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage);
#line 20 "../src/Views/VPNPage.vala"
	switch (property_id) {
#line 20 "../src/Views/VPNPage.vala"
		case NETWORK_VPN_PAGE_OWNER_PROPERTY:
#line 20 "../src/Views/VPNPage.vala"
		network_vpn_page_set_owner (self, g_value_get_object (value));
#line 20 "../src/Views/VPNPage.vala"
		break;
#line 2419 "VPNPage.c"
		default:
#line 20 "../src/Views/VPNPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Views/VPNPage.vala"
		break;
#line 2425 "VPNPage.c"
	}
}

