/* WifiPage.c generated by valac 0.56.14, the Vala compiler
 * generated from WifiPage.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <nma-wifi-dialog.h>
#include <gio/gio.h>
#include <pango/pango.h>

enum  {
	NETWORK_WIFI_INTERFACE_0_PROPERTY,
	NETWORK_WIFI_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _rf_kill_device_unref0(var) ((var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block7Data Block7Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
typedef struct _NetworkWifiInterfaceConnectToNetworkData NetworkWifiInterfaceConnectToNetworkData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NetworkWifiInterfacePrivate {
	RFKillManager* rfkill;
	NMAccessPoint* active_ap;
	GtkListBox* wifi_list;
	NetworkWifiMenuItem* _active_wifi_item;
	GtkStack* placeholder;
	gboolean locked;
	gboolean software_locked;
	gboolean hardware_locked;
	guint timeout_scan;
};

struct _Block7Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMClient* client;
};

struct _Block8Data {
	int _ref_count_;
	Block7Data * _data7_;
	NMAWifiDialog* wifi_dialog;
};

struct _Block9Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMAWifiDialog* hidden_dialog;
};

struct _Block10Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMConnection* fuzzy;
	NMConnection* dialog_connection;
	gpointer _async_data_;
};

struct _NetworkWifiInterfaceConnectToNetworkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	NetworkWifiInterface* self;
	NMAWifiDialog* wifi_dialog;
	Block10Data* _data10_;
	NMDevice* dialog_device;
	NMAccessPoint* dialog_ap;
	NMDevice* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMConnection* _tmp2_;
	NetworkNetworkManager* network_manager;
	NetworkNetworkManager* _tmp3_;
	NMClient* client;
	NetworkNetworkManager* _tmp4_;
	NMClient* _tmp5_;
	NMClient* _tmp6_;
	NMClient* _tmp7_;
	GPtrArray* _tmp8_;
	gchar* path;
	NMAccessPoint* _tmp9_;
	NMAccessPoint* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	NMConnection* _tmp13_;
	NMClient* _tmp14_;
	NMConnection* _tmp15_;
	NMDeviceWifi* _tmp16_;
	const gchar* _tmp17_;
	NMActiveConnection* _tmp18_;
	NMActiveConnection* _tmp19_;
	GError* _error_;
	GError* _tmp20_;
	const gchar* _tmp21_;
	gchar* mode;
	NMSettingWireless* setting_wireless;
	NMConnection* _tmp22_;
	NMSettingWireless* _tmp23_;
	NMSettingWireless* _tmp24_;
	NMSettingWireless* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	NMSettingConnection* connection_setting;
	NMConnection* _tmp29_;
	NMSettingConnection* _tmp30_;
	NMSettingConnection* _tmp31_;
	NMSettingConnection* _tmp32_;
	NMSettingConnection* _tmp33_;
	NMConnection* _tmp34_;
	NMSettingConnection* _tmp35_;
	NMSetting* _tmp36_;
	NMClient* _tmp37_;
	NMConnection* _tmp38_;
	NMDevice* _tmp39_;
	const gchar* _tmp40_;
	NMActiveConnection* _tmp41_;
	NMActiveConnection* _tmp42_;
	GError* _vala1__error_;
	GError* _tmp43_;
	const gchar* _tmp44_;
	GError* _inner_error0_;
};

static gint NetworkWifiInterface_private_offset;
static gpointer network_wifi_interface_parent_class = NULL;

static void network_wifi_interface_real_update_name (NetworkWidgetsPage* base,
                                              gint count);
static void network_wifi_interface_access_point_added_cb (NetworkWifiInterface* self,
                                                   GObject* ap_);
static void network_wifi_interface_wifi_activate_cb (NetworkWifiInterface* self,
                                              NetworkWifiMenuItem* row);
static void _network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action (NetworkWifiMenuItem* _sender,
                                                                                  gpointer self);
static void network_wifi_interface_update_active_ap (NetworkWifiInterface* self);
static NetworkWifiMenuItem* network_wifi_interface_get_active_wifi_item (NetworkWifiInterface* self);
static void network_wifi_interface_set_active_wifi_item (NetworkWifiInterface* self,
                                                  NetworkWifiMenuItem* value);
static void network_wifi_interface_access_point_removed_cb (NetworkWifiInterface* self,
                                                     GObject* ap_);
static void network_wifi_interface_real_update (NetworkWidgetsPage* base);
static void network_wifi_interface_cancel_scan (NetworkWifiInterface* self);
static void network_wifi_interface_set_scan_placeholder (NetworkWifiInterface* self);
static void _rf_kill_device_unref0_ (gpointer var);
static inline void _g_list_free__rf_kill_device_unref0_ (GList* self);
static void ____lambda15_ (NetworkWifiInterface* self);
static void _____lambda15__gtk_button_clicked (GtkButton* _sender,
                                        gpointer self);
static void ____lambda18_ (NetworkWifiInterface* self);
static void _____lambda18__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                               gpointer self);
static void network_wifi_interface_real_update_switch (NetworkWidgetsPage* base);
static void network_wifi_interface_real_control_switch_activated (NetworkWidgetsPage* base);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static NMConnection* network_wifi_interface_get_valid_connection (NetworkWifiInterface* self,
                                                           NMAccessPoint* ap,
                                                           GPtrArray* ap_connections);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda10_ (Block8Data* _data8_,
                   gint response);
static void network_wifi_interface_connect_to_network (NetworkWifiInterface* self,
                                                NMAWifiDialog* wifi_dialog,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void network_wifi_interface_connect_to_network_finish (NetworkWifiInterface* self,
                                                       GAsyncResult* _res_);
static void ____lambda10__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static void ___lambda12_ (Block7Data* _data7_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda12__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static gboolean __lambda13_ (NetworkWifiInterface* self);
static gboolean ___lambda13__gsource_func (gpointer self);
static void network_wifi_interface_connect_to_hidden (NetworkWifiInterface* self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda19_ (Block9Data* _data9_,
                  gint response);
static void ___lambda19__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void network_wifi_interface_connect_to_network_data_free (gpointer _data);
static gboolean network_wifi_interface_connect_to_network_co (NetworkWifiInterfaceConnectToNetworkData* _data_);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda11_ (Block10Data* _data10_,
                  NMRemoteConnection* possible);
static void ___lambda11__gfunc (gconstpointer data,
                         gpointer self);
static void network_wifi_interface_connect_to_network_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static gboolean ___lambda14_ (NetworkWifiInterface* self);
static gboolean ____lambda14__gsource_func (gpointer self);
static gint network_wifi_interface_sort_func (NetworkWifiInterface* self,
                                       GtkListBoxRow* r1,
                                       GtkListBoxRow* r2);
static GObject * network_wifi_interface_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static gint _network_wifi_interface_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                               GtkListBoxRow* row2,
                                                               gpointer self);
static void _network_wifi_interface___lambda20_ (NetworkWifiInterface* self);
static void __network_wifi_interface___lambda20__gtk_widget_hide (GtkWidget* _sender,
                                                           gpointer self);
static void _network_wifi_interface_connect_to_hidden_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_added (RFKillManager* _sender,
                                                                RFKillDevice* device,
                                                                gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_changed (RFKillManager* _sender,
                                                                  RFKillDevice* device,
                                                                  gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_deleted (RFKillManager* _sender,
                                                                  RFKillDevice* device,
                                                                  gpointer self);
static void _network_widgets_page_update_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void _network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added (NMDeviceWifi* _sender,
                                                                                      GObject* ap,
                                                                                      gpointer self);
static void _network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed (NMDeviceWifi* _sender,
                                                                                          GObject* ap,
                                                                                          gpointer self);
static void _network_widgets_page_update_nm_device_state_changed (NMDevice* _sender,
                                                           guint new_state,
                                                           guint old_state,
                                                           guint reason,
                                                           gpointer self);
static void _network_wifi_interface_access_point_added_cb_gfunc (gconstpointer data,
                                                          gpointer self);
static void network_wifi_interface_finalize (GObject * obj);
static GType network_wifi_interface_get_type_once (void);
static void _vala_network_wifi_interface_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_interface_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_interface_get_instance_private (NetworkWifiInterface* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiInterface_private_offset);
}

NetworkWifiInterface*
network_wifi_interface_construct (GType object_type,
                                  NMDevice* device)
{
	NetworkWifiInterface * self = NULL;
#line 49 "../src/Views/WifiPage.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 50 "../src/Views/WifiPage.vala"
	self = (NetworkWifiInterface*) g_object_new (object_type, "activatable", TRUE, "device", device, NULL);
#line 49 "../src/Views/WifiPage.vala"
	return self;
#line 306 "WifiPage.c"
}

NetworkWifiInterface*
network_wifi_interface_new (NMDevice* device)
{
#line 49 "../src/Views/WifiPage.vala"
	return network_wifi_interface_construct (NETWORK_TYPE_WIFI_INTERFACE, device);
#line 314 "WifiPage.c"
}

static void
network_wifi_interface_real_update_name (NetworkWidgetsPage* base,
                                         gint count)
{
	NetworkWifiInterface * self;
#line 187 "../src/Views/WifiPage.vala"
	self = (NetworkWifiInterface*) base;
#line 188 "../src/Views/WifiPage.vala"
	if (count <= 1) {
#line 189 "../src/Views/WifiPage.vala"
		granite_simple_settings_page_set_title ((GraniteSimpleSettingsPage*) self, _ ("Wireless"));
#line 328 "WifiPage.c"
	} else {
		NMDevice* _tmp0_;
		NMDevice* _tmp1_;
		const gchar* _tmp2_;
#line 191 "../src/Views/WifiPage.vala"
		_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
#line 191 "../src/Views/WifiPage.vala"
		_tmp1_ = _tmp0_;
#line 191 "../src/Views/WifiPage.vala"
		_tmp2_ = nm_device_get_description (_tmp1_);
#line 191 "../src/Views/WifiPage.vala"
		granite_simple_settings_page_set_title ((GraniteSimpleSettingsPage*) self, _tmp2_);
#line 341 "WifiPage.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 196 "../src/Views/WifiPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 350 "WifiPage.c"
}

static void
_network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action (NetworkWifiMenuItem* _sender,
                                                                             gpointer self)
{
#line 217 "../src/Views/WifiPage.vala"
	network_wifi_interface_wifi_activate_cb ((NetworkWifiInterface*) self, _sender);
#line 359 "WifiPage.c"
}

static void
network_wifi_interface_access_point_added_cb (NetworkWifiInterface* self,
                                              GObject* ap_)
{
	NMAccessPoint* ap = NULL;
	NMAccessPoint* _tmp0_;
	gboolean found = FALSE;
	NMAccessPoint* _tmp1_;
	GBytes* _tmp2_;
	GBytes* _tmp3_;
	gboolean _tmp16_ = FALSE;
#line 195 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Views/WifiPage.vala"
	g_return_if_fail (ap_ != NULL);
#line 196 "../src/Views/WifiPage.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ap_, nm_access_point_get_type (), NMAccessPoint));
#line 196 "../src/Views/WifiPage.vala"
	ap = _tmp0_;
#line 198 "../src/Views/WifiPage.vala"
	found = FALSE;
#line 200 "../src/Views/WifiPage.vala"
	_tmp1_ = ap;
#line 200 "../src/Views/WifiPage.vala"
	_tmp2_ = nm_access_point_get_ssid (_tmp1_);
#line 200 "../src/Views/WifiPage.vala"
	_tmp3_ = _tmp2_;
#line 200 "../src/Views/WifiPage.vala"
	if (_tmp3_ != NULL) {
#line 391 "WifiPage.c"
		GtkListBox* _tmp4_;
		GList* _tmp5_;
#line 201 "../src/Views/WifiPage.vala"
		_tmp4_ = self->priv->wifi_list;
#line 201 "../src/Views/WifiPage.vala"
		_tmp5_ = gtk_container_get_children ((GtkContainer*) _tmp4_);
#line 398 "WifiPage.c"
		{
			GList* w_collection = NULL;
			GList* w_it = NULL;
#line 201 "../src/Views/WifiPage.vala"
			w_collection = _tmp5_;
#line 201 "../src/Views/WifiPage.vala"
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 406 "WifiPage.c"
				GtkWidget* w = NULL;
#line 201 "../src/Views/WifiPage.vala"
				w = (GtkWidget*) w_it->data;
#line 410 "WifiPage.c"
				{
					NetworkWifiMenuItem* menu_item = NULL;
					GtkWidget* _tmp6_;
					NetworkWifiMenuItem* _tmp7_;
					NMAccessPoint* _tmp8_;
					GBytes* _tmp9_;
					GBytes* _tmp10_;
					NetworkWifiMenuItem* _tmp11_;
					GBytes* _tmp12_;
					GBytes* _tmp13_;
#line 202 "../src/Views/WifiPage.vala"
					_tmp6_ = w;
#line 202 "../src/Views/WifiPage.vala"
					_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
#line 202 "../src/Views/WifiPage.vala"
					menu_item = _tmp7_;
#line 204 "../src/Views/WifiPage.vala"
					_tmp8_ = ap;
#line 204 "../src/Views/WifiPage.vala"
					_tmp9_ = nm_access_point_get_ssid (_tmp8_);
#line 204 "../src/Views/WifiPage.vala"
					_tmp10_ = _tmp9_;
#line 204 "../src/Views/WifiPage.vala"
					_tmp11_ = menu_item;
#line 204 "../src/Views/WifiPage.vala"
					_tmp12_ = network_wifi_menu_item_get_ssid (_tmp11_);
#line 204 "../src/Views/WifiPage.vala"
					_tmp13_ = _tmp12_;
#line 204 "../src/Views/WifiPage.vala"
					if (g_bytes_compare (_tmp10_, _tmp13_) == 0) {
#line 441 "WifiPage.c"
						NetworkWifiMenuItem* _tmp14_;
						NMAccessPoint* _tmp15_;
#line 205 "../src/Views/WifiPage.vala"
						found = TRUE;
#line 206 "../src/Views/WifiPage.vala"
						_tmp14_ = menu_item;
#line 206 "../src/Views/WifiPage.vala"
						_tmp15_ = ap;
#line 206 "../src/Views/WifiPage.vala"
						network_wifi_menu_item_add_ap (_tmp14_, _tmp15_);
#line 207 "../src/Views/WifiPage.vala"
						_g_object_unref0 (menu_item);
#line 207 "../src/Views/WifiPage.vala"
						break;
#line 456 "WifiPage.c"
					}
#line 201 "../src/Views/WifiPage.vala"
					_g_object_unref0 (menu_item);
#line 460 "WifiPage.c"
				}
			}
#line 201 "../src/Views/WifiPage.vala"
			(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
#line 465 "WifiPage.c"
		}
	}
#line 213 "../src/Views/WifiPage.vala"
	if (!found) {
#line 470 "WifiPage.c"
		NMAccessPoint* _tmp17_;
		GBytes* _tmp18_;
		GBytes* _tmp19_;
#line 213 "../src/Views/WifiPage.vala"
		_tmp17_ = ap;
#line 213 "../src/Views/WifiPage.vala"
		_tmp18_ = nm_access_point_get_ssid (_tmp17_);
#line 213 "../src/Views/WifiPage.vala"
		_tmp19_ = _tmp18_;
#line 213 "../src/Views/WifiPage.vala"
		_tmp16_ = _tmp19_ != NULL;
#line 482 "WifiPage.c"
	} else {
#line 213 "../src/Views/WifiPage.vala"
		_tmp16_ = FALSE;
#line 486 "WifiPage.c"
	}
#line 213 "../src/Views/WifiPage.vala"
	if (_tmp16_) {
#line 490 "WifiPage.c"
		NetworkWifiMenuItem* item = NULL;
		NMAccessPoint* _tmp20_;
		NetworkWifiMenuItem* _tmp21_ = NULL;
		NetworkWifiMenuItem* _tmp22_;
		GtkListBox* _tmp23_;
		NetworkWifiMenuItem* _tmp24_;
		GtkListBox* _tmp25_;
#line 214 "../src/Views/WifiPage.vala"
		_tmp20_ = ap;
#line 214 "../src/Views/WifiPage.vala"
		_tmp21_ = network_wifi_menu_item_new (_tmp20_);
#line 214 "../src/Views/WifiPage.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp21_, TRUE);
#line 214 "../src/Views/WifiPage.vala"
		g_object_ref_sink (_tmp21_);
#line 214 "../src/Views/WifiPage.vala"
		item = _tmp21_;
#line 217 "../src/Views/WifiPage.vala"
		_tmp22_ = item;
#line 217 "../src/Views/WifiPage.vala"
		g_signal_connect_object (_tmp22_, "user-action", (GCallback) _network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action, self, 0);
#line 219 "../src/Views/WifiPage.vala"
		_tmp23_ = self->priv->wifi_list;
#line 219 "../src/Views/WifiPage.vala"
		_tmp24_ = item;
#line 219 "../src/Views/WifiPage.vala"
		gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 220 "../src/Views/WifiPage.vala"
		_tmp25_ = self->priv->wifi_list;
#line 220 "../src/Views/WifiPage.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp25_);
#line 222 "../src/Views/WifiPage.vala"
		network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 213 "../src/Views/WifiPage.vala"
		_g_object_unref0 (item);
#line 526 "WifiPage.c"
	}
#line 195 "../src/Views/WifiPage.vala"
	_g_object_unref0 (ap);
#line 530 "WifiPage.c"
}

static void
network_wifi_interface_update_active_ap (NetworkWifiInterface* self)
{
	NMDeviceWifi* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	NetworkWifiMenuItem* _tmp3_;
	NMAccessPoint* _tmp8_;
#line 226 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/Views/WifiPage.vala"
	g_debug ("WifiPage.vala:227: Update active AP");
#line 229 "../src/Views/WifiPage.vala"
	_tmp0_ = self->wifi_device;
#line 229 "../src/Views/WifiPage.vala"
	_tmp1_ = nm_device_wifi_get_active_access_point (_tmp0_);
#line 229 "../src/Views/WifiPage.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 229 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->active_ap);
#line 229 "../src/Views/WifiPage.vala"
	self->priv->active_ap = _tmp2_;
#line 231 "../src/Views/WifiPage.vala"
	_tmp3_ = self->priv->_active_wifi_item;
#line 231 "../src/Views/WifiPage.vala"
	if (_tmp3_ != NULL) {
#line 559 "WifiPage.c"
		NetworkWifiMenuItem* _tmp4_;
		NMDeviceState _tmp5_;
		NMDeviceState _tmp6_;
#line 232 "../src/Views/WifiPage.vala"
		_tmp4_ = self->priv->_active_wifi_item;
#line 232 "../src/Views/WifiPage.vala"
		_tmp5_ = network_wifi_menu_item_get_state (_tmp4_);
#line 232 "../src/Views/WifiPage.vala"
		_tmp6_ = _tmp5_;
#line 232 "../src/Views/WifiPage.vala"
		if (_tmp6_ == NM_DEVICE_STATE_PREPARE) {
#line 571 "WifiPage.c"
			NetworkWifiMenuItem* _tmp7_;
#line 233 "../src/Views/WifiPage.vala"
			_tmp7_ = self->priv->_active_wifi_item;
#line 233 "../src/Views/WifiPage.vala"
			network_wifi_menu_item_set_state (_tmp7_, NM_DEVICE_STATE_DISCONNECTED);
#line 577 "WifiPage.c"
		}
#line 235 "../src/Views/WifiPage.vala"
		network_wifi_interface_set_active_wifi_item (self, NULL);
#line 581 "WifiPage.c"
	}
#line 238 "../src/Views/WifiPage.vala"
	_tmp8_ = self->priv->active_ap;
#line 238 "../src/Views/WifiPage.vala"
	if (_tmp8_ == NULL) {
#line 239 "../src/Views/WifiPage.vala"
		g_debug ("WifiPage.vala:239: No active AP");
#line 589 "WifiPage.c"
	} else {
		NMAccessPoint* _tmp9_;
		GBytes* _tmp10_;
		gsize _tmp11_ = 0;
		guint8* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean found = FALSE;
		GtkListBox* _tmp15_;
		GList* _tmp16_;
#line 241 "../src/Views/WifiPage.vala"
		_tmp9_ = self->priv->active_ap;
#line 241 "../src/Views/WifiPage.vala"
		_tmp10_ = nm_access_point_get_ssid (_tmp9_);
#line 241 "../src/Views/WifiPage.vala"
		_tmp12_ = g_bytes_get_data (_tmp10_, &_tmp11_);
#line 241 "../src/Views/WifiPage.vala"
		_tmp13_ = nm_utils_ssid_to_utf8 (_tmp12_, (gsize) _tmp11_);
#line 241 "../src/Views/WifiPage.vala"
		_tmp14_ = _tmp13_;
#line 241 "../src/Views/WifiPage.vala"
		g_debug ("WifiPage.vala:241: Active ap: %s", _tmp14_);
#line 241 "../src/Views/WifiPage.vala"
		_g_free0 (_tmp14_);
#line 243 "../src/Views/WifiPage.vala"
		found = FALSE;
#line 244 "../src/Views/WifiPage.vala"
		_tmp15_ = self->priv->wifi_list;
#line 244 "../src/Views/WifiPage.vala"
		_tmp16_ = gtk_container_get_children ((GtkContainer*) _tmp15_);
#line 620 "WifiPage.c"
		{
			GList* w_collection = NULL;
			GList* w_it = NULL;
#line 244 "../src/Views/WifiPage.vala"
			w_collection = _tmp16_;
#line 244 "../src/Views/WifiPage.vala"
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 628 "WifiPage.c"
				GtkWidget* w = NULL;
#line 244 "../src/Views/WifiPage.vala"
				w = (GtkWidget*) w_it->data;
#line 632 "WifiPage.c"
				{
					NetworkWifiMenuItem* menu_item = NULL;
					GtkWidget* _tmp17_;
					NetworkWifiMenuItem* _tmp18_;
					NMAccessPoint* _tmp19_;
					GBytes* _tmp20_;
					GBytes* _tmp21_;
					NetworkWifiMenuItem* _tmp22_;
					GBytes* _tmp23_;
					GBytes* _tmp24_;
#line 245 "../src/Views/WifiPage.vala"
					_tmp17_ = w;
#line 245 "../src/Views/WifiPage.vala"
					_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
#line 245 "../src/Views/WifiPage.vala"
					menu_item = _tmp18_;
#line 247 "../src/Views/WifiPage.vala"
					_tmp19_ = self->priv->active_ap;
#line 247 "../src/Views/WifiPage.vala"
					_tmp20_ = nm_access_point_get_ssid (_tmp19_);
#line 247 "../src/Views/WifiPage.vala"
					_tmp21_ = _tmp20_;
#line 247 "../src/Views/WifiPage.vala"
					_tmp22_ = menu_item;
#line 247 "../src/Views/WifiPage.vala"
					_tmp23_ = network_wifi_menu_item_get_ssid (_tmp22_);
#line 247 "../src/Views/WifiPage.vala"
					_tmp24_ = _tmp23_;
#line 247 "../src/Views/WifiPage.vala"
					if (g_bytes_compare (_tmp21_, _tmp24_) == 0) {
#line 663 "WifiPage.c"
						NetworkWifiMenuItem* _tmp25_;
						NetworkWifiMenuItem* _tmp26_;
						NetworkWifiMenuItem* _tmp27_;
						NMDeviceState _tmp28_;
						NMDeviceState _tmp29_;
#line 248 "../src/Views/WifiPage.vala"
						found = TRUE;
#line 249 "../src/Views/WifiPage.vala"
						_tmp25_ = menu_item;
#line 249 "../src/Views/WifiPage.vala"
						network_wifi_menu_item_set_active (_tmp25_, TRUE);
#line 250 "../src/Views/WifiPage.vala"
						_tmp26_ = menu_item;
#line 250 "../src/Views/WifiPage.vala"
						network_wifi_interface_set_active_wifi_item (self, _tmp26_);
#line 251 "../src/Views/WifiPage.vala"
						_tmp27_ = self->priv->_active_wifi_item;
#line 251 "../src/Views/WifiPage.vala"
						_tmp28_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
#line 251 "../src/Views/WifiPage.vala"
						_tmp29_ = _tmp28_;
#line 251 "../src/Views/WifiPage.vala"
						network_wifi_menu_item_set_state (_tmp27_, _tmp29_);
#line 687 "WifiPage.c"
					}
#line 244 "../src/Views/WifiPage.vala"
					_g_object_unref0 (menu_item);
#line 691 "WifiPage.c"
				}
			}
#line 244 "../src/Views/WifiPage.vala"
			(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
#line 696 "WifiPage.c"
		}
#line 256 "../src/Views/WifiPage.vala"
		if (!found) {
#line 257 "../src/Views/WifiPage.vala"
			g_debug ("WifiPage.vala:257: Active AP not added");
#line 702 "WifiPage.c"
		}
	}
}

static void
network_wifi_interface_access_point_removed_cb (NetworkWifiInterface* self,
                                                GObject* ap_)
{
	NMAccessPoint* ap = NULL;
	NMAccessPoint* _tmp0_;
	NetworkWifiMenuItem* found_item = NULL;
	GtkListBox* _tmp1_;
	GList* _tmp2_;
	NetworkWifiMenuItem* _tmp14_;
#line 262 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/Views/WifiPage.vala"
	g_return_if_fail (ap_ != NULL);
#line 263 "../src/Views/WifiPage.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ap_, nm_access_point_get_type (), NMAccessPoint));
#line 263 "../src/Views/WifiPage.vala"
	ap = _tmp0_;
#line 265 "../src/Views/WifiPage.vala"
	found_item = NULL;
#line 267 "../src/Views/WifiPage.vala"
	_tmp1_ = self->priv->wifi_list;
#line 267 "../src/Views/WifiPage.vala"
	_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
#line 731 "WifiPage.c"
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
#line 267 "../src/Views/WifiPage.vala"
		w_collection = _tmp2_;
#line 267 "../src/Views/WifiPage.vala"
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 739 "WifiPage.c"
			GtkWidget* w = NULL;
#line 267 "../src/Views/WifiPage.vala"
			w = (GtkWidget*) w_it->data;
#line 743 "WifiPage.c"
			{
				NetworkWifiMenuItem* menu_item = NULL;
				GtkWidget* _tmp3_;
				NetworkWifiMenuItem* _tmp4_;
				NetworkWifiMenuItem* _tmp5_;
				NMAccessPoint* _tmp6_;
				GBytes* _tmp7_;
				GBytes* _tmp8_;
				NetworkWifiMenuItem* _tmp9_;
				GBytes* _tmp10_;
				GBytes* _tmp11_;
#line 268 "../src/Views/WifiPage.vala"
				_tmp3_ = w;
#line 268 "../src/Views/WifiPage.vala"
				_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
#line 268 "../src/Views/WifiPage.vala"
				menu_item = _tmp4_;
#line 270 "../src/Views/WifiPage.vala"
				_tmp5_ = menu_item;
#line 270 "../src/Views/WifiPage.vala"
				_vala_assert (_tmp5_ != NULL, "menu_item != null");
#line 272 "../src/Views/WifiPage.vala"
				_tmp6_ = ap;
#line 272 "../src/Views/WifiPage.vala"
				_tmp7_ = nm_access_point_get_ssid (_tmp6_);
#line 272 "../src/Views/WifiPage.vala"
				_tmp8_ = _tmp7_;
#line 272 "../src/Views/WifiPage.vala"
				_tmp9_ = menu_item;
#line 272 "../src/Views/WifiPage.vala"
				_tmp10_ = network_wifi_menu_item_get_ssid (_tmp9_);
#line 272 "../src/Views/WifiPage.vala"
				_tmp11_ = _tmp10_;
#line 272 "../src/Views/WifiPage.vala"
				if (g_bytes_compare (_tmp8_, _tmp11_) == 0) {
#line 779 "WifiPage.c"
					NetworkWifiMenuItem* _tmp12_;
					NetworkWifiMenuItem* _tmp13_;
#line 273 "../src/Views/WifiPage.vala"
					_tmp12_ = menu_item;
#line 273 "../src/Views/WifiPage.vala"
					_tmp13_ = _g_object_ref0 (_tmp12_);
#line 273 "../src/Views/WifiPage.vala"
					_g_object_unref0 (found_item);
#line 273 "../src/Views/WifiPage.vala"
					found_item = _tmp13_;
#line 274 "../src/Views/WifiPage.vala"
					_g_object_unref0 (menu_item);
#line 274 "../src/Views/WifiPage.vala"
					break;
#line 794 "WifiPage.c"
				}
#line 267 "../src/Views/WifiPage.vala"
				_g_object_unref0 (menu_item);
#line 798 "WifiPage.c"
			}
		}
#line 267 "../src/Views/WifiPage.vala"
		(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
#line 803 "WifiPage.c"
	}
#line 278 "../src/Views/WifiPage.vala"
	_tmp14_ = found_item;
#line 278 "../src/Views/WifiPage.vala"
	if (_tmp14_ == NULL) {
#line 279 "../src/Views/WifiPage.vala"
		g_critical ("WifiPage.vala:279: Couldn't remove an access point which has not been " \
"added.");
#line 811 "WifiPage.c"
	} else {
		NetworkWifiMenuItem* _tmp15_;
		NMAccessPoint* _tmp16_;
#line 281 "../src/Views/WifiPage.vala"
		_tmp15_ = found_item;
#line 281 "../src/Views/WifiPage.vala"
		_tmp16_ = ap;
#line 281 "../src/Views/WifiPage.vala"
		if (!network_wifi_menu_item_remove_ap (_tmp15_, _tmp16_)) {
#line 821 "WifiPage.c"
			NetworkWifiMenuItem* _tmp17_;
#line 282 "../src/Views/WifiPage.vala"
			_tmp17_ = found_item;
#line 282 "../src/Views/WifiPage.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp17_);
#line 827 "WifiPage.c"
		}
	}
#line 286 "../src/Views/WifiPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 262 "../src/Views/WifiPage.vala"
	_g_object_unref0 (found_item);
#line 262 "../src/Views/WifiPage.vala"
	_g_object_unref0 (ap);
#line 836 "WifiPage.c"
}

static gpointer
_rf_kill_device_ref0 (gpointer self)
{
#line 341 "../src/Views/WifiPage.vala"
	return self ? rf_kill_device_ref (self) : NULL;
#line 844 "WifiPage.c"
}

static void
_rf_kill_device_unref0_ (gpointer var)
{
#line 341 "../src/Views/WifiPage.vala"
	(var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL));
#line 852 "WifiPage.c"
}

static inline void
_g_list_free__rf_kill_device_unref0_ (GList* self)
{
#line 341 "../src/Views/WifiPage.vala"
	g_list_free_full (self, (GDestroyNotify) _rf_kill_device_unref0_);
#line 860 "WifiPage.c"
}

static void
____lambda15_ (NetworkWifiInterface* self)
{
	GError* _inner_error0_ = NULL;
	{
		NMDevice* _tmp0_;
		NMDevice* _tmp1_;
#line 404 "../src/Views/WifiPage.vala"
		_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
#line 404 "../src/Views/WifiPage.vala"
		_tmp1_ = _tmp0_;
#line 404 "../src/Views/WifiPage.vala"
		nm_device_disconnect (_tmp1_, NULL, &_inner_error0_);
#line 404 "../src/Views/WifiPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 878 "WifiPage.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 403 "../src/Views/WifiPage.vala"
		e = _inner_error0_;
#line 403 "../src/Views/WifiPage.vala"
		_inner_error0_ = NULL;
#line 406 "../src/Views/WifiPage.vala"
		_tmp2_ = e;
#line 406 "../src/Views/WifiPage.vala"
		_tmp3_ = _tmp2_->message;
#line 406 "../src/Views/WifiPage.vala"
		g_warning ("WifiPage.vala:406: %s", _tmp3_);
#line 403 "../src/Views/WifiPage.vala"
		_g_error_free0 (e);
#line 900 "WifiPage.c"
	}
	__finally0:
#line 403 "../src/Views/WifiPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 403 "../src/Views/WifiPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 403 "../src/Views/WifiPage.vala"
		g_clear_error (&_inner_error0_);
#line 403 "../src/Views/WifiPage.vala"
		return;
#line 911 "WifiPage.c"
	}
}

static void
_____lambda15__gtk_button_clicked (GtkButton* _sender,
                                   gpointer self)
{
#line 402 "../src/Views/WifiPage.vala"
	____lambda15_ ((NetworkWifiInterface*) self);
#line 921 "WifiPage.c"
}

static void
____lambda18_ (NetworkWifiInterface* self)
{
	GtkPopover* _tmp0_;
	GtkToggleButton* _tmp1_;
#line 424 "../src/Views/WifiPage.vala"
	_tmp0_ = self->popover;
#line 424 "../src/Views/WifiPage.vala"
	_tmp1_ = self->info_btn;
#line 424 "../src/Views/WifiPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, gtk_toggle_button_get_active (_tmp1_));
#line 935 "WifiPage.c"
}

static void
_____lambda18__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                          gpointer self)
{
#line 423 "../src/Views/WifiPage.vala"
	____lambda18_ ((NetworkWifiInterface*) self);
#line 944 "WifiPage.c"
}

static void
network_wifi_interface_real_update (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	gboolean sensitive = FALSE;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp4_;
	GtkToggleButton* _tmp6_;
	GtkButton* _tmp8_;
	NetworkWifiMenuItem* old_active = NULL;
	NetworkWifiMenuItem* _tmp12_;
	NetworkWifiMenuItem* _tmp13_;
	NMDeviceWifi* _tmp14_;
	NMDeviceWifi* _tmp15_;
	NMDeviceState _tmp16_;
	NMDeviceState _tmp17_;
	NMDeviceWifi* _tmp23_;
	NMDeviceState _tmp24_;
	NMDeviceState _tmp25_;
	NMDeviceState _tmp26_;
	NMDeviceState _tmp27_;
	GEnumValue* _tmp28_;
	RFKillManager* _tmp29_;
	GList* _tmp30_;
	gboolean _tmp41_ = FALSE;
	gboolean is_hotspot = FALSE;
	NMDeviceWifi* _tmp42_;
	NMAccessPoint* active_access_point = NULL;
	NMDeviceWifi* _tmp43_;
	NMAccessPoint* _tmp44_;
	NMAccessPoint* _tmp45_;
	gboolean _tmp46_ = FALSE;
	NMAccessPoint* _tmp47_;
	GtkRevealer* _tmp48_;
	gboolean _tmp53_ = FALSE;
	NMAccessPoint* _tmp54_;
#line 289 "../src/Views/WifiPage.vala"
	self = (NetworkWifiInterface*) base;
#line 290 "../src/Views/WifiPage.vala"
	_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
#line 290 "../src/Views/WifiPage.vala"
	_tmp1_ = _tmp0_;
#line 290 "../src/Views/WifiPage.vala"
	sensitive = nm_device_get_state (_tmp1_) == NM_DEVICE_STATE_ACTIVATED;
#line 291 "../src/Views/WifiPage.vala"
	_tmp2_ = self->disconnect_btn;
#line 291 "../src/Views/WifiPage.vala"
	if (_tmp2_ != NULL) {
#line 997 "WifiPage.c"
		GtkButton* _tmp3_;
#line 292 "../src/Views/WifiPage.vala"
		_tmp3_ = self->disconnect_btn;
#line 292 "../src/Views/WifiPage.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, sensitive);
#line 1003 "WifiPage.c"
	}
#line 295 "../src/Views/WifiPage.vala"
	_tmp4_ = self->settings_btn;
#line 295 "../src/Views/WifiPage.vala"
	if (_tmp4_ != NULL) {
#line 1009 "WifiPage.c"
		GtkButton* _tmp5_;
#line 296 "../src/Views/WifiPage.vala"
		_tmp5_ = self->settings_btn;
#line 296 "../src/Views/WifiPage.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, sensitive);
#line 1015 "WifiPage.c"
	}
#line 299 "../src/Views/WifiPage.vala"
	_tmp6_ = self->info_btn;
#line 299 "../src/Views/WifiPage.vala"
	if (_tmp6_ != NULL) {
#line 1021 "WifiPage.c"
		GtkToggleButton* _tmp7_;
#line 300 "../src/Views/WifiPage.vala"
		_tmp7_ = self->info_btn;
#line 300 "../src/Views/WifiPage.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, sensitive);
#line 1027 "WifiPage.c"
	}
#line 303 "../src/Views/WifiPage.vala"
	_tmp8_ = self->hidden_btn;
#line 303 "../src/Views/WifiPage.vala"
	if (_tmp8_ != NULL) {
#line 1033 "WifiPage.c"
		GtkButton* _tmp9_;
		NMDeviceState _tmp10_;
		NMDeviceState _tmp11_;
#line 304 "../src/Views/WifiPage.vala"
		_tmp9_ = self->hidden_btn;
#line 304 "../src/Views/WifiPage.vala"
		_tmp10_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
#line 304 "../src/Views/WifiPage.vala"
		_tmp11_ = _tmp10_;
#line 304 "../src/Views/WifiPage.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, _tmp11_ != NM_DEVICE_STATE_UNAVAILABLE);
#line 1045 "WifiPage.c"
	}
#line 307 "../src/Views/WifiPage.vala"
	_tmp12_ = self->priv->_active_wifi_item;
#line 307 "../src/Views/WifiPage.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 307 "../src/Views/WifiPage.vala"
	old_active = _tmp13_;
#line 309 "../src/Views/WifiPage.vala"
	_tmp14_ = self->wifi_device;
#line 309 "../src/Views/WifiPage.vala"
	if (network_utils_get_device_is_hotspot (_tmp14_)) {
#line 310 "../src/Views/WifiPage.vala"
		network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_DISCONNECTED);
#line 311 "../src/Views/WifiPage.vala"
		_g_object_unref0 (old_active);
#line 311 "../src/Views/WifiPage.vala"
		return;
#line 1063 "WifiPage.c"
	}
#line 314 "../src/Views/WifiPage.vala"
	_tmp15_ = self->wifi_device;
#line 314 "../src/Views/WifiPage.vala"
	_tmp16_ = nm_device_get_state ((NMDevice*) _tmp15_);
#line 314 "../src/Views/WifiPage.vala"
	_tmp17_ = _tmp16_;
#line 314 "../src/Views/WifiPage.vala"
	switch (_tmp17_) {
#line 314 "../src/Views/WifiPage.vala"
		case NM_DEVICE_STATE_UNKNOWN:
#line 314 "../src/Views/WifiPage.vala"
		case NM_DEVICE_STATE_UNMANAGED:
#line 314 "../src/Views/WifiPage.vala"
		case NM_DEVICE_STATE_FAILED:
#line 1079 "WifiPage.c"
		{
			NetworkWifiMenuItem* _tmp18_;
#line 318 "../src/Views/WifiPage.vala"
			_tmp18_ = self->priv->_active_wifi_item;
#line 318 "../src/Views/WifiPage.vala"
			if (_tmp18_ != NULL) {
#line 1086 "WifiPage.c"
				NetworkWifiMenuItem* _tmp19_;
				NMDeviceState _tmp20_;
				NMDeviceState _tmp21_;
#line 319 "../src/Views/WifiPage.vala"
				_tmp19_ = self->priv->_active_wifi_item;
#line 319 "../src/Views/WifiPage.vala"
				_tmp20_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
#line 319 "../src/Views/WifiPage.vala"
				_tmp21_ = _tmp20_;
#line 319 "../src/Views/WifiPage.vala"
				network_wifi_menu_item_set_state (_tmp19_, _tmp21_);
#line 1098 "WifiPage.c"
			}
#line 321 "../src/Views/WifiPage.vala"
			network_wifi_interface_cancel_scan (self);
#line 322 "../src/Views/WifiPage.vala"
			break;
#line 1104 "WifiPage.c"
		}
#line 314 "../src/Views/WifiPage.vala"
		case NM_DEVICE_STATE_DEACTIVATING:
#line 314 "../src/Views/WifiPage.vala"
		case NM_DEVICE_STATE_UNAVAILABLE:
#line 1110 "WifiPage.c"
		{
			GtkStack* _tmp22_;
#line 326 "../src/Views/WifiPage.vala"
			network_wifi_interface_cancel_scan (self);
#line 327 "../src/Views/WifiPage.vala"
			_tmp22_ = self->priv->placeholder;
#line 327 "../src/Views/WifiPage.vala"
			gtk_stack_set_visible_child_name (_tmp22_, "wireless-off");
#line 328 "../src/Views/WifiPage.vala"
			break;
#line 1121 "WifiPage.c"
		}
		default:
		{
#line 330 "../src/Views/WifiPage.vala"
			network_wifi_interface_set_scan_placeholder (self);
#line 331 "../src/Views/WifiPage.vala"
			break;
#line 1129 "WifiPage.c"
		}
	}
#line 334 "../src/Views/WifiPage.vala"
	_tmp23_ = self->wifi_device;
#line 334 "../src/Views/WifiPage.vala"
	_tmp24_ = nm_device_get_state ((NMDevice*) _tmp23_);
#line 334 "../src/Views/WifiPage.vala"
	_tmp25_ = _tmp24_;
#line 334 "../src/Views/WifiPage.vala"
	network_widgets_page_set_state ((NetworkWidgetsPage*) self, _tmp25_);
#line 336 "../src/Views/WifiPage.vala"
	_tmp26_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
#line 336 "../src/Views/WifiPage.vala"
	_tmp27_ = _tmp26_;
#line 336 "../src/Views/WifiPage.vala"
	_tmp28_ = g_enum_get_value (g_type_class_ref (nm_device_state_get_type ()), _tmp27_);
#line 336 "../src/Views/WifiPage.vala"
	g_debug ("WifiPage.vala:336: New network state: %s", (_tmp28_ != NULL) ? _tmp28_->value_name : NULL);
#line 339 "../src/Views/WifiPage.vala"
	self->priv->software_locked = FALSE;
#line 340 "../src/Views/WifiPage.vala"
	self->priv->hardware_locked = FALSE;
#line 341 "../src/Views/WifiPage.vala"
	_tmp29_ = self->priv->rfkill;
#line 341 "../src/Views/WifiPage.vala"
	_tmp30_ = rf_kill_manager_get_devices (_tmp29_);
#line 1156 "WifiPage.c"
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
#line 341 "../src/Views/WifiPage.vala"
		device_collection = _tmp30_;
#line 341 "../src/Views/WifiPage.vala"
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 1164 "WifiPage.c"
			RFKillDevice* _tmp31_;
			RFKillDevice* device = NULL;
#line 341 "../src/Views/WifiPage.vala"
			_tmp31_ = _rf_kill_device_ref0 ((RFKillDevice*) device_it->data);
#line 341 "../src/Views/WifiPage.vala"
			device = _tmp31_;
#line 1171 "WifiPage.c"
			{
				RFKillDevice* _tmp32_;
				RFKillDeviceType _tmp33_;
				RFKillDeviceType _tmp34_;
				RFKillDevice* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
				RFKillDevice* _tmp38_;
				gboolean _tmp39_;
				gboolean _tmp40_;
#line 342 "../src/Views/WifiPage.vala"
				_tmp32_ = device;
#line 342 "../src/Views/WifiPage.vala"
				_tmp33_ = rf_kill_device_get_device_type (_tmp32_);
#line 342 "../src/Views/WifiPage.vala"
				_tmp34_ = _tmp33_;
#line 342 "../src/Views/WifiPage.vala"
				if (_tmp34_ != RF_KILL_DEVICE_TYPE_WLAN) {
#line 343 "../src/Views/WifiPage.vala"
					_rf_kill_device_unref0 (device);
#line 343 "../src/Views/WifiPage.vala"
					continue;
#line 1194 "WifiPage.c"
				}
#line 345 "../src/Views/WifiPage.vala"
				_tmp35_ = device;
#line 345 "../src/Views/WifiPage.vala"
				_tmp36_ = rf_kill_device_get_software_lock (_tmp35_);
#line 345 "../src/Views/WifiPage.vala"
				_tmp37_ = _tmp36_;
#line 345 "../src/Views/WifiPage.vala"
				if (_tmp37_) {
#line 346 "../src/Views/WifiPage.vala"
					self->priv->software_locked = TRUE;
#line 1206 "WifiPage.c"
				}
#line 347 "../src/Views/WifiPage.vala"
				_tmp38_ = device;
#line 347 "../src/Views/WifiPage.vala"
				_tmp39_ = rf_kill_device_get_hardware_lock (_tmp38_);
#line 347 "../src/Views/WifiPage.vala"
				_tmp40_ = _tmp39_;
#line 347 "../src/Views/WifiPage.vala"
				if (_tmp40_) {
#line 348 "../src/Views/WifiPage.vala"
					self->priv->hardware_locked = TRUE;
#line 1218 "WifiPage.c"
				}
#line 341 "../src/Views/WifiPage.vala"
				_rf_kill_device_unref0 (device);
#line 1222 "WifiPage.c"
			}
		}
#line 341 "../src/Views/WifiPage.vala"
		(device_collection == NULL) ? NULL : (device_collection = (_g_list_free__rf_kill_device_unref0_ (device_collection), NULL));
#line 1227 "WifiPage.c"
	}
#line 351 "../src/Views/WifiPage.vala"
	if (self->priv->hardware_locked) {
#line 351 "../src/Views/WifiPage.vala"
		_tmp41_ = TRUE;
#line 1233 "WifiPage.c"
	} else {
#line 351 "../src/Views/WifiPage.vala"
		_tmp41_ = self->priv->software_locked;
#line 1237 "WifiPage.c"
	}
#line 351 "../src/Views/WifiPage.vala"
	self->priv->locked = _tmp41_;
#line 353 "../src/Views/WifiPage.vala"
	network_wifi_interface_update_active_ap (self);
#line 355 "../src/Views/WifiPage.vala"
	NETWORK_WIDGETS_PAGE_CLASS (network_wifi_interface_parent_class)->update (G_TYPE_CHECK_INSTANCE_CAST (self, NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPage));
#line 357 "../src/Views/WifiPage.vala"
	_tmp42_ = self->wifi_device;
#line 357 "../src/Views/WifiPage.vala"
	is_hotspot = network_utils_get_device_is_hotspot (_tmp42_);
#line 359 "../src/Views/WifiPage.vala"
	_tmp43_ = self->wifi_device;
#line 359 "../src/Views/WifiPage.vala"
	_tmp44_ = nm_device_wifi_get_active_access_point (_tmp43_);
#line 359 "../src/Views/WifiPage.vala"
	_tmp45_ = _tmp44_;
#line 359 "../src/Views/WifiPage.vala"
	active_access_point = _tmp45_;
#line 360 "../src/Views/WifiPage.vala"
	_tmp47_ = active_access_point;
#line 360 "../src/Views/WifiPage.vala"
	if (_tmp47_ != NULL) {
#line 360 "../src/Views/WifiPage.vala"
		_tmp46_ = !is_hotspot;
#line 1263 "WifiPage.c"
	} else {
#line 360 "../src/Views/WifiPage.vala"
		_tmp46_ = FALSE;
#line 1267 "WifiPage.c"
	}
#line 360 "../src/Views/WifiPage.vala"
	_tmp48_ = self->top_revealer;
#line 360 "../src/Views/WifiPage.vala"
	gtk_revealer_set_reveal_child (_tmp48_, _tmp46_);
#line 362 "../src/Views/WifiPage.vala"
	if (is_hotspot) {
#line 1275 "WifiPage.c"
		GtkStack* _tmp49_;
		GtkBox* _tmp50_;
#line 363 "../src/Views/WifiPage.vala"
		_tmp49_ = self->list_stack;
#line 363 "../src/Views/WifiPage.vala"
		_tmp50_ = self->hotspot_mode_alert;
#line 363 "../src/Views/WifiPage.vala"
		gtk_stack_set_visible_child (_tmp49_, (GtkWidget*) _tmp50_);
#line 1284 "WifiPage.c"
	} else {
		GtkStack* _tmp51_;
		GtkScrolledWindow* _tmp52_;
#line 365 "../src/Views/WifiPage.vala"
		_tmp51_ = self->list_stack;
#line 365 "../src/Views/WifiPage.vala"
		_tmp52_ = self->scrolled;
#line 365 "../src/Views/WifiPage.vala"
		gtk_stack_set_visible_child (_tmp51_, (GtkWidget*) _tmp52_);
#line 1294 "WifiPage.c"
	}
#line 368 "../src/Views/WifiPage.vala"
	_tmp54_ = active_access_point;
#line 368 "../src/Views/WifiPage.vala"
	if (_tmp54_ == NULL) {
#line 1300 "WifiPage.c"
		NetworkWifiMenuItem* _tmp55_;
#line 368 "../src/Views/WifiPage.vala"
		_tmp55_ = old_active;
#line 368 "../src/Views/WifiPage.vala"
		_tmp53_ = _tmp55_ != NULL;
#line 1306 "WifiPage.c"
	} else {
#line 368 "../src/Views/WifiPage.vala"
		_tmp53_ = FALSE;
#line 1310 "WifiPage.c"
	}
#line 368 "../src/Views/WifiPage.vala"
	if (_tmp53_) {
#line 1314 "WifiPage.c"
		NetworkWifiMenuItem* _tmp56_;
		NetworkWifiMenuItem* _tmp57_;
		gboolean _tmp58_ = FALSE;
		GtkFrame* _tmp59_;
		GtkButton* _tmp64_;
		GtkButton* _tmp65_;
#line 369 "../src/Views/WifiPage.vala"
		_tmp56_ = old_active;
#line 369 "../src/Views/WifiPage.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp56_, FALSE);
#line 370 "../src/Views/WifiPage.vala"
		_tmp57_ = old_active;
#line 370 "../src/Views/WifiPage.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp57_, TRUE);
#line 372 "../src/Views/WifiPage.vala"
		_tmp59_ = self->connected_frame;
#line 372 "../src/Views/WifiPage.vala"
		if (_tmp59_ != NULL) {
#line 1333 "WifiPage.c"
			GtkFrame* _tmp60_;
			GtkWidget* _tmp61_;
#line 372 "../src/Views/WifiPage.vala"
			_tmp60_ = self->connected_frame;
#line 372 "../src/Views/WifiPage.vala"
			_tmp61_ = gtk_bin_get_child ((GtkBin*) _tmp60_);
#line 372 "../src/Views/WifiPage.vala"
			_tmp58_ = _tmp61_ != NULL;
#line 1342 "WifiPage.c"
		} else {
#line 372 "../src/Views/WifiPage.vala"
			_tmp58_ = FALSE;
#line 1346 "WifiPage.c"
		}
#line 372 "../src/Views/WifiPage.vala"
		if (_tmp58_) {
#line 1350 "WifiPage.c"
			GtkFrame* _tmp62_;
			GtkWidget* _tmp63_;
#line 373 "../src/Views/WifiPage.vala"
			_tmp62_ = self->connected_frame;
#line 373 "../src/Views/WifiPage.vala"
			_tmp63_ = gtk_bin_get_child ((GtkBin*) _tmp62_);
#line 373 "../src/Views/WifiPage.vala"
			gtk_widget_destroy (_tmp63_);
#line 1359 "WifiPage.c"
		}
#line 376 "../src/Views/WifiPage.vala"
		_g_object_unref0 (self->settings_btn);
#line 376 "../src/Views/WifiPage.vala"
		self->settings_btn = NULL;
#line 376 "../src/Views/WifiPage.vala"
		_tmp64_ = self->settings_btn;
#line 376 "../src/Views/WifiPage.vala"
		_tmp65_ = _g_object_ref0 (_tmp64_);
#line 376 "../src/Views/WifiPage.vala"
		_g_object_unref0 (self->disconnect_btn);
#line 376 "../src/Views/WifiPage.vala"
		self->disconnect_btn = _tmp65_;
#line 1373 "WifiPage.c"
	} else {
		gboolean _tmp66_ = FALSE;
		NMAccessPoint* _tmp67_;
#line 377 "../src/Views/WifiPage.vala"
		_tmp67_ = active_access_point;
#line 377 "../src/Views/WifiPage.vala"
		if (_tmp67_ != NULL) {
#line 1381 "WifiPage.c"
			NetworkWifiMenuItem* _tmp68_;
			NetworkWifiMenuItem* _tmp69_;
#line 377 "../src/Views/WifiPage.vala"
			_tmp68_ = self->priv->_active_wifi_item;
#line 377 "../src/Views/WifiPage.vala"
			_tmp69_ = old_active;
#line 377 "../src/Views/WifiPage.vala"
			_tmp66_ = _tmp68_ != _tmp69_;
#line 1390 "WifiPage.c"
		} else {
#line 377 "../src/Views/WifiPage.vala"
			_tmp66_ = FALSE;
#line 1394 "WifiPage.c"
		}
#line 377 "../src/Views/WifiPage.vala"
		if (_tmp66_) {
#line 1398 "WifiPage.c"
			NetworkWifiMenuItem* _tmp70_;
			NetworkWifiMenuItem* _tmp79_;
			NetworkWifiMenuItem* _tmp80_;
			NetworkWifiMenuItem* top_item = NULL;
			NMAccessPoint* _tmp81_;
			NetworkWifiMenuItem* _tmp82_ = NULL;
			GtkBox* _tmp83_;
			GtkBox* _tmp84_;
			NetworkWifiMenuItem* _tmp85_;
			NMDevice* _tmp86_;
			NMDevice* _tmp87_;
			GtkButton* _tmp88_ = NULL;
			GtkButton* _tmp89_;
			GtkStyleContext* _tmp90_;
			GtkButton* _tmp91_;
			NMDeviceWifi* _tmp92_;
			NMDevice* _tmp93_;
			NMDevice* _tmp94_;
			NetworkWidgetsSettingsButton* _tmp95_ = NULL;
			GtkImage* _tmp96_;
			GtkToggleButton* _tmp97_ = NULL;
			GtkToggleButton* _tmp98_;
			GtkStyleContext* _tmp99_;
			GtkPopover* _tmp100_;
			GtkToggleButton* _tmp101_;
			GtkToggleButton* _tmp102_;
			GtkBox* button_box = NULL;
			GtkBox* _tmp103_ = NULL;
			GtkBox* _tmp104_;
			GtkButton* _tmp105_;
			GtkBox* _tmp106_;
			GtkButton* _tmp107_;
			GtkBox* _tmp108_;
			GtkBox* _tmp109_;
			GtkBox* _tmp110_;
			GtkBox* _tmp111_;
			GtkToggleButton* _tmp112_;
			GtkFrame* _tmp113_;
			GtkBox* _tmp114_;
			GtkBox* _tmp115_;
			GtkFrame* _tmp116_;
#line 379 "../src/Views/WifiPage.vala"
			_tmp70_ = old_active;
#line 379 "../src/Views/WifiPage.vala"
			if (_tmp70_ != NULL) {
#line 1444 "WifiPage.c"
				NetworkWifiMenuItem* _tmp71_;
				NetworkWifiMenuItem* _tmp72_;
				gboolean _tmp73_ = FALSE;
				GtkFrame* _tmp74_;
#line 380 "../src/Views/WifiPage.vala"
				_tmp71_ = old_active;
#line 380 "../src/Views/WifiPage.vala"
				gtk_widget_set_no_show_all ((GtkWidget*) _tmp71_, FALSE);
#line 381 "../src/Views/WifiPage.vala"
				_tmp72_ = old_active;
#line 381 "../src/Views/WifiPage.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp72_, TRUE);
#line 383 "../src/Views/WifiPage.vala"
				_tmp74_ = self->connected_frame;
#line 383 "../src/Views/WifiPage.vala"
				if (_tmp74_ != NULL) {
#line 1461 "WifiPage.c"
					GtkFrame* _tmp75_;
					GtkWidget* _tmp76_;
#line 383 "../src/Views/WifiPage.vala"
					_tmp75_ = self->connected_frame;
#line 383 "../src/Views/WifiPage.vala"
					_tmp76_ = gtk_bin_get_child ((GtkBin*) _tmp75_);
#line 383 "../src/Views/WifiPage.vala"
					_tmp73_ = _tmp76_ != NULL;
#line 1470 "WifiPage.c"
				} else {
#line 383 "../src/Views/WifiPage.vala"
					_tmp73_ = FALSE;
#line 1474 "WifiPage.c"
				}
#line 383 "../src/Views/WifiPage.vala"
				if (_tmp73_) {
#line 1478 "WifiPage.c"
					GtkFrame* _tmp77_;
					GtkWidget* _tmp78_;
#line 384 "../src/Views/WifiPage.vala"
					_tmp77_ = self->connected_frame;
#line 384 "../src/Views/WifiPage.vala"
					_tmp78_ = gtk_bin_get_child ((GtkBin*) _tmp77_);
#line 384 "../src/Views/WifiPage.vala"
					gtk_widget_destroy (_tmp78_);
#line 1487 "WifiPage.c"
				}
			}
#line 388 "../src/Views/WifiPage.vala"
			_tmp79_ = self->priv->_active_wifi_item;
#line 388 "../src/Views/WifiPage.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp79_, TRUE);
#line 389 "../src/Views/WifiPage.vala"
			_tmp80_ = self->priv->_active_wifi_item;
#line 389 "../src/Views/WifiPage.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp80_, FALSE);
#line 391 "../src/Views/WifiPage.vala"
			_tmp81_ = active_access_point;
#line 391 "../src/Views/WifiPage.vala"
			_tmp82_ = network_wifi_menu_item_new (_tmp81_);
#line 391 "../src/Views/WifiPage.vala"
			network_wifi_menu_item_set_state (_tmp82_, NM_DEVICE_STATE_ACTIVATED);
#line 391 "../src/Views/WifiPage.vala"
			g_object_ref_sink (_tmp82_);
#line 391 "../src/Views/WifiPage.vala"
			top_item = _tmp82_;
#line 395 "../src/Views/WifiPage.vala"
			_tmp83_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 395 "../src/Views/WifiPage.vala"
			g_object_ref_sink (_tmp83_);
#line 395 "../src/Views/WifiPage.vala"
			_g_object_unref0 (self->connected_box);
#line 395 "../src/Views/WifiPage.vala"
			self->connected_box = _tmp83_;
#line 396 "../src/Views/WifiPage.vala"
			_tmp84_ = self->connected_box;
#line 396 "../src/Views/WifiPage.vala"
			_tmp85_ = top_item;
#line 396 "../src/Views/WifiPage.vala"
			gtk_container_add ((GtkContainer*) _tmp84_, (GtkWidget*) _tmp85_);
#line 398 "../src/Views/WifiPage.vala"
			_tmp86_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
#line 398 "../src/Views/WifiPage.vala"
			_tmp87_ = _tmp86_;
#line 398 "../src/Views/WifiPage.vala"
			_tmp88_ = (GtkButton*) gtk_button_new_with_label (_ ("Disconnect"));
#line 398 "../src/Views/WifiPage.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp88_, nm_device_get_state (_tmp87_) == NM_DEVICE_STATE_ACTIVATED);
#line 398 "../src/Views/WifiPage.vala"
			g_object_ref_sink (_tmp88_);
#line 398 "../src/Views/WifiPage.vala"
			_g_object_unref0 (self->disconnect_btn);
#line 398 "../src/Views/WifiPage.vala"
			self->disconnect_btn = _tmp88_;
#line 401 "../src/Views/WifiPage.vala"
			_tmp89_ = self->disconnect_btn;
#line 401 "../src/Views/WifiPage.vala"
			_tmp90_ = gtk_widget_get_style_context ((GtkWidget*) _tmp89_);
#line 401 "../src/Views/WifiPage.vala"
			gtk_style_context_add_class (_tmp90_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 402 "../src/Views/WifiPage.vala"
			_tmp91_ = self->disconnect_btn;
#line 402 "../src/Views/WifiPage.vala"
			g_signal_connect_object (_tmp91_, "clicked", (GCallback) _____lambda15__gtk_button_clicked, self, 0);
#line 410 "../src/Views/WifiPage.vala"
			_tmp92_ = self->wifi_device;
#line 410 "../src/Views/WifiPage.vala"
			_tmp93_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
#line 410 "../src/Views/WifiPage.vala"
			_tmp94_ = _tmp93_;
#line 410 "../src/Views/WifiPage.vala"
			_tmp95_ = network_widgets_settings_button_new_from_device ((NMDevice*) _tmp92_, _ ("Settings…"));
#line 410 "../src/Views/WifiPage.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp95_, nm_device_get_state (_tmp94_) == NM_DEVICE_STATE_ACTIVATED);
#line 410 "../src/Views/WifiPage.vala"
			g_object_ref_sink (_tmp95_);
#line 410 "../src/Views/WifiPage.vala"
			_g_object_unref0 (self->settings_btn);
#line 410 "../src/Views/WifiPage.vala"
			self->settings_btn = (GtkButton*) _tmp95_;
#line 414 "../src/Views/WifiPage.vala"
			_tmp96_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 414 "../src/Views/WifiPage.vala"
			g_object_ref_sink (_tmp96_);
#line 414 "../src/Views/WifiPage.vala"
			_tmp97_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 414 "../src/Views/WifiPage.vala"
			gtk_widget_set_margin_top ((GtkWidget*) _tmp97_, 6);
#line 414 "../src/Views/WifiPage.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) _tmp97_, 6);
#line 414 "../src/Views/WifiPage.vala"
			gtk_button_set_image ((GtkButton*) _tmp97_, (GtkWidget*) _tmp96_);
#line 414 "../src/Views/WifiPage.vala"
			_g_object_unref0 (_tmp96_);
#line 414 "../src/Views/WifiPage.vala"
			g_object_ref_sink (_tmp97_);
#line 414 "../src/Views/WifiPage.vala"
			_g_object_unref0 (self->info_btn);
#line 414 "../src/Views/WifiPage.vala"
			self->info_btn = _tmp97_;
#line 419 "../src/Views/WifiPage.vala"
			_tmp98_ = self->info_btn;
#line 419 "../src/Views/WifiPage.vala"
			_tmp99_ = gtk_widget_get_style_context ((GtkWidget*) _tmp98_);
#line 419 "../src/Views/WifiPage.vala"
			gtk_style_context_add_class (_tmp99_, GTK_STYLE_CLASS_FLAT);
#line 421 "../src/Views/WifiPage.vala"
			_tmp100_ = self->popover;
#line 421 "../src/Views/WifiPage.vala"
			_tmp101_ = self->info_btn;
#line 421 "../src/Views/WifiPage.vala"
			gtk_popover_set_relative_to (_tmp100_, (GtkWidget*) _tmp101_);
#line 423 "../src/Views/WifiPage.vala"
			_tmp102_ = self->info_btn;
#line 423 "../src/Views/WifiPage.vala"
			g_signal_connect_object (_tmp102_, "toggled", (GCallback) _____lambda18__gtk_toggle_button_toggled, self, 0);
#line 427 "../src/Views/WifiPage.vala"
			_tmp103_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 427 "../src/Views/WifiPage.vala"
			gtk_box_set_homogeneous (_tmp103_, TRUE);
#line 427 "../src/Views/WifiPage.vala"
			g_object_set ((GtkWidget*) _tmp103_, "margin", 6, NULL);
#line 427 "../src/Views/WifiPage.vala"
			gtk_widget_set_valign ((GtkWidget*) _tmp103_, GTK_ALIGN_CENTER);
#line 427 "../src/Views/WifiPage.vala"
			g_object_ref_sink (_tmp103_);
#line 427 "../src/Views/WifiPage.vala"
			button_box = _tmp103_;
#line 432 "../src/Views/WifiPage.vala"
			_tmp104_ = button_box;
#line 432 "../src/Views/WifiPage.vala"
			_tmp105_ = self->disconnect_btn;
#line 432 "../src/Views/WifiPage.vala"
			gtk_box_pack_end (_tmp104_, (GtkWidget*) _tmp105_, FALSE, FALSE, (guint) 0);
#line 433 "../src/Views/WifiPage.vala"
			_tmp106_ = button_box;
#line 433 "../src/Views/WifiPage.vala"
			_tmp107_ = self->settings_btn;
#line 433 "../src/Views/WifiPage.vala"
			gtk_box_pack_end (_tmp106_, (GtkWidget*) _tmp107_, FALSE, FALSE, (guint) 0);
#line 434 "../src/Views/WifiPage.vala"
			_tmp108_ = button_box;
#line 434 "../src/Views/WifiPage.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp108_);
#line 436 "../src/Views/WifiPage.vala"
			_tmp109_ = self->connected_box;
#line 436 "../src/Views/WifiPage.vala"
			_tmp110_ = button_box;
#line 436 "../src/Views/WifiPage.vala"
			gtk_box_pack_end (_tmp109_, (GtkWidget*) _tmp110_, FALSE, FALSE, (guint) 0);
#line 437 "../src/Views/WifiPage.vala"
			_tmp111_ = self->connected_box;
#line 437 "../src/Views/WifiPage.vala"
			_tmp112_ = self->info_btn;
#line 437 "../src/Views/WifiPage.vala"
			gtk_box_pack_end (_tmp111_, (GtkWidget*) _tmp112_, FALSE, FALSE, (guint) 0);
#line 438 "../src/Views/WifiPage.vala"
			_tmp113_ = self->connected_frame;
#line 438 "../src/Views/WifiPage.vala"
			_tmp114_ = self->connected_box;
#line 438 "../src/Views/WifiPage.vala"
			gtk_container_add ((GtkContainer*) _tmp113_, (GtkWidget*) _tmp114_);
#line 440 "../src/Views/WifiPage.vala"
			_tmp115_ = self->connected_box;
#line 440 "../src/Views/WifiPage.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp115_);
#line 441 "../src/Views/WifiPage.vala"
			_tmp116_ = self->connected_frame;
#line 441 "../src/Views/WifiPage.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp116_);
#line 377 "../src/Views/WifiPage.vala"
			_g_object_unref0 (button_box);
#line 377 "../src/Views/WifiPage.vala"
			_g_object_unref0 (top_item);
#line 1656 "WifiPage.c"
		}
	}
#line 289 "../src/Views/WifiPage.vala"
	_g_object_unref0 (old_active);
#line 1661 "WifiPage.c"
}

static void
network_wifi_interface_real_update_switch (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
#line 445 "../src/Views/WifiPage.vala"
	self = (NetworkWifiInterface*) base;
#line 446 "../src/Views/WifiPage.vala"
	_tmp0_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 446 "../src/Views/WifiPage.vala"
	_tmp1_ = _tmp0_;
#line 446 "../src/Views/WifiPage.vala"
	gtk_switch_set_active (_tmp1_, !self->priv->software_locked);
#line 1678 "WifiPage.c"
}

static void
network_wifi_interface_real_control_switch_activated (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	gboolean active = FALSE;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 449 "../src/Views/WifiPage.vala"
	self = (NetworkWifiInterface*) base;
#line 450 "../src/Views/WifiPage.vala"
	_tmp0_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 450 "../src/Views/WifiPage.vala"
	_tmp1_ = _tmp0_;
#line 450 "../src/Views/WifiPage.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 450 "../src/Views/WifiPage.vala"
	_tmp3_ = _tmp2_;
#line 450 "../src/Views/WifiPage.vala"
	active = _tmp3_;
#line 451 "../src/Views/WifiPage.vala"
	if (active == self->priv->software_locked) {
#line 1704 "WifiPage.c"
		RFKillManager* _tmp4_;
		NetworkNetworkManager* network_manager = NULL;
		NetworkNetworkManager* _tmp5_;
		NetworkNetworkManager* _tmp6_;
		NMClient* _tmp7_;
		NMClient* _tmp8_;
#line 452 "../src/Views/WifiPage.vala"
		_tmp4_ = self->priv->rfkill;
#line 452 "../src/Views/WifiPage.vala"
		rf_kill_manager_set_software_lock (_tmp4_, RF_KILL_DEVICE_TYPE_WLAN, !active);
#line 453 "../src/Views/WifiPage.vala"
		_tmp5_ = network_network_manager_get_default ();
#line 453 "../src/Views/WifiPage.vala"
		network_manager = _tmp5_;
#line 454 "../src/Views/WifiPage.vala"
		_tmp6_ = network_manager;
#line 454 "../src/Views/WifiPage.vala"
		_tmp7_ = network_network_manager_get_client (_tmp6_);
#line 454 "../src/Views/WifiPage.vala"
		_tmp8_ = _tmp7_;
#line 454 "../src/Views/WifiPage.vala"
		nm_client_wireless_set_enabled (_tmp8_, active);
#line 1727 "WifiPage.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 458 "../src/Views/WifiPage.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 458 "../src/Views/WifiPage.vala"
	return _data7_;
#line 1738 "WifiPage.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 458 "../src/Views/WifiPage.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1748 "WifiPage.c"
		NetworkWifiInterface* self;
#line 458 "../src/Views/WifiPage.vala"
		self = _data7_->self;
#line 458 "../src/Views/WifiPage.vala"
		_g_object_unref0 (self);
#line 458 "../src/Views/WifiPage.vala"
		g_slice_free (Block7Data, _data7_);
#line 1756 "WifiPage.c"
	}
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 472 "../src/Views/WifiPage.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 1765 "WifiPage.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 484 "../src/Views/WifiPage.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 484 "../src/Views/WifiPage.vala"
	return _data8_;
#line 1775 "WifiPage.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 484 "../src/Views/WifiPage.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1785 "WifiPage.c"
		NetworkWifiInterface* self;
#line 484 "../src/Views/WifiPage.vala"
		self = _data8_->_data7_->self;
#line 484 "../src/Views/WifiPage.vala"
		_g_object_unref0 (_data8_->wifi_dialog);
#line 484 "../src/Views/WifiPage.vala"
		block7_data_unref (_data8_->_data7_);
#line 484 "../src/Views/WifiPage.vala"
		_data8_->_data7_ = NULL;
#line 484 "../src/Views/WifiPage.vala"
		g_slice_free (Block8Data, _data8_);
#line 1797 "WifiPage.c"
	}
}

static void
___lambda10_ (Block8Data* _data8_,
              gint response)
{
	Block7Data* _data7_;
	NetworkWifiInterface* self;
#line 526 "../src/Views/WifiPage.vala"
	_data7_ = _data8_->_data7_;
#line 526 "../src/Views/WifiPage.vala"
	self = _data7_->self;
#line 527 "../src/Views/WifiPage.vala"
	if (response == ((gint) GTK_RESPONSE_OK)) {
#line 1813 "WifiPage.c"
		NMAWifiDialog* _tmp0_;
#line 528 "../src/Views/WifiPage.vala"
		_tmp0_ = _data8_->wifi_dialog;
#line 528 "../src/Views/WifiPage.vala"
		network_wifi_interface_connect_to_network (self, _tmp0_, NULL, NULL);
#line 1819 "WifiPage.c"
	}
}

static void
____lambda10__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 526 "../src/Views/WifiPage.vala"
	___lambda10_ (self, response_id);
#line 1830 "WifiPage.c"
}

static gpointer
_g_bytes_ref0 (gpointer self)
{
#line 545 "../src/Views/WifiPage.vala"
	return self ? g_bytes_ref (self) : NULL;
#line 1838 "WifiPage.c"
}

static void
___lambda12_ (Block7Data* _data7_,
              GObject* obj,
              GAsyncResult* res)
{
	NetworkWifiInterface* self;
	GError* _inner_error0_ = NULL;
#line 556 "../src/Views/WifiPage.vala"
	self = _data7_->self;
#line 556 "../src/Views/WifiPage.vala"
	g_return_if_fail (res != NULL);
#line 1852 "WifiPage.c"
	{
		NMClient* _tmp0_;
		NMActiveConnection* _tmp1_;
		NMActiveConnection* _tmp2_;
#line 558 "../src/Views/WifiPage.vala"
		_tmp0_ = _data7_->client;
#line 558 "../src/Views/WifiPage.vala"
		_tmp1_ = nm_client_add_and_activate_connection_finish (_tmp0_, res, &_inner_error0_);
#line 558 "../src/Views/WifiPage.vala"
		_tmp2_ = _tmp1_;
#line 558 "../src/Views/WifiPage.vala"
		_g_object_unref0 (_tmp2_);
#line 558 "../src/Views/WifiPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1867 "WifiPage.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 557 "../src/Views/WifiPage.vala"
		_error_ = _inner_error0_;
#line 557 "../src/Views/WifiPage.vala"
		_inner_error0_ = NULL;
#line 560 "../src/Views/WifiPage.vala"
		_tmp3_ = _error_;
#line 560 "../src/Views/WifiPage.vala"
		_tmp4_ = _tmp3_->message;
#line 560 "../src/Views/WifiPage.vala"
		g_warning ("WifiPage.vala:560: %s", _tmp4_);
#line 557 "../src/Views/WifiPage.vala"
		_g_error_free0 (_error_);
#line 1889 "WifiPage.c"
	}
	__finally0:
#line 557 "../src/Views/WifiPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 557 "../src/Views/WifiPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 557 "../src/Views/WifiPage.vala"
		g_clear_error (&_inner_error0_);
#line 557 "../src/Views/WifiPage.vala"
		return;
#line 1900 "WifiPage.c"
	}
}

static void
____lambda12__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 551 "../src/Views/WifiPage.vala"
	___lambda12_ (self, source_object, res);
#line 551 "../src/Views/WifiPage.vala"
	block7_data_unref (self);
#line 1913 "WifiPage.c"
}

static gboolean
__lambda13_ (NetworkWifiInterface* self)
{
	gboolean result;
#line 569 "../src/Views/WifiPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 569 "../src/Views/WifiPage.vala"
	result = FALSE;
#line 569 "../src/Views/WifiPage.vala"
	return result;
#line 1926 "WifiPage.c"
}

static gboolean
___lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda13_ ((NetworkWifiInterface*) self);
#line 569 "../src/Views/WifiPage.vala"
	return result;
#line 1936 "WifiPage.c"
}

static void
network_wifi_interface_wifi_activate_cb (NetworkWifiInterface* self,
                                         NetworkWifiMenuItem* row)
{
	Block7Data* _data7_;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
	NMDeviceWifi* _tmp2_;
	NMAccessPoint* _tmp3_;
	NMAccessPoint* _tmp4_;
	NMAccessPoint* _tmp5_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp6_;
	NetworkNetworkManager* _tmp7_;
	NMClient* _tmp8_;
	NMClient* _tmp9_;
	GPtrArray* connections = NULL;
	NMClient* _tmp10_;
	GPtrArray* _tmp11_;
	GPtrArray* _tmp12_;
	GPtrArray* device_connections = NULL;
	NMDeviceWifi* _tmp13_;
	GPtrArray* _tmp14_;
	GPtrArray* _tmp15_;
	GPtrArray* ap_connections = NULL;
	NMAccessPoint* _tmp16_;
	NMAccessPoint* _tmp17_;
	GPtrArray* _tmp18_;
	GPtrArray* _tmp19_;
	NMConnection* valid_connection = NULL;
	NMAccessPoint* _tmp20_;
	NMAccessPoint* _tmp21_;
	GPtrArray* _tmp22_;
	NMConnection* _tmp23_;
	NMConnection* _tmp24_;
	NMConnection* connection = NULL;
	NMConnection* _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
#line 458 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/Views/WifiPage.vala"
	g_return_if_fail (row != NULL);
#line 458 "../src/Views/WifiPage.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 458 "../src/Views/WifiPage.vala"
	_data7_->_ref_count_ = 1;
#line 458 "../src/Views/WifiPage.vala"
	_data7_->self = g_object_ref (self);
#line 459 "../src/Views/WifiPage.vala"
	_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
#line 459 "../src/Views/WifiPage.vala"
	_tmp1_ = _tmp0_;
#line 459 "../src/Views/WifiPage.vala"
	if (_tmp1_ == NULL) {
#line 460 "../src/Views/WifiPage.vala"
		block7_data_unref (_data7_);
#line 460 "../src/Views/WifiPage.vala"
		_data7_ = NULL;
#line 460 "../src/Views/WifiPage.vala"
		return;
#line 2000 "WifiPage.c"
	}
#line 464 "../src/Views/WifiPage.vala"
	_tmp2_ = self->wifi_device;
#line 464 "../src/Views/WifiPage.vala"
	_tmp3_ = nm_device_wifi_get_active_access_point (_tmp2_);
#line 464 "../src/Views/WifiPage.vala"
	_tmp4_ = network_wifi_menu_item_get_ap (row);
#line 464 "../src/Views/WifiPage.vala"
	_tmp5_ = _tmp4_;
#line 464 "../src/Views/WifiPage.vala"
	if (_tmp3_ == _tmp5_) {
#line 465 "../src/Views/WifiPage.vala"
		block7_data_unref (_data7_);
#line 465 "../src/Views/WifiPage.vala"
		_data7_ = NULL;
#line 465 "../src/Views/WifiPage.vala"
		return;
#line 2018 "WifiPage.c"
	}
#line 468 "../src/Views/WifiPage.vala"
	_tmp6_ = network_network_manager_get_default ();
#line 468 "../src/Views/WifiPage.vala"
	network_manager = _tmp6_;
#line 469 "../src/Views/WifiPage.vala"
	_tmp7_ = network_manager;
#line 469 "../src/Views/WifiPage.vala"
	_tmp8_ = network_network_manager_get_client (_tmp7_);
#line 469 "../src/Views/WifiPage.vala"
	_tmp9_ = _tmp8_;
#line 469 "../src/Views/WifiPage.vala"
	_data7_->client = _tmp9_;
#line 472 "../src/Views/WifiPage.vala"
	_tmp10_ = _data7_->client;
#line 472 "../src/Views/WifiPage.vala"
	_tmp11_ = nm_client_get_connections (_tmp10_);
#line 472 "../src/Views/WifiPage.vala"
	_tmp12_ = _g_ptr_array_ref0 (_tmp11_);
#line 472 "../src/Views/WifiPage.vala"
	connections = _tmp12_;
#line 473 "../src/Views/WifiPage.vala"
	_tmp13_ = self->wifi_device;
#line 473 "../src/Views/WifiPage.vala"
	_tmp14_ = connections;
#line 473 "../src/Views/WifiPage.vala"
	_tmp15_ = nm_device_filter_connections ((NMDevice*) _tmp13_, _tmp14_);
#line 473 "../src/Views/WifiPage.vala"
	device_connections = _tmp15_;
#line 474 "../src/Views/WifiPage.vala"
	_tmp16_ = network_wifi_menu_item_get_ap (row);
#line 474 "../src/Views/WifiPage.vala"
	_tmp17_ = _tmp16_;
#line 474 "../src/Views/WifiPage.vala"
	_tmp18_ = device_connections;
#line 474 "../src/Views/WifiPage.vala"
	_tmp19_ = nm_access_point_filter_connections (_tmp17_, _tmp18_);
#line 474 "../src/Views/WifiPage.vala"
	ap_connections = _tmp19_;
#line 476 "../src/Views/WifiPage.vala"
	_tmp20_ = network_wifi_menu_item_get_ap (row);
#line 476 "../src/Views/WifiPage.vala"
	_tmp21_ = _tmp20_;
#line 476 "../src/Views/WifiPage.vala"
	_tmp22_ = ap_connections;
#line 476 "../src/Views/WifiPage.vala"
	_tmp23_ = network_wifi_interface_get_valid_connection (self, _tmp21_, _tmp22_);
#line 476 "../src/Views/WifiPage.vala"
	valid_connection = _tmp23_;
#line 477 "../src/Views/WifiPage.vala"
	_tmp24_ = valid_connection;
#line 477 "../src/Views/WifiPage.vala"
	if (_tmp24_ != NULL) {
#line 2072 "WifiPage.c"
		NMClient* _tmp25_;
		NMConnection* _tmp26_;
		NMDeviceWifi* _tmp27_;
		NMAccessPoint* _tmp28_;
		NMAccessPoint* _tmp29_;
		const gchar* _tmp30_;
#line 478 "../src/Views/WifiPage.vala"
		_tmp25_ = _data7_->client;
#line 478 "../src/Views/WifiPage.vala"
		_tmp26_ = valid_connection;
#line 478 "../src/Views/WifiPage.vala"
		_tmp27_ = self->wifi_device;
#line 478 "../src/Views/WifiPage.vala"
		_tmp28_ = network_wifi_menu_item_get_ap (row);
#line 478 "../src/Views/WifiPage.vala"
		_tmp29_ = _tmp28_;
#line 478 "../src/Views/WifiPage.vala"
		_tmp30_ = nm_object_get_path ((NMObject*) _tmp29_);
#line 478 "../src/Views/WifiPage.vala"
		nm_client_activate_connection_async (_tmp25_, _tmp26_, (NMDevice*) _tmp27_, _tmp30_, NULL, NULL, NULL);
#line 479 "../src/Views/WifiPage.vala"
		_g_object_unref0 (valid_connection);
#line 479 "../src/Views/WifiPage.vala"
		_g_ptr_array_unref0 (ap_connections);
#line 479 "../src/Views/WifiPage.vala"
		_g_ptr_array_unref0 (device_connections);
#line 479 "../src/Views/WifiPage.vala"
		_g_ptr_array_unref0 (connections);
#line 479 "../src/Views/WifiPage.vala"
		block7_data_unref (_data7_);
#line 479 "../src/Views/WifiPage.vala"
		_data7_ = NULL;
#line 479 "../src/Views/WifiPage.vala"
		return;
#line 2107 "WifiPage.c"
	}
#line 482 "../src/Views/WifiPage.vala"
	_tmp31_ = nm_simple_connection_new ();
#line 482 "../src/Views/WifiPage.vala"
	connection = _tmp31_;
#line 484 "../src/Views/WifiPage.vala"
	_tmp32_ = network_wifi_menu_item_get_is_secured (row);
#line 484 "../src/Views/WifiPage.vala"
	_tmp33_ = _tmp32_;
#line 484 "../src/Views/WifiPage.vala"
	if (_tmp33_) {
#line 2119 "WifiPage.c"
		Block8Data* _data8_;
		NMSettingConnection* s_con = NULL;
		gchar* _tmp34_;
		NMSettingConnection* _tmp35_ = NULL;
		NMConnection* _tmp36_;
		NMSettingConnection* _tmp37_;
		NMSetting* _tmp38_;
		gboolean _tmp39_ = FALSE;
		NMAccessPoint* _tmp40_;
		NMAccessPoint* _tmp41_;
		NMSettingWireless* s_wifi = NULL;
		NMSettingWireless* _tmp49_;
		NMSettingWireless* _tmp50_;
		NMAccessPoint* _tmp51_;
		NMAccessPoint* _tmp52_;
		GBytes* _tmp53_;
		NMConnection* _tmp54_;
		NMSettingWireless* _tmp55_;
		NMSetting* _tmp56_;
		gboolean _tmp57_ = FALSE;
		NMAccessPoint* _tmp58_;
		NMAccessPoint* _tmp59_;
		NMClient* _tmp73_;
		NMConnection* _tmp74_;
		NMDeviceWifi* _tmp75_;
		NMAccessPoint* _tmp76_;
		NMAccessPoint* _tmp77_;
		GtkWidget* _tmp78_;
		GtkWindow* _tmp79_;
		NMAWifiDialog* _tmp80_ = NULL;
		NMAWifiDialog* _tmp81_;
		NMAWifiDialog* _tmp82_;
		NMAWifiDialog* _tmp83_;
#line 484 "../src/Views/WifiPage.vala"
		_data8_ = g_slice_new0 (Block8Data);
#line 484 "../src/Views/WifiPage.vala"
		_data8_->_ref_count_ = 1;
#line 484 "../src/Views/WifiPage.vala"
		_data8_->_data7_ = block7_data_ref (_data7_);
#line 485 "../src/Views/WifiPage.vala"
		_tmp34_ = nm_utils_uuid_generate ();
#line 485 "../src/Views/WifiPage.vala"
		_tmp35_ = (NMSettingConnection*) nm_setting_connection_new ();
#line 485 "../src/Views/WifiPage.vala"
		g_object_set (_tmp35_, "uuid", _tmp34_, NULL);
#line 485 "../src/Views/WifiPage.vala"
		_g_free0 (_tmp34_);
#line 485 "../src/Views/WifiPage.vala"
		s_con = _tmp35_;
#line 488 "../src/Views/WifiPage.vala"
		_tmp36_ = connection;
#line 488 "../src/Views/WifiPage.vala"
		_tmp37_ = s_con;
#line 488 "../src/Views/WifiPage.vala"
		_tmp38_ = _g_object_ref0 ((NMSetting*) _tmp37_);
#line 488 "../src/Views/WifiPage.vala"
		nm_connection_add_setting (_tmp36_, _tmp38_);
#line 490 "../src/Views/WifiPage.vala"
		_tmp40_ = network_wifi_menu_item_get_ap (row);
#line 490 "../src/Views/WifiPage.vala"
		_tmp41_ = _tmp40_;
#line 490 "../src/Views/WifiPage.vala"
		if ((nm_access_point_get_rsn_flags (_tmp41_) & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE) {
#line 490 "../src/Views/WifiPage.vala"
			_tmp39_ = TRUE;
#line 2185 "WifiPage.c"
		} else {
			NMAccessPoint* _tmp42_;
			NMAccessPoint* _tmp43_;
#line 491 "../src/Views/WifiPage.vala"
			_tmp42_ = network_wifi_menu_item_get_ap (row);
#line 491 "../src/Views/WifiPage.vala"
			_tmp43_ = _tmp42_;
#line 491 "../src/Views/WifiPage.vala"
			_tmp39_ = (nm_access_point_get_wpa_flags (_tmp43_) & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE;
#line 2195 "WifiPage.c"
		}
#line 490 "../src/Views/WifiPage.vala"
		if (_tmp39_) {
#line 2199 "WifiPage.c"
			NMSettingWirelessSecurity* s_wsec = NULL;
			NMSettingWirelessSecurity* _tmp44_;
			NMSettingWirelessSecurity* _tmp45_;
			NMConnection* _tmp46_;
			NMSettingWirelessSecurity* _tmp47_;
			NMSetting* _tmp48_;
#line 492 "../src/Views/WifiPage.vala"
			_tmp44_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
#line 492 "../src/Views/WifiPage.vala"
			s_wsec = _tmp44_;
#line 493 "../src/Views/WifiPage.vala"
			_tmp45_ = s_wsec;
#line 493 "../src/Views/WifiPage.vala"
			g_object_set (_tmp45_, "key-mgmt", "sae", NULL);
#line 494 "../src/Views/WifiPage.vala"
			_tmp46_ = connection;
#line 494 "../src/Views/WifiPage.vala"
			_tmp47_ = s_wsec;
#line 494 "../src/Views/WifiPage.vala"
			_tmp48_ = _g_object_ref0 ((NMSetting*) _tmp47_);
#line 494 "../src/Views/WifiPage.vala"
			nm_connection_add_setting (_tmp46_, _tmp48_);
#line 490 "../src/Views/WifiPage.vala"
			_g_object_unref0 (s_wsec);
#line 2224 "WifiPage.c"
		}
#line 497 "../src/Views/WifiPage.vala"
		_tmp49_ = (NMSettingWireless*) nm_setting_wireless_new ();
#line 497 "../src/Views/WifiPage.vala"
		s_wifi = _tmp49_;
#line 498 "../src/Views/WifiPage.vala"
		_tmp50_ = s_wifi;
#line 498 "../src/Views/WifiPage.vala"
		_tmp51_ = network_wifi_menu_item_get_ap (row);
#line 498 "../src/Views/WifiPage.vala"
		_tmp52_ = _tmp51_;
#line 498 "../src/Views/WifiPage.vala"
		_tmp53_ = nm_access_point_get_ssid (_tmp52_);
#line 498 "../src/Views/WifiPage.vala"
		g_object_set (_tmp50_, "ssid", _tmp53_, NULL);
#line 499 "../src/Views/WifiPage.vala"
		_tmp54_ = connection;
#line 499 "../src/Views/WifiPage.vala"
		_tmp55_ = s_wifi;
#line 499 "../src/Views/WifiPage.vala"
		_tmp56_ = _g_object_ref0 ((NMSetting*) _tmp55_);
#line 499 "../src/Views/WifiPage.vala"
		nm_connection_add_setting (_tmp54_, _tmp56_);
#line 504 "../src/Views/WifiPage.vala"
		_tmp58_ = network_wifi_menu_item_get_ap (row);
#line 504 "../src/Views/WifiPage.vala"
		_tmp59_ = _tmp58_;
#line 504 "../src/Views/WifiPage.vala"
		if ((nm_access_point_get_rsn_flags (_tmp59_) & NM_802_11_AP_SEC_KEY_MGMT_802_1X) == NM_802_11_AP_SEC_KEY_MGMT_802_1X) {
#line 504 "../src/Views/WifiPage.vala"
			_tmp57_ = TRUE;
#line 2256 "WifiPage.c"
		} else {
			NMAccessPoint* _tmp60_;
			NMAccessPoint* _tmp61_;
#line 505 "../src/Views/WifiPage.vala"
			_tmp60_ = network_wifi_menu_item_get_ap (row);
#line 505 "../src/Views/WifiPage.vala"
			_tmp61_ = _tmp60_;
#line 505 "../src/Views/WifiPage.vala"
			_tmp57_ = (nm_access_point_get_wpa_flags (_tmp61_) & NM_802_11_AP_SEC_KEY_MGMT_802_1X) == NM_802_11_AP_SEC_KEY_MGMT_802_1X;
#line 2266 "WifiPage.c"
		}
#line 504 "../src/Views/WifiPage.vala"
		if (_tmp57_) {
#line 2270 "WifiPage.c"
			NMSettingWirelessSecurity* s_wsec = NULL;
			gchar* _tmp62_;
			NMSettingWirelessSecurity* _tmp63_ = NULL;
			NMConnection* _tmp64_;
			NMSettingWirelessSecurity* _tmp65_;
			NMSetting* _tmp66_;
			NMSetting8021x* s_8021x = NULL;
			NMSetting8021x* _tmp67_;
			NMSetting8021x* _tmp68_;
			NMSetting8021x* _tmp69_;
			NMConnection* _tmp70_;
			NMSetting8021x* _tmp71_;
			NMSetting* _tmp72_;
#line 507 "../src/Views/WifiPage.vala"
			_tmp62_ = g_strdup ("wpa-eap");
#line 507 "../src/Views/WifiPage.vala"
			_tmp63_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
#line 507 "../src/Views/WifiPage.vala"
			g_object_set (_tmp63_, "key-mgmt", _tmp62_, NULL);
#line 507 "../src/Views/WifiPage.vala"
			_g_free0 (_tmp62_);
#line 507 "../src/Views/WifiPage.vala"
			s_wsec = _tmp63_;
#line 510 "../src/Views/WifiPage.vala"
			_tmp64_ = connection;
#line 510 "../src/Views/WifiPage.vala"
			_tmp65_ = s_wsec;
#line 510 "../src/Views/WifiPage.vala"
			_tmp66_ = _g_object_ref0 ((NMSetting*) _tmp65_);
#line 510 "../src/Views/WifiPage.vala"
			nm_connection_add_setting (_tmp64_, _tmp66_);
#line 512 "../src/Views/WifiPage.vala"
			_tmp67_ = (NMSetting8021x*) nm_setting_802_1x_new ();
#line 512 "../src/Views/WifiPage.vala"
			s_8021x = _tmp67_;
#line 513 "../src/Views/WifiPage.vala"
			_tmp68_ = s_8021x;
#line 513 "../src/Views/WifiPage.vala"
			nm_setting_802_1x_add_eap_method (_tmp68_, "ttls");
#line 514 "../src/Views/WifiPage.vala"
			_tmp69_ = s_8021x;
#line 514 "../src/Views/WifiPage.vala"
			g_object_set (_tmp69_, "phase2-auth", "mschapv2", NULL);
#line 515 "../src/Views/WifiPage.vala"
			_tmp70_ = connection;
#line 515 "../src/Views/WifiPage.vala"
			_tmp71_ = s_8021x;
#line 515 "../src/Views/WifiPage.vala"
			_tmp72_ = _g_object_ref0 ((NMSetting*) _tmp71_);
#line 515 "../src/Views/WifiPage.vala"
			nm_connection_add_setting (_tmp70_, _tmp72_);
#line 504 "../src/Views/WifiPage.vala"
			_g_object_unref0 (s_8021x);
#line 504 "../src/Views/WifiPage.vala"
			_g_object_unref0 (s_wsec);
#line 2326 "WifiPage.c"
		}
#line 521 "../src/Views/WifiPage.vala"
		_tmp73_ = _data7_->client;
#line 521 "../src/Views/WifiPage.vala"
		_tmp74_ = connection;
#line 521 "../src/Views/WifiPage.vala"
		_tmp75_ = self->wifi_device;
#line 521 "../src/Views/WifiPage.vala"
		_tmp76_ = network_wifi_menu_item_get_ap (row);
#line 521 "../src/Views/WifiPage.vala"
		_tmp77_ = _tmp76_;
#line 521 "../src/Views/WifiPage.vala"
		_tmp78_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 521 "../src/Views/WifiPage.vala"
		_tmp79_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, gtk_window_get_type (), GtkWindow));
#line 521 "../src/Views/WifiPage.vala"
		_tmp80_ = (NMAWifiDialog*) nma_wifi_dialog_new (_tmp73_, _tmp74_, (NMDevice*) _tmp75_, _tmp77_, FALSE);
#line 521 "../src/Views/WifiPage.vala"
		gtk_window_set_deletable ((GtkWindow*) _tmp80_, FALSE);
#line 521 "../src/Views/WifiPage.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp80_, _tmp79_);
#line 521 "../src/Views/WifiPage.vala"
		_g_object_unref0 (_tmp79_);
#line 521 "../src/Views/WifiPage.vala"
		g_object_set ((GtkWindow*) _tmp80_, "window-position", GTK_WIN_POS_CENTER_ON_PARENT, NULL);
#line 521 "../src/Views/WifiPage.vala"
		g_object_ref_sink (_tmp80_);
#line 521 "../src/Views/WifiPage.vala"
		_data8_->wifi_dialog = _tmp80_;
#line 526 "../src/Views/WifiPage.vala"
		_tmp81_ = _data8_->wifi_dialog;
#line 526 "../src/Views/WifiPage.vala"
		g_signal_connect_data ((GtkDialog*) _tmp81_, "response", (GCallback) ____lambda10__gtk_dialog_response, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 532 "../src/Views/WifiPage.vala"
		_tmp82_ = _data8_->wifi_dialog;
#line 532 "../src/Views/WifiPage.vala"
		gtk_dialog_run ((GtkDialog*) _tmp82_);
#line 533 "../src/Views/WifiPage.vala"
		_tmp83_ = _data8_->wifi_dialog;
#line 533 "../src/Views/WifiPage.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp83_);
#line 484 "../src/Views/WifiPage.vala"
		_g_object_unref0 (s_wifi);
#line 484 "../src/Views/WifiPage.vala"
		_g_object_unref0 (s_con);
#line 484 "../src/Views/WifiPage.vala"
		block8_data_unref (_data8_);
#line 484 "../src/Views/WifiPage.vala"
		_data8_ = NULL;
#line 2376 "WifiPage.c"
	} else {
		gboolean _tmp84_ = FALSE;
		NMAccessPoint* _tmp85_;
		NMAccessPoint* _tmp86_;
		NMClient* _tmp107_;
		NMConnection* _tmp108_;
		NMDeviceWifi* _tmp109_;
		NMAccessPoint* _tmp110_;
		NMAccessPoint* _tmp111_;
		const gchar* _tmp112_;
#line 535 "../src/Views/WifiPage.vala"
		_tmp85_ = network_wifi_menu_item_get_ap (row);
#line 535 "../src/Views/WifiPage.vala"
		_tmp86_ = _tmp85_;
#line 535 "../src/Views/WifiPage.vala"
		if ((nm_access_point_get_rsn_flags (_tmp86_) & NM_802_11_AP_SEC_KEY_MGMT_OWE) == NM_802_11_AP_SEC_KEY_MGMT_OWE) {
#line 535 "../src/Views/WifiPage.vala"
			_tmp84_ = TRUE;
#line 2395 "WifiPage.c"
		} else {
			NMAccessPoint* _tmp87_;
			NMAccessPoint* _tmp88_;
#line 536 "../src/Views/WifiPage.vala"
			_tmp87_ = network_wifi_menu_item_get_ap (row);
#line 536 "../src/Views/WifiPage.vala"
			_tmp88_ = _tmp87_;
#line 536 "../src/Views/WifiPage.vala"
			_tmp84_ = (nm_access_point_get_wpa_flags (_tmp88_) & NM_802_11_AP_SEC_KEY_MGMT_OWE) == NM_802_11_AP_SEC_KEY_MGMT_OWE;
#line 2405 "WifiPage.c"
		}
#line 535 "../src/Views/WifiPage.vala"
		if (_tmp84_) {
#line 2409 "WifiPage.c"
			NMSettingConnection* s_con = NULL;
			gchar* _tmp89_;
			NMSettingConnection* _tmp90_ = NULL;
			NMConnection* _tmp91_;
			NMSettingConnection* _tmp92_;
			NMSetting* _tmp93_;
			NMSettingWirelessSecurity* s_wsec = NULL;
			gchar* _tmp94_;
			NMSettingWirelessSecurity* _tmp95_ = NULL;
			NMConnection* _tmp96_;
			NMSettingWirelessSecurity* _tmp97_;
			NMSetting* _tmp98_;
			NMSettingWireless* s_wifi = NULL;
			NMAccessPoint* _tmp99_;
			NMAccessPoint* _tmp100_;
			GBytes* _tmp101_;
			GBytes* _tmp102_;
			NMSettingWireless* _tmp103_ = NULL;
			NMConnection* _tmp104_;
			NMSettingWireless* _tmp105_;
			NMSetting* _tmp106_;
#line 537 "../src/Views/WifiPage.vala"
			_tmp89_ = nm_utils_uuid_generate ();
#line 537 "../src/Views/WifiPage.vala"
			_tmp90_ = (NMSettingConnection*) nm_setting_connection_new ();
#line 537 "../src/Views/WifiPage.vala"
			g_object_set (_tmp90_, "uuid", _tmp89_, NULL);
#line 537 "../src/Views/WifiPage.vala"
			_g_free0 (_tmp89_);
#line 537 "../src/Views/WifiPage.vala"
			s_con = _tmp90_;
#line 540 "../src/Views/WifiPage.vala"
			_tmp91_ = connection;
#line 540 "../src/Views/WifiPage.vala"
			_tmp92_ = s_con;
#line 540 "../src/Views/WifiPage.vala"
			_tmp93_ = _g_object_ref0 ((NMSetting*) _tmp92_);
#line 540 "../src/Views/WifiPage.vala"
			nm_connection_add_setting (_tmp91_, _tmp93_);
#line 541 "../src/Views/WifiPage.vala"
			_tmp94_ = g_strdup ("owe");
#line 541 "../src/Views/WifiPage.vala"
			_tmp95_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
#line 541 "../src/Views/WifiPage.vala"
			g_object_set (_tmp95_, "key-mgmt", _tmp94_, NULL);
#line 541 "../src/Views/WifiPage.vala"
			_g_free0 (_tmp94_);
#line 541 "../src/Views/WifiPage.vala"
			s_wsec = _tmp95_;
#line 544 "../src/Views/WifiPage.vala"
			_tmp96_ = connection;
#line 544 "../src/Views/WifiPage.vala"
			_tmp97_ = s_wsec;
#line 544 "../src/Views/WifiPage.vala"
			_tmp98_ = _g_object_ref0 ((NMSetting*) _tmp97_);
#line 544 "../src/Views/WifiPage.vala"
			nm_connection_add_setting (_tmp96_, _tmp98_);
#line 545 "../src/Views/WifiPage.vala"
			_tmp99_ = network_wifi_menu_item_get_ap (row);
#line 545 "../src/Views/WifiPage.vala"
			_tmp100_ = _tmp99_;
#line 545 "../src/Views/WifiPage.vala"
			_tmp101_ = nm_access_point_get_ssid (_tmp100_);
#line 545 "../src/Views/WifiPage.vala"
			_tmp102_ = _g_bytes_ref0 (_tmp101_);
#line 545 "../src/Views/WifiPage.vala"
			_tmp103_ = (NMSettingWireless*) nm_setting_wireless_new ();
#line 545 "../src/Views/WifiPage.vala"
			g_object_set (_tmp103_, "ssid", _tmp102_, NULL);
#line 545 "../src/Views/WifiPage.vala"
			_g_bytes_unref0 (_tmp102_);
#line 545 "../src/Views/WifiPage.vala"
			s_wifi = _tmp103_;
#line 548 "../src/Views/WifiPage.vala"
			_tmp104_ = connection;
#line 548 "../src/Views/WifiPage.vala"
			_tmp105_ = s_wifi;
#line 548 "../src/Views/WifiPage.vala"
			_tmp106_ = _g_object_ref0 ((NMSetting*) _tmp105_);
#line 548 "../src/Views/WifiPage.vala"
			nm_connection_add_setting (_tmp104_, _tmp106_);
#line 535 "../src/Views/WifiPage.vala"
			_g_object_unref0 (s_wifi);
#line 535 "../src/Views/WifiPage.vala"
			_g_object_unref0 (s_wsec);
#line 535 "../src/Views/WifiPage.vala"
			_g_object_unref0 (s_con);
#line 2497 "WifiPage.c"
		}
#line 551 "../src/Views/WifiPage.vala"
		_tmp107_ = _data7_->client;
#line 551 "../src/Views/WifiPage.vala"
		_tmp108_ = connection;
#line 551 "../src/Views/WifiPage.vala"
		_tmp109_ = self->wifi_device;
#line 551 "../src/Views/WifiPage.vala"
		_tmp110_ = network_wifi_menu_item_get_ap (row);
#line 551 "../src/Views/WifiPage.vala"
		_tmp111_ = _tmp110_;
#line 551 "../src/Views/WifiPage.vala"
		_tmp112_ = nm_object_get_path ((NMObject*) _tmp111_);
#line 551 "../src/Views/WifiPage.vala"
		nm_client_add_and_activate_connection_async (_tmp107_, _tmp108_, (NMDevice*) _tmp109_, _tmp112_, NULL, ____lambda12__gasync_ready_callback, block7_data_ref (_data7_));
#line 2513 "WifiPage.c"
	}
#line 569 "../src/Views/WifiPage.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda13__gsource_func, g_object_ref (self), g_object_unref);
#line 458 "../src/Views/WifiPage.vala"
	_g_object_unref0 (connection);
#line 458 "../src/Views/WifiPage.vala"
	_g_object_unref0 (valid_connection);
#line 458 "../src/Views/WifiPage.vala"
	_g_ptr_array_unref0 (ap_connections);
#line 458 "../src/Views/WifiPage.vala"
	_g_ptr_array_unref0 (device_connections);
#line 458 "../src/Views/WifiPage.vala"
	_g_ptr_array_unref0 (connections);
#line 458 "../src/Views/WifiPage.vala"
	block7_data_unref (_data7_);
#line 458 "../src/Views/WifiPage.vala"
	_data7_ = NULL;
#line 2531 "WifiPage.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5905 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5906 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5906 "glib-2.0.vapi"
	return result;
#line 2544 "WifiPage.c"
}

static NMConnection*
network_wifi_interface_get_valid_connection (NetworkWifiInterface* self,
                                             NMAccessPoint* ap,
                                             GPtrArray* ap_connections)
{
	NMConnection* result;
#line 572 "../src/Views/WifiPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 572 "../src/Views/WifiPage.vala"
	g_return_val_if_fail (ap != NULL, NULL);
#line 572 "../src/Views/WifiPage.vala"
	g_return_val_if_fail (ap_connections != NULL, NULL);
#line 2559 "WifiPage.c"
	{
		gint i = 0;
#line 573 "../src/Views/WifiPage.vala"
		i = 0;
#line 2564 "WifiPage.c"
		{
			gboolean _tmp0_ = FALSE;
#line 573 "../src/Views/WifiPage.vala"
			_tmp0_ = TRUE;
#line 573 "../src/Views/WifiPage.vala"
			while (TRUE) {
#line 2571 "WifiPage.c"
				gint _tmp2_;
				gint _tmp3_;
				NMConnection* connection = NULL;
				gconstpointer _tmp4_;
				NMConnection* _tmp5_;
#line 573 "../src/Views/WifiPage.vala"
				if (!_tmp0_) {
#line 2579 "WifiPage.c"
					gint _tmp1_;
#line 573 "../src/Views/WifiPage.vala"
					_tmp1_ = i;
#line 573 "../src/Views/WifiPage.vala"
					i = _tmp1_ + 1;
#line 2585 "WifiPage.c"
				}
#line 573 "../src/Views/WifiPage.vala"
				_tmp0_ = FALSE;
#line 573 "../src/Views/WifiPage.vala"
				_tmp2_ = vala_g_ptr_array_get_length (ap_connections);
#line 573 "../src/Views/WifiPage.vala"
				_tmp3_ = _tmp2_;
#line 573 "../src/Views/WifiPage.vala"
				if (!(i < _tmp3_)) {
#line 573 "../src/Views/WifiPage.vala"
					break;
#line 2597 "WifiPage.c"
				}
#line 574 "../src/Views/WifiPage.vala"
				_tmp4_ = g_ptr_array_index (ap_connections, (guint) i);
#line 574 "../src/Views/WifiPage.vala"
				connection = (NMConnection*) _tmp4_;
#line 575 "../src/Views/WifiPage.vala"
				_tmp5_ = connection;
#line 575 "../src/Views/WifiPage.vala"
				if (nm_access_point_connection_valid (ap, _tmp5_)) {
#line 2607 "WifiPage.c"
					NMConnection* _tmp6_;
					NMConnection* _tmp7_;
#line 576 "../src/Views/WifiPage.vala"
					_tmp6_ = connection;
#line 576 "../src/Views/WifiPage.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 576 "../src/Views/WifiPage.vala"
					result = _tmp7_;
#line 576 "../src/Views/WifiPage.vala"
					return result;
#line 2618 "WifiPage.c"
				}
			}
		}
	}
#line 580 "../src/Views/WifiPage.vala"
	result = NULL;
#line 580 "../src/Views/WifiPage.vala"
	return result;
#line 2627 "WifiPage.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 583 "../src/Views/WifiPage.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 583 "../src/Views/WifiPage.vala"
	return _data9_;
#line 2637 "WifiPage.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 583 "../src/Views/WifiPage.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 2647 "WifiPage.c"
		NetworkWifiInterface* self;
#line 583 "../src/Views/WifiPage.vala"
		self = _data9_->self;
#line 583 "../src/Views/WifiPage.vala"
		_g_object_unref0 (_data9_->hidden_dialog);
#line 583 "../src/Views/WifiPage.vala"
		_g_object_unref0 (self);
#line 583 "../src/Views/WifiPage.vala"
		g_slice_free (Block9Data, _data9_);
#line 2657 "WifiPage.c"
	}
}

static void
__lambda19_ (Block9Data* _data9_,
             gint response)
{
	NetworkWifiInterface* self;
#line 591 "../src/Views/WifiPage.vala"
	self = _data9_->self;
#line 592 "../src/Views/WifiPage.vala"
	if (response == ((gint) GTK_RESPONSE_OK)) {
#line 593 "../src/Views/WifiPage.vala"
		network_wifi_interface_connect_to_network (self, _data9_->hidden_dialog, NULL, NULL);
#line 2672 "WifiPage.c"
	}
}

static void
___lambda19__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 591 "../src/Views/WifiPage.vala"
	__lambda19_ (self, response_id);
#line 2683 "WifiPage.c"
}

static void
network_wifi_interface_connect_to_hidden (NetworkWifiInterface* self)
{
	Block9Data* _data9_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp0_;
	NMClient* _tmp1_;
	NMClient* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWindow* _tmp4_;
	NMAWifiDialog* _tmp5_ = NULL;
#line 583 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 583 "../src/Views/WifiPage.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 583 "../src/Views/WifiPage.vala"
	_data9_->_ref_count_ = 1;
#line 583 "../src/Views/WifiPage.vala"
	_data9_->self = g_object_ref (self);
#line 584 "../src/Views/WifiPage.vala"
	_tmp0_ = network_network_manager_get_default ();
#line 584 "../src/Views/WifiPage.vala"
	network_manager = _tmp0_;
#line 586 "../src/Views/WifiPage.vala"
	_tmp1_ = network_network_manager_get_client (network_manager);
#line 586 "../src/Views/WifiPage.vala"
	_tmp2_ = _tmp1_;
#line 586 "../src/Views/WifiPage.vala"
	_tmp3_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 586 "../src/Views/WifiPage.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow));
#line 586 "../src/Views/WifiPage.vala"
	_tmp5_ = (NMAWifiDialog*) nma_wifi_dialog_new_for_other (_tmp2_);
#line 586 "../src/Views/WifiPage.vala"
	gtk_window_set_deletable ((GtkWindow*) _tmp5_, FALSE);
#line 586 "../src/Views/WifiPage.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp5_, _tmp4_);
#line 586 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_tmp4_);
#line 586 "../src/Views/WifiPage.vala"
	g_object_set ((GtkWindow*) _tmp5_, "window-position", GTK_WIN_POS_CENTER_ON_PARENT, NULL);
#line 586 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp5_);
#line 586 "../src/Views/WifiPage.vala"
	_data9_->hidden_dialog = _tmp5_;
#line 591 "../src/Views/WifiPage.vala"
	g_signal_connect_data ((GtkDialog*) _data9_->hidden_dialog, "response", (GCallback) ___lambda19__gtk_dialog_response, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 597 "../src/Views/WifiPage.vala"
	gtk_dialog_run ((GtkDialog*) _data9_->hidden_dialog);
#line 598 "../src/Views/WifiPage.vala"
	gtk_widget_destroy ((GtkWidget*) _data9_->hidden_dialog);
#line 583 "../src/Views/WifiPage.vala"
	block9_data_unref (_data9_);
#line 583 "../src/Views/WifiPage.vala"
	_data9_ = NULL;
#line 2741 "WifiPage.c"
}

static void
network_wifi_interface_connect_to_network_data_free (gpointer _data)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = _data;
#line 21 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_data_->wifi_dialog);
#line 21 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/Views/WifiPage.vala"
	g_slice_free (NetworkWifiInterfaceConnectToNetworkData, _data_);
#line 2755 "WifiPage.c"
}

static void
network_wifi_interface_connect_to_network (NetworkWifiInterface* self,
                                           NMAWifiDialog* wifi_dialog,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	NetworkWifiInterface* _tmp0_;
	NMAWifiDialog* _tmp1_;
#line 21 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Views/WifiPage.vala"
	g_return_if_fail (wifi_dialog != NULL);
#line 21 "../src/Views/WifiPage.vala"
	_data_ = g_slice_new0 (NetworkWifiInterfaceConnectToNetworkData);
#line 21 "../src/Views/WifiPage.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/Views/WifiPage.vala"
	g_task_set_task_data (_data_->_async_result, _data_, network_wifi_interface_connect_to_network_data_free);
#line 21 "../src/Views/WifiPage.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/Views/WifiPage.vala"
	_data_->self = _tmp0_;
#line 21 "../src/Views/WifiPage.vala"
	_tmp1_ = _g_object_ref0 (wifi_dialog);
#line 21 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_data_->wifi_dialog);
#line 21 "../src/Views/WifiPage.vala"
	_data_->wifi_dialog = _tmp1_;
#line 21 "../src/Views/WifiPage.vala"
	network_wifi_interface_connect_to_network_co (_data_);
#line 2789 "WifiPage.c"
}

static void
network_wifi_interface_connect_to_network_finish (NetworkWifiInterface* self,
                                                  GAsyncResult* _res_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
#line 21 "../src/Views/WifiPage.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2799 "WifiPage.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 601 "../src/Views/WifiPage.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 601 "../src/Views/WifiPage.vala"
	return _data10_;
#line 2809 "WifiPage.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 601 "../src/Views/WifiPage.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2819 "WifiPage.c"
		NetworkWifiInterface* self;
#line 601 "../src/Views/WifiPage.vala"
		self = _data10_->self;
#line 601 "../src/Views/WifiPage.vala"
		_g_object_unref0 (_data10_->dialog_connection);
#line 601 "../src/Views/WifiPage.vala"
		_g_object_unref0 (_data10_->fuzzy);
#line 601 "../src/Views/WifiPage.vala"
		_g_object_unref0 (self);
#line 601 "../src/Views/WifiPage.vala"
		g_slice_free (Block10Data, _data10_);
#line 2831 "WifiPage.c"
	}
}

static void
__lambda11_ (Block10Data* _data10_,
             NMRemoteConnection* possible)
{
	NetworkWifiInterface* self;
	NMConnection* _tmp0_;
#line 609 "../src/Views/WifiPage.vala"
	self = _data10_->self;
#line 609 "../src/Views/WifiPage.vala"
	g_return_if_fail (possible != NULL);
#line 610 "../src/Views/WifiPage.vala"
	_tmp0_ = _data10_->dialog_connection;
#line 610 "../src/Views/WifiPage.vala"
	if (nm_connection_compare (_tmp0_, (NMConnection*) possible, NM_SETTING_COMPARE_FLAG_FUZZY | NM_SETTING_COMPARE_FLAG_IGNORE_ID)) {
#line 2849 "WifiPage.c"
		NMConnection* _tmp1_;
#line 611 "../src/Views/WifiPage.vala"
		_tmp1_ = _g_object_ref0 ((NMConnection*) possible);
#line 611 "../src/Views/WifiPage.vala"
		_g_object_unref0 (_data10_->fuzzy);
#line 611 "../src/Views/WifiPage.vala"
		_data10_->fuzzy = _tmp1_;
#line 2857 "WifiPage.c"
	}
}

static void
___lambda11__gfunc (gconstpointer data,
                    gpointer self)
{
#line 609 "../src/Views/WifiPage.vala"
	__lambda11_ (self, (NMRemoteConnection*) data);
#line 2867 "WifiPage.c"
}

static void
network_wifi_interface_connect_to_network_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
#line 622 "../src/Views/WifiPage.vala"
	_data_ = _user_data_;
#line 622 "../src/Views/WifiPage.vala"
	_data_->_source_object_ = source_object;
#line 622 "../src/Views/WifiPage.vala"
	_data_->_res_ = _res_;
#line 622 "../src/Views/WifiPage.vala"
	network_wifi_interface_connect_to_network_co (_data_);
#line 2884 "WifiPage.c"
}

static gboolean
network_wifi_interface_connect_to_network_co (NetworkWifiInterfaceConnectToNetworkData* _data_)
{
#line 601 "../src/Views/WifiPage.vala"
	switch (_data_->_state_) {
#line 601 "../src/Views/WifiPage.vala"
		case 0:
#line 2894 "WifiPage.c"
		goto _state_0;
#line 601 "../src/Views/WifiPage.vala"
		case 1:
#line 2898 "WifiPage.c"
		goto _state_1;
#line 601 "../src/Views/WifiPage.vala"
		case 2:
#line 2902 "WifiPage.c"
		goto _state_2;
		default:
#line 601 "../src/Views/WifiPage.vala"
		g_assert_not_reached ();
#line 2907 "WifiPage.c"
	}
	_state_0:
#line 601 "../src/Views/WifiPage.vala"
	_data_->_data10_ = g_slice_new0 (Block10Data);
#line 601 "../src/Views/WifiPage.vala"
	_data_->_data10_->_ref_count_ = 1;
#line 601 "../src/Views/WifiPage.vala"
	_data_->_data10_->self = g_object_ref (_data_->self);
#line 601 "../src/Views/WifiPage.vala"
	_data_->_data10_->_async_data_ = _data_;
#line 602 "../src/Views/WifiPage.vala"
	_data_->_data10_->fuzzy = NULL;
#line 604 "../src/Views/WifiPage.vala"
	_data_->dialog_ap = NULL;
#line 605 "../src/Views/WifiPage.vala"
	_data_->_tmp0_ = NULL;
#line 605 "../src/Views/WifiPage.vala"
	_data_->_tmp1_ = NULL;
#line 605 "../src/Views/WifiPage.vala"
	_data_->_tmp2_ = nma_wifi_dialog_get_connection (_data_->wifi_dialog, &_data_->_tmp0_, &_data_->_tmp1_);
#line 605 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_data_->dialog_device);
#line 605 "../src/Views/WifiPage.vala"
	_data_->dialog_device = _data_->_tmp0_;
#line 605 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_data_->dialog_ap);
#line 605 "../src/Views/WifiPage.vala"
	_data_->dialog_ap = _data_->_tmp1_;
#line 605 "../src/Views/WifiPage.vala"
	_data_->_data10_->dialog_connection = _data_->_tmp2_;
#line 607 "../src/Views/WifiPage.vala"
	_data_->_tmp3_ = network_network_manager_get_default ();
#line 607 "../src/Views/WifiPage.vala"
	_data_->network_manager = _data_->_tmp3_;
#line 608 "../src/Views/WifiPage.vala"
	_data_->_tmp4_ = _data_->network_manager;
#line 608 "../src/Views/WifiPage.vala"
	_data_->_tmp5_ = network_network_manager_get_client (_data_->_tmp4_);
#line 608 "../src/Views/WifiPage.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 608 "../src/Views/WifiPage.vala"
	_data_->client = _data_->_tmp6_;
#line 609 "../src/Views/WifiPage.vala"
	_data_->_tmp7_ = _data_->client;
#line 609 "../src/Views/WifiPage.vala"
	_data_->_tmp8_ = nm_client_get_connections (_data_->_tmp7_);
#line 609 "../src/Views/WifiPage.vala"
	g_ptr_array_foreach (_data_->_tmp8_, ___lambda11__gfunc, _data_->_data10_);
#line 615 "../src/Views/WifiPage.vala"
	_data_->path = NULL;
#line 616 "../src/Views/WifiPage.vala"
	_data_->_tmp9_ = _data_->dialog_ap;
#line 616 "../src/Views/WifiPage.vala"
	if (_data_->_tmp9_ != NULL) {
#line 617 "../src/Views/WifiPage.vala"
		_data_->_tmp10_ = _data_->dialog_ap;
#line 617 "../src/Views/WifiPage.vala"
		_data_->_tmp11_ = nm_object_get_path ((NMObject*) _data_->_tmp10_);
#line 617 "../src/Views/WifiPage.vala"
		_data_->_tmp12_ = g_strdup (_data_->_tmp11_);
#line 617 "../src/Views/WifiPage.vala"
		_g_free0 (_data_->path);
#line 617 "../src/Views/WifiPage.vala"
		_data_->path = _data_->_tmp12_;
#line 2972 "WifiPage.c"
	}
#line 620 "../src/Views/WifiPage.vala"
	_data_->_tmp13_ = _data_->_data10_->fuzzy;
#line 620 "../src/Views/WifiPage.vala"
	if (_data_->_tmp13_ != NULL) {
#line 2978 "WifiPage.c"
		{
#line 622 "../src/Views/WifiPage.vala"
			_data_->_tmp14_ = _data_->client;
#line 622 "../src/Views/WifiPage.vala"
			_data_->_tmp15_ = _data_->_data10_->fuzzy;
#line 622 "../src/Views/WifiPage.vala"
			_data_->_tmp16_ = _data_->self->wifi_device;
#line 622 "../src/Views/WifiPage.vala"
			_data_->_tmp17_ = _data_->path;
#line 622 "../src/Views/WifiPage.vala"
			_data_->_state_ = 1;
#line 622 "../src/Views/WifiPage.vala"
			nm_client_activate_connection_async (_data_->_tmp14_, _data_->_tmp15_, (NMDevice*) _data_->_tmp16_, _data_->_tmp17_, NULL, network_wifi_interface_connect_to_network_ready, _data_);
#line 622 "../src/Views/WifiPage.vala"
			return FALSE;
#line 2994 "WifiPage.c"
			_state_1:
#line 622 "../src/Views/WifiPage.vala"
			_data_->_tmp18_ = nm_client_activate_connection_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
#line 622 "../src/Views/WifiPage.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 622 "../src/Views/WifiPage.vala"
			_g_object_unref0 (_data_->_tmp19_);
#line 622 "../src/Views/WifiPage.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3004 "WifiPage.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 621 "../src/Views/WifiPage.vala"
			_data_->_error_ = _data_->_inner_error0_;
#line 621 "../src/Views/WifiPage.vala"
			_data_->_inner_error0_ = NULL;
#line 624 "../src/Views/WifiPage.vala"
			_data_->_tmp20_ = _data_->_error_;
#line 624 "../src/Views/WifiPage.vala"
			_data_->_tmp21_ = _data_->_tmp20_->message;
#line 624 "../src/Views/WifiPage.vala"
			g_critical ("WifiPage.vala:624: %s", _data_->_tmp21_);
#line 621 "../src/Views/WifiPage.vala"
			_g_error_free0 (_data_->_error_);
#line 3023 "WifiPage.c"
		}
		__finally0:
#line 621 "../src/Views/WifiPage.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 621 "../src/Views/WifiPage.vala"
			_g_free0 (_data_->path);
#line 621 "../src/Views/WifiPage.vala"
			_g_object_unref0 (_data_->dialog_ap);
#line 621 "../src/Views/WifiPage.vala"
			_g_object_unref0 (_data_->dialog_device);
#line 621 "../src/Views/WifiPage.vala"
			block10_data_unref (_data_->_data10_);
#line 621 "../src/Views/WifiPage.vala"
			_data_->_data10_ = NULL;
#line 621 "../src/Views/WifiPage.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 621 "../src/Views/WifiPage.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 621 "../src/Views/WifiPage.vala"
			g_object_unref (_data_->_async_result);
#line 621 "../src/Views/WifiPage.vala"
			return FALSE;
#line 3046 "WifiPage.c"
		}
	} else {
#line 627 "../src/Views/WifiPage.vala"
		_data_->mode = NULL;
#line 628 "../src/Views/WifiPage.vala"
		_data_->_tmp22_ = _data_->_data10_->dialog_connection;
#line 628 "../src/Views/WifiPage.vala"
		_data_->_tmp23_ = nm_connection_get_setting_wireless (_data_->_tmp22_);
#line 628 "../src/Views/WifiPage.vala"
		_data_->setting_wireless = _data_->_tmp23_;
#line 629 "../src/Views/WifiPage.vala"
		_data_->_tmp24_ = _data_->setting_wireless;
#line 629 "../src/Views/WifiPage.vala"
		if (_data_->_tmp24_ != NULL) {
#line 630 "../src/Views/WifiPage.vala"
			_data_->_tmp25_ = _data_->setting_wireless;
#line 630 "../src/Views/WifiPage.vala"
			_data_->_tmp26_ = nm_setting_wireless_get_mode (_data_->_tmp25_);
#line 630 "../src/Views/WifiPage.vala"
			_data_->_tmp27_ = g_strdup (_data_->_tmp26_);
#line 630 "../src/Views/WifiPage.vala"
			_g_free0 (_data_->mode);
#line 630 "../src/Views/WifiPage.vala"
			_data_->mode = _data_->_tmp27_;
#line 3071 "WifiPage.c"
		}
#line 633 "../src/Views/WifiPage.vala"
		_data_->_tmp28_ = _data_->mode;
#line 633 "../src/Views/WifiPage.vala"
		if (g_strcmp0 (_data_->_tmp28_, "adhoc") == 0) {
#line 634 "../src/Views/WifiPage.vala"
			_data_->_tmp29_ = _data_->_data10_->dialog_connection;
#line 634 "../src/Views/WifiPage.vala"
			_data_->_tmp30_ = nm_connection_get_setting_connection (_data_->_tmp29_);
#line 634 "../src/Views/WifiPage.vala"
			_data_->_tmp31_ = _g_object_ref0 (_data_->_tmp30_);
#line 634 "../src/Views/WifiPage.vala"
			_data_->connection_setting = _data_->_tmp31_;
#line 635 "../src/Views/WifiPage.vala"
			_data_->_tmp32_ = _data_->connection_setting;
#line 635 "../src/Views/WifiPage.vala"
			if (_data_->_tmp32_ == NULL) {
#line 636 "../src/Views/WifiPage.vala"
				_data_->_tmp33_ = (NMSettingConnection*) nm_setting_connection_new ();
#line 636 "../src/Views/WifiPage.vala"
				_g_object_unref0 (_data_->connection_setting);
#line 636 "../src/Views/WifiPage.vala"
				_data_->connection_setting = _data_->_tmp33_;
#line 3095 "WifiPage.c"
			}
#line 639 "../src/Views/WifiPage.vala"
			_data_->_tmp34_ = _data_->_data10_->dialog_connection;
#line 639 "../src/Views/WifiPage.vala"
			_data_->_tmp35_ = _data_->connection_setting;
#line 639 "../src/Views/WifiPage.vala"
			_data_->_tmp36_ = _g_object_ref0 ((NMSetting*) _data_->_tmp35_);
#line 639 "../src/Views/WifiPage.vala"
			nm_connection_add_setting (_data_->_tmp34_, _data_->_tmp36_);
#line 633 "../src/Views/WifiPage.vala"
			_g_object_unref0 (_data_->connection_setting);
#line 3107 "WifiPage.c"
		}
		{
#line 643 "../src/Views/WifiPage.vala"
			_data_->_tmp37_ = _data_->client;
#line 643 "../src/Views/WifiPage.vala"
			_data_->_tmp38_ = _data_->_data10_->dialog_connection;
#line 643 "../src/Views/WifiPage.vala"
			_data_->_tmp39_ = _data_->dialog_device;
#line 643 "../src/Views/WifiPage.vala"
			_data_->_tmp40_ = _data_->path;
#line 643 "../src/Views/WifiPage.vala"
			_data_->_state_ = 2;
#line 643 "../src/Views/WifiPage.vala"
			nm_client_add_and_activate_connection_async (_data_->_tmp37_, _data_->_tmp38_, _data_->_tmp39_, _data_->_tmp40_, NULL, network_wifi_interface_connect_to_network_ready, _data_);
#line 643 "../src/Views/WifiPage.vala"
			return FALSE;
#line 3124 "WifiPage.c"
			_state_2:
#line 643 "../src/Views/WifiPage.vala"
			_data_->_tmp41_ = nm_client_add_and_activate_connection_finish (_data_->_tmp37_, _data_->_res_, &_data_->_inner_error0_);
#line 643 "../src/Views/WifiPage.vala"
			_data_->_tmp42_ = _data_->_tmp41_;
#line 643 "../src/Views/WifiPage.vala"
			_g_object_unref0 (_data_->_tmp42_);
#line 643 "../src/Views/WifiPage.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3134 "WifiPage.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 642 "../src/Views/WifiPage.vala"
			_data_->_vala1__error_ = _data_->_inner_error0_;
#line 642 "../src/Views/WifiPage.vala"
			_data_->_inner_error0_ = NULL;
#line 645 "../src/Views/WifiPage.vala"
			_data_->_tmp43_ = _data_->_vala1__error_;
#line 645 "../src/Views/WifiPage.vala"
			_data_->_tmp44_ = _data_->_tmp43_->message;
#line 645 "../src/Views/WifiPage.vala"
			g_critical ("WifiPage.vala:645: %s", _data_->_tmp44_);
#line 642 "../src/Views/WifiPage.vala"
			_g_error_free0 (_data_->_vala1__error_);
#line 3153 "WifiPage.c"
		}
		__finally1:
#line 642 "../src/Views/WifiPage.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 642 "../src/Views/WifiPage.vala"
			_g_free0 (_data_->mode);
#line 642 "../src/Views/WifiPage.vala"
			_g_free0 (_data_->path);
#line 642 "../src/Views/WifiPage.vala"
			_g_object_unref0 (_data_->dialog_ap);
#line 642 "../src/Views/WifiPage.vala"
			_g_object_unref0 (_data_->dialog_device);
#line 642 "../src/Views/WifiPage.vala"
			block10_data_unref (_data_->_data10_);
#line 642 "../src/Views/WifiPage.vala"
			_data_->_data10_ = NULL;
#line 642 "../src/Views/WifiPage.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 642 "../src/Views/WifiPage.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 642 "../src/Views/WifiPage.vala"
			g_object_unref (_data_->_async_result);
#line 642 "../src/Views/WifiPage.vala"
			return FALSE;
#line 3178 "WifiPage.c"
		}
#line 620 "../src/Views/WifiPage.vala"
		_g_free0 (_data_->mode);
#line 3182 "WifiPage.c"
	}
#line 601 "../src/Views/WifiPage.vala"
	_g_free0 (_data_->path);
#line 601 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_data_->dialog_ap);
#line 601 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_data_->dialog_device);
#line 601 "../src/Views/WifiPage.vala"
	block10_data_unref (_data_->_data10_);
#line 601 "../src/Views/WifiPage.vala"
	_data_->_data10_ = NULL;
#line 601 "../src/Views/WifiPage.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 601 "../src/Views/WifiPage.vala"
	if (_data_->_state_ != 0) {
#line 601 "../src/Views/WifiPage.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 601 "../src/Views/WifiPage.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3202 "WifiPage.c"
		}
	}
#line 601 "../src/Views/WifiPage.vala"
	g_object_unref (_data_->_async_result);
#line 601 "../src/Views/WifiPage.vala"
	return FALSE;
#line 3209 "WifiPage.c"
}

static void
network_wifi_interface_cancel_scan (NetworkWifiInterface* self)
{
#line 651 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 652 "../src/Views/WifiPage.vala"
	if (self->priv->timeout_scan > ((guint) 0)) {
#line 653 "../src/Views/WifiPage.vala"
		g_source_remove (self->priv->timeout_scan);
#line 654 "../src/Views/WifiPage.vala"
		self->priv->timeout_scan = (guint) 0;
#line 3223 "WifiPage.c"
	}
}

static gboolean
___lambda14_ (NetworkWifiInterface* self)
{
	NMDeviceWifi* _tmp0_;
	GtkStack* _tmp1_;
	gboolean result;
#line 665 "../src/Views/WifiPage.vala"
	_tmp0_ = self->wifi_device;
#line 665 "../src/Views/WifiPage.vala"
	if (network_utils_get_device_is_hotspot (_tmp0_)) {
#line 666 "../src/Views/WifiPage.vala"
		result = FALSE;
#line 666 "../src/Views/WifiPage.vala"
		return result;
#line 3241 "WifiPage.c"
	}
#line 669 "../src/Views/WifiPage.vala"
	self->priv->timeout_scan = (guint) 0;
#line 670 "../src/Views/WifiPage.vala"
	_tmp1_ = self->priv->placeholder;
#line 670 "../src/Views/WifiPage.vala"
	gtk_stack_set_visible_child_name (_tmp1_, "no-aps");
#line 671 "../src/Views/WifiPage.vala"
	result = FALSE;
#line 671 "../src/Views/WifiPage.vala"
	return result;
#line 3253 "WifiPage.c"
}

static gboolean
____lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda14_ ((NetworkWifiInterface*) self);
#line 664 "../src/Views/WifiPage.vala"
	return result;
#line 3263 "WifiPage.c"
}

static void
network_wifi_interface_set_scan_placeholder (NetworkWifiInterface* self)
{
	NMDeviceState _tmp0_;
	NMDeviceState _tmp1_;
#line 658 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 660 "../src/Views/WifiPage.vala"
	_tmp0_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
#line 660 "../src/Views/WifiPage.vala"
	_tmp1_ = _tmp0_;
#line 660 "../src/Views/WifiPage.vala"
	if (_tmp1_ == NM_DEVICE_STATE_DISCONNECTED) {
#line 3279 "WifiPage.c"
		GtkStack* _tmp2_;
		NMDeviceWifi* _tmp3_;
#line 661 "../src/Views/WifiPage.vala"
		_tmp2_ = self->priv->placeholder;
#line 661 "../src/Views/WifiPage.vala"
		gtk_stack_set_visible_child_name (_tmp2_, "scanning");
#line 662 "../src/Views/WifiPage.vala"
		network_wifi_interface_cancel_scan (self);
#line 663 "../src/Views/WifiPage.vala"
		_tmp3_ = self->wifi_device;
#line 663 "../src/Views/WifiPage.vala"
		nm_device_wifi_request_scan_async (_tmp3_, NULL, NULL, NULL);
#line 664 "../src/Views/WifiPage.vala"
		self->priv->timeout_scan = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 5000, ____lambda14__gsource_func, g_object_ref (self), g_object_unref);
#line 3294 "WifiPage.c"
	}
}

static gint
network_wifi_interface_sort_func (NetworkWifiInterface* self,
                                  GtkListBoxRow* r1,
                                  GtkListBoxRow* r2)
{
	gboolean _tmp0_ = FALSE;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	NMAccessPoint* _tmp5_;
	NMAccessPoint* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	gint result;
#line 676 "../src/Views/WifiPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 676 "../src/Views/WifiPage.vala"
	g_return_val_if_fail (r1 != NULL, 0);
#line 676 "../src/Views/WifiPage.vala"
	g_return_val_if_fail (r2 != NULL, 0);
#line 677 "../src/Views/WifiPage.vala"
	if (r1 == NULL) {
#line 677 "../src/Views/WifiPage.vala"
		_tmp0_ = TRUE;
#line 3323 "WifiPage.c"
	} else {
#line 677 "../src/Views/WifiPage.vala"
		_tmp0_ = r2 == NULL;
#line 3327 "WifiPage.c"
	}
#line 677 "../src/Views/WifiPage.vala"
	if (_tmp0_) {
#line 678 "../src/Views/WifiPage.vala"
		result = 0;
#line 678 "../src/Views/WifiPage.vala"
		return result;
#line 3335 "WifiPage.c"
	}
#line 681 "../src/Views/WifiPage.vala"
	_tmp1_ = network_wifi_menu_item_get_ap (G_TYPE_CHECK_INSTANCE_CAST (r2, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
#line 681 "../src/Views/WifiPage.vala"
	_tmp2_ = _tmp1_;
#line 681 "../src/Views/WifiPage.vala"
	_tmp3_ = nm_access_point_get_strength (_tmp2_);
#line 681 "../src/Views/WifiPage.vala"
	_tmp4_ = _tmp3_;
#line 681 "../src/Views/WifiPage.vala"
	_tmp5_ = network_wifi_menu_item_get_ap (G_TYPE_CHECK_INSTANCE_CAST (r1, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
#line 681 "../src/Views/WifiPage.vala"
	_tmp6_ = _tmp5_;
#line 681 "../src/Views/WifiPage.vala"
	_tmp7_ = nm_access_point_get_strength (_tmp6_);
#line 681 "../src/Views/WifiPage.vala"
	_tmp8_ = _tmp7_;
#line 681 "../src/Views/WifiPage.vala"
	result = (gint) (_tmp4_ - _tmp8_);
#line 681 "../src/Views/WifiPage.vala"
	return result;
#line 3357 "WifiPage.c"
}

static NetworkWifiMenuItem*
network_wifi_interface_get_active_wifi_item (NetworkWifiInterface* self)
{
	NetworkWifiMenuItem* result;
	NetworkWifiMenuItem* _tmp0_;
#line 28 "../src/Views/WifiPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Views/WifiPage.vala"
	_tmp0_ = self->priv->_active_wifi_item;
#line 28 "../src/Views/WifiPage.vala"
	result = _tmp0_;
#line 28 "../src/Views/WifiPage.vala"
	return result;
#line 3373 "WifiPage.c"
}

static void
network_wifi_interface_set_active_wifi_item (NetworkWifiInterface* self,
                                             NetworkWifiMenuItem* value)
{
	NetworkWifiMenuItem* _tmp0_;
#line 28 "../src/Views/WifiPage.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Views/WifiPage.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->_active_wifi_item);
#line 28 "../src/Views/WifiPage.vala"
	self->priv->_active_wifi_item = _tmp0_;
#line 3389 "WifiPage.c"
}

static gint
_network_wifi_interface_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                          GtkListBoxRow* row2,
                                                          gpointer self)
{
	gint result;
	result = network_wifi_interface_sort_func ((NetworkWifiInterface*) self, row1, row2);
#line 65 "../src/Views/WifiPage.vala"
	return result;
#line 3401 "WifiPage.c"
}

static void
_network_wifi_interface___lambda20_ (NetworkWifiInterface* self)
{
	GtkToggleButton* _tmp0_;
#line 101 "../src/Views/WifiPage.vala"
	_tmp0_ = self->info_btn;
#line 101 "../src/Views/WifiPage.vala"
	gtk_toggle_button_set_active (_tmp0_, FALSE);
#line 3412 "WifiPage.c"
}

static void
__network_wifi_interface___lambda20__gtk_widget_hide (GtkWidget* _sender,
                                                      gpointer self)
{
#line 100 "../src/Views/WifiPage.vala"
	_network_wifi_interface___lambda20_ ((NetworkWifiInterface*) self);
#line 3421 "WifiPage.c"
}

static void
_network_wifi_interface_connect_to_hidden_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 113 "../src/Views/WifiPage.vala"
	network_wifi_interface_connect_to_hidden ((NetworkWifiInterface*) self);
#line 3430 "WifiPage.c"
}

static void
_network_widgets_page_update_rf_kill_manager_device_added (RFKillManager* _sender,
                                                           RFKillDevice* device,
                                                           gpointer self)
{
#line 166 "../src/Views/WifiPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 3440 "WifiPage.c"
}

static void
_network_widgets_page_update_rf_kill_manager_device_changed (RFKillManager* _sender,
                                                             RFKillDevice* device,
                                                             gpointer self)
{
#line 167 "../src/Views/WifiPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 3450 "WifiPage.c"
}

static void
_network_widgets_page_update_rf_kill_manager_device_deleted (RFKillManager* _sender,
                                                             RFKillDevice* device,
                                                             gpointer self)
{
#line 168 "../src/Views/WifiPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 3460 "WifiPage.c"
}

static void
_network_widgets_page_update_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 170 "../src/Views/WifiPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 3470 "WifiPage.c"
}

static void
_network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added (NMDeviceWifi* _sender,
                                                                                 GObject* ap,
                                                                                 gpointer self)
{
#line 171 "../src/Views/WifiPage.vala"
	network_wifi_interface_access_point_added_cb ((NetworkWifiInterface*) self, ap);
#line 3480 "WifiPage.c"
}

static void
_network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed (NMDeviceWifi* _sender,
                                                                                     GObject* ap,
                                                                                     gpointer self)
{
#line 172 "../src/Views/WifiPage.vala"
	network_wifi_interface_access_point_removed_cb ((NetworkWifiInterface*) self, ap);
#line 3490 "WifiPage.c"
}

static void
_network_widgets_page_update_nm_device_state_changed (NMDevice* _sender,
                                                      guint new_state,
                                                      guint old_state,
                                                      guint reason,
                                                      gpointer self)
{
#line 173 "../src/Views/WifiPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 3502 "WifiPage.c"
}

static void
_network_wifi_interface_access_point_added_cb_gfunc (gconstpointer data,
                                                     gpointer self)
{
#line 177 "../src/Views/WifiPage.vala"
	network_wifi_interface_access_point_added_cb ((NetworkWifiInterface*) self, (GObject*) data);
#line 3511 "WifiPage.c"
}

static GObject *
network_wifi_interface_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWifiInterface * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkStack* _tmp2_ = NULL;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkStack* _tmp6_;
	GraniteWidgetsAlertView* hotspot_mode_alert = NULL;
	GraniteWidgetsAlertView* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	GtkListBox* _tmp9_;
	GtkListBox* _tmp10_;
	GtkListBox* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	GtkListBox* _tmp14_;
	GtkStack* _tmp15_;
	GtkStack* _tmp16_;
	GraniteWidgetsAlertView* _tmp17_;
	GtkStack* _tmp18_;
	GtkScrolledWindow* _tmp19_;
	GtkStack* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkFrame* main_frame = NULL;
	GtkFrame* _tmp22_ = NULL;
	GtkFrame* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkFrame* _tmp25_;
	GtkStack* _tmp26_;
	NetworkWidgetsInfoBox* _tmp27_;
	GtkToggleButton* _tmp28_;
	GtkPopover* _tmp29_ = NULL;
	GtkPopover* _tmp30_;
	NetworkWidgetsInfoBox* _tmp31_;
	GtkPopover* _tmp32_;
	GtkFrame* _tmp33_;
	GtkFrame* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkRevealer* _tmp36_ = NULL;
	GtkRevealer* _tmp37_;
	GtkFrame* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkButtonBox* _tmp41_;
	GtkButtonBox* _tmp42_;
	NetworkWidgetsSettingsButton* _tmp43_;
	NetworkWidgetsSettingsButton* _tmp44_;
	GtkButtonBox* _tmp45_;
	GtkButtonBox* _tmp46_;
	GtkButton* _tmp47_;
	NMDevice* _tmp48_;
	NMDevice* _tmp49_;
	NMDeviceWifi* _tmp50_;
	GraniteWidgetsAlertView* no_aps_alert = NULL;
	GraniteWidgetsAlertView* _tmp51_;
	GraniteWidgetsAlertView* _tmp52_;
	GraniteWidgetsAlertView* wireless_off_alert = NULL;
	GraniteWidgetsAlertView* _tmp53_;
	GraniteWidgetsAlertView* _tmp54_;
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp55_ = NULL;
	GtkSpinner* _tmp56_;
	GtkLabel* scanning = NULL;
	GtkLabel* _tmp57_ = NULL;
	GtkLabel* _tmp58_;
	GtkStyleContext* _tmp59_;
	GtkBox* scanning_box = NULL;
	GtkBox* _tmp60_ = NULL;
	GtkBox* _tmp61_;
	GtkLabel* _tmp62_;
	GtkBox* _tmp63_;
	GtkSpinner* _tmp64_;
	GtkStack* _tmp65_;
	GraniteWidgetsAlertView* _tmp66_;
	GtkStack* _tmp67_;
	GraniteWidgetsAlertView* _tmp68_;
	GtkStack* _tmp69_;
	GtkBox* _tmp70_;
	GtkStack* _tmp71_;
	RFKillManager* _tmp72_;
	RFKillManager* _tmp73_;
	RFKillManager* _tmp74_;
	RFKillManager* _tmp75_;
	RFKillManager* _tmp76_;
	NMDeviceWifi* _tmp77_;
	NMDeviceWifi* _tmp78_;
	NMDeviceWifi* _tmp79_;
	NMDeviceWifi* _tmp80_;
	GPtrArray* aps = NULL;
	NMDeviceWifi* _tmp81_;
	GPtrArray* _tmp82_;
	GPtrArray* _tmp83_;
	gboolean _tmp84_ = FALSE;
	GPtrArray* _tmp85_;
	GtkGrid* _tmp90_;
	GtkGrid* _tmp91_;
	GtkRevealer* _tmp92_;
	GtkGrid* _tmp93_;
	GtkGrid* _tmp94_;
	GtkFrame* _tmp95_;
	GtkGrid* _tmp96_;
	GtkGrid* _tmp97_;
#line 56 "../src/Views/WifiPage.vala"
	parent_class = G_OBJECT_CLASS (network_wifi_interface_parent_class);
#line 56 "../src/Views/WifiPage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 56 "../src/Views/WifiPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
#line 57 "../src/Views/WifiPage.vala"
	granite_simple_settings_page_set_icon_name ((GraniteSimpleSettingsPage*) self, "network-wireless");
#line 58 "../src/Views/WifiPage.vala"
	_tmp0_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 58 "../src/Views/WifiPage.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Views/WifiPage.vala"
	gtk_grid_set_row_spacing (_tmp1_, 0);
#line 60 "../src/Views/WifiPage.vala"
	_tmp2_ = (GtkStack*) gtk_stack_new ();
#line 60 "../src/Views/WifiPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 60 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp2_);
#line 60 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->placeholder);
#line 60 "../src/Views/WifiPage.vala"
	self->priv->placeholder = _tmp2_;
#line 64 "../src/Views/WifiPage.vala"
	_tmp3_ = (GtkListBox*) gtk_list_box_new ();
#line 64 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp3_);
#line 64 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->wifi_list);
#line 64 "../src/Views/WifiPage.vala"
	self->priv->wifi_list = _tmp3_;
#line 65 "../src/Views/WifiPage.vala"
	_tmp4_ = self->priv->wifi_list;
#line 65 "../src/Views/WifiPage.vala"
	gtk_list_box_set_sort_func (_tmp4_, _network_wifi_interface_sort_func_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 66 "../src/Views/WifiPage.vala"
	_tmp5_ = self->priv->wifi_list;
#line 66 "../src/Views/WifiPage.vala"
	_tmp6_ = self->priv->placeholder;
#line 66 "../src/Views/WifiPage.vala"
	gtk_list_box_set_placeholder (_tmp5_, (GtkWidget*) _tmp6_);
#line 68 "../src/Views/WifiPage.vala"
	_tmp7_ = granite_widgets_alert_view_new (_ ("This device is in Hotspot Mode"), _ ("Turn off the Hotspot Mode to connect to other Access Points."), "");
#line 68 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp7_);
#line 68 "../src/Views/WifiPage.vala"
	hotspot_mode_alert = _tmp7_;
#line 73 "../src/Views/WifiPage.vala"
	_tmp8_ = hotspot_mode_alert;
#line 73 "../src/Views/WifiPage.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
#line 75 "../src/Views/WifiPage.vala"
	_tmp9_ = self->priv->wifi_list;
#line 75 "../src/Views/WifiPage.vala"
	gtk_list_box_set_selection_mode (_tmp9_, GTK_SELECTION_SINGLE);
#line 76 "../src/Views/WifiPage.vala"
	_tmp10_ = self->priv->wifi_list;
#line 76 "../src/Views/WifiPage.vala"
	gtk_list_box_set_activate_on_single_click (_tmp10_, FALSE);
#line 77 "../src/Views/WifiPage.vala"
	_tmp11_ = self->priv->wifi_list;
#line 77 "../src/Views/WifiPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp11_, TRUE);
#line 79 "../src/Views/WifiPage.vala"
	_tmp12_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 79 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp12_);
#line 79 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->scrolled);
#line 79 "../src/Views/WifiPage.vala"
	self->scrolled = _tmp12_;
#line 80 "../src/Views/WifiPage.vala"
	_tmp13_ = self->scrolled;
#line 80 "../src/Views/WifiPage.vala"
	_tmp14_ = self->priv->wifi_list;
#line 80 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 82 "../src/Views/WifiPage.vala"
	_tmp15_ = (GtkStack*) gtk_stack_new ();
#line 82 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp15_);
#line 82 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->list_stack);
#line 82 "../src/Views/WifiPage.vala"
	self->list_stack = _tmp15_;
#line 83 "../src/Views/WifiPage.vala"
	_tmp16_ = self->list_stack;
#line 83 "../src/Views/WifiPage.vala"
	_tmp17_ = hotspot_mode_alert;
#line 83 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
#line 84 "../src/Views/WifiPage.vala"
	_tmp18_ = self->list_stack;
#line 84 "../src/Views/WifiPage.vala"
	_tmp19_ = self->scrolled;
#line 84 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 85 "../src/Views/WifiPage.vala"
	_tmp20_ = self->list_stack;
#line 85 "../src/Views/WifiPage.vala"
	_tmp21_ = self->scrolled;
#line 85 "../src/Views/WifiPage.vala"
	gtk_stack_set_visible_child (_tmp20_, (GtkWidget*) _tmp21_);
#line 87 "../src/Views/WifiPage.vala"
	_tmp22_ = (GtkFrame*) gtk_frame_new (NULL);
#line 87 "../src/Views/WifiPage.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp22_, 12);
#line 87 "../src/Views/WifiPage.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp22_, TRUE);
#line 87 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp22_);
#line 87 "../src/Views/WifiPage.vala"
	main_frame = _tmp22_;
#line 91 "../src/Views/WifiPage.vala"
	_tmp23_ = main_frame;
#line 91 "../src/Views/WifiPage.vala"
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _tmp23_);
#line 91 "../src/Views/WifiPage.vala"
	gtk_style_context_add_class (_tmp24_, GTK_STYLE_CLASS_VIEW);
#line 92 "../src/Views/WifiPage.vala"
	_tmp25_ = main_frame;
#line 92 "../src/Views/WifiPage.vala"
	_tmp26_ = self->list_stack;
#line 92 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 94 "../src/Views/WifiPage.vala"
	_tmp27_ = ((NetworkWidgetsPage*) self)->info_box;
#line 94 "../src/Views/WifiPage.vala"
	g_object_set ((GtkWidget*) _tmp27_, "margin", 12, NULL);
#line 96 "../src/Views/WifiPage.vala"
	_tmp28_ = self->info_btn;
#line 96 "../src/Views/WifiPage.vala"
	_tmp29_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) _tmp28_);
#line 96 "../src/Views/WifiPage.vala"
	gtk_popover_set_position (_tmp29_, GTK_POS_BOTTOM);
#line 96 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp29_);
#line 96 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->popover);
#line 96 "../src/Views/WifiPage.vala"
	self->popover = _tmp29_;
#line 99 "../src/Views/WifiPage.vala"
	_tmp30_ = self->popover;
#line 99 "../src/Views/WifiPage.vala"
	_tmp31_ = ((NetworkWidgetsPage*) self)->info_box;
#line 99 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 100 "../src/Views/WifiPage.vala"
	_tmp32_ = self->popover;
#line 100 "../src/Views/WifiPage.vala"
	g_signal_connect_object ((GtkWidget*) _tmp32_, "hide", (GCallback) __network_wifi_interface___lambda20__gtk_widget_hide, self, 0);
#line 104 "../src/Views/WifiPage.vala"
	_tmp33_ = (GtkFrame*) gtk_frame_new (NULL);
#line 104 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp33_);
#line 104 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->connected_frame);
#line 104 "../src/Views/WifiPage.vala"
	self->connected_frame = _tmp33_;
#line 105 "../src/Views/WifiPage.vala"
	_tmp34_ = self->connected_frame;
#line 105 "../src/Views/WifiPage.vala"
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 105 "../src/Views/WifiPage.vala"
	gtk_style_context_add_class (_tmp35_, GTK_STYLE_CLASS_VIEW);
#line 107 "../src/Views/WifiPage.vala"
	_tmp36_ = (GtkRevealer*) gtk_revealer_new ();
#line 107 "../src/Views/WifiPage.vala"
	gtk_revealer_set_transition_type (_tmp36_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 107 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp36_);
#line 107 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->top_revealer);
#line 107 "../src/Views/WifiPage.vala"
	self->top_revealer = _tmp36_;
#line 110 "../src/Views/WifiPage.vala"
	_tmp37_ = self->top_revealer;
#line 110 "../src/Views/WifiPage.vala"
	_tmp38_ = self->connected_frame;
#line 110 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
#line 112 "../src/Views/WifiPage.vala"
	_tmp39_ = (GtkButton*) gtk_button_new_with_label (_ ("Connect to Hidden Network…"));
#line 112 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp39_);
#line 112 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->hidden_btn);
#line 112 "../src/Views/WifiPage.vala"
	self->hidden_btn = _tmp39_;
#line 113 "../src/Views/WifiPage.vala"
	_tmp40_ = self->hidden_btn;
#line 113 "../src/Views/WifiPage.vala"
	g_signal_connect_object (_tmp40_, "clicked", (GCallback) _network_wifi_interface_connect_to_hidden_gtk_button_clicked, self, 0);
#line 115 "../src/Views/WifiPage.vala"
	_tmp41_ = granite_simple_settings_page_get_action_area ((GraniteSimpleSettingsPage*) self);
#line 115 "../src/Views/WifiPage.vala"
	_tmp42_ = _tmp41_;
#line 115 "../src/Views/WifiPage.vala"
	_tmp43_ = network_widgets_settings_button_new ();
#line 115 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp43_);
#line 115 "../src/Views/WifiPage.vala"
	_tmp44_ = _tmp43_;
#line 115 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp44_);
#line 115 "../src/Views/WifiPage.vala"
	_g_object_unref0 (_tmp44_);
#line 116 "../src/Views/WifiPage.vala"
	_tmp45_ = granite_simple_settings_page_get_action_area ((GraniteSimpleSettingsPage*) self);
#line 116 "../src/Views/WifiPage.vala"
	_tmp46_ = _tmp45_;
#line 116 "../src/Views/WifiPage.vala"
	_tmp47_ = self->hidden_btn;
#line 116 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
#line 118 "../src/Views/WifiPage.vala"
	_tmp48_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
#line 118 "../src/Views/WifiPage.vala"
	_tmp49_ = _tmp48_;
#line 118 "../src/Views/WifiPage.vala"
	_tmp50_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, nm_device_wifi_get_type (), NMDeviceWifi));
#line 118 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->wifi_device);
#line 118 "../src/Views/WifiPage.vala"
	self->wifi_device = _tmp50_;
#line 119 "../src/Views/WifiPage.vala"
	network_wifi_interface_set_active_wifi_item (self, NULL);
#line 121 "../src/Views/WifiPage.vala"
	_tmp51_ = granite_widgets_alert_view_new (_ ("No Access Points Available"), _ ("There are no wireless access points within range."), "");
#line 121 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp51_);
#line 121 "../src/Views/WifiPage.vala"
	no_aps_alert = _tmp51_;
#line 126 "../src/Views/WifiPage.vala"
	_tmp52_ = no_aps_alert;
#line 126 "../src/Views/WifiPage.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp52_);
#line 128 "../src/Views/WifiPage.vala"
	_tmp53_ = granite_widgets_alert_view_new (_ ("Wireless Is Disabled"), _ ("Enable wireless to discover nearby wireless access points."), "");
#line 128 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp53_);
#line 128 "../src/Views/WifiPage.vala"
	wireless_off_alert = _tmp53_;
#line 133 "../src/Views/WifiPage.vala"
	_tmp54_ = wireless_off_alert;
#line 133 "../src/Views/WifiPage.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp54_);
#line 135 "../src/Views/WifiPage.vala"
	_tmp55_ = (GtkSpinner*) gtk_spinner_new ();
#line 135 "../src/Views/WifiPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp55_, TRUE);
#line 135 "../src/Views/WifiPage.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp55_, GTK_ALIGN_CENTER);
#line 135 "../src/Views/WifiPage.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp55_, GTK_ALIGN_CENTER);
#line 135 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp55_);
#line 135 "../src/Views/WifiPage.vala"
	spinner = _tmp55_;
#line 140 "../src/Views/WifiPage.vala"
	_tmp56_ = spinner;
#line 140 "../src/Views/WifiPage.vala"
	gtk_spinner_start (_tmp56_);
#line 142 "../src/Views/WifiPage.vala"
	_tmp57_ = (GtkLabel*) gtk_label_new (_ ("Scanning for Access Points…"));
#line 142 "../src/Views/WifiPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp57_, TRUE);
#line 142 "../src/Views/WifiPage.vala"
	g_object_set (_tmp57_, "wrap", TRUE, NULL);
#line 142 "../src/Views/WifiPage.vala"
	g_object_set (_tmp57_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 142 "../src/Views/WifiPage.vala"
	gtk_label_set_max_width_chars (_tmp57_, 30);
#line 142 "../src/Views/WifiPage.vala"
	gtk_label_set_justify (_tmp57_, GTK_JUSTIFY_CENTER);
#line 142 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp57_);
#line 142 "../src/Views/WifiPage.vala"
	scanning = _tmp57_;
#line 149 "../src/Views/WifiPage.vala"
	_tmp58_ = scanning;
#line 149 "../src/Views/WifiPage.vala"
	_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
#line 149 "../src/Views/WifiPage.vala"
	gtk_style_context_add_class (_tmp59_, "h2");
#line 151 "../src/Views/WifiPage.vala"
	_tmp60_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 151 "../src/Views/WifiPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp60_, TRUE);
#line 151 "../src/Views/WifiPage.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp60_, GTK_ALIGN_CENTER);
#line 151 "../src/Views/WifiPage.vala"
	g_object_ref_sink (_tmp60_);
#line 151 "../src/Views/WifiPage.vala"
	scanning_box = _tmp60_;
#line 155 "../src/Views/WifiPage.vala"
	_tmp61_ = scanning_box;
#line 155 "../src/Views/WifiPage.vala"
	_tmp62_ = scanning;
#line 155 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp61_, (GtkWidget*) _tmp62_);
#line 156 "../src/Views/WifiPage.vala"
	_tmp63_ = scanning_box;
#line 156 "../src/Views/WifiPage.vala"
	_tmp64_ = spinner;
#line 156 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
#line 158 "../src/Views/WifiPage.vala"
	_tmp65_ = self->priv->placeholder;
#line 158 "../src/Views/WifiPage.vala"
	_tmp66_ = no_aps_alert;
#line 158 "../src/Views/WifiPage.vala"
	gtk_stack_add_named (_tmp65_, (GtkWidget*) _tmp66_, "no-aps");
#line 159 "../src/Views/WifiPage.vala"
	_tmp67_ = self->priv->placeholder;
#line 159 "../src/Views/WifiPage.vala"
	_tmp68_ = wireless_off_alert;
#line 159 "../src/Views/WifiPage.vala"
	gtk_stack_add_named (_tmp67_, (GtkWidget*) _tmp68_, "wireless-off");
#line 160 "../src/Views/WifiPage.vala"
	_tmp69_ = self->priv->placeholder;
#line 160 "../src/Views/WifiPage.vala"
	_tmp70_ = scanning_box;
#line 160 "../src/Views/WifiPage.vala"
	gtk_stack_add_named (_tmp69_, (GtkWidget*) _tmp70_, "scanning");
#line 161 "../src/Views/WifiPage.vala"
	_tmp71_ = self->priv->placeholder;
#line 161 "../src/Views/WifiPage.vala"
	gtk_stack_set_visible_child_name (_tmp71_, "no-aps");
#line 164 "../src/Views/WifiPage.vala"
	_tmp72_ = rf_kill_manager_new ();
#line 164 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->rfkill);
#line 164 "../src/Views/WifiPage.vala"
	self->priv->rfkill = _tmp72_;
#line 165 "../src/Views/WifiPage.vala"
	_tmp73_ = self->priv->rfkill;
#line 165 "../src/Views/WifiPage.vala"
	rf_kill_manager_open (_tmp73_);
#line 166 "../src/Views/WifiPage.vala"
	_tmp74_ = self->priv->rfkill;
#line 166 "../src/Views/WifiPage.vala"
	g_signal_connect_object (_tmp74_, "device-added", (GCallback) _network_widgets_page_update_rf_kill_manager_device_added, (NetworkWidgetsPage*) self, 0);
#line 167 "../src/Views/WifiPage.vala"
	_tmp75_ = self->priv->rfkill;
#line 167 "../src/Views/WifiPage.vala"
	g_signal_connect_object (_tmp75_, "device-changed", (GCallback) _network_widgets_page_update_rf_kill_manager_device_changed, (NetworkWidgetsPage*) self, 0);
#line 168 "../src/Views/WifiPage.vala"
	_tmp76_ = self->priv->rfkill;
#line 168 "../src/Views/WifiPage.vala"
	g_signal_connect_object (_tmp76_, "device-deleted", (GCallback) _network_widgets_page_update_rf_kill_manager_device_deleted, (NetworkWidgetsPage*) self, 0);
#line 170 "../src/Views/WifiPage.vala"
	_tmp77_ = self->wifi_device;
#line 170 "../src/Views/WifiPage.vala"
	g_signal_connect_object ((GObject*) _tmp77_, "notify::active-access-point", (GCallback) _network_widgets_page_update_g_object_notify, (NetworkWidgetsPage*) self, 0);
#line 171 "../src/Views/WifiPage.vala"
	_tmp78_ = self->wifi_device;
#line 171 "../src/Views/WifiPage.vala"
	g_signal_connect_object (_tmp78_, "access-point-added", (GCallback) _network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added, self, 0);
#line 172 "../src/Views/WifiPage.vala"
	_tmp79_ = self->wifi_device;
#line 172 "../src/Views/WifiPage.vala"
	g_signal_connect_object (_tmp79_, "access-point-removed", (GCallback) _network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed, self, 0);
#line 173 "../src/Views/WifiPage.vala"
	_tmp80_ = self->wifi_device;
#line 173 "../src/Views/WifiPage.vala"
	g_signal_connect_object ((NMDevice*) _tmp80_, "state-changed", (GCallback) _network_widgets_page_update_nm_device_state_changed, (NetworkWidgetsPage*) self, 0);
#line 175 "../src/Views/WifiPage.vala"
	_tmp81_ = self->wifi_device;
#line 175 "../src/Views/WifiPage.vala"
	_tmp82_ = nm_device_wifi_get_access_points (_tmp81_);
#line 175 "../src/Views/WifiPage.vala"
	_tmp83_ = _g_ptr_array_ref0 (_tmp82_);
#line 175 "../src/Views/WifiPage.vala"
	aps = _tmp83_;
#line 176 "../src/Views/WifiPage.vala"
	_tmp85_ = aps;
#line 176 "../src/Views/WifiPage.vala"
	if (_tmp85_ != NULL) {
#line 4004 "WifiPage.c"
		GPtrArray* _tmp86_;
		gint _tmp87_;
		gint _tmp88_;
#line 176 "../src/Views/WifiPage.vala"
		_tmp86_ = aps;
#line 176 "../src/Views/WifiPage.vala"
		_tmp87_ = vala_g_ptr_array_get_length (_tmp86_);
#line 176 "../src/Views/WifiPage.vala"
		_tmp88_ = _tmp87_;
#line 176 "../src/Views/WifiPage.vala"
		_tmp84_ = _tmp88_ > 0;
#line 4016 "WifiPage.c"
	} else {
#line 176 "../src/Views/WifiPage.vala"
		_tmp84_ = FALSE;
#line 4020 "WifiPage.c"
	}
#line 176 "../src/Views/WifiPage.vala"
	if (_tmp84_) {
#line 4024 "WifiPage.c"
		GPtrArray* _tmp89_;
#line 177 "../src/Views/WifiPage.vala"
		_tmp89_ = aps;
#line 177 "../src/Views/WifiPage.vala"
		g_ptr_array_foreach (_tmp89_, _network_wifi_interface_access_point_added_cb_gfunc, self);
#line 4030 "WifiPage.c"
	}
#line 180 "../src/Views/WifiPage.vala"
	_tmp90_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 180 "../src/Views/WifiPage.vala"
	_tmp91_ = _tmp90_;
#line 180 "../src/Views/WifiPage.vala"
	_tmp92_ = self->top_revealer;
#line 180 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp91_, (GtkWidget*) _tmp92_);
#line 181 "../src/Views/WifiPage.vala"
	_tmp93_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 181 "../src/Views/WifiPage.vala"
	_tmp94_ = _tmp93_;
#line 181 "../src/Views/WifiPage.vala"
	_tmp95_ = main_frame;
#line 181 "../src/Views/WifiPage.vala"
	gtk_container_add ((GtkContainer*) _tmp94_, (GtkWidget*) _tmp95_);
#line 182 "../src/Views/WifiPage.vala"
	_tmp96_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 182 "../src/Views/WifiPage.vala"
	_tmp97_ = _tmp96_;
#line 182 "../src/Views/WifiPage.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp97_);
#line 184 "../src/Views/WifiPage.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 56 "../src/Views/WifiPage.vala"
	_g_ptr_array_unref0 (aps);
#line 56 "../src/Views/WifiPage.vala"
	_g_object_unref0 (scanning_box);
#line 56 "../src/Views/WifiPage.vala"
	_g_object_unref0 (scanning);
#line 56 "../src/Views/WifiPage.vala"
	_g_object_unref0 (spinner);
#line 56 "../src/Views/WifiPage.vala"
	_g_object_unref0 (wireless_off_alert);
#line 56 "../src/Views/WifiPage.vala"
	_g_object_unref0 (no_aps_alert);
#line 56 "../src/Views/WifiPage.vala"
	_g_object_unref0 (main_frame);
#line 56 "../src/Views/WifiPage.vala"
	_g_object_unref0 (hotspot_mode_alert);
#line 56 "../src/Views/WifiPage.vala"
	return obj;
#line 4074 "WifiPage.c"
}

static void
network_wifi_interface_class_init (NetworkWifiInterfaceClass * klass,
                                   gpointer klass_data)
{
#line 21 "../src/Views/WifiPage.vala"
	network_wifi_interface_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Views/WifiPage.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWifiInterface_private_offset);
#line 21 "../src/Views/WifiPage.vala"
	((NetworkWidgetsPageClass *) klass)->update_name = (void (*) (NetworkWidgetsPage*, gint)) network_wifi_interface_real_update_name;
#line 21 "../src/Views/WifiPage.vala"
	((NetworkWidgetsPageClass *) klass)->update = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_update;
#line 21 "../src/Views/WifiPage.vala"
	((NetworkWidgetsPageClass *) klass)->update_switch = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_update_switch;
#line 21 "../src/Views/WifiPage.vala"
	((NetworkWidgetsPageClass *) klass)->control_switch_activated = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_control_switch_activated;
#line 21 "../src/Views/WifiPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_interface_get_property;
#line 21 "../src/Views/WifiPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_interface_set_property;
#line 21 "../src/Views/WifiPage.vala"
	G_OBJECT_CLASS (klass)->constructor = network_wifi_interface_constructor;
#line 21 "../src/Views/WifiPage.vala"
	G_OBJECT_CLASS (klass)->finalize = network_wifi_interface_finalize;
#line 4101 "WifiPage.c"
}

static void
network_wifi_interface_instance_init (NetworkWifiInterface * self,
                                      gpointer klass)
{
#line 21 "../src/Views/WifiPage.vala"
	self->priv = network_wifi_interface_get_instance_private (self);
#line 35 "../src/Views/WifiPage.vala"
	self->priv->timeout_scan = (guint) 0;
#line 41 "../src/Views/WifiPage.vala"
	self->connected_box = NULL;
#line 4114 "WifiPage.c"
}

static void
network_wifi_interface_finalize (GObject * obj)
{
	NetworkWifiInterface * self;
#line 21 "../src/Views/WifiPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
#line 22 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->rfkill);
#line 23 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->wifi_device);
#line 24 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->active_ap);
#line 26 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->wifi_list);
#line 28 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->_active_wifi_item);
#line 29 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->priv->placeholder);
#line 37 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->connected_frame);
#line 38 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->list_stack);
#line 39 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->scrolled);
#line 40 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->hotspot_mode_alert);
#line 41 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->connected_box);
#line 42 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->top_revealer);
#line 43 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->disconnect_btn);
#line 44 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->settings_btn);
#line 45 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->hidden_btn);
#line 46 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->info_btn);
#line 47 "../src/Views/WifiPage.vala"
	_g_object_unref0 (self->popover);
#line 21 "../src/Views/WifiPage.vala"
	G_OBJECT_CLASS (network_wifi_interface_parent_class)->finalize (obj);
#line 4159 "WifiPage.c"
}

static GType
network_wifi_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiInterface), 0, (GInstanceInitFunc) network_wifi_interface_instance_init, NULL };
	GType network_wifi_interface_type_id;
	network_wifi_interface_type_id = g_type_register_static (NETWORK_WIDGETS_TYPE_PAGE, "NetworkWifiInterface", &g_define_type_info, 0);
	NetworkWifiInterface_private_offset = g_type_add_instance_private (network_wifi_interface_type_id, sizeof (NetworkWifiInterfacePrivate));
	return network_wifi_interface_type_id;
}

GType
network_wifi_interface_get_type (void)
{
	static volatile gsize network_wifi_interface_type_id__once = 0;
	if (g_once_init_enter (&network_wifi_interface_type_id__once)) {
		GType network_wifi_interface_type_id;
		network_wifi_interface_type_id = network_wifi_interface_get_type_once ();
		g_once_init_leave (&network_wifi_interface_type_id__once, network_wifi_interface_type_id);
	}
	return network_wifi_interface_type_id__once;
}

static void
_vala_network_wifi_interface_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
#line 21 "../src/Views/WifiPage.vala"
	switch (property_id) {
#line 4194 "WifiPage.c"
		default:
#line 21 "../src/Views/WifiPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Views/WifiPage.vala"
		break;
#line 4200 "WifiPage.c"
	}
}

static void
_vala_network_wifi_interface_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
#line 21 "../src/Views/WifiPage.vala"
	switch (property_id) {
#line 4214 "WifiPage.c"
		default:
#line 21 "../src/Views/WifiPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Views/WifiPage.vala"
		break;
#line 4220 "WifiPage.c"
	}
}

