/* DeviceItem.c generated by valac 0.56.14, the Vala compiler
 * generated from DeviceItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <NetworkManager.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <granite.h>

enum  {
	NETWORK_WIDGETS_DEVICE_ITEM_0_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block14Data Block14Data;

struct _NetworkWidgetsDeviceItemPrivate {
	NMDevice* _device;
	NetworkWidgetsPage* _page;
	gchar* _title;
	gchar* _subtitle;
	gchar* _icon_name;
	NetworkUtilsItemType _item_type;
	GtkImage* status_image;
};

struct _Block14Data {
	int _ref_count_;
	NetworkWidgetsDeviceItem* self;
	NetworkWidgetsPage* page;
};

static gint NetworkWidgetsDeviceItem_private_offset;
static gpointer network_widgets_device_item_parent_class = NULL;

static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void __lambda6_ (Block14Data* _data14_);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean _nm_device_state_equal (const NMDeviceState * s1,
                                 const NMDeviceState * s2);
static GObject * network_widgets_device_item_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void network_widgets_device_item_finalize (GObject * obj);
static GType network_widgets_device_item_get_type_once (void);
static void _vala_network_widgets_device_item_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_network_widgets_device_item_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
network_widgets_device_item_get_instance_private (NetworkWidgetsDeviceItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsDeviceItem_private_offset);
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_construct (GType object_type,
                                       const gchar* title,
                                       const gchar* icon_name)
{
	NetworkWidgetsDeviceItem * self = NULL;
#line 31 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 31 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 32 "../src/Widgets/DeviceItem.vala"
	self = (NetworkWidgetsDeviceItem*) g_object_new (object_type, "title", title, "icon-name", icon_name, NULL);
#line 31 "../src/Widgets/DeviceItem.vala"
	return self;
#line 111 "DeviceItem.c"
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_new (const gchar* title,
                                 const gchar* icon_name)
{
#line 31 "../src/Widgets/DeviceItem.vala"
	return network_widgets_device_item_construct (NETWORK_WIDGETS_TYPE_DEVICE_ITEM, title, icon_name);
#line 120 "DeviceItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/Widgets/DeviceItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 128 "DeviceItem.c"
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 38 "../src/Widgets/DeviceItem.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 38 "../src/Widgets/DeviceItem.vala"
	return _data14_;
#line 138 "DeviceItem.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 38 "../src/Widgets/DeviceItem.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 148 "DeviceItem.c"
		NetworkWidgetsDeviceItem* self;
#line 38 "../src/Widgets/DeviceItem.vala"
		self = _data14_->self;
#line 38 "../src/Widgets/DeviceItem.vala"
		_g_object_unref0 (_data14_->page);
#line 38 "../src/Widgets/DeviceItem.vala"
		_g_object_unref0 (self);
#line 38 "../src/Widgets/DeviceItem.vala"
		g_slice_free (Block14Data, _data14_);
#line 158 "DeviceItem.c"
	}
}

static void
__lambda6_ (Block14Data* _data14_)
{
	NetworkWidgetsDeviceItem* self;
	NMDeviceState _tmp0_;
	NMDeviceState _tmp1_;
#line 50 "../src/Widgets/DeviceItem.vala"
	self = _data14_->self;
#line 51 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = network_widgets_page_get_state (_data14_->page);
#line 51 "../src/Widgets/DeviceItem.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/Widgets/DeviceItem.vala"
	network_widgets_device_item_switch_status (self, NETWORK_UTILS_CUSTOM_MODE_INVALID, &_tmp1_);
#line 176 "DeviceItem.c"
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 50 "../src/Widgets/DeviceItem.vala"
	__lambda6_ (self);
#line 186 "DeviceItem.c"
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_construct_from_page (GType object_type,
                                                 NetworkWidgetsPage* page,
                                                 const gchar* icon_name)
{
	NetworkWidgetsDeviceItem * self = NULL;
	Block14Data* _data14_;
	NetworkWidgetsPage* _tmp0_;
	NMDevice* _tmp1_;
	NMDevice* _tmp2_;
	NMDeviceState _tmp3_;
	NMDeviceState _tmp4_;
#line 38 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 38 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 38 "../src/Widgets/DeviceItem.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 38 "../src/Widgets/DeviceItem.vala"
	_data14_->_ref_count_ = 1;
#line 38 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = _g_object_ref0 (page);
#line 38 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (_data14_->page);
#line 38 "../src/Widgets/DeviceItem.vala"
	_data14_->page = _tmp0_;
#line 39 "../src/Widgets/DeviceItem.vala"
	_tmp1_ = network_widgets_page_get_device (_data14_->page);
#line 39 "../src/Widgets/DeviceItem.vala"
	_tmp2_ = _tmp1_;
#line 39 "../src/Widgets/DeviceItem.vala"
	self = (NetworkWidgetsDeviceItem*) g_object_new (object_type, "device", _tmp2_, "icon-name", icon_name, "item-type", NETWORK_UTILS_ITEM_TYPE_DEVICE, "page", _data14_->page, NULL);
#line 39 "../src/Widgets/DeviceItem.vala"
	_data14_->self = g_object_ref (self);
#line 46 "../src/Widgets/DeviceItem.vala"
	g_object_bind_property_with_closures ((GObject*) _data14_->page, "title", (GObject*) self, "title", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 47 "../src/Widgets/DeviceItem.vala"
	g_object_bind_property_with_closures ((GObject*) _data14_->page, "icon-name", (GObject*) self, "icon-name", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 49 "../src/Widgets/DeviceItem.vala"
	_tmp3_ = network_widgets_page_get_state (_data14_->page);
#line 49 "../src/Widgets/DeviceItem.vala"
	_tmp4_ = _tmp3_;
#line 49 "../src/Widgets/DeviceItem.vala"
	network_widgets_device_item_switch_status (self, NETWORK_UTILS_CUSTOM_MODE_INVALID, &_tmp4_);
#line 50 "../src/Widgets/DeviceItem.vala"
	g_signal_connect_data ((GObject*) _data14_->page, "notify::state", (GCallback) ___lambda6__g_object_notify, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 38 "../src/Widgets/DeviceItem.vala"
	block14_data_unref (_data14_);
#line 38 "../src/Widgets/DeviceItem.vala"
	_data14_ = NULL;
#line 38 "../src/Widgets/DeviceItem.vala"
	return self;
#line 241 "DeviceItem.c"
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_new_from_page (NetworkWidgetsPage* page,
                                           const gchar* icon_name)
{
#line 38 "../src/Widgets/DeviceItem.vala"
	return network_widgets_device_item_construct_from_page (NETWORK_WIDGETS_TYPE_DEVICE_ITEM, page, icon_name);
#line 250 "DeviceItem.c"
}

static gboolean
_nm_device_state_equal (const NMDeviceState * s1,
                        const NMDeviceState * s2)
{
#line 121 "../src/Widgets/DeviceItem.vala"
	if (s1 == s2) {
#line 121 "../src/Widgets/DeviceItem.vala"
		return TRUE;
#line 261 "DeviceItem.c"
	}
#line 121 "../src/Widgets/DeviceItem.vala"
	if (s1 == NULL) {
#line 121 "../src/Widgets/DeviceItem.vala"
		return FALSE;
#line 267 "DeviceItem.c"
	}
#line 121 "../src/Widgets/DeviceItem.vala"
	if (s2 == NULL) {
#line 121 "../src/Widgets/DeviceItem.vala"
		return FALSE;
#line 273 "DeviceItem.c"
	}
#line 121 "../src/Widgets/DeviceItem.vala"
	return (*s1) == (*s2);
#line 277 "DeviceItem.c"
}

void
network_widgets_device_item_switch_status (NetworkWidgetsDeviceItem* self,
                                           NetworkUtilsCustomMode custom_mode,
                                           NMDeviceState* state)
{
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
#line 104 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Widgets/DeviceItem.vala"
	if (state != NULL) {
#line 294 "DeviceItem.c"
		gboolean _tmp4_ = FALSE;
		NMDevice* _tmp5_;
#line 106 "../src/Widgets/DeviceItem.vala"
		switch (*state) {
#line 106 "../src/Widgets/DeviceItem.vala"
			case NM_DEVICE_STATE_ACTIVATED:
#line 301 "DeviceItem.c"
			{
				GtkImage* _tmp0_;
#line 108 "../src/Widgets/DeviceItem.vala"
				_tmp0_ = self->priv->status_image;
#line 108 "../src/Widgets/DeviceItem.vala"
				g_object_set (_tmp0_, "icon-name", "user-available", NULL);
#line 109 "../src/Widgets/DeviceItem.vala"
				break;
#line 310 "DeviceItem.c"
			}
#line 106 "../src/Widgets/DeviceItem.vala"
			case NM_DEVICE_STATE_DISCONNECTED:
#line 314 "DeviceItem.c"
			{
				GtkImage* _tmp1_;
#line 111 "../src/Widgets/DeviceItem.vala"
				_tmp1_ = self->priv->status_image;
#line 111 "../src/Widgets/DeviceItem.vala"
				g_object_set (_tmp1_, "icon-name", "user-offline", NULL);
#line 112 "../src/Widgets/DeviceItem.vala"
				break;
#line 323 "DeviceItem.c"
			}
#line 106 "../src/Widgets/DeviceItem.vala"
			case NM_DEVICE_STATE_FAILED:
#line 327 "DeviceItem.c"
			{
				GtkImage* _tmp2_;
#line 114 "../src/Widgets/DeviceItem.vala"
				_tmp2_ = self->priv->status_image;
#line 114 "../src/Widgets/DeviceItem.vala"
				g_object_set (_tmp2_, "icon-name", "user-busy", NULL);
#line 115 "../src/Widgets/DeviceItem.vala"
				break;
#line 336 "DeviceItem.c"
			}
			default:
			{
				GtkImage* _tmp3_;
#line 117 "../src/Widgets/DeviceItem.vala"
				_tmp3_ = self->priv->status_image;
#line 117 "../src/Widgets/DeviceItem.vala"
				g_object_set (_tmp3_, "icon-name", "user-away", NULL);
#line 118 "../src/Widgets/DeviceItem.vala"
				break;
#line 347 "DeviceItem.c"
			}
		}
#line 121 "../src/Widgets/DeviceItem.vala"
		_tmp5_ = self->priv->_device;
#line 121 "../src/Widgets/DeviceItem.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, nm_device_wifi_get_type ())) {
#line 354 "DeviceItem.c"
			NMDeviceState _tmp6_;
#line 121 "../src/Widgets/DeviceItem.vala"
			_tmp6_ = NM_DEVICE_STATE_UNAVAILABLE;
#line 121 "../src/Widgets/DeviceItem.vala"
			_tmp4_ = _nm_device_state_equal (state, &_tmp6_) == TRUE;
#line 360 "DeviceItem.c"
		} else {
#line 121 "../src/Widgets/DeviceItem.vala"
			_tmp4_ = FALSE;
#line 364 "DeviceItem.c"
		}
#line 121 "../src/Widgets/DeviceItem.vala"
		if (_tmp4_) {
#line 122 "../src/Widgets/DeviceItem.vala"
			network_widgets_device_item_set_subtitle (self, _ ("Disabled"));
#line 370 "DeviceItem.c"
		} else {
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 124 "../src/Widgets/DeviceItem.vala"
			_tmp7_ = network_utils_state_to_string (*state);
#line 124 "../src/Widgets/DeviceItem.vala"
			_tmp8_ = _tmp7_;
#line 124 "../src/Widgets/DeviceItem.vala"
			network_widgets_device_item_set_subtitle (self, _tmp8_);
#line 124 "../src/Widgets/DeviceItem.vala"
			_g_free0 (_tmp8_);
#line 382 "DeviceItem.c"
		}
	} else {
#line 126 "../src/Widgets/DeviceItem.vala"
		if (custom_mode != NETWORK_UTILS_CUSTOM_MODE_INVALID) {
#line 127 "../src/Widgets/DeviceItem.vala"
			switch (custom_mode) {
#line 127 "../src/Widgets/DeviceItem.vala"
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_NONE:
#line 391 "DeviceItem.c"
				{
					GtkImage* _tmp9_;
#line 129 "../src/Widgets/DeviceItem.vala"
					network_widgets_device_item_set_subtitle (self, _ ("Disabled"));
#line 130 "../src/Widgets/DeviceItem.vala"
					_tmp9_ = self->priv->status_image;
#line 130 "../src/Widgets/DeviceItem.vala"
					g_object_set (_tmp9_, "icon-name", "user-offline", NULL);
#line 131 "../src/Widgets/DeviceItem.vala"
					break;
#line 402 "DeviceItem.c"
				}
#line 127 "../src/Widgets/DeviceItem.vala"
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_MANUAL:
#line 406 "DeviceItem.c"
				{
					GtkImage* _tmp10_;
#line 133 "../src/Widgets/DeviceItem.vala"
					network_widgets_device_item_set_subtitle (self, _ ("Enabled (manual mode)"));
#line 134 "../src/Widgets/DeviceItem.vala"
					_tmp10_ = self->priv->status_image;
#line 134 "../src/Widgets/DeviceItem.vala"
					g_object_set (_tmp10_, "icon-name", "user-available", NULL);
#line 135 "../src/Widgets/DeviceItem.vala"
					break;
#line 417 "DeviceItem.c"
				}
#line 127 "../src/Widgets/DeviceItem.vala"
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_AUTO:
#line 421 "DeviceItem.c"
				{
					GtkImage* _tmp11_;
#line 137 "../src/Widgets/DeviceItem.vala"
					network_widgets_device_item_set_subtitle (self, _ ("Enabled (auto mode)"));
#line 138 "../src/Widgets/DeviceItem.vala"
					_tmp11_ = self->priv->status_image;
#line 138 "../src/Widgets/DeviceItem.vala"
					g_object_set (_tmp11_, "icon-name", "user-available", NULL);
#line 139 "../src/Widgets/DeviceItem.vala"
					break;
#line 432 "DeviceItem.c"
				}
				default:
#line 127 "../src/Widgets/DeviceItem.vala"
				break;
#line 437 "DeviceItem.c"
			}
		}
	}
#line 143 "../src/Widgets/DeviceItem.vala"
	_tmp12_ = self->priv->_subtitle;
#line 143 "../src/Widgets/DeviceItem.vala"
	_tmp13_ = g_strconcat ("<span font_size='small'>", _tmp12_, NULL);
#line 143 "../src/Widgets/DeviceItem.vala"
	_tmp14_ = _tmp13_;
#line 143 "../src/Widgets/DeviceItem.vala"
	_tmp15_ = g_strconcat (_tmp14_, "</span>", NULL);
#line 143 "../src/Widgets/DeviceItem.vala"
	_tmp16_ = _tmp15_;
#line 143 "../src/Widgets/DeviceItem.vala"
	network_widgets_device_item_set_subtitle (self, _tmp16_);
#line 143 "../src/Widgets/DeviceItem.vala"
	_g_free0 (_tmp16_);
#line 143 "../src/Widgets/DeviceItem.vala"
	_g_free0 (_tmp14_);
#line 457 "DeviceItem.c"
}

NMDevice*
network_widgets_device_item_get_device (NetworkWidgetsDeviceItem* self)
{
	NMDevice* result;
	NMDevice* _tmp0_;
#line 22 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_device;
#line 22 "../src/Widgets/DeviceItem.vala"
	result = _tmp0_;
#line 22 "../src/Widgets/DeviceItem.vala"
	return result;
#line 473 "DeviceItem.c"
}

static void
network_widgets_device_item_set_device (NetworkWidgetsDeviceItem* self,
                                        NMDevice* value)
{
	NMDevice* old_value;
#line 22 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Widgets/DeviceItem.vala"
	old_value = network_widgets_device_item_get_device (self);
#line 22 "../src/Widgets/DeviceItem.vala"
	if (old_value != value) {
#line 487 "DeviceItem.c"
		NMDevice* _tmp0_;
#line 22 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 22 "../src/Widgets/DeviceItem.vala"
		_g_object_unref0 (self->priv->_device);
#line 22 "../src/Widgets/DeviceItem.vala"
		self->priv->_device = _tmp0_;
#line 22 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY]);
#line 497 "DeviceItem.c"
	}
}

NetworkWidgetsPage*
network_widgets_device_item_get_page (NetworkWidgetsDeviceItem* self)
{
	NetworkWidgetsPage* result;
	NetworkWidgetsPage* _tmp0_;
#line 23 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_page;
#line 23 "../src/Widgets/DeviceItem.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/DeviceItem.vala"
	return result;
#line 514 "DeviceItem.c"
}

void
network_widgets_device_item_set_page (NetworkWidgetsDeviceItem* self,
                                      NetworkWidgetsPage* value)
{
	NetworkWidgetsPage* old_value;
#line 23 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/DeviceItem.vala"
	old_value = network_widgets_device_item_get_page (self);
#line 23 "../src/Widgets/DeviceItem.vala"
	if (old_value != value) {
#line 528 "DeviceItem.c"
		NetworkWidgetsPage* _tmp0_;
#line 23 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Widgets/DeviceItem.vala"
		_g_object_unref0 (self->priv->_page);
#line 23 "../src/Widgets/DeviceItem.vala"
		self->priv->_page = _tmp0_;
#line 23 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY]);
#line 538 "DeviceItem.c"
	}
}

const gchar*
network_widgets_device_item_get_title (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_title;
#line 24 "../src/Widgets/DeviceItem.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/DeviceItem.vala"
	return result;
#line 555 "DeviceItem.c"
}

void
network_widgets_device_item_set_title (NetworkWidgetsDeviceItem* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 24 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/DeviceItem.vala"
	old_value = network_widgets_device_item_get_title (self);
#line 24 "../src/Widgets/DeviceItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 569 "DeviceItem.c"
		gchar* _tmp0_;
#line 24 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../src/Widgets/DeviceItem.vala"
		_g_free0 (self->priv->_title);
#line 24 "../src/Widgets/DeviceItem.vala"
		self->priv->_title = _tmp0_;
#line 24 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY]);
#line 579 "DeviceItem.c"
	}
}

const gchar*
network_widgets_device_item_get_subtitle (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_subtitle;
#line 25 "../src/Widgets/DeviceItem.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/DeviceItem.vala"
	return result;
#line 596 "DeviceItem.c"
}

void
network_widgets_device_item_set_subtitle (NetworkWidgetsDeviceItem* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 25 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/DeviceItem.vala"
	old_value = network_widgets_device_item_get_subtitle (self);
#line 25 "../src/Widgets/DeviceItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 610 "DeviceItem.c"
		gchar* _tmp0_;
#line 25 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../src/Widgets/DeviceItem.vala"
		_g_free0 (self->priv->_subtitle);
#line 25 "../src/Widgets/DeviceItem.vala"
		self->priv->_subtitle = _tmp0_;
#line 25 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY]);
#line 620 "DeviceItem.c"
	}
}

const gchar*
network_widgets_device_item_get_icon_name (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_icon_name;
#line 26 "../src/Widgets/DeviceItem.vala"
	result = _tmp0_;
#line 26 "../src/Widgets/DeviceItem.vala"
	return result;
#line 637 "DeviceItem.c"
}

void
network_widgets_device_item_set_icon_name (NetworkWidgetsDeviceItem* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 26 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/DeviceItem.vala"
	old_value = network_widgets_device_item_get_icon_name (self);
#line 26 "../src/Widgets/DeviceItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 651 "DeviceItem.c"
		gchar* _tmp0_;
#line 26 "../src/Widgets/DeviceItem.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/Widgets/DeviceItem.vala"
		_g_free0 (self->priv->_icon_name);
#line 26 "../src/Widgets/DeviceItem.vala"
		self->priv->_icon_name = _tmp0_;
#line 26 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY]);
#line 661 "DeviceItem.c"
	}
}

NetworkUtilsItemType
network_widgets_device_item_get_item_type (NetworkWidgetsDeviceItem* self)
{
	NetworkUtilsItemType result;
#line 27 "../src/Widgets/DeviceItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/Widgets/DeviceItem.vala"
	result = self->priv->_item_type;
#line 27 "../src/Widgets/DeviceItem.vala"
	return result;
#line 675 "DeviceItem.c"
}

void
network_widgets_device_item_set_item_type (NetworkWidgetsDeviceItem* self,
                                           NetworkUtilsItemType value)
{
	NetworkUtilsItemType old_value;
#line 27 "../src/Widgets/DeviceItem.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Widgets/DeviceItem.vala"
	old_value = network_widgets_device_item_get_item_type (self);
#line 27 "../src/Widgets/DeviceItem.vala"
	if (old_value != value) {
#line 27 "../src/Widgets/DeviceItem.vala"
		self->priv->_item_type = value;
#line 27 "../src/Widgets/DeviceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY]);
#line 693 "DeviceItem.c"
	}
}

static GObject *
network_widgets_device_item_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsDeviceItem * self;
	GtkImage* row_image = NULL;
	const gchar* _tmp0_;
	GtkImage* _tmp1_ = NULL;
	GtkLabel* row_title = NULL;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* row_description = NULL;
	const gchar* _tmp6_;
	GtkLabel* _tmp7_ = NULL;
	GtkImage* _tmp8_ = NULL;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp9_ = NULL;
	GtkOverlay* _tmp10_;
	GtkImage* _tmp11_;
	GtkOverlay* _tmp12_;
	GtkImage* _tmp13_;
	GtkGrid* row_grid = NULL;
	GtkGrid* _tmp14_ = NULL;
	GtkGrid* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkGrid* _tmp17_;
	GtkLabel* _tmp18_;
	GtkGrid* _tmp19_;
	GtkLabel* _tmp20_;
	GtkGrid* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkImage* _tmp24_;
#line 55 "../src/Widgets/DeviceItem.vala"
	parent_class = G_OBJECT_CLASS (network_widgets_device_item_parent_class);
#line 55 "../src/Widgets/DeviceItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 55 "../src/Widgets/DeviceItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
#line 56 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = self->priv->_icon_name;
#line 56 "../src/Widgets/DeviceItem.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 56 "../src/Widgets/DeviceItem.vala"
	gtk_image_set_pixel_size (_tmp1_, 32);
#line 56 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp1_);
#line 56 "../src/Widgets/DeviceItem.vala"
	row_image = _tmp1_;
#line 60 "../src/Widgets/DeviceItem.vala"
	_tmp2_ = self->priv->_title;
#line 60 "../src/Widgets/DeviceItem.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
#line 60 "../src/Widgets/DeviceItem.vala"
	gtk_label_set_ellipsize (_tmp3_, PANGO_ELLIPSIZE_END);
#line 60 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 60 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 60 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp3_);
#line 60 "../src/Widgets/DeviceItem.vala"
	row_title = _tmp3_;
#line 65 "../src/Widgets/DeviceItem.vala"
	_tmp4_ = row_title;
#line 65 "../src/Widgets/DeviceItem.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 65 "../src/Widgets/DeviceItem.vala"
	gtk_style_context_add_class (_tmp5_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 67 "../src/Widgets/DeviceItem.vala"
	_tmp6_ = self->priv->_subtitle;
#line 67 "../src/Widgets/DeviceItem.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (_tmp6_);
#line 67 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp7_, 2);
#line 67 "../src/Widgets/DeviceItem.vala"
	gtk_label_set_use_markup (_tmp7_, TRUE);
#line 67 "../src/Widgets/DeviceItem.vala"
	gtk_label_set_ellipsize (_tmp7_, PANGO_ELLIPSIZE_END);
#line 67 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 67 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 67 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp7_);
#line 67 "../src/Widgets/DeviceItem.vala"
	row_description = _tmp7_;
#line 75 "../src/Widgets/DeviceItem.vala"
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("user-available", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 75 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
#line 75 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
#line 75 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp8_);
#line 75 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (self->priv->status_image);
#line 75 "../src/Widgets/DeviceItem.vala"
	self->priv->status_image = _tmp8_;
#line 80 "../src/Widgets/DeviceItem.vala"
	_tmp9_ = (GtkOverlay*) gtk_overlay_new ();
#line 80 "../src/Widgets/DeviceItem.vala"
	g_object_set ((GtkWidget*) _tmp9_, "width-request", 38, NULL);
#line 80 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp9_);
#line 80 "../src/Widgets/DeviceItem.vala"
	overlay = _tmp9_;
#line 83 "../src/Widgets/DeviceItem.vala"
	_tmp10_ = overlay;
#line 83 "../src/Widgets/DeviceItem.vala"
	_tmp11_ = row_image;
#line 83 "../src/Widgets/DeviceItem.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
#line 84 "../src/Widgets/DeviceItem.vala"
	_tmp12_ = overlay;
#line 84 "../src/Widgets/DeviceItem.vala"
	_tmp13_ = self->priv->status_image;
#line 84 "../src/Widgets/DeviceItem.vala"
	gtk_overlay_add_overlay (_tmp12_, (GtkWidget*) _tmp13_);
#line 86 "../src/Widgets/DeviceItem.vala"
	_tmp14_ = (GtkGrid*) gtk_grid_new ();
#line 86 "../src/Widgets/DeviceItem.vala"
	g_object_set ((GtkWidget*) _tmp14_, "margin", 6, NULL);
#line 86 "../src/Widgets/DeviceItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp14_, 3);
#line 86 "../src/Widgets/DeviceItem.vala"
	gtk_grid_set_column_spacing (_tmp14_, 3);
#line 86 "../src/Widgets/DeviceItem.vala"
	g_object_ref_sink (_tmp14_);
#line 86 "../src/Widgets/DeviceItem.vala"
	row_grid = _tmp14_;
#line 91 "../src/Widgets/DeviceItem.vala"
	_tmp15_ = row_grid;
#line 91 "../src/Widgets/DeviceItem.vala"
	_tmp16_ = overlay;
#line 91 "../src/Widgets/DeviceItem.vala"
	gtk_grid_attach (_tmp15_, (GtkWidget*) _tmp16_, 0, 0, 1, 2);
#line 92 "../src/Widgets/DeviceItem.vala"
	_tmp17_ = row_grid;
#line 92 "../src/Widgets/DeviceItem.vala"
	_tmp18_ = row_title;
#line 92 "../src/Widgets/DeviceItem.vala"
	gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 1, 0, 1, 1);
#line 93 "../src/Widgets/DeviceItem.vala"
	_tmp19_ = row_grid;
#line 93 "../src/Widgets/DeviceItem.vala"
	_tmp20_ = row_description;
#line 93 "../src/Widgets/DeviceItem.vala"
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 1, 1, 1, 1);
#line 95 "../src/Widgets/DeviceItem.vala"
	_tmp21_ = row_grid;
#line 95 "../src/Widgets/DeviceItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp21_);
#line 97 "../src/Widgets/DeviceItem.vala"
	_tmp22_ = row_title;
#line 97 "../src/Widgets/DeviceItem.vala"
	g_object_bind_property_with_closures ((GObject*) self, "title", (GObject*) _tmp22_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 98 "../src/Widgets/DeviceItem.vala"
	_tmp23_ = row_description;
#line 98 "../src/Widgets/DeviceItem.vala"
	g_object_bind_property_with_closures ((GObject*) self, "subtitle", (GObject*) _tmp23_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 99 "../src/Widgets/DeviceItem.vala"
	_tmp24_ = row_image;
#line 99 "../src/Widgets/DeviceItem.vala"
	g_object_bind_property_with_closures ((GObject*) self, "icon-name", (GObject*) _tmp24_, "icon-name", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 101 "../src/Widgets/DeviceItem.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 55 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (row_grid);
#line 55 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (overlay);
#line 55 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (row_description);
#line 55 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (row_title);
#line 55 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (row_image);
#line 55 "../src/Widgets/DeviceItem.vala"
	return obj;
#line 881 "DeviceItem.c"
}

static void
network_widgets_device_item_class_init (NetworkWidgetsDeviceItemClass * klass,
                                        gpointer klass_data)
{
#line 21 "../src/Widgets/DeviceItem.vala"
	network_widgets_device_item_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/DeviceItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsDeviceItem_private_offset);
#line 21 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_widgets_device_item_get_property;
#line 21 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_widgets_device_item_set_property;
#line 21 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (klass)->constructor = network_widgets_device_item_constructor;
#line 21 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_widgets_device_item_finalize;
#line 21 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", nm_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", NETWORK_WIDGETS_TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/DeviceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY] = g_param_spec_enum ("item-type", "item-type", "item-type", NETWORK_UTILS_TYPE_ITEM_TYPE, NETWORK_UTILS_ITEM_TYPE_INVALID, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 912 "DeviceItem.c"
}

static void
network_widgets_device_item_instance_init (NetworkWidgetsDeviceItem * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 21 "../src/Widgets/DeviceItem.vala"
	self->priv = network_widgets_device_item_get_instance_private (self);
#line 22 "../src/Widgets/DeviceItem.vala"
	self->priv->_device = NULL;
#line 23 "../src/Widgets/DeviceItem.vala"
	self->priv->_page = NULL;
#line 24 "../src/Widgets/DeviceItem.vala"
	_tmp0_ = g_strdup ("");
#line 24 "../src/Widgets/DeviceItem.vala"
	self->priv->_title = _tmp0_;
#line 25 "../src/Widgets/DeviceItem.vala"
	_tmp1_ = g_strdup ("");
#line 25 "../src/Widgets/DeviceItem.vala"
	self->priv->_subtitle = _tmp1_;
#line 26 "../src/Widgets/DeviceItem.vala"
	_tmp2_ = g_strdup ("network-wired");
#line 26 "../src/Widgets/DeviceItem.vala"
	self->priv->_icon_name = _tmp2_;
#line 27 "../src/Widgets/DeviceItem.vala"
	self->priv->_item_type = NETWORK_UTILS_ITEM_TYPE_INVALID;
#line 942 "DeviceItem.c"
}

static void
network_widgets_device_item_finalize (GObject * obj)
{
	NetworkWidgetsDeviceItem * self;
#line 21 "../src/Widgets/DeviceItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
#line 22 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (self->priv->_device);
#line 23 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (self->priv->_page);
#line 24 "../src/Widgets/DeviceItem.vala"
	_g_free0 (self->priv->_title);
#line 25 "../src/Widgets/DeviceItem.vala"
	_g_free0 (self->priv->_subtitle);
#line 26 "../src/Widgets/DeviceItem.vala"
	_g_free0 (self->priv->_icon_name);
#line 29 "../src/Widgets/DeviceItem.vala"
	_g_object_unref0 (self->priv->status_image);
#line 21 "../src/Widgets/DeviceItem.vala"
	G_OBJECT_CLASS (network_widgets_device_item_parent_class)->finalize (obj);
#line 965 "DeviceItem.c"
}

static GType
network_widgets_device_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsDeviceItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_device_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsDeviceItem), 0, (GInstanceInitFunc) network_widgets_device_item_instance_init, NULL };
	GType network_widgets_device_item_type_id;
	network_widgets_device_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWidgetsDeviceItem", &g_define_type_info, 0);
	NetworkWidgetsDeviceItem_private_offset = g_type_add_instance_private (network_widgets_device_item_type_id, sizeof (NetworkWidgetsDeviceItemPrivate));
	return network_widgets_device_item_type_id;
}

GType
network_widgets_device_item_get_type (void)
{
	static volatile gsize network_widgets_device_item_type_id__once = 0;
	if (g_once_init_enter (&network_widgets_device_item_type_id__once)) {
		GType network_widgets_device_item_type_id;
		network_widgets_device_item_type_id = network_widgets_device_item_get_type_once ();
		g_once_init_leave (&network_widgets_device_item_type_id__once, network_widgets_device_item_type_id);
	}
	return network_widgets_device_item_type_id__once;
}

static void
_vala_network_widgets_device_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NetworkWidgetsDeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
#line 21 "../src/Widgets/DeviceItem.vala"
	switch (property_id) {
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		g_value_set_object (value, network_widgets_device_item_get_device (self));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		g_value_set_object (value, network_widgets_device_item_get_page (self));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		g_value_set_string (value, network_widgets_device_item_get_title (self));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		g_value_set_string (value, network_widgets_device_item_get_subtitle (self));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		g_value_set_string (value, network_widgets_device_item_get_icon_name (self));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		g_value_set_enum (value, network_widgets_device_item_get_item_type (self));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 1036 "DeviceItem.c"
		default:
#line 21 "../src/Widgets/DeviceItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 1042 "DeviceItem.c"
	}
}

static void
_vala_network_widgets_device_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NetworkWidgetsDeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
#line 21 "../src/Widgets/DeviceItem.vala"
	switch (property_id) {
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		network_widgets_device_item_set_device (self, g_value_get_object (value));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		network_widgets_device_item_set_page (self, g_value_get_object (value));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		network_widgets_device_item_set_title (self, g_value_get_string (value));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		network_widgets_device_item_set_subtitle (self, g_value_get_string (value));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		network_widgets_device_item_set_icon_name (self, g_value_get_string (value));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 21 "../src/Widgets/DeviceItem.vala"
		case NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY:
#line 21 "../src/Widgets/DeviceItem.vala"
		network_widgets_device_item_set_item_type (self, g_value_get_enum (value));
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 1092 "DeviceItem.c"
		default:
#line 21 "../src/Widgets/DeviceItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/DeviceItem.vala"
		break;
#line 1098 "DeviceItem.c"
	}
}

