/* DeviceList.c generated by valac 0.56.14, the Vala compiler
 * generated from DeviceList.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <NetworkManager.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <granite.h>

enum  {
	NETWORK_WIDGETS_DEVICE_LIST_0_PROPERTY,
	NETWORK_WIDGETS_DEVICE_LIST_NUM_PROPERTIES
};
static GParamSpec* network_widgets_device_list_properties[NETWORK_WIDGETS_DEVICE_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NETWORK_WIDGETS_DEVICE_LIST_SHOW_NO_DEVICES_SIGNAL,
	NETWORK_WIDGETS_DEVICE_LIST_NUM_SIGNALS
};
static guint network_widgets_device_list_signals[NETWORK_WIDGETS_DEVICE_LIST_NUM_SIGNALS] = {0};

struct _NetworkWidgetsDeviceListPrivate {
	GtkLabel* virtual_l;
	GtkLabel* devices_l;
	NetworkWidgetsDeviceItem* proxy;
	NetworkWidgetsDeviceItem* vpn;
};

static gint NetworkWidgetsDeviceList_private_offset;
static gpointer network_widgets_device_list_parent_class = NULL;

static void network_widgets_device_list_add_proxy (NetworkWidgetsDeviceList* self);
static void network_widgets_device_list_add_vpn (NetworkWidgetsDeviceList* self);
static gint network_widgets_device_list_sort_items (NetworkWidgetsDeviceList* self,
                                             GtkListBoxRow* row1,
                                             GtkListBoxRow* row2);
static void network_widgets_device_list_update_headers (NetworkWidgetsDeviceList* self,
                                                 GtkListBoxRow* row,
                                                 GtkListBoxRow* before);
static GObject * network_widgets_device_list_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _network_widgets_device_list_update_headers_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                                  GtkListBoxRow* before,
                                                                                  gpointer self);
static gint _network_widgets_device_list_sort_items_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                     GtkListBoxRow* row2,
                                                                     gpointer self);
static void _network_widgets_device_list___lambda48_ (NetworkWidgetsDeviceList* self,
                                               GtkListBoxRow* row);
static void __network_widgets_device_list___lambda48__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                          GtkListBoxRow* row,
                                                                          gpointer self);
static void network_widgets_device_list_finalize (GObject * obj);
static GType network_widgets_device_list_get_type_once (void);

static inline gpointer
network_widgets_device_list_get_instance_private (NetworkWidgetsDeviceList* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsDeviceList_private_offset);
}

void
network_widgets_device_list_add_iface_to_list (NetworkWidgetsDeviceList* self,
                                               NetworkWidgetsPage* page)
{
	NetworkWidgetsDeviceItem* item = NULL;
	NetworkWidgetsDeviceItem* _tmp9_;
#line 56 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (page != NULL);
#line 58 "../src/Widgets/DeviceList.vala"
	if (NETWORK_IS_WIFI_INTERFACE (page)) {
#line 99 "DeviceList.c"
		NetworkWidgetsDeviceItem* _tmp0_;
#line 59 "../src/Widgets/DeviceList.vala"
		_tmp0_ = network_widgets_device_item_new_from_page (page, "network-wired");
#line 59 "../src/Widgets/DeviceList.vala"
		g_object_ref_sink (_tmp0_);
#line 59 "../src/Widgets/DeviceList.vala"
		_g_object_unref0 (item);
#line 59 "../src/Widgets/DeviceList.vala"
		item = _tmp0_;
#line 109 "DeviceList.c"
	} else {
#line 60 "../src/Widgets/DeviceList.vala"
		if (NETWORK_WIDGETS_IS_HOTSPOT_INTERFACE (page)) {
#line 113 "DeviceList.c"
			NetworkWidgetsDeviceItem* _tmp1_;
			NetworkWidgetsDeviceItem* _tmp2_;
#line 61 "../src/Widgets/DeviceList.vala"
			_tmp1_ = network_widgets_device_item_new_from_page (page, "network-wired");
#line 61 "../src/Widgets/DeviceList.vala"
			g_object_ref_sink (_tmp1_);
#line 61 "../src/Widgets/DeviceList.vala"
			_g_object_unref0 (item);
#line 61 "../src/Widgets/DeviceList.vala"
			item = _tmp1_;
#line 62 "../src/Widgets/DeviceList.vala"
			_tmp2_ = item;
#line 62 "../src/Widgets/DeviceList.vala"
			network_widgets_device_item_set_item_type (_tmp2_, NETWORK_UTILS_ITEM_TYPE_VIRTUAL);
#line 128 "DeviceList.c"
		} else {
#line 63 "../src/Widgets/DeviceList.vala"
			if (NETWORK_WIDGETS_IS_MODEM_INTERFACE (page)) {
#line 132 "DeviceList.c"
				NetworkWidgetsDeviceItem* _tmp3_;
#line 64 "../src/Widgets/DeviceList.vala"
				_tmp3_ = network_widgets_device_item_new_from_page (page, "network-wired");
#line 64 "../src/Widgets/DeviceList.vala"
				g_object_ref_sink (_tmp3_);
#line 64 "../src/Widgets/DeviceList.vala"
				_g_object_unref0 (item);
#line 64 "../src/Widgets/DeviceList.vala"
				item = _tmp3_;
#line 142 "DeviceList.c"
			} else {
				NMDevice* _tmp4_;
				NMDevice* _tmp5_;
				const gchar* _tmp6_;
#line 66 "../src/Widgets/DeviceList.vala"
				_tmp4_ = network_widgets_page_get_device (page);
#line 66 "../src/Widgets/DeviceList.vala"
				_tmp5_ = _tmp4_;
#line 66 "../src/Widgets/DeviceList.vala"
				_tmp6_ = nm_device_get_iface (_tmp5_);
#line 66 "../src/Widgets/DeviceList.vala"
				if (g_str_has_prefix (_tmp6_, "usb")) {
#line 155 "DeviceList.c"
					NetworkWidgetsDeviceItem* _tmp7_;
#line 67 "../src/Widgets/DeviceList.vala"
					_tmp7_ = network_widgets_device_item_new_from_page (page, "drive-removable-media");
#line 67 "../src/Widgets/DeviceList.vala"
					g_object_ref_sink (_tmp7_);
#line 67 "../src/Widgets/DeviceList.vala"
					_g_object_unref0 (item);
#line 67 "../src/Widgets/DeviceList.vala"
					item = _tmp7_;
#line 165 "DeviceList.c"
				} else {
					NetworkWidgetsDeviceItem* _tmp8_;
#line 69 "../src/Widgets/DeviceList.vala"
					_tmp8_ = network_widgets_device_item_new_from_page (page, "network-wired");
#line 69 "../src/Widgets/DeviceList.vala"
					g_object_ref_sink (_tmp8_);
#line 69 "../src/Widgets/DeviceList.vala"
					_g_object_unref0 (item);
#line 69 "../src/Widgets/DeviceList.vala"
					item = _tmp8_;
#line 176 "DeviceList.c"
				}
			}
		}
	}
#line 73 "../src/Widgets/DeviceList.vala"
	_tmp9_ = item;
#line 73 "../src/Widgets/DeviceList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp9_);
#line 56 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (item);
#line 187 "DeviceList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "../src/Widgets/DeviceList.vala"
	return self ? g_object_ref (self) : NULL;
#line 195 "DeviceList.c"
}

void
network_widgets_device_list_remove_iface_from_list (NetworkWidgetsDeviceList* self,
                                                    NetworkWidgetsPage* iface)
{
	GList* _tmp0_;
#line 76 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (iface != NULL);
#line 77 "../src/Widgets/DeviceList.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 209 "DeviceList.c"
	{
		GList* _list_item_collection = NULL;
		GList* _list_item_it = NULL;
#line 77 "../src/Widgets/DeviceList.vala"
		_list_item_collection = _tmp0_;
#line 77 "../src/Widgets/DeviceList.vala"
		for (_list_item_it = _list_item_collection; _list_item_it != NULL; _list_item_it = _list_item_it->next) {
#line 217 "DeviceList.c"
			GtkWidget* _tmp1_;
			GtkWidget* _list_item = NULL;
#line 77 "../src/Widgets/DeviceList.vala"
			_tmp1_ = _g_object_ref0 ((GtkWidget*) _list_item_it->data);
#line 77 "../src/Widgets/DeviceList.vala"
			_list_item = _tmp1_;
#line 224 "DeviceList.c"
			{
				NetworkWidgetsDeviceItem* list_item = NULL;
				GtkWidget* _tmp2_;
				NetworkWidgetsDeviceItem* _tmp3_;
				NetworkWidgetsDeviceItem* _tmp4_;
				NetworkWidgetsPage* _tmp5_;
				NetworkWidgetsPage* _tmp6_;
#line 78 "../src/Widgets/DeviceList.vala"
				_tmp2_ = _list_item;
#line 78 "../src/Widgets/DeviceList.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem));
#line 78 "../src/Widgets/DeviceList.vala"
				list_item = _tmp3_;
#line 79 "../src/Widgets/DeviceList.vala"
				_tmp4_ = list_item;
#line 79 "../src/Widgets/DeviceList.vala"
				_tmp5_ = network_widgets_device_item_get_page (_tmp4_);
#line 79 "../src/Widgets/DeviceList.vala"
				_tmp6_ = _tmp5_;
#line 79 "../src/Widgets/DeviceList.vala"
				if (_tmp6_ == iface) {
#line 246 "DeviceList.c"
					NetworkWidgetsDeviceItem* _tmp7_;
#line 80 "../src/Widgets/DeviceList.vala"
					_tmp7_ = list_item;
#line 80 "../src/Widgets/DeviceList.vala"
					network_widgets_device_list_remove_row_from_list (self, _tmp7_);
#line 252 "DeviceList.c"
				}
#line 77 "../src/Widgets/DeviceList.vala"
				_g_object_unref0 (list_item);
#line 77 "../src/Widgets/DeviceList.vala"
				_g_object_unref0 (_list_item);
#line 258 "DeviceList.c"
			}
		}
#line 77 "../src/Widgets/DeviceList.vala"
		(_list_item_collection == NULL) ? NULL : (_list_item_collection = (g_list_free (_list_item_collection), NULL));
#line 263 "DeviceList.c"
	}
}

void
network_widgets_device_list_add_connection (NetworkWidgetsDeviceList* self,
                                            NMRemoteConnection* connection)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 86 "../src/Widgets/DeviceList.vala"
	static GQuark _tmp2_label0 = 0;
#line 86 "../src/Widgets/DeviceList.vala"
	static GQuark _tmp2_label1 = 0;
#line 85 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (connection != NULL);
#line 86 "../src/Widgets/DeviceList.vala"
	_tmp0_ = nm_connection_get_connection_type ((NMConnection*) connection);
#line 86 "../src/Widgets/DeviceList.vala"
	_tmp1_ = _tmp0_;
#line 86 "../src/Widgets/DeviceList.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 86 "../src/Widgets/DeviceList.vala"
	if ((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string (NM_SETTING_WIREGUARD_SETTING_NAME)))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string (NM_SETTING_VPN_SETTING_NAME))))) {
#line 86 "../src/Widgets/DeviceList.vala"
		switch (0) {
#line 292 "DeviceList.c"
			default:
			{
				NetworkWidgetsDeviceItem* _tmp4_;
				NetworkWidgetsPage* _tmp5_;
				NetworkWidgetsPage* _tmp6_;
#line 89 "../src/Widgets/DeviceList.vala"
				_tmp4_ = self->priv->vpn;
#line 89 "../src/Widgets/DeviceList.vala"
				_tmp5_ = network_widgets_device_item_get_page (_tmp4_);
#line 89 "../src/Widgets/DeviceList.vala"
				_tmp6_ = _tmp5_;
#line 89 "../src/Widgets/DeviceList.vala"
				network_vpn_page_add_connection (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage), connection);
#line 90 "../src/Widgets/DeviceList.vala"
				break;
#line 308 "DeviceList.c"
			}
		}
	} else {
#line 86 "../src/Widgets/DeviceList.vala"
		switch (0) {
#line 314 "DeviceList.c"
			default:
			{
#line 92 "../src/Widgets/DeviceList.vala"
				break;
#line 319 "DeviceList.c"
			}
		}
	}
}

void
network_widgets_device_list_remove_connection (NetworkWidgetsDeviceList* self,
                                               NMRemoteConnection* connection)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 97 "../src/Widgets/DeviceList.vala"
	static GQuark _tmp2_label0 = 0;
#line 97 "../src/Widgets/DeviceList.vala"
	static GQuark _tmp2_label1 = 0;
#line 96 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (connection != NULL);
#line 97 "../src/Widgets/DeviceList.vala"
	_tmp0_ = nm_connection_get_connection_type ((NMConnection*) connection);
#line 97 "../src/Widgets/DeviceList.vala"
	_tmp1_ = _tmp0_;
#line 97 "../src/Widgets/DeviceList.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 97 "../src/Widgets/DeviceList.vala"
	if ((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string (NM_SETTING_WIREGUARD_SETTING_NAME)))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string (NM_SETTING_VPN_SETTING_NAME))))) {
#line 97 "../src/Widgets/DeviceList.vala"
		switch (0) {
#line 350 "DeviceList.c"
			default:
			{
				NetworkWidgetsDeviceItem* _tmp4_;
				NetworkWidgetsPage* _tmp5_;
				NetworkWidgetsPage* _tmp6_;
#line 100 "../src/Widgets/DeviceList.vala"
				_tmp4_ = self->priv->vpn;
#line 100 "../src/Widgets/DeviceList.vala"
				_tmp5_ = network_widgets_device_item_get_page (_tmp4_);
#line 100 "../src/Widgets/DeviceList.vala"
				_tmp6_ = _tmp5_;
#line 100 "../src/Widgets/DeviceList.vala"
				network_vpn_page_remove_connection (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage), connection);
#line 101 "../src/Widgets/DeviceList.vala"
				break;
#line 366 "DeviceList.c"
			}
		}
	} else {
#line 97 "../src/Widgets/DeviceList.vala"
		switch (0) {
#line 372 "DeviceList.c"
			default:
			{
#line 103 "../src/Widgets/DeviceList.vala"
				break;
#line 377 "DeviceList.c"
			}
		}
	}
}

void
network_widgets_device_list_remove_row_from_list (NetworkWidgetsDeviceList* self,
                                                  NetworkWidgetsDeviceItem* item)
{
#line 107 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (item != NULL);
#line 108 "../src/Widgets/DeviceList.vala"
	gtk_container_remove ((GtkContainer*) self, (GtkWidget*) item);
#line 109 "../src/Widgets/DeviceList.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 395 "DeviceList.c"
}

static void
network_widgets_device_list_add_proxy (NetworkWidgetsDeviceList* self)
{
	NetworkWidgetsDeviceItem* _tmp0_ = NULL;
	NetworkWidgetsDeviceItem* _tmp1_;
	NetworkWidgetsDeviceItem* _tmp2_;
	NetworkWidgetsProxyPage* _tmp3_;
	NetworkWidgetsProxyPage* _tmp4_;
	NetworkWidgetsDeviceItem* _tmp5_;
#line 112 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/Widgets/DeviceList.vala"
	_tmp0_ = network_widgets_device_item_new (_ ("Proxy"), "preferences-system-network");
#line 113 "../src/Widgets/DeviceList.vala"
	network_widgets_device_item_set_item_type (_tmp0_, NETWORK_UTILS_ITEM_TYPE_VIRTUAL);
#line 113 "../src/Widgets/DeviceList.vala"
	g_object_ref_sink (_tmp0_);
#line 113 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (self->priv->proxy);
#line 113 "../src/Widgets/DeviceList.vala"
	self->priv->proxy = _tmp0_;
#line 116 "../src/Widgets/DeviceList.vala"
	_tmp1_ = self->priv->proxy;
#line 116 "../src/Widgets/DeviceList.vala"
	_tmp2_ = self->priv->proxy;
#line 116 "../src/Widgets/DeviceList.vala"
	_tmp3_ = network_widgets_proxy_page_new (_tmp2_);
#line 116 "../src/Widgets/DeviceList.vala"
	g_object_ref_sink (_tmp3_);
#line 116 "../src/Widgets/DeviceList.vala"
	_tmp4_ = _tmp3_;
#line 116 "../src/Widgets/DeviceList.vala"
	network_widgets_device_item_set_page (_tmp1_, (NetworkWidgetsPage*) _tmp4_);
#line 116 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (_tmp4_);
#line 117 "../src/Widgets/DeviceList.vala"
	_tmp5_ = self->priv->proxy;
#line 117 "../src/Widgets/DeviceList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
#line 437 "DeviceList.c"
}

static void
network_widgets_device_list_add_vpn (NetworkWidgetsDeviceList* self)
{
	NetworkWidgetsDeviceItem* _tmp0_ = NULL;
	NetworkWidgetsDeviceItem* _tmp1_;
	NetworkWidgetsDeviceItem* _tmp2_;
	NetworkVPNPage* _tmp3_;
	NetworkVPNPage* _tmp4_;
	NetworkWidgetsDeviceItem* _tmp5_;
#line 120 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/Widgets/DeviceList.vala"
	_tmp0_ = network_widgets_device_item_new (_ ("VPN"), "network-vpn");
#line 121 "../src/Widgets/DeviceList.vala"
	network_widgets_device_item_set_item_type (_tmp0_, NETWORK_UTILS_ITEM_TYPE_VIRTUAL);
#line 121 "../src/Widgets/DeviceList.vala"
	g_object_ref_sink (_tmp0_);
#line 121 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (self->priv->vpn);
#line 121 "../src/Widgets/DeviceList.vala"
	self->priv->vpn = _tmp0_;
#line 124 "../src/Widgets/DeviceList.vala"
	_tmp1_ = self->priv->vpn;
#line 124 "../src/Widgets/DeviceList.vala"
	_tmp2_ = self->priv->vpn;
#line 124 "../src/Widgets/DeviceList.vala"
	_tmp3_ = network_vpn_page_new (_tmp2_);
#line 124 "../src/Widgets/DeviceList.vala"
	g_object_ref_sink (_tmp3_);
#line 124 "../src/Widgets/DeviceList.vala"
	_tmp4_ = _tmp3_;
#line 124 "../src/Widgets/DeviceList.vala"
	network_widgets_device_item_set_page (_tmp1_, (NetworkWidgetsPage*) _tmp4_);
#line 124 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (_tmp4_);
#line 125 "../src/Widgets/DeviceList.vala"
	_tmp5_ = self->priv->vpn;
#line 125 "../src/Widgets/DeviceList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
#line 479 "DeviceList.c"
}

void
network_widgets_device_list_select_first_item (NetworkWidgetsDeviceList* self)
{
	GtkListBoxRow* _tmp0_;
#line 128 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/Widgets/DeviceList.vala"
	_tmp0_ = gtk_list_box_get_row_at_index ((GtkListBox*) self, 0);
#line 129 "../src/Widgets/DeviceList.vala"
	g_signal_emit_by_name (_tmp0_, "activate");
#line 492 "DeviceList.c"
}

static gint
network_widgets_device_list_sort_items (NetworkWidgetsDeviceList* self,
                                        GtkListBoxRow* row1,
                                        GtkListBoxRow* row2)
{
	NetworkUtilsItemType _tmp0_;
	NetworkUtilsItemType _tmp1_;
	gint result;
#line 132 "../src/Widgets/DeviceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 132 "../src/Widgets/DeviceList.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 132 "../src/Widgets/DeviceList.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 133 "../src/Widgets/DeviceList.vala"
	_tmp0_ = network_widgets_device_item_get_item_type (G_TYPE_CHECK_INSTANCE_CAST (row1, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem));
#line 133 "../src/Widgets/DeviceList.vala"
	_tmp1_ = _tmp0_;
#line 133 "../src/Widgets/DeviceList.vala"
	if (_tmp1_ == NETWORK_UTILS_ITEM_TYPE_DEVICE) {
#line 134 "../src/Widgets/DeviceList.vala"
		result = -1;
#line 134 "../src/Widgets/DeviceList.vala"
		return result;
#line 519 "DeviceList.c"
	} else {
		NetworkUtilsItemType _tmp2_;
		NetworkUtilsItemType _tmp3_;
#line 135 "../src/Widgets/DeviceList.vala"
		_tmp2_ = network_widgets_device_item_get_item_type (G_TYPE_CHECK_INSTANCE_CAST (row1, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem));
#line 135 "../src/Widgets/DeviceList.vala"
		_tmp3_ = _tmp2_;
#line 135 "../src/Widgets/DeviceList.vala"
		if (_tmp3_ == NETWORK_UTILS_ITEM_TYPE_VIRTUAL) {
#line 136 "../src/Widgets/DeviceList.vala"
			result = 1;
#line 136 "../src/Widgets/DeviceList.vala"
			return result;
#line 533 "DeviceList.c"
		} else {
#line 138 "../src/Widgets/DeviceList.vala"
			result = 0;
#line 138 "../src/Widgets/DeviceList.vala"
			return result;
#line 539 "DeviceList.c"
		}
	}
}

static void
network_widgets_device_list_update_headers (NetworkWidgetsDeviceList* self,
                                            GtkListBoxRow* row,
                                            GtkListBoxRow* before)
{
	NetworkWidgetsDeviceItem* row_item = NULL;
	NetworkWidgetsDeviceItem* before_item = NULL;
	NetworkWidgetsDeviceItem* _tmp0_;
	NetworkUtilsItemType _tmp1_;
	NetworkUtilsItemType _tmp2_;
#line 142 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/Widgets/DeviceList.vala"
	g_return_if_fail (row != NULL);
#line 143 "../src/Widgets/DeviceList.vala"
	row_item = G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
#line 144 "../src/Widgets/DeviceList.vala"
	before_item = G_TYPE_CHECK_INSTANCE_CAST (before, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
#line 145 "../src/Widgets/DeviceList.vala"
	_tmp0_ = row_item;
#line 145 "../src/Widgets/DeviceList.vala"
	_tmp1_ = network_widgets_device_item_get_item_type (_tmp0_);
#line 145 "../src/Widgets/DeviceList.vala"
	_tmp2_ = _tmp1_;
#line 145 "../src/Widgets/DeviceList.vala"
	if (_tmp2_ == NETWORK_UTILS_ITEM_TYPE_VIRTUAL) {
#line 570 "DeviceList.c"
		gboolean _tmp3_ = FALSE;
		NetworkWidgetsDeviceItem* _tmp4_;
		GtkLabel* _tmp8_;
		GtkContainer* _tmp9_;
		GtkLabel* _tmp11_;
#line 146 "../src/Widgets/DeviceList.vala"
		_tmp4_ = before_item;
#line 146 "../src/Widgets/DeviceList.vala"
		if (_tmp4_ != NULL) {
#line 580 "DeviceList.c"
			NetworkWidgetsDeviceItem* _tmp5_;
			NetworkUtilsItemType _tmp6_;
			NetworkUtilsItemType _tmp7_;
#line 146 "../src/Widgets/DeviceList.vala"
			_tmp5_ = before_item;
#line 146 "../src/Widgets/DeviceList.vala"
			_tmp6_ = network_widgets_device_item_get_item_type (_tmp5_);
#line 146 "../src/Widgets/DeviceList.vala"
			_tmp7_ = _tmp6_;
#line 146 "../src/Widgets/DeviceList.vala"
			_tmp3_ = _tmp7_ == NETWORK_UTILS_ITEM_TYPE_VIRTUAL;
#line 592 "DeviceList.c"
		} else {
#line 146 "../src/Widgets/DeviceList.vala"
			_tmp3_ = FALSE;
#line 596 "DeviceList.c"
		}
#line 146 "../src/Widgets/DeviceList.vala"
		if (_tmp3_) {
#line 147 "../src/Widgets/DeviceList.vala"
			gtk_list_box_row_set_header (row, NULL);
#line 148 "../src/Widgets/DeviceList.vala"
			return;
#line 604 "DeviceList.c"
		}
#line 151 "../src/Widgets/DeviceList.vala"
		_tmp8_ = self->priv->virtual_l;
#line 151 "../src/Widgets/DeviceList.vala"
		_tmp9_ = gtk_widget_get_parent ((GtkWidget*) _tmp8_);
#line 151 "../src/Widgets/DeviceList.vala"
		if (_tmp9_ != NULL) {
#line 612 "DeviceList.c"
			GtkLabel* _tmp10_;
#line 152 "../src/Widgets/DeviceList.vala"
			_tmp10_ = self->priv->virtual_l;
#line 152 "../src/Widgets/DeviceList.vala"
			gtk_widget_unparent ((GtkWidget*) _tmp10_);
#line 618 "DeviceList.c"
		}
#line 155 "../src/Widgets/DeviceList.vala"
		_tmp11_ = self->priv->virtual_l;
#line 155 "../src/Widgets/DeviceList.vala"
		gtk_list_box_row_set_header (row, (GtkWidget*) _tmp11_);
#line 624 "DeviceList.c"
	} else {
		NetworkWidgetsDeviceItem* _tmp12_;
		NetworkUtilsItemType _tmp13_;
		NetworkUtilsItemType _tmp14_;
#line 156 "../src/Widgets/DeviceList.vala"
		_tmp12_ = row_item;
#line 156 "../src/Widgets/DeviceList.vala"
		_tmp13_ = network_widgets_device_item_get_item_type (_tmp12_);
#line 156 "../src/Widgets/DeviceList.vala"
		_tmp14_ = _tmp13_;
#line 156 "../src/Widgets/DeviceList.vala"
		if (_tmp14_ == NETWORK_UTILS_ITEM_TYPE_DEVICE) {
#line 637 "DeviceList.c"
			gboolean _tmp15_ = FALSE;
			NetworkWidgetsDeviceItem* _tmp16_;
			GtkLabel* _tmp20_;
			GtkContainer* _tmp21_;
			GtkLabel* _tmp23_;
#line 157 "../src/Widgets/DeviceList.vala"
			_tmp16_ = before_item;
#line 157 "../src/Widgets/DeviceList.vala"
			if (_tmp16_ != NULL) {
#line 647 "DeviceList.c"
				NetworkWidgetsDeviceItem* _tmp17_;
				NetworkUtilsItemType _tmp18_;
				NetworkUtilsItemType _tmp19_;
#line 157 "../src/Widgets/DeviceList.vala"
				_tmp17_ = before_item;
#line 157 "../src/Widgets/DeviceList.vala"
				_tmp18_ = network_widgets_device_item_get_item_type (_tmp17_);
#line 157 "../src/Widgets/DeviceList.vala"
				_tmp19_ = _tmp18_;
#line 157 "../src/Widgets/DeviceList.vala"
				_tmp15_ = _tmp19_ == NETWORK_UTILS_ITEM_TYPE_DEVICE;
#line 659 "DeviceList.c"
			} else {
#line 157 "../src/Widgets/DeviceList.vala"
				_tmp15_ = FALSE;
#line 663 "DeviceList.c"
			}
#line 157 "../src/Widgets/DeviceList.vala"
			if (_tmp15_) {
#line 158 "../src/Widgets/DeviceList.vala"
				gtk_list_box_row_set_header (row, NULL);
#line 159 "../src/Widgets/DeviceList.vala"
				return;
#line 671 "DeviceList.c"
			}
#line 162 "../src/Widgets/DeviceList.vala"
			_tmp20_ = self->priv->devices_l;
#line 162 "../src/Widgets/DeviceList.vala"
			_tmp21_ = gtk_widget_get_parent ((GtkWidget*) _tmp20_);
#line 162 "../src/Widgets/DeviceList.vala"
			if (_tmp21_ != NULL) {
#line 679 "DeviceList.c"
				GtkLabel* _tmp22_;
#line 163 "../src/Widgets/DeviceList.vala"
				_tmp22_ = self->priv->devices_l;
#line 163 "../src/Widgets/DeviceList.vala"
				gtk_widget_unparent ((GtkWidget*) _tmp22_);
#line 685 "DeviceList.c"
			}
#line 166 "../src/Widgets/DeviceList.vala"
			_tmp23_ = self->priv->devices_l;
#line 166 "../src/Widgets/DeviceList.vala"
			gtk_list_box_row_set_header (row, (GtkWidget*) _tmp23_);
#line 691 "DeviceList.c"
		} else {
#line 168 "../src/Widgets/DeviceList.vala"
			gtk_list_box_row_set_header (row, NULL);
#line 695 "DeviceList.c"
		}
	}
}

NetworkWidgetsDeviceList*
network_widgets_device_list_construct (GType object_type)
{
	NetworkWidgetsDeviceList * self = NULL;
#line 21 "../src/Widgets/DeviceList.vala"
	self = (NetworkWidgetsDeviceList*) g_object_new (object_type, NULL);
#line 21 "../src/Widgets/DeviceList.vala"
	return self;
#line 708 "DeviceList.c"
}

NetworkWidgetsDeviceList*
network_widgets_device_list_new (void)
{
#line 21 "../src/Widgets/DeviceList.vala"
	return network_widgets_device_list_construct (NETWORK_WIDGETS_TYPE_DEVICE_LIST);
#line 716 "DeviceList.c"
}

static void
_network_widgets_device_list_update_headers_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                             GtkListBoxRow* before,
                                                                             gpointer self)
{
#line 43 "../src/Widgets/DeviceList.vala"
	network_widgets_device_list_update_headers ((NetworkWidgetsDeviceList*) self, row, before);
#line 726 "DeviceList.c"
}

static gint
_network_widgets_device_list_sort_items_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                GtkListBoxRow* row2,
                                                                gpointer self)
{
	gint result;
	result = network_widgets_device_list_sort_items ((NetworkWidgetsDeviceList*) self, row1, row2);
#line 44 "../src/Widgets/DeviceList.vala"
	return result;
#line 738 "DeviceList.c"
}

static void
_network_widgets_device_list___lambda48_ (NetworkWidgetsDeviceList* self,
                                          GtkListBoxRow* row)
{
#line 52 "../src/Widgets/DeviceList.vala"
	g_signal_emit_by_name (row, "activate");
#line 747 "DeviceList.c"
}

static void
__network_widgets_device_list___lambda48__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                     GtkListBoxRow* row,
                                                                     gpointer self)
{
#line 51 "../src/Widgets/DeviceList.vala"
	_network_widgets_device_list___lambda48_ ((NetworkWidgetsDeviceList*) self, row);
#line 757 "DeviceList.c"
}

static GObject *
network_widgets_device_list_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsDeviceList * self;
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	gboolean show = FALSE;
	GList* _tmp6_;
	GList* _tmp7_;
	gboolean _tmp8_;
#line 29 "../src/Widgets/DeviceList.vala"
	parent_class = G_OBJECT_CLASS (network_widgets_device_list_parent_class);
#line 29 "../src/Widgets/DeviceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 29 "../src/Widgets/DeviceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_LIST, NetworkWidgetsDeviceList);
#line 30 "../src/Widgets/DeviceList.vala"
	gtk_list_box_set_selection_mode ((GtkListBox*) self, GTK_SELECTION_SINGLE);
#line 31 "../src/Widgets/DeviceList.vala"
	gtk_list_box_set_activate_on_single_click ((GtkListBox*) self, TRUE);
#line 33 "../src/Widgets/DeviceList.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Virtual"));
#line 33 "../src/Widgets/DeviceList.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
#line 33 "../src/Widgets/DeviceList.vala"
	g_object_ref_sink (_tmp0_);
#line 33 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (self->priv->virtual_l);
#line 33 "../src/Widgets/DeviceList.vala"
	self->priv->virtual_l = _tmp0_;
#line 36 "../src/Widgets/DeviceList.vala"
	_tmp1_ = self->priv->virtual_l;
#line 36 "../src/Widgets/DeviceList.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 36 "../src/Widgets/DeviceList.vala"
	gtk_style_context_add_class (_tmp2_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 38 "../src/Widgets/DeviceList.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_ ("Devices"));
#line 38 "../src/Widgets/DeviceList.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 38 "../src/Widgets/DeviceList.vala"
	g_object_ref_sink (_tmp3_);
#line 38 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (self->priv->devices_l);
#line 38 "../src/Widgets/DeviceList.vala"
	self->priv->devices_l = _tmp3_;
#line 41 "../src/Widgets/DeviceList.vala"
	_tmp4_ = self->priv->devices_l;
#line 41 "../src/Widgets/DeviceList.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 41 "../src/Widgets/DeviceList.vala"
	gtk_style_context_add_class (_tmp5_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 43 "../src/Widgets/DeviceList.vala"
	gtk_list_box_set_header_func ((GtkListBox*) self, _network_widgets_device_list_update_headers_gtk_list_box_update_header_func, g_object_ref (self), g_object_unref);
#line 44 "../src/Widgets/DeviceList.vala"
	gtk_list_box_set_sort_func ((GtkListBox*) self, _network_widgets_device_list_sort_items_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 46 "../src/Widgets/DeviceList.vala"
	_tmp6_ = gtk_container_get_children ((GtkContainer*) self);
#line 46 "../src/Widgets/DeviceList.vala"
	_tmp7_ = _tmp6_;
#line 46 "../src/Widgets/DeviceList.vala"
	_tmp8_ = g_list_length (_tmp7_) > ((guint) 0);
#line 46 "../src/Widgets/DeviceList.vala"
	(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
#line 46 "../src/Widgets/DeviceList.vala"
	show = _tmp8_;
#line 47 "../src/Widgets/DeviceList.vala"
	g_signal_emit (self, network_widgets_device_list_signals[NETWORK_WIDGETS_DEVICE_LIST_SHOW_NO_DEVICES_SIGNAL], 0, !show);
#line 48 "../src/Widgets/DeviceList.vala"
	network_widgets_device_list_add_proxy (self);
#line 49 "../src/Widgets/DeviceList.vala"
	network_widgets_device_list_add_vpn (self);
#line 51 "../src/Widgets/DeviceList.vala"
	g_signal_connect_object ((GtkListBox*) self, "row-selected", (GCallback) __network_widgets_device_list___lambda48__gtk_list_box_row_selected, self, 0);
#line 29 "../src/Widgets/DeviceList.vala"
	return obj;
#line 844 "DeviceList.c"
}

static void
network_widgets_device_list_class_init (NetworkWidgetsDeviceListClass * klass,
                                        gpointer klass_data)
{
#line 21 "../src/Widgets/DeviceList.vala"
	network_widgets_device_list_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/DeviceList.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsDeviceList_private_offset);
#line 21 "../src/Widgets/DeviceList.vala"
	G_OBJECT_CLASS (klass)->constructor = network_widgets_device_list_constructor;
#line 21 "../src/Widgets/DeviceList.vala"
	G_OBJECT_CLASS (klass)->finalize = network_widgets_device_list_finalize;
#line 21 "../src/Widgets/DeviceList.vala"
	network_widgets_device_list_signals[NETWORK_WIDGETS_DEVICE_LIST_SHOW_NO_DEVICES_SIGNAL] = g_signal_new ("show-no-devices", NETWORK_WIDGETS_TYPE_DEVICE_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 861 "DeviceList.c"
}

static void
network_widgets_device_list_instance_init (NetworkWidgetsDeviceList * self,
                                           gpointer klass)
{
#line 21 "../src/Widgets/DeviceList.vala"
	self->priv = network_widgets_device_list_get_instance_private (self);
#line 870 "DeviceList.c"
}

static void
network_widgets_device_list_finalize (GObject * obj)
{
	NetworkWidgetsDeviceList * self;
#line 21 "../src/Widgets/DeviceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_LIST, NetworkWidgetsDeviceList);
#line 24 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (self->priv->virtual_l);
#line 25 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (self->priv->devices_l);
#line 26 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (self->priv->proxy);
#line 27 "../src/Widgets/DeviceList.vala"
	_g_object_unref0 (self->priv->vpn);
#line 21 "../src/Widgets/DeviceList.vala"
	G_OBJECT_CLASS (network_widgets_device_list_parent_class)->finalize (obj);
#line 889 "DeviceList.c"
}

static GType
network_widgets_device_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsDeviceListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_device_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsDeviceList), 0, (GInstanceInitFunc) network_widgets_device_list_instance_init, NULL };
	GType network_widgets_device_list_type_id;
	network_widgets_device_list_type_id = g_type_register_static (gtk_list_box_get_type (), "NetworkWidgetsDeviceList", &g_define_type_info, 0);
	NetworkWidgetsDeviceList_private_offset = g_type_add_instance_private (network_widgets_device_list_type_id, sizeof (NetworkWidgetsDeviceListPrivate));
	return network_widgets_device_list_type_id;
}

GType
network_widgets_device_list_get_type (void)
{
	static volatile gsize network_widgets_device_list_type_id__once = 0;
	if (g_once_init_enter (&network_widgets_device_list_type_id__once)) {
		GType network_widgets_device_list_type_id;
		network_widgets_device_list_type_id = network_widgets_device_list_get_type_once ();
		g_once_init_leave (&network_widgets_device_list_type_id__once, network_widgets_device_list_type_id);
	}
	return network_widgets_device_list_type_id__once;
}

