/* InfoBox.c generated by valac 0.56.14, the Vala compiler
 * generated from InfoBox.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <float.h>
#include <math.h>

#define NETWORK_UNKNOWN_STR _ ("Unknown")

enum  {
	NETWORK_WIDGETS_INFO_BOX_0_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_NUM_PROPERTIES
};
static GParamSpec* network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block12Data Block12Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
enum  {
	NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL,
	NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL,
	NETWORK_WIDGETS_INFO_BOX_NUM_SIGNALS
};
static guint network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_NUM_SIGNALS] = {0};

struct _NetworkWidgetsInfoBoxPrivate {
	NMDevice* _device;
	NetworkWidgetsDeviceItem* _owner;
	GtkLabel* ip4address;
	GtkLabel* ip6address;
	GtkLabel* mask;
	GtkLabel* router;
	GtkLabel* dns;
	GtkLabel* sent;
	GtkLabel* received;
	GtkLabel* ip6address_head;
};

struct _Block12Data {
	int _ref_count_;
	NetworkWidgetsInfoBox* self;
	gint i;
	GPtrArray* addresses;
};

static gint NetworkWidgetsInfoBox_private_offset;
static gpointer network_widgets_info_box_parent_class = NULL;

static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void ___lambda7_ (Block12Data* _data12_,
                  NMIPAddress* addr);
static void ____lambda7__gfunc (gconstpointer data,
                         gpointer self);
static GObject * network_widgets_info_box_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _network_widgets_info_box___lambda8_ (NetworkWidgetsInfoBox* self);
static void __network_widgets_info_box___lambda8__nm_device_state_changed (NMDevice* _sender,
                                                                    guint new_state,
                                                                    guint old_state,
                                                                    guint reason,
                                                                    gpointer self);
static void network_widgets_info_box_finalize (GObject * obj);
static GType network_widgets_info_box_get_type_once (void);
static void _vala_network_widgets_info_box_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_network_widgets_info_box_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
network_widgets_info_box_get_instance_private (NetworkWidgetsInfoBox* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsInfoBox_private_offset);
}

NetworkWidgetsInfoBox*
network_widgets_info_box_construct_from_device (GType object_type,
                                                NMDevice* device)
{
	NetworkWidgetsInfoBox * self = NULL;
#line 37 "../src/Widgets/InfoBox.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 38 "../src/Widgets/InfoBox.vala"
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, "device", device, NULL);
#line 37 "../src/Widgets/InfoBox.vala"
	return self;
#line 133 "InfoBox.c"
}

NetworkWidgetsInfoBox*
network_widgets_info_box_new_from_device (NMDevice* device)
{
#line 37 "../src/Widgets/InfoBox.vala"
	return network_widgets_info_box_construct_from_device (NETWORK_WIDGETS_TYPE_INFO_BOX, device);
#line 141 "InfoBox.c"
}

NetworkWidgetsInfoBox*
network_widgets_info_box_construct_from_owner (GType object_type,
                                               NetworkWidgetsDeviceItem* owner)
{
	NetworkWidgetsInfoBox * self = NULL;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
#line 41 "../src/Widgets/InfoBox.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 42 "../src/Widgets/InfoBox.vala"
	_tmp0_ = network_widgets_device_item_get_device (owner);
#line 42 "../src/Widgets/InfoBox.vala"
	_tmp1_ = _tmp0_;
#line 42 "../src/Widgets/InfoBox.vala"
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, "owner", owner, "device", _tmp1_, NULL);
#line 41 "../src/Widgets/InfoBox.vala"
	return self;
#line 161 "InfoBox.c"
}

NetworkWidgetsInfoBox*
network_widgets_info_box_new_from_owner (NetworkWidgetsDeviceItem* owner)
{
#line 41 "../src/Widgets/InfoBox.vala"
	return network_widgets_info_box_construct_from_owner (NETWORK_WIDGETS_TYPE_INFO_BOX, owner);
#line 169 "InfoBox.c"
}

void
network_widgets_info_box_update_activity (NetworkWidgetsInfoBox* self,
                                          const gchar* sent_bytes,
                                          const gchar* received_bytes)
{
	const gchar* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	const gchar* _tmp2_ = NULL;
	GtkLabel* _tmp3_;
#line 150 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (sent_bytes != NULL);
#line 150 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (received_bytes != NULL);
#line 151 "../src/Widgets/InfoBox.vala"
	_tmp0_ = sent_bytes;
#line 151 "../src/Widgets/InfoBox.vala"
	if (_tmp0_ == NULL) {
#line 151 "../src/Widgets/InfoBox.vala"
		_tmp0_ = NETWORK_UNKNOWN_STR;
#line 193 "InfoBox.c"
	}
#line 151 "../src/Widgets/InfoBox.vala"
	_tmp1_ = self->priv->sent;
#line 151 "../src/Widgets/InfoBox.vala"
	gtk_label_set_label (_tmp1_, _tmp0_);
#line 152 "../src/Widgets/InfoBox.vala"
	_tmp2_ = received_bytes;
#line 152 "../src/Widgets/InfoBox.vala"
	if (_tmp2_ == NULL) {
#line 152 "../src/Widgets/InfoBox.vala"
		_tmp2_ = NETWORK_UNKNOWN_STR;
#line 205 "InfoBox.c"
	}
#line 152 "../src/Widgets/InfoBox.vala"
	_tmp3_ = self->priv->received;
#line 152 "../src/Widgets/InfoBox.vala"
	gtk_label_set_label (_tmp3_, _tmp2_);
#line 211 "InfoBox.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 156 "../src/Widgets/InfoBox.vala"
	return self ? g_object_ref (self) : NULL;
#line 219 "InfoBox.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5905 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5906 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5906 "glib-2.0.vapi"
	return result;
#line 232 "InfoBox.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 170 "../src/Widgets/InfoBox.vala"
	if (length >= 0) {
#line 241 "InfoBox.c"
		gchar** result;
		gssize i;
#line 170 "../src/Widgets/InfoBox.vala"
		result = g_new0 (gchar*, length + 1);
#line 170 "../src/Widgets/InfoBox.vala"
		for (i = 0; i < length; i++) {
#line 248 "InfoBox.c"
			gchar* _tmp0_;
#line 170 "../src/Widgets/InfoBox.vala"
			_tmp0_ = g_strdup (self[i]);
#line 170 "../src/Widgets/InfoBox.vala"
			result[i] = _tmp0_;
#line 254 "InfoBox.c"
		}
#line 170 "../src/Widgets/InfoBox.vala"
		return result;
#line 258 "InfoBox.c"
	}
#line 170 "../src/Widgets/InfoBox.vala"
	return NULL;
#line 262 "InfoBox.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 186 "../src/Widgets/InfoBox.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 186 "../src/Widgets/InfoBox.vala"
	return _data12_;
#line 272 "InfoBox.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 186 "../src/Widgets/InfoBox.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 282 "InfoBox.c"
		NetworkWidgetsInfoBox* self;
#line 186 "../src/Widgets/InfoBox.vala"
		self = _data12_->self;
#line 186 "../src/Widgets/InfoBox.vala"
		_g_ptr_array_unref0 (_data12_->addresses);
#line 186 "../src/Widgets/InfoBox.vala"
		_g_object_unref0 (self);
#line 186 "../src/Widgets/InfoBox.vala"
		g_slice_free (Block12Data, _data12_);
#line 292 "InfoBox.c"
	}
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 188 "../src/Widgets/InfoBox.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 301 "InfoBox.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 322 "InfoBox.c"
}

static void
___lambda7_ (Block12Data* _data12_,
             NMIPAddress* addr)
{
	NetworkWidgetsInfoBox* self;
	gchar* inet_str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GPtrArray* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp28_;
#line 189 "../src/Widgets/InfoBox.vala"
	self = _data12_->self;
#line 189 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (addr != NULL);
#line 190 "../src/Widgets/InfoBox.vala"
	nm_ip_address_ref (addr);
#line 191 "../src/Widgets/InfoBox.vala"
	_tmp0_ = nm_ip_address_get_address (addr);
#line 191 "../src/Widgets/InfoBox.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 191 "../src/Widgets/InfoBox.vala"
	_tmp2_ = _tmp1_;
#line 191 "../src/Widgets/InfoBox.vala"
	_tmp3_ = g_strdup_printf ("%u", nm_ip_address_get_prefix (addr));
#line 191 "../src/Widgets/InfoBox.vala"
	_tmp4_ = _tmp3_;
#line 191 "../src/Widgets/InfoBox.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 191 "../src/Widgets/InfoBox.vala"
	_tmp6_ = _tmp5_;
#line 191 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp4_);
#line 191 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp2_);
#line 191 "../src/Widgets/InfoBox.vala"
	inet_str = _tmp6_;
#line 192 "../src/Widgets/InfoBox.vala"
	_tmp7_ = self->priv->ip6address;
#line 192 "../src/Widgets/InfoBox.vala"
	_tmp8_ = self->priv->ip6address_head;
#line 192 "../src/Widgets/InfoBox.vala"
	_tmp9_ = inet_str;
#line 192 "../src/Widgets/InfoBox.vala"
	_tmp10_ = string_strip (_tmp9_);
#line 192 "../src/Widgets/InfoBox.vala"
	_tmp11_ = _tmp10_;
#line 192 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, g_strcmp0 (_tmp11_, "") != 0);
#line 192 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, g_strcmp0 (_tmp11_, "") != 0);
#line 192 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp11_);
#line 193 "../src/Widgets/InfoBox.vala"
	_tmp12_ = self->priv->ip6address;
#line 193 "../src/Widgets/InfoBox.vala"
	_tmp13_ = self->priv->ip6address;
#line 193 "../src/Widgets/InfoBox.vala"
	_tmp14_ = gtk_label_get_label (_tmp13_);
#line 193 "../src/Widgets/InfoBox.vala"
	_tmp15_ = _tmp14_;
#line 193 "../src/Widgets/InfoBox.vala"
	_tmp16_ = inet_str;
#line 193 "../src/Widgets/InfoBox.vala"
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 193 "../src/Widgets/InfoBox.vala"
	_tmp18_ = _tmp17_;
#line 193 "../src/Widgets/InfoBox.vala"
	gtk_label_set_label (_tmp13_, _tmp18_);
#line 193 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp18_);
#line 194 "../src/Widgets/InfoBox.vala"
	_tmp19_ = _data12_->addresses;
#line 194 "../src/Widgets/InfoBox.vala"
	_tmp20_ = vala_g_ptr_array_get_length (_tmp19_);
#line 194 "../src/Widgets/InfoBox.vala"
	_tmp21_ = _tmp20_;
#line 194 "../src/Widgets/InfoBox.vala"
	if (_data12_->i < _tmp21_) {
#line 422 "InfoBox.c"
		GtkLabel* _tmp22_;
		GtkLabel* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 195 "../src/Widgets/InfoBox.vala"
		_tmp22_ = self->priv->ip6address;
#line 195 "../src/Widgets/InfoBox.vala"
		_tmp23_ = self->priv->ip6address;
#line 195 "../src/Widgets/InfoBox.vala"
		_tmp24_ = gtk_label_get_label (_tmp23_);
#line 195 "../src/Widgets/InfoBox.vala"
		_tmp25_ = _tmp24_;
#line 195 "../src/Widgets/InfoBox.vala"
		_tmp26_ = g_strconcat (_tmp25_, "\n", NULL);
#line 195 "../src/Widgets/InfoBox.vala"
		_tmp27_ = _tmp26_;
#line 195 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp23_, _tmp27_);
#line 195 "../src/Widgets/InfoBox.vala"
		_g_free0 (_tmp27_);
#line 445 "InfoBox.c"
	}
#line 198 "../src/Widgets/InfoBox.vala"
	_tmp28_ = _data12_->i;
#line 198 "../src/Widgets/InfoBox.vala"
	_data12_->i = _tmp28_ + 1;
#line 189 "../src/Widgets/InfoBox.vala"
	_g_free0 (inet_str);
#line 453 "InfoBox.c"
}

static void
____lambda7__gfunc (gconstpointer data,
                    gpointer self)
{
#line 189 "../src/Widgets/InfoBox.vala"
	___lambda7_ (self, (NMIPAddress*) data);
#line 462 "InfoBox.c"
}

void
network_widgets_info_box_update_status (NetworkWidgetsInfoBox* self)
{
	NMIPConfig* ipv4 = NULL;
	NMDevice* _tmp0_;
	NMIPConfig* _tmp1_;
	NMIPConfig* _tmp2_;
	NMIPConfig* _tmp3_;
	NMIPConfig* ip6 = NULL;
	NMDevice* _tmp51_;
	NMIPConfig* _tmp52_;
	NMIPConfig* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	NMIPConfig* _tmp56_;
	GtkLabel* _tmp57_;
	NMIPConfig* _tmp58_;
	NetworkWidgetsDeviceItem* _tmp63_;
#line 155 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Widgets/InfoBox.vala"
	_tmp0_ = self->priv->_device;
#line 156 "../src/Widgets/InfoBox.vala"
	_tmp1_ = nm_device_get_ip4_config (_tmp0_);
#line 156 "../src/Widgets/InfoBox.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 156 "../src/Widgets/InfoBox.vala"
	ipv4 = _tmp2_;
#line 157 "../src/Widgets/InfoBox.vala"
	_tmp3_ = ipv4;
#line 157 "../src/Widgets/InfoBox.vala"
	if (_tmp3_ != NULL) {
#line 497 "InfoBox.c"
		NMIPConfig* _tmp4_;
		GPtrArray* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		const gchar* _tmp19_ = NULL;
		NMIPConfig* _tmp20_;
		const gchar* _tmp21_;
		GtkLabel* _tmp22_;
		GtkLabel* _tmp23_;
		NMIPConfig* _tmp24_;
		gchar** _tmp25_;
		gchar** _tmp26_;
#line 158 "../src/Widgets/InfoBox.vala"
		_tmp4_ = ipv4;
#line 158 "../src/Widgets/InfoBox.vala"
		_tmp5_ = nm_ip_config_get_addresses (_tmp4_);
#line 158 "../src/Widgets/InfoBox.vala"
		_tmp6_ = vala_g_ptr_array_get_length (_tmp5_);
#line 158 "../src/Widgets/InfoBox.vala"
		_tmp7_ = _tmp6_;
#line 158 "../src/Widgets/InfoBox.vala"
		if (_tmp7_ > 0) {
#line 520 "InfoBox.c"
			NMIPAddress* address = NULL;
			NMIPConfig* _tmp8_;
			GPtrArray* _tmp9_;
			gconstpointer _tmp10_;
			GtkLabel* _tmp11_;
			NMIPAddress* _tmp12_;
			const gchar* _tmp13_;
			guint32 mask_addr = 0U;
			NMIPAddress* _tmp14_;
			struct in_addr source_addr = {0};
			struct in_addr _tmp15_ = {0};
			const gchar* _tmp16_ = NULL;
			const gchar* _tmp17_;
			GtkLabel* _tmp18_;
#line 159 "../src/Widgets/InfoBox.vala"
			_tmp8_ = ipv4;
#line 159 "../src/Widgets/InfoBox.vala"
			_tmp9_ = nm_ip_config_get_addresses (_tmp8_);
#line 159 "../src/Widgets/InfoBox.vala"
			_tmp10_ = g_ptr_array_index (_tmp9_, (guint) 0);
#line 159 "../src/Widgets/InfoBox.vala"
			address = (NMIPAddress*) _tmp10_;
#line 160 "../src/Widgets/InfoBox.vala"
			_tmp11_ = self->priv->ip4address;
#line 160 "../src/Widgets/InfoBox.vala"
			_tmp12_ = address;
#line 160 "../src/Widgets/InfoBox.vala"
			_tmp13_ = nm_ip_address_get_address (_tmp12_);
#line 160 "../src/Widgets/InfoBox.vala"
			gtk_label_set_label (_tmp11_, _tmp13_);
#line 161 "../src/Widgets/InfoBox.vala"
			_tmp14_ = address;
#line 161 "../src/Widgets/InfoBox.vala"
			mask_addr = htonl (((guint32) 0xffffffffLL) << (32 - nm_ip_address_get_prefix (_tmp14_)));
#line 162 "../src/Widgets/InfoBox.vala"
			memset (&_tmp15_, 0, sizeof (struct in_addr));
#line 162 "../src/Widgets/InfoBox.vala"
			_tmp15_.s_addr = mask_addr;
#line 162 "../src/Widgets/InfoBox.vala"
			source_addr = _tmp15_;
#line 163 "../src/Widgets/InfoBox.vala"
			_tmp17_ = inet_ntoa (source_addr);
#line 163 "../src/Widgets/InfoBox.vala"
			_tmp16_ = _tmp17_;
#line 163 "../src/Widgets/InfoBox.vala"
			if (_tmp16_ == NULL) {
#line 163 "../src/Widgets/InfoBox.vala"
				_tmp16_ = NETWORK_UNKNOWN_STR;
#line 569 "InfoBox.c"
			}
#line 163 "../src/Widgets/InfoBox.vala"
			_tmp18_ = self->priv->mask;
#line 163 "../src/Widgets/InfoBox.vala"
			gtk_label_set_label (_tmp18_, _tmp16_);
#line 158 "../src/Widgets/InfoBox.vala"
			 (source_addr);
#line 577 "InfoBox.c"
		}
#line 166 "../src/Widgets/InfoBox.vala"
		_tmp20_ = ipv4;
#line 166 "../src/Widgets/InfoBox.vala"
		_tmp21_ = nm_ip_config_get_gateway (_tmp20_);
#line 166 "../src/Widgets/InfoBox.vala"
		_tmp19_ = _tmp21_;
#line 166 "../src/Widgets/InfoBox.vala"
		if (_tmp19_ == NULL) {
#line 166 "../src/Widgets/InfoBox.vala"
			_tmp19_ = NETWORK_UNKNOWN_STR;
#line 589 "InfoBox.c"
		}
#line 166 "../src/Widgets/InfoBox.vala"
		_tmp22_ = self->priv->router;
#line 166 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp22_, _tmp19_);
#line 168 "../src/Widgets/InfoBox.vala"
		_tmp23_ = self->priv->dns;
#line 168 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp23_, "");
#line 169 "../src/Widgets/InfoBox.vala"
		_tmp24_ = ipv4;
#line 169 "../src/Widgets/InfoBox.vala"
		_tmp26_ = _tmp25_ = nm_ip_config_get_nameservers (_tmp24_);
#line 169 "../src/Widgets/InfoBox.vala"
		if (_vala_array_length (_tmp25_) > 0) {
#line 605 "InfoBox.c"
			gchar** dns_addr = NULL;
			NMIPConfig* _tmp27_;
			gchar** _tmp28_;
			gchar** _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
			gint dns_addr_length1;
			gint _dns_addr_size_;
			GtkLabel* _tmp31_;
			gchar** _tmp32_;
			gint _tmp32__length1;
			const gchar* _tmp33_;
#line 170 "../src/Widgets/InfoBox.vala"
			_tmp27_ = ipv4;
#line 170 "../src/Widgets/InfoBox.vala"
			_tmp29_ = _tmp28_ = nm_ip_config_get_nameservers (_tmp27_);
#line 170 "../src/Widgets/InfoBox.vala"
			_tmp30_ = (_tmp29_ != NULL) ? _vala_array_dup1 (_tmp29_, _vala_array_length (_tmp28_)) : _tmp29_;
#line 170 "../src/Widgets/InfoBox.vala"
			_tmp30__length1 = _vala_array_length (_tmp28_);
#line 170 "../src/Widgets/InfoBox.vala"
			dns_addr = _tmp30_;
#line 170 "../src/Widgets/InfoBox.vala"
			dns_addr_length1 = _tmp30__length1;
#line 170 "../src/Widgets/InfoBox.vala"
			_dns_addr_size_ = dns_addr_length1;
#line 171 "../src/Widgets/InfoBox.vala"
			_tmp31_ = self->priv->dns;
#line 171 "../src/Widgets/InfoBox.vala"
			_tmp32_ = dns_addr;
#line 171 "../src/Widgets/InfoBox.vala"
			_tmp32__length1 = dns_addr_length1;
#line 171 "../src/Widgets/InfoBox.vala"
			_tmp33_ = _tmp32_[0];
#line 171 "../src/Widgets/InfoBox.vala"
			gtk_label_set_label (_tmp31_, _tmp33_);
#line 642 "InfoBox.c"
			{
				gint i = 0;
#line 172 "../src/Widgets/InfoBox.vala"
				i = 1;
#line 647 "InfoBox.c"
				{
					gboolean _tmp34_ = FALSE;
#line 172 "../src/Widgets/InfoBox.vala"
					_tmp34_ = TRUE;
#line 172 "../src/Widgets/InfoBox.vala"
					while (TRUE) {
#line 654 "InfoBox.c"
						gchar** _tmp36_;
						gint _tmp36__length1;
						GtkLabel* _tmp37_;
						GtkLabel* _tmp38_;
						const gchar* _tmp39_;
						const gchar* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar** _tmp43_;
						gint _tmp43__length1;
						const gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
#line 172 "../src/Widgets/InfoBox.vala"
						if (!_tmp34_) {
#line 670 "InfoBox.c"
							gint _tmp35_;
#line 172 "../src/Widgets/InfoBox.vala"
							_tmp35_ = i;
#line 172 "../src/Widgets/InfoBox.vala"
							i = _tmp35_ + 1;
#line 676 "InfoBox.c"
						}
#line 172 "../src/Widgets/InfoBox.vala"
						_tmp34_ = FALSE;
#line 172 "../src/Widgets/InfoBox.vala"
						_tmp36_ = dns_addr;
#line 172 "../src/Widgets/InfoBox.vala"
						_tmp36__length1 = dns_addr_length1;
#line 172 "../src/Widgets/InfoBox.vala"
						if (!(i < _tmp36__length1)) {
#line 172 "../src/Widgets/InfoBox.vala"
							break;
#line 688 "InfoBox.c"
						}
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp37_ = self->priv->dns;
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp38_ = self->priv->dns;
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp39_ = gtk_label_get_label (_tmp38_);
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp40_ = _tmp39_;
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp41_ = g_strconcat (_tmp40_, ", ", NULL);
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp42_ = _tmp41_;
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp43_ = dns_addr;
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp43__length1 = dns_addr_length1;
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp44_ = _tmp43_[i];
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp45_ = g_strconcat (_tmp42_, _tmp44_, NULL);
#line 173 "../src/Widgets/InfoBox.vala"
						_tmp46_ = _tmp45_;
#line 173 "../src/Widgets/InfoBox.vala"
						gtk_label_set_label (_tmp37_, _tmp46_);
#line 173 "../src/Widgets/InfoBox.vala"
						_g_free0 (_tmp46_);
#line 173 "../src/Widgets/InfoBox.vala"
						_g_free0 (_tmp42_);
#line 718 "InfoBox.c"
					}
				}
			}
#line 169 "../src/Widgets/InfoBox.vala"
			dns_addr = (_vala_array_free (dns_addr, dns_addr_length1, (GDestroyNotify) g_free), NULL);
#line 724 "InfoBox.c"
		}
	} else {
		GtkLabel* _tmp47_;
		GtkLabel* _tmp48_;
		GtkLabel* _tmp49_;
		GtkLabel* _tmp50_;
#line 177 "../src/Widgets/InfoBox.vala"
		_tmp47_ = self->priv->ip4address;
#line 177 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp47_, NETWORK_UNKNOWN_STR);
#line 178 "../src/Widgets/InfoBox.vala"
		_tmp48_ = self->priv->mask;
#line 178 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp48_, NETWORK_UNKNOWN_STR);
#line 179 "../src/Widgets/InfoBox.vala"
		_tmp49_ = self->priv->router;
#line 179 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp49_, NETWORK_UNKNOWN_STR);
#line 180 "../src/Widgets/InfoBox.vala"
		_tmp50_ = self->priv->dns;
#line 180 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp50_, NETWORK_UNKNOWN_STR);
#line 747 "InfoBox.c"
	}
#line 183 "../src/Widgets/InfoBox.vala"
	_tmp51_ = self->priv->_device;
#line 183 "../src/Widgets/InfoBox.vala"
	_tmp52_ = nm_device_get_ip6_config (_tmp51_);
#line 183 "../src/Widgets/InfoBox.vala"
	_tmp53_ = _g_object_ref0 (_tmp52_);
#line 183 "../src/Widgets/InfoBox.vala"
	ip6 = _tmp53_;
#line 184 "../src/Widgets/InfoBox.vala"
	_tmp54_ = self->priv->ip6address;
#line 184 "../src/Widgets/InfoBox.vala"
	_tmp55_ = self->priv->ip6address_head;
#line 184 "../src/Widgets/InfoBox.vala"
	_tmp56_ = ip6;
#line 184 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp55_, _tmp56_ != NULL);
#line 184 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp54_, _tmp56_ != NULL);
#line 185 "../src/Widgets/InfoBox.vala"
	_tmp57_ = self->priv->ip6address;
#line 185 "../src/Widgets/InfoBox.vala"
	gtk_label_set_label (_tmp57_, "");
#line 186 "../src/Widgets/InfoBox.vala"
	_tmp58_ = ip6;
#line 186 "../src/Widgets/InfoBox.vala"
	if (_tmp58_ != NULL) {
#line 775 "InfoBox.c"
		Block12Data* _data12_;
		NMIPConfig* _tmp59_;
		GPtrArray* _tmp60_;
		GPtrArray* _tmp61_;
		GPtrArray* _tmp62_;
#line 186 "../src/Widgets/InfoBox.vala"
		_data12_ = g_slice_new0 (Block12Data);
#line 186 "../src/Widgets/InfoBox.vala"
		_data12_->_ref_count_ = 1;
#line 186 "../src/Widgets/InfoBox.vala"
		_data12_->self = g_object_ref (self);
#line 187 "../src/Widgets/InfoBox.vala"
		_data12_->i = 1;
#line 188 "../src/Widgets/InfoBox.vala"
		_tmp59_ = ip6;
#line 188 "../src/Widgets/InfoBox.vala"
		_tmp60_ = nm_ip_config_get_addresses (_tmp59_);
#line 188 "../src/Widgets/InfoBox.vala"
		_tmp61_ = _g_ptr_array_ref0 (_tmp60_);
#line 188 "../src/Widgets/InfoBox.vala"
		_data12_->addresses = _tmp61_;
#line 189 "../src/Widgets/InfoBox.vala"
		_tmp62_ = _data12_->addresses;
#line 189 "../src/Widgets/InfoBox.vala"
		g_ptr_array_foreach (_tmp62_, ____lambda7__gfunc, _data12_);
#line 186 "../src/Widgets/InfoBox.vala"
		block12_data_unref (_data12_);
#line 186 "../src/Widgets/InfoBox.vala"
		_data12_ = NULL;
#line 805 "InfoBox.c"
	}
#line 203 "../src/Widgets/InfoBox.vala"
	_tmp63_ = self->priv->_owner;
#line 203 "../src/Widgets/InfoBox.vala"
	if (_tmp63_ != NULL) {
#line 811 "InfoBox.c"
		NetworkWidgetsDeviceItem* _tmp64_;
#line 204 "../src/Widgets/InfoBox.vala"
		_tmp64_ = self->priv->_owner;
#line 204 "../src/Widgets/InfoBox.vala"
		g_signal_emit (self, network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL], 0, _tmp64_);
#line 817 "InfoBox.c"
	}
#line 207 "../src/Widgets/InfoBox.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 155 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (ip6);
#line 155 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (ipv4);
#line 825 "InfoBox.c"
}

NetworkWidgetsInfoBox*
network_widgets_info_box_construct (GType object_type)
{
	NetworkWidgetsInfoBox * self = NULL;
#line 21 "../src/Widgets/InfoBox.vala"
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, NULL);
#line 21 "../src/Widgets/InfoBox.vala"
	return self;
#line 836 "InfoBox.c"
}

NetworkWidgetsInfoBox*
network_widgets_info_box_new (void)
{
#line 21 "../src/Widgets/InfoBox.vala"
	return network_widgets_info_box_construct (NETWORK_WIDGETS_TYPE_INFO_BOX);
#line 844 "InfoBox.c"
}

NMDevice*
network_widgets_info_box_get_device (NetworkWidgetsInfoBox* self)
{
	NMDevice* result;
	NMDevice* _tmp0_;
#line 24 "../src/Widgets/InfoBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/InfoBox.vala"
	_tmp0_ = self->priv->_device;
#line 24 "../src/Widgets/InfoBox.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/InfoBox.vala"
	return result;
#line 860 "InfoBox.c"
}

static void
network_widgets_info_box_set_device (NetworkWidgetsInfoBox* self,
                                     NMDevice* value)
{
	NMDevice* old_value;
#line 24 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/InfoBox.vala"
	old_value = network_widgets_info_box_get_device (self);
#line 24 "../src/Widgets/InfoBox.vala"
	if (old_value != value) {
#line 874 "InfoBox.c"
		NMDevice* _tmp0_;
#line 24 "../src/Widgets/InfoBox.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Widgets/InfoBox.vala"
		_g_object_unref0 (self->priv->_device);
#line 24 "../src/Widgets/InfoBox.vala"
		self->priv->_device = _tmp0_;
#line 24 "../src/Widgets/InfoBox.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY]);
#line 884 "InfoBox.c"
	}
}

NetworkWidgetsDeviceItem*
network_widgets_info_box_get_owner (NetworkWidgetsInfoBox* self)
{
	NetworkWidgetsDeviceItem* result;
	NetworkWidgetsDeviceItem* _tmp0_;
#line 25 "../src/Widgets/InfoBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/InfoBox.vala"
	_tmp0_ = self->priv->_owner;
#line 25 "../src/Widgets/InfoBox.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/InfoBox.vala"
	return result;
#line 901 "InfoBox.c"
}

static void
network_widgets_info_box_set_owner (NetworkWidgetsInfoBox* self,
                                    NetworkWidgetsDeviceItem* value)
{
	NetworkWidgetsDeviceItem* old_value;
#line 25 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/InfoBox.vala"
	old_value = network_widgets_info_box_get_owner (self);
#line 25 "../src/Widgets/InfoBox.vala"
	if (old_value != value) {
#line 915 "InfoBox.c"
		NetworkWidgetsDeviceItem* _tmp0_;
#line 25 "../src/Widgets/InfoBox.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/Widgets/InfoBox.vala"
		_g_object_unref0 (self->priv->_owner);
#line 25 "../src/Widgets/InfoBox.vala"
		self->priv->_owner = _tmp0_;
#line 25 "../src/Widgets/InfoBox.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY]);
#line 925 "InfoBox.c"
	}
}

static void
_network_widgets_info_box___lambda8_ (NetworkWidgetsInfoBox* self)
{
#line 142 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_update_status (self);
#line 143 "../src/Widgets/InfoBox.vala"
	g_signal_emit (self, network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL], 0);
#line 936 "InfoBox.c"
}

static void
__network_widgets_info_box___lambda8__nm_device_state_changed (NMDevice* _sender,
                                                               guint new_state,
                                                               guint old_state,
                                                               guint reason,
                                                               gpointer self)
{
#line 141 "../src/Widgets/InfoBox.vala"
	_network_widgets_info_box___lambda8_ ((NetworkWidgetsInfoBox*) self);
#line 948 "InfoBox.c"
}

static GObject *
network_widgets_info_box_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsInfoBox * self;
	GtkImage* sent_head = NULL;
	GtkImage* _tmp0_;
	GtkLabel* _tmp1_;
	GtkGrid* sent_grid = NULL;
	gchar* _tmp2_;
	GtkGrid* _tmp3_ = NULL;
	GtkGrid* _tmp4_;
	GtkImage* _tmp5_;
	GtkGrid* _tmp6_;
	GtkLabel* _tmp7_;
	GtkImage* received_head = NULL;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkGrid* received_grid = NULL;
	gchar* _tmp10_;
	GtkGrid* _tmp11_ = NULL;
	GtkGrid* _tmp12_;
	GtkImage* _tmp13_;
	GtkGrid* _tmp14_;
	GtkLabel* _tmp15_;
	GtkGrid* send_receive_grid = NULL;
	GtkGrid* _tmp16_ = NULL;
	GtkGrid* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkLabel* ip4address_head = NULL;
	GtkLabel* _tmp21_ = NULL;
	GtkLabel* _tmp22_ = NULL;
	GtkLabel* _tmp23_ = NULL;
	GtkLabel* _tmp24_ = NULL;
	GtkLabel* mask_head = NULL;
	GtkLabel* _tmp25_ = NULL;
	GtkLabel* _tmp26_ = NULL;
	GtkLabel* router_head = NULL;
	GtkLabel* _tmp27_ = NULL;
	GtkLabel* _tmp28_ = NULL;
	GtkLabel* dns_head = NULL;
	GtkLabel* _tmp29_ = NULL;
	GtkLabel* _tmp30_ = NULL;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkLabel* _tmp41_;
	GtkLabel* _tmp42_;
	GtkLabel* _tmp43_;
	GtkLabel* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkGrid* _tmp50_;
	GtkLabel* _tmp51_;
	NMDevice* _tmp52_;
#line 45 "../src/Widgets/InfoBox.vala"
	parent_class = G_OBJECT_CLASS (network_widgets_info_box_parent_class);
#line 45 "../src/Widgets/InfoBox.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 45 "../src/Widgets/InfoBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
#line 46 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
#line 47 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
#line 49 "../src/Widgets/InfoBox.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("go-up-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 49 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp0_);
#line 49 "../src/Widgets/InfoBox.vala"
	sent_head = _tmp0_;
#line 50 "../src/Widgets/InfoBox.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
#line 50 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp1_);
#line 50 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->sent);
#line 50 "../src/Widgets/InfoBox.vala"
	self->priv->sent = _tmp1_;
#line 52 "../src/Widgets/InfoBox.vala"
	_tmp2_ = g_strdup (_ ("Sent"));
#line 52 "../src/Widgets/InfoBox.vala"
	_tmp3_ = (GtkGrid*) gtk_grid_new ();
#line 52 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_column_spacing (_tmp3_, 12);
#line 52 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _tmp2_);
#line 52 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp2_);
#line 52 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp3_);
#line 52 "../src/Widgets/InfoBox.vala"
	sent_grid = _tmp3_;
#line 56 "../src/Widgets/InfoBox.vala"
	_tmp4_ = sent_grid;
#line 56 "../src/Widgets/InfoBox.vala"
	_tmp5_ = sent_head;
#line 56 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 57 "../src/Widgets/InfoBox.vala"
	_tmp6_ = sent_grid;
#line 57 "../src/Widgets/InfoBox.vala"
	_tmp7_ = self->priv->sent;
#line 57 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 59 "../src/Widgets/InfoBox.vala"
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("go-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 59 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp8_);
#line 59 "../src/Widgets/InfoBox.vala"
	received_head = _tmp8_;
#line 60 "../src/Widgets/InfoBox.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 60 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp9_);
#line 60 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->received);
#line 60 "../src/Widgets/InfoBox.vala"
	self->priv->received = _tmp9_;
#line 62 "../src/Widgets/InfoBox.vala"
	_tmp10_ = g_strdup (_ ("Received"));
#line 62 "../src/Widgets/InfoBox.vala"
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
#line 62 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_column_spacing (_tmp11_, 12);
#line 62 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp10_);
#line 62 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp10_);
#line 62 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp11_);
#line 62 "../src/Widgets/InfoBox.vala"
	received_grid = _tmp11_;
#line 66 "../src/Widgets/InfoBox.vala"
	_tmp12_ = received_grid;
#line 66 "../src/Widgets/InfoBox.vala"
	_tmp13_ = received_head;
#line 66 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 67 "../src/Widgets/InfoBox.vala"
	_tmp14_ = received_grid;
#line 67 "../src/Widgets/InfoBox.vala"
	_tmp15_ = self->priv->received;
#line 67 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 69 "../src/Widgets/InfoBox.vala"
	_tmp16_ = (GtkGrid*) gtk_grid_new ();
#line 69 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_CENTER);
#line 69 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_column_spacing (_tmp16_, 12);
#line 69 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp16_, 12);
#line 69 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp16_);
#line 69 "../src/Widgets/InfoBox.vala"
	send_receive_grid = _tmp16_;
#line 74 "../src/Widgets/InfoBox.vala"
	_tmp17_ = send_receive_grid;
#line 74 "../src/Widgets/InfoBox.vala"
	_tmp18_ = sent_grid;
#line 74 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 75 "../src/Widgets/InfoBox.vala"
	_tmp19_ = send_receive_grid;
#line 75 "../src/Widgets/InfoBox.vala"
	_tmp20_ = received_grid;
#line 75 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 77 "../src/Widgets/InfoBox.vala"
	_tmp21_ = (GtkLabel*) gtk_label_new (_ ("IP Address:"));
#line 77 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_END);
#line 77 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp21_);
#line 77 "../src/Widgets/InfoBox.vala"
	ip4address_head = _tmp21_;
#line 81 "../src/Widgets/InfoBox.vala"
	_tmp22_ = (GtkLabel*) gtk_label_new (NULL);
#line 81 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp22_, TRUE);
#line 81 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp22_, (gfloat) 0);
#line 81 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp22_);
#line 81 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip4address);
#line 81 "../src/Widgets/InfoBox.vala"
	self->priv->ip4address = _tmp22_;
#line 86 "../src/Widgets/InfoBox.vala"
	_tmp23_ = (GtkLabel*) gtk_label_new (_ ("IPv6 Address:"));
#line 86 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp23_, TRUE);
#line 86 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_END);
#line 86 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp23_);
#line 86 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip6address_head);
#line 86 "../src/Widgets/InfoBox.vala"
	self->priv->ip6address_head = _tmp23_;
#line 91 "../src/Widgets/InfoBox.vala"
	_tmp24_ = (GtkLabel*) gtk_label_new (NULL);
#line 91 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp24_, TRUE);
#line 91 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp24_, TRUE);
#line 91 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp24_, (gfloat) 0);
#line 91 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp24_);
#line 91 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip6address);
#line 91 "../src/Widgets/InfoBox.vala"
	self->priv->ip6address = _tmp24_;
#line 97 "../src/Widgets/InfoBox.vala"
	_tmp25_ = (GtkLabel*) gtk_label_new (_ ("Subnet mask:"));
#line 97 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_END);
#line 97 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp25_);
#line 97 "../src/Widgets/InfoBox.vala"
	mask_head = _tmp25_;
#line 101 "../src/Widgets/InfoBox.vala"
	_tmp26_ = (GtkLabel*) gtk_label_new (NULL);
#line 101 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp26_, TRUE);
#line 101 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp26_, (gfloat) 0);
#line 101 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp26_);
#line 101 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->mask);
#line 101 "../src/Widgets/InfoBox.vala"
	self->priv->mask = _tmp26_;
#line 106 "../src/Widgets/InfoBox.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_ ("Router:"));
#line 106 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_END);
#line 106 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp27_);
#line 106 "../src/Widgets/InfoBox.vala"
	router_head = _tmp27_;
#line 110 "../src/Widgets/InfoBox.vala"
	_tmp28_ = (GtkLabel*) gtk_label_new (NULL);
#line 110 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp28_, TRUE);
#line 110 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp28_, (gfloat) 0);
#line 110 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp28_);
#line 110 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->router);
#line 110 "../src/Widgets/InfoBox.vala"
	self->priv->router = _tmp28_;
#line 115 "../src/Widgets/InfoBox.vala"
	_tmp29_ = (GtkLabel*) gtk_label_new (_ ("DNS:"));
#line 115 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_END);
#line 115 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp29_);
#line 115 "../src/Widgets/InfoBox.vala"
	dns_head = _tmp29_;
#line 119 "../src/Widgets/InfoBox.vala"
	_tmp30_ = (GtkLabel*) gtk_label_new (NULL);
#line 119 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp30_, TRUE);
#line 119 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp30_, (gfloat) 0);
#line 119 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp30_);
#line 119 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->dns);
#line 119 "../src/Widgets/InfoBox.vala"
	self->priv->dns = _tmp30_;
#line 124 "../src/Widgets/InfoBox.vala"
	_tmp31_ = ip4address_head;
#line 124 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp31_, 0, 0, 1, 1);
#line 125 "../src/Widgets/InfoBox.vala"
	_tmp32_ = self->priv->ip4address;
#line 125 "../src/Widgets/InfoBox.vala"
	_tmp33_ = ip4address_head;
#line 125 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp32_, (GtkWidget*) _tmp33_, GTK_POS_RIGHT, 1, 1);
#line 127 "../src/Widgets/InfoBox.vala"
	_tmp34_ = self->priv->ip6address_head;
#line 127 "../src/Widgets/InfoBox.vala"
	_tmp35_ = ip4address_head;
#line 127 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp34_, (GtkWidget*) _tmp35_, GTK_POS_BOTTOM, 1, 1);
#line 128 "../src/Widgets/InfoBox.vala"
	_tmp36_ = self->priv->ip6address;
#line 128 "../src/Widgets/InfoBox.vala"
	_tmp37_ = self->priv->ip6address_head;
#line 128 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp36_, (GtkWidget*) _tmp37_, GTK_POS_RIGHT, 1, 1);
#line 130 "../src/Widgets/InfoBox.vala"
	_tmp38_ = mask_head;
#line 130 "../src/Widgets/InfoBox.vala"
	_tmp39_ = self->priv->ip6address_head;
#line 130 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp38_, (GtkWidget*) _tmp39_, GTK_POS_BOTTOM, 1, 1);
#line 131 "../src/Widgets/InfoBox.vala"
	_tmp40_ = self->priv->mask;
#line 131 "../src/Widgets/InfoBox.vala"
	_tmp41_ = mask_head;
#line 131 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp40_, (GtkWidget*) _tmp41_, GTK_POS_RIGHT, 1, 1);
#line 133 "../src/Widgets/InfoBox.vala"
	_tmp42_ = router_head;
#line 133 "../src/Widgets/InfoBox.vala"
	_tmp43_ = mask_head;
#line 133 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp42_, (GtkWidget*) _tmp43_, GTK_POS_BOTTOM, 1, 1);
#line 134 "../src/Widgets/InfoBox.vala"
	_tmp44_ = self->priv->router;
#line 134 "../src/Widgets/InfoBox.vala"
	_tmp45_ = router_head;
#line 134 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp44_, (GtkWidget*) _tmp45_, GTK_POS_RIGHT, 1, 1);
#line 136 "../src/Widgets/InfoBox.vala"
	_tmp46_ = dns_head;
#line 136 "../src/Widgets/InfoBox.vala"
	_tmp47_ = router_head;
#line 136 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp46_, (GtkWidget*) _tmp47_, GTK_POS_BOTTOM, 1, 1);
#line 137 "../src/Widgets/InfoBox.vala"
	_tmp48_ = self->priv->dns;
#line 137 "../src/Widgets/InfoBox.vala"
	_tmp49_ = dns_head;
#line 137 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp48_, (GtkWidget*) _tmp49_, GTK_POS_RIGHT, 1, 1);
#line 139 "../src/Widgets/InfoBox.vala"
	_tmp50_ = send_receive_grid;
#line 139 "../src/Widgets/InfoBox.vala"
	_tmp51_ = dns_head;
#line 139 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp50_, (GtkWidget*) _tmp51_, GTK_POS_BOTTOM, 4, 1);
#line 141 "../src/Widgets/InfoBox.vala"
	_tmp52_ = self->priv->_device;
#line 141 "../src/Widgets/InfoBox.vala"
	g_signal_connect_object (_tmp52_, "state-changed", (GCallback) __network_widgets_info_box___lambda8__nm_device_state_changed, self, 0);
#line 146 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_update_status (self);
#line 147 "../src/Widgets/InfoBox.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (dns_head);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (router_head);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (mask_head);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (ip4address_head);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (send_receive_grid);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (received_grid);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (received_head);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (sent_grid);
#line 45 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (sent_head);
#line 45 "../src/Widgets/InfoBox.vala"
	return obj;
#line 1333 "InfoBox.c"
}

static void
network_widgets_info_box_class_init (NetworkWidgetsInfoBoxClass * klass,
                                     gpointer klass_data)
{
#line 21 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/InfoBox.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsInfoBox_private_offset);
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_widgets_info_box_get_property;
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_widgets_info_box_set_property;
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (klass)->constructor = network_widgets_info_box_constructor;
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (klass)->finalize = network_widgets_info_box_finalize;
#line 21 "../src/Widgets/InfoBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", nm_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/InfoBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY] = g_param_spec_object ("owner", "owner", "owner", NETWORK_WIDGETS_TYPE_DEVICE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL] = g_signal_new ("update-sidebar", NETWORK_WIDGETS_TYPE_INFO_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NETWORK_WIDGETS_TYPE_DEVICE_ITEM);
#line 21 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL] = g_signal_new ("info-changed", NETWORK_WIDGETS_TYPE_INFO_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1360 "InfoBox.c"
}

static void
network_widgets_info_box_instance_init (NetworkWidgetsInfoBox * self,
                                        gpointer klass)
{
#line 21 "../src/Widgets/InfoBox.vala"
	self->priv = network_widgets_info_box_get_instance_private (self);
#line 1369 "InfoBox.c"
}

static void
network_widgets_info_box_finalize (GObject * obj)
{
	NetworkWidgetsInfoBox * self;
#line 21 "../src/Widgets/InfoBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
#line 24 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->_device);
#line 25 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->_owner);
#line 27 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip4address);
#line 28 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip6address);
#line 29 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->mask);
#line 30 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->router);
#line 31 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->dns);
#line 32 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->sent);
#line 33 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->received);
#line 35 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip6address_head);
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (network_widgets_info_box_parent_class)->finalize (obj);
#line 1400 "InfoBox.c"
}

static GType
network_widgets_info_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsInfoBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_info_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsInfoBox), 0, (GInstanceInitFunc) network_widgets_info_box_instance_init, NULL };
	GType network_widgets_info_box_type_id;
	network_widgets_info_box_type_id = g_type_register_static (gtk_grid_get_type (), "NetworkWidgetsInfoBox", &g_define_type_info, 0);
	NetworkWidgetsInfoBox_private_offset = g_type_add_instance_private (network_widgets_info_box_type_id, sizeof (NetworkWidgetsInfoBoxPrivate));
	return network_widgets_info_box_type_id;
}

GType
network_widgets_info_box_get_type (void)
{
	static volatile gsize network_widgets_info_box_type_id__once = 0;
	if (g_once_init_enter (&network_widgets_info_box_type_id__once)) {
		GType network_widgets_info_box_type_id;
		network_widgets_info_box_type_id = network_widgets_info_box_get_type_once ();
		g_once_init_leave (&network_widgets_info_box_type_id__once, network_widgets_info_box_type_id);
	}
	return network_widgets_info_box_type_id__once;
}

static void
_vala_network_widgets_info_box_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
#line 21 "../src/Widgets/InfoBox.vala"
	switch (property_id) {
#line 21 "../src/Widgets/InfoBox.vala"
		case NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY:
#line 21 "../src/Widgets/InfoBox.vala"
		g_value_set_object (value, network_widgets_info_box_get_device (self));
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 21 "../src/Widgets/InfoBox.vala"
		case NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY:
#line 21 "../src/Widgets/InfoBox.vala"
		g_value_set_object (value, network_widgets_info_box_get_owner (self));
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 1447 "InfoBox.c"
		default:
#line 21 "../src/Widgets/InfoBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 1453 "InfoBox.c"
	}
}

static void
_vala_network_widgets_info_box_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
#line 21 "../src/Widgets/InfoBox.vala"
	switch (property_id) {
#line 21 "../src/Widgets/InfoBox.vala"
		case NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY:
#line 21 "../src/Widgets/InfoBox.vala"
		network_widgets_info_box_set_device (self, g_value_get_object (value));
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 21 "../src/Widgets/InfoBox.vala"
		case NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY:
#line 21 "../src/Widgets/InfoBox.vala"
		network_widgets_info_box_set_owner (self, g_value_get_object (value));
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 1479 "InfoBox.c"
		default:
#line 21 "../src/Widgets/InfoBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 1485 "InfoBox.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

