/* Page.c generated by valac 0.56.14, the Vala compiler
 * generated from Page.vala, do not modify */

/*
 * Copyright 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 *              xapantu
 */

#include "networking.h"
#include <NetworkManager.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <glib-object.h>

#define NETWORK_UNKNOWN_STR _ ("Unknown")

enum  {
	NETWORK_WIDGETS_PAGE_0_PROPERTY,
	NETWORK_WIDGETS_PAGE_STATE_PROPERTY,
	NETWORK_WIDGETS_PAGE_DEVICE_PROPERTY,
	NETWORK_WIDGETS_PAGE_NUM_PROPERTIES
};
static GParamSpec* network_widgets_page_properties[NETWORK_WIDGETS_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))

struct _NetworkWidgetsPagePrivate {
	NMDeviceState _state;
	NMDevice* _device;
	gboolean switch_updating;
};

static gint NetworkWidgetsPage_private_offset;
static gpointer network_widgets_page_parent_class = NULL;

static void network_widgets_page_real_update (NetworkWidgetsPage* self);
static void network_widgets_page_real_update_name (NetworkWidgetsPage* self,
                                            gint count);
static void network_widgets_page_real_update_switch (NetworkWidgetsPage* self);
static void network_widgets_page_real_control_switch_activated (NetworkWidgetsPage* self);
static GObject * network_widgets_page_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _network_widgets_page_control_switch_activated_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
static void _network_widgets_page_update_network_widgets_info_box_info_changed (NetworkWidgetsInfoBox* _sender,
                                                                         gpointer self);
static void network_widgets_page_finalize (GObject * obj);
static GType network_widgets_page_get_type_once (void);
static void _vala_network_widgets_page_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_network_widgets_page_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
network_widgets_page_get_instance_private (NetworkWidgetsPage* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsPage_private_offset);
}

static void
network_widgets_page_real_update (NetworkWidgetsPage* self)
{
	NetworkWidgetsInfoBox* _tmp0_;
#line 56 "../src/Widgets/Page.vala"
	_tmp0_ = self->info_box;
#line 56 "../src/Widgets/Page.vala"
	if (_tmp0_ != NULL) {
#line 98 "Page.c"
		gchar* sent_bytes = NULL;
		gchar* received_bytes = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		NetworkWidgetsInfoBox* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 58 "../src/Widgets/Page.vala"
		network_widgets_page_get_activity_information (self, &_tmp1_, &_tmp2_);
#line 58 "../src/Widgets/Page.vala"
		_g_free0 (sent_bytes);
#line 58 "../src/Widgets/Page.vala"
		sent_bytes = _tmp1_;
#line 58 "../src/Widgets/Page.vala"
		_g_free0 (received_bytes);
#line 58 "../src/Widgets/Page.vala"
		received_bytes = _tmp2_;
#line 59 "../src/Widgets/Page.vala"
		_tmp3_ = self->info_box;
#line 59 "../src/Widgets/Page.vala"
		_tmp4_ = sent_bytes;
#line 59 "../src/Widgets/Page.vala"
		_tmp5_ = received_bytes;
#line 59 "../src/Widgets/Page.vala"
		network_widgets_info_box_update_activity (_tmp3_, _tmp4_, _tmp5_);
#line 56 "../src/Widgets/Page.vala"
		_g_free0 (received_bytes);
#line 56 "../src/Widgets/Page.vala"
		_g_free0 (sent_bytes);
#line 128 "Page.c"
	}
#line 62 "../src/Widgets/Page.vala"
	network_widgets_page_update_switch (self);
#line 132 "Page.c"
}

void
network_widgets_page_update (NetworkWidgetsPage* self)
{
	NetworkWidgetsPageClass* _klass_;
#line 55 "../src/Widgets/Page.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Widgets/Page.vala"
	_klass_ = NETWORK_WIDGETS_PAGE_GET_CLASS (self);
#line 55 "../src/Widgets/Page.vala"
	if (_klass_->update) {
#line 55 "../src/Widgets/Page.vala"
		_klass_->update (self);
#line 147 "Page.c"
	}
}

static void
network_widgets_page_real_update_name (NetworkWidgetsPage* self,
                                       gint count)
{
	NMDevice* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 66 "../src/Widgets/Page.vala"
	_tmp0_ = self->priv->_device;
#line 66 "../src/Widgets/Page.vala"
	_tmp1_ = nm_device_get_description (_tmp0_);
#line 66 "../src/Widgets/Page.vala"
	_tmp2_ = g_strdup_printf (_ ("Unknown type: %s "), _tmp1_);
#line 66 "../src/Widgets/Page.vala"
	_tmp3_ = _tmp2_;
#line 66 "../src/Widgets/Page.vala"
	granite_simple_settings_page_set_title ((GraniteSimpleSettingsPage*) self, _tmp3_);
#line 66 "../src/Widgets/Page.vala"
	_g_free0 (_tmp3_);
#line 171 "Page.c"
}

void
network_widgets_page_update_name (NetworkWidgetsPage* self,
                                  gint count)
{
	NetworkWidgetsPageClass* _klass_;
#line 65 "../src/Widgets/Page.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/Widgets/Page.vala"
	_klass_ = NETWORK_WIDGETS_PAGE_GET_CLASS (self);
#line 65 "../src/Widgets/Page.vala"
	if (_klass_->update_name) {
#line 65 "../src/Widgets/Page.vala"
		_klass_->update_name (self, count);
#line 187 "Page.c"
	}
}

static void
network_widgets_page_real_update_switch (NetworkWidgetsPage* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	NMDevice* _tmp2_;
	NMDeviceState _tmp3_;
	NMDeviceState _tmp4_;
#line 70 "../src/Widgets/Page.vala"
	_tmp0_ = granite_simple_settings_page_get_activatable ((GraniteSimpleSettingsPage*) self);
#line 70 "../src/Widgets/Page.vala"
	_tmp1_ = _tmp0_;
#line 70 "../src/Widgets/Page.vala"
	if (!_tmp1_) {
#line 71 "../src/Widgets/Page.vala"
		return;
#line 207 "Page.c"
	}
#line 73 "../src/Widgets/Page.vala"
	self->priv->switch_updating = TRUE;
#line 74 "../src/Widgets/Page.vala"
	_tmp2_ = self->priv->_device;
#line 74 "../src/Widgets/Page.vala"
	_tmp3_ = nm_device_get_state (_tmp2_);
#line 74 "../src/Widgets/Page.vala"
	_tmp4_ = _tmp3_;
#line 74 "../src/Widgets/Page.vala"
	switch (_tmp4_) {
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_UNKNOWN:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_UNMANAGED:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_UNAVAILABLE:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_FAILED:
#line 227 "Page.c"
		{
			GtkSwitch* _tmp5_;
			GtkSwitch* _tmp6_;
			GtkSwitch* _tmp7_;
			GtkSwitch* _tmp8_;
#line 79 "../src/Widgets/Page.vala"
			_tmp5_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 79 "../src/Widgets/Page.vala"
			_tmp6_ = _tmp5_;
#line 79 "../src/Widgets/Page.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 80 "../src/Widgets/Page.vala"
			_tmp7_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 80 "../src/Widgets/Page.vala"
			_tmp8_ = _tmp7_;
#line 80 "../src/Widgets/Page.vala"
			gtk_switch_set_active (_tmp8_, FALSE);
#line 81 "../src/Widgets/Page.vala"
			break;
#line 247 "Page.c"
		}
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_DISCONNECTED:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_DEACTIVATING:
#line 253 "Page.c"
		{
			GtkSwitch* _tmp9_;
			GtkSwitch* _tmp10_;
			GtkSwitch* _tmp11_;
			GtkSwitch* _tmp12_;
#line 84 "../src/Widgets/Page.vala"
			_tmp9_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 84 "../src/Widgets/Page.vala"
			_tmp10_ = _tmp9_;
#line 84 "../src/Widgets/Page.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
#line 85 "../src/Widgets/Page.vala"
			_tmp11_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 85 "../src/Widgets/Page.vala"
			_tmp12_ = _tmp11_;
#line 85 "../src/Widgets/Page.vala"
			gtk_switch_set_active (_tmp12_, FALSE);
#line 86 "../src/Widgets/Page.vala"
			self->priv->switch_updating = FALSE;
#line 87 "../src/Widgets/Page.vala"
			break;
#line 275 "Page.c"
		}
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_PREPARE:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_CONFIG:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_NEED_AUTH:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_IP_CONFIG:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_IP_CHECK:
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_SECONDARIES:
#line 289 "Page.c"
		{
			GtkSwitch* _tmp13_;
			GtkSwitch* _tmp14_;
			GtkSwitch* _tmp15_;
			GtkSwitch* _tmp16_;
#line 94 "../src/Widgets/Page.vala"
			_tmp13_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 94 "../src/Widgets/Page.vala"
			_tmp14_ = _tmp13_;
#line 94 "../src/Widgets/Page.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
#line 95 "../src/Widgets/Page.vala"
			_tmp15_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 95 "../src/Widgets/Page.vala"
			_tmp16_ = _tmp15_;
#line 95 "../src/Widgets/Page.vala"
			gtk_switch_set_active (_tmp16_, TRUE);
#line 96 "../src/Widgets/Page.vala"
			break;
#line 309 "Page.c"
		}
#line 74 "../src/Widgets/Page.vala"
		case NM_DEVICE_STATE_ACTIVATED:
#line 313 "Page.c"
		{
			GtkSwitch* _tmp17_;
			GtkSwitch* _tmp18_;
			GtkSwitch* _tmp19_;
			GtkSwitch* _tmp20_;
#line 98 "../src/Widgets/Page.vala"
			_tmp17_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 98 "../src/Widgets/Page.vala"
			_tmp18_ = _tmp17_;
#line 98 "../src/Widgets/Page.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, TRUE);
#line 99 "../src/Widgets/Page.vala"
			_tmp19_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 99 "../src/Widgets/Page.vala"
			_tmp20_ = _tmp19_;
#line 99 "../src/Widgets/Page.vala"
			gtk_switch_set_active (_tmp20_, TRUE);
#line 100 "../src/Widgets/Page.vala"
			self->priv->switch_updating = FALSE;
#line 101 "../src/Widgets/Page.vala"
			break;
#line 335 "Page.c"
		}
		default:
		{
#line 103 "../src/Widgets/Page.vala"
			break;
#line 341 "Page.c"
		}
	}
}

void
network_widgets_page_update_switch (NetworkWidgetsPage* self)
{
	NetworkWidgetsPageClass* _klass_;
#line 69 "../src/Widgets/Page.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/Widgets/Page.vala"
	_klass_ = NETWORK_WIDGETS_PAGE_GET_CLASS (self);
#line 69 "../src/Widgets/Page.vala"
	if (_klass_->update_switch) {
#line 69 "../src/Widgets/Page.vala"
		_klass_->update_switch (self);
#line 358 "Page.c"
	}
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 130 "../src/Widgets/Page.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 367 "Page.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5905 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5906 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5906 "glib-2.0.vapi"
	return result;
#line 380 "Page.c"
}

static void
network_widgets_page_real_control_switch_activated (NetworkWidgetsPage* self)
{
	gboolean _tmp0_ = FALSE;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GError* _inner_error0_ = NULL;
#line 108 "../src/Widgets/Page.vala"
	if (self->priv->switch_updating) {
#line 109 "../src/Widgets/Page.vala"
		return;
#line 396 "Page.c"
	}
#line 112 "../src/Widgets/Page.vala"
	_tmp1_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 112 "../src/Widgets/Page.vala"
	_tmp2_ = _tmp1_;
#line 112 "../src/Widgets/Page.vala"
	_tmp3_ = gtk_switch_get_active (_tmp2_);
#line 112 "../src/Widgets/Page.vala"
	_tmp4_ = _tmp3_;
#line 112 "../src/Widgets/Page.vala"
	if (!_tmp4_) {
#line 408 "Page.c"
		NMDevice* _tmp5_;
#line 112 "../src/Widgets/Page.vala"
		_tmp5_ = self->priv->_device;
#line 112 "../src/Widgets/Page.vala"
		_tmp0_ = nm_device_get_state (_tmp5_) == NM_DEVICE_STATE_ACTIVATED;
#line 414 "Page.c"
	} else {
#line 112 "../src/Widgets/Page.vala"
		_tmp0_ = FALSE;
#line 418 "Page.c"
	}
#line 112 "../src/Widgets/Page.vala"
	if (_tmp0_) {
#line 422 "Page.c"
		{
			NMDevice* _tmp6_;
#line 114 "../src/Widgets/Page.vala"
			_tmp6_ = self->priv->_device;
#line 114 "../src/Widgets/Page.vala"
			nm_device_disconnect (_tmp6_, NULL, &_inner_error0_);
#line 114 "../src/Widgets/Page.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 431 "Page.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GtkSwitch* _tmp7_;
			GtkSwitch* _tmp8_;
			GraniteMessageDialog* message_dialog = NULL;
			GraniteMessageDialog* _tmp9_;
			GraniteMessageDialog* _tmp10_;
			GError* _tmp11_;
			const gchar* _tmp12_;
			GraniteMessageDialog* _tmp13_;
			GraniteMessageDialog* _tmp14_;
#line 113 "../src/Widgets/Page.vala"
			e = _inner_error0_;
#line 113 "../src/Widgets/Page.vala"
			_inner_error0_ = NULL;
#line 116 "../src/Widgets/Page.vala"
			_tmp7_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 116 "../src/Widgets/Page.vala"
			_tmp8_ = _tmp7_;
#line 116 "../src/Widgets/Page.vala"
			gtk_switch_set_active (_tmp8_, TRUE);
#line 118 "../src/Widgets/Page.vala"
			_tmp9_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Failed To Disconnect"), _ ("Unable to disconnect from the currently connected network"), "network-error", GTK_BUTTONS_CLOSE);
#line 118 "../src/Widgets/Page.vala"
			g_object_ref_sink (_tmp9_);
#line 118 "../src/Widgets/Page.vala"
			message_dialog = _tmp9_;
#line 124 "../src/Widgets/Page.vala"
			_tmp10_ = message_dialog;
#line 124 "../src/Widgets/Page.vala"
			_tmp11_ = e;
#line 124 "../src/Widgets/Page.vala"
			_tmp12_ = _tmp11_->message;
#line 124 "../src/Widgets/Page.vala"
			granite_message_dialog_show_error_details (_tmp10_, _tmp12_);
#line 125 "../src/Widgets/Page.vala"
			_tmp13_ = message_dialog;
#line 125 "../src/Widgets/Page.vala"
			gtk_dialog_run ((GtkDialog*) _tmp13_);
#line 126 "../src/Widgets/Page.vala"
			_tmp14_ = message_dialog;
#line 126 "../src/Widgets/Page.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp14_);
#line 113 "../src/Widgets/Page.vala"
			_g_object_unref0 (message_dialog);
#line 113 "../src/Widgets/Page.vala"
			_g_error_free0 (e);
#line 484 "Page.c"
		}
		__finally0:
#line 113 "../src/Widgets/Page.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/Widgets/Page.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "../src/Widgets/Page.vala"
			g_clear_error (&_inner_error0_);
#line 113 "../src/Widgets/Page.vala"
			return;
#line 495 "Page.c"
		}
	} else {
		gboolean _tmp15_ = FALSE;
		GtkSwitch* _tmp16_;
		GtkSwitch* _tmp17_;
		gboolean _tmp18_;
		gboolean _tmp19_;
#line 128 "../src/Widgets/Page.vala"
		_tmp16_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 128 "../src/Widgets/Page.vala"
		_tmp17_ = _tmp16_;
#line 128 "../src/Widgets/Page.vala"
		_tmp18_ = gtk_switch_get_active (_tmp17_);
#line 128 "../src/Widgets/Page.vala"
		_tmp19_ = _tmp18_;
#line 128 "../src/Widgets/Page.vala"
		if (_tmp19_) {
#line 513 "Page.c"
			NMDevice* _tmp20_;
#line 128 "../src/Widgets/Page.vala"
			_tmp20_ = self->priv->_device;
#line 128 "../src/Widgets/Page.vala"
			_tmp15_ = nm_device_get_state (_tmp20_) == NM_DEVICE_STATE_DISCONNECTED;
#line 519 "Page.c"
		} else {
#line 128 "../src/Widgets/Page.vala"
			_tmp15_ = FALSE;
#line 523 "Page.c"
		}
#line 128 "../src/Widgets/Page.vala"
		if (_tmp15_) {
#line 527 "Page.c"
			NMConnection* connection = NULL;
			NMConnection* _tmp21_;
			GPtrArray* remote_array = NULL;
			NMDevice* _tmp22_;
			GPtrArray* _tmp23_;
			GPtrArray* _tmp24_;
			gboolean _tmp25_ = FALSE;
			GPtrArray* _tmp26_;
#line 129 "../src/Widgets/Page.vala"
			_tmp21_ = nm_simple_connection_new ();
#line 129 "../src/Widgets/Page.vala"
			connection = _tmp21_;
#line 130 "../src/Widgets/Page.vala"
			_tmp22_ = self->priv->_device;
#line 130 "../src/Widgets/Page.vala"
			_tmp23_ = nm_device_get_available_connections (_tmp22_);
#line 130 "../src/Widgets/Page.vala"
			_tmp24_ = _g_ptr_array_ref0 (_tmp23_);
#line 130 "../src/Widgets/Page.vala"
			remote_array = _tmp24_;
#line 131 "../src/Widgets/Page.vala"
			_tmp26_ = remote_array;
#line 131 "../src/Widgets/Page.vala"
			if (_tmp26_ != NULL) {
#line 552 "Page.c"
				GPtrArray* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
#line 131 "../src/Widgets/Page.vala"
				_tmp27_ = remote_array;
#line 131 "../src/Widgets/Page.vala"
				_tmp28_ = vala_g_ptr_array_get_length (_tmp27_);
#line 131 "../src/Widgets/Page.vala"
				_tmp29_ = _tmp28_;
#line 131 "../src/Widgets/Page.vala"
				_tmp25_ = _tmp29_ > 0;
#line 564 "Page.c"
			} else {
#line 131 "../src/Widgets/Page.vala"
				_tmp25_ = FALSE;
#line 568 "Page.c"
			}
#line 131 "../src/Widgets/Page.vala"
			if (_tmp25_) {
#line 572 "Page.c"
				NMConnection* _tmp30_;
				GPtrArray* _tmp31_;
				gconstpointer _tmp32_;
				const gchar* _tmp33_;
				NetworkNetworkManager* network_manager = NULL;
				NetworkNetworkManager* _tmp34_;
				NetworkNetworkManager* _tmp35_;
				NMClient* _tmp36_;
				NMClient* _tmp37_;
				NMConnection* _tmp38_;
				NMDevice* _tmp39_;
#line 132 "../src/Widgets/Page.vala"
				_tmp30_ = connection;
#line 132 "../src/Widgets/Page.vala"
				_tmp31_ = remote_array;
#line 132 "../src/Widgets/Page.vala"
				_tmp32_ = g_ptr_array_index (_tmp31_, (guint) 0);
#line 132 "../src/Widgets/Page.vala"
				_tmp33_ = nm_connection_get_path ((NMConnection*) ((NMRemoteConnection*) _tmp32_));
#line 132 "../src/Widgets/Page.vala"
				nm_connection_set_path (_tmp30_, _tmp33_);
#line 133 "../src/Widgets/Page.vala"
				_tmp34_ = network_network_manager_get_default ();
#line 133 "../src/Widgets/Page.vala"
				network_manager = _tmp34_;
#line 134 "../src/Widgets/Page.vala"
				_tmp35_ = network_manager;
#line 134 "../src/Widgets/Page.vala"
				_tmp36_ = network_network_manager_get_client (_tmp35_);
#line 134 "../src/Widgets/Page.vala"
				_tmp37_ = _tmp36_;
#line 134 "../src/Widgets/Page.vala"
				_tmp38_ = connection;
#line 134 "../src/Widgets/Page.vala"
				_tmp39_ = self->priv->_device;
#line 134 "../src/Widgets/Page.vala"
				nm_client_activate_connection_async (_tmp37_, _tmp38_, _tmp39_, NULL, NULL, NULL, NULL);
#line 610 "Page.c"
			}
#line 128 "../src/Widgets/Page.vala"
			_g_ptr_array_unref0 (remote_array);
#line 128 "../src/Widgets/Page.vala"
			_g_object_unref0 (connection);
#line 616 "Page.c"
		}
	}
}

void
network_widgets_page_control_switch_activated (NetworkWidgetsPage* self)
{
	NetworkWidgetsPageClass* _klass_;
#line 107 "../src/Widgets/Page.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/Widgets/Page.vala"
	_klass_ = NETWORK_WIDGETS_PAGE_GET_CLASS (self);
#line 107 "../src/Widgets/Page.vala"
	if (_klass_->control_switch_activated) {
#line 107 "../src/Widgets/Page.vala"
		_klass_->control_switch_activated (self);
#line 633 "Page.c"
	}
}

static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result;
#line 839 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 840 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, _base);
#line 840 "glib-2.0.vapi"
	return result;
#line 648 "Page.c"
}

void
network_widgets_page_get_activity_information (NetworkWidgetsPage* self,
                                               gchar** sent_bytes,
                                               gchar** received_bytes)
{
	gchar* _vala_sent_bytes = NULL;
	gchar* _vala_received_bytes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* iface = NULL;
	NMDevice* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* tx_bytes_path = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* rx_bytes_path = NULL;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	gboolean _tmp14_;
	GError* _inner_error0_ = NULL;
#line 139 "../src/Widgets/Page.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/Widgets/Page.vala"
	_tmp0_ = g_strdup (NETWORK_UNKNOWN_STR);
#line 140 "../src/Widgets/Page.vala"
	_g_free0 (_vala_sent_bytes);
#line 140 "../src/Widgets/Page.vala"
	_vala_sent_bytes = _tmp0_;
#line 141 "../src/Widgets/Page.vala"
	_tmp1_ = g_strdup (NETWORK_UNKNOWN_STR);
#line 141 "../src/Widgets/Page.vala"
	_g_free0 (_vala_received_bytes);
#line 141 "../src/Widgets/Page.vala"
	_vala_received_bytes = _tmp1_;
#line 143 "../src/Widgets/Page.vala"
	_tmp2_ = self->priv->_device;
#line 143 "../src/Widgets/Page.vala"
	_tmp3_ = nm_device_get_ip_iface (_tmp2_);
#line 143 "../src/Widgets/Page.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 143 "../src/Widgets/Page.vala"
	iface = _tmp4_;
#line 144 "../src/Widgets/Page.vala"
	_tmp5_ = iface;
#line 144 "../src/Widgets/Page.vala"
	if (_tmp5_ == NULL) {
#line 145 "../src/Widgets/Page.vala"
		_g_free0 (iface);
#line 145 "../src/Widgets/Page.vala"
		if (sent_bytes) {
#line 145 "../src/Widgets/Page.vala"
			*sent_bytes = _vala_sent_bytes;
#line 709 "Page.c"
		} else {
#line 145 "../src/Widgets/Page.vala"
			_g_free0 (_vala_sent_bytes);
#line 713 "Page.c"
		}
#line 145 "../src/Widgets/Page.vala"
		if (received_bytes) {
#line 145 "../src/Widgets/Page.vala"
			*received_bytes = _vala_received_bytes;
#line 719 "Page.c"
		} else {
#line 145 "../src/Widgets/Page.vala"
			_g_free0 (_vala_received_bytes);
#line 723 "Page.c"
		}
#line 145 "../src/Widgets/Page.vala"
		return;
#line 727 "Page.c"
	}
#line 147 "../src/Widgets/Page.vala"
	_tmp6_ = iface;
#line 147 "../src/Widgets/Page.vala"
	_tmp7_ = g_build_filename (G_DIR_SEPARATOR_S, "sys", "class", "net", _tmp6_, "statistics", "tx_bytes", NULL);
#line 147 "../src/Widgets/Page.vala"
	tx_bytes_path = _tmp7_;
#line 148 "../src/Widgets/Page.vala"
	_tmp8_ = iface;
#line 148 "../src/Widgets/Page.vala"
	_tmp9_ = g_build_filename (G_DIR_SEPARATOR_S, "sys", "class", "net", _tmp8_, "statistics", "rx_bytes", NULL);
#line 148 "../src/Widgets/Page.vala"
	rx_bytes_path = _tmp9_;
#line 150 "../src/Widgets/Page.vala"
	_tmp11_ = tx_bytes_path;
#line 150 "../src/Widgets/Page.vala"
	_tmp12_ = g_file_new_for_path (_tmp11_);
#line 150 "../src/Widgets/Page.vala"
	_tmp13_ = _tmp12_;
#line 150 "../src/Widgets/Page.vala"
	_tmp14_ = g_file_query_exists (_tmp13_, NULL);
#line 150 "../src/Widgets/Page.vala"
	_g_object_unref0 (_tmp13_);
#line 150 "../src/Widgets/Page.vala"
	if (_tmp14_) {
#line 753 "Page.c"
		const gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 151 "../src/Widgets/Page.vala"
		_tmp15_ = rx_bytes_path;
#line 151 "../src/Widgets/Page.vala"
		_tmp16_ = g_file_new_for_path (_tmp15_);
#line 151 "../src/Widgets/Page.vala"
		_tmp17_ = _tmp16_;
#line 151 "../src/Widgets/Page.vala"
		_tmp10_ = g_file_query_exists (_tmp17_, NULL);
#line 151 "../src/Widgets/Page.vala"
		_g_object_unref0 (_tmp17_);
#line 767 "Page.c"
	} else {
#line 150 "../src/Widgets/Page.vala"
		_tmp10_ = FALSE;
#line 771 "Page.c"
	}
#line 150 "../src/Widgets/Page.vala"
	if (!_tmp10_) {
#line 152 "../src/Widgets/Page.vala"
		_g_free0 (rx_bytes_path);
#line 152 "../src/Widgets/Page.vala"
		_g_free0 (tx_bytes_path);
#line 152 "../src/Widgets/Page.vala"
		_g_free0 (iface);
#line 152 "../src/Widgets/Page.vala"
		if (sent_bytes) {
#line 152 "../src/Widgets/Page.vala"
			*sent_bytes = _vala_sent_bytes;
#line 785 "Page.c"
		} else {
#line 152 "../src/Widgets/Page.vala"
			_g_free0 (_vala_sent_bytes);
#line 789 "Page.c"
		}
#line 152 "../src/Widgets/Page.vala"
		if (received_bytes) {
#line 152 "../src/Widgets/Page.vala"
			*received_bytes = _vala_received_bytes;
#line 795 "Page.c"
		} else {
#line 152 "../src/Widgets/Page.vala"
			_g_free0 (_vala_received_bytes);
#line 799 "Page.c"
		}
#line 152 "../src/Widgets/Page.vala"
		return;
#line 803 "Page.c"
	}
	{
		gchar* tx_bytes = NULL;
		gchar* rx_bytes = NULL;
		const gchar* _tmp18_;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		gchar* _tmp21_ = NULL;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
#line 158 "../src/Widgets/Page.vala"
		_tmp18_ = tx_bytes_path;
#line 158 "../src/Widgets/Page.vala"
		g_file_get_contents (_tmp18_, &_tmp19_, NULL, &_inner_error0_);
#line 158 "../src/Widgets/Page.vala"
		_g_free0 (tx_bytes);
#line 158 "../src/Widgets/Page.vala"
		tx_bytes = _tmp19_;
#line 158 "../src/Widgets/Page.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 158 "../src/Widgets/Page.vala"
			_g_free0 (rx_bytes);
#line 158 "../src/Widgets/Page.vala"
			_g_free0 (tx_bytes);
#line 158 "../src/Widgets/Page.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 832 "Page.c"
				goto __catch0_g_file_error;
			}
#line 158 "../src/Widgets/Page.vala"
			_g_free0 (rx_bytes_path);
#line 158 "../src/Widgets/Page.vala"
			_g_free0 (tx_bytes_path);
#line 158 "../src/Widgets/Page.vala"
			_g_free0 (iface);
#line 158 "../src/Widgets/Page.vala"
			_g_free0 (_vala_sent_bytes);
#line 158 "../src/Widgets/Page.vala"
			_g_free0 (_vala_received_bytes);
#line 158 "../src/Widgets/Page.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 158 "../src/Widgets/Page.vala"
			g_clear_error (&_inner_error0_);
#line 158 "../src/Widgets/Page.vala"
			return;
#line 851 "Page.c"
		}
#line 159 "../src/Widgets/Page.vala"
		_tmp20_ = rx_bytes_path;
#line 159 "../src/Widgets/Page.vala"
		g_file_get_contents (_tmp20_, &_tmp21_, NULL, &_inner_error0_);
#line 159 "../src/Widgets/Page.vala"
		_g_free0 (rx_bytes);
#line 159 "../src/Widgets/Page.vala"
		rx_bytes = _tmp21_;
#line 159 "../src/Widgets/Page.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../src/Widgets/Page.vala"
			_g_free0 (rx_bytes);
#line 159 "../src/Widgets/Page.vala"
			_g_free0 (tx_bytes);
#line 159 "../src/Widgets/Page.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 869 "Page.c"
				goto __catch0_g_file_error;
			}
#line 159 "../src/Widgets/Page.vala"
			_g_free0 (rx_bytes_path);
#line 159 "../src/Widgets/Page.vala"
			_g_free0 (tx_bytes_path);
#line 159 "../src/Widgets/Page.vala"
			_g_free0 (iface);
#line 159 "../src/Widgets/Page.vala"
			_g_free0 (_vala_sent_bytes);
#line 159 "../src/Widgets/Page.vala"
			_g_free0 (_vala_received_bytes);
#line 159 "../src/Widgets/Page.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 159 "../src/Widgets/Page.vala"
			g_clear_error (&_inner_error0_);
#line 159 "../src/Widgets/Page.vala"
			return;
#line 888 "Page.c"
		}
#line 161 "../src/Widgets/Page.vala"
		_tmp22_ = tx_bytes;
#line 161 "../src/Widgets/Page.vala"
		_tmp23_ = g_format_size_full (uint64_parse (_tmp22_, (guint) 0), G_FORMAT_SIZE_DEFAULT);
#line 161 "../src/Widgets/Page.vala"
		_g_free0 (_vala_sent_bytes);
#line 161 "../src/Widgets/Page.vala"
		_vala_sent_bytes = _tmp23_;
#line 162 "../src/Widgets/Page.vala"
		_tmp24_ = rx_bytes;
#line 162 "../src/Widgets/Page.vala"
		_tmp25_ = g_format_size_full (uint64_parse (_tmp24_, (guint) 0), G_FORMAT_SIZE_DEFAULT);
#line 162 "../src/Widgets/Page.vala"
		_g_free0 (_vala_received_bytes);
#line 162 "../src/Widgets/Page.vala"
		_vala_received_bytes = _tmp25_;
#line 155 "../src/Widgets/Page.vala"
		_g_free0 (rx_bytes);
#line 155 "../src/Widgets/Page.vala"
		_g_free0 (tx_bytes);
#line 910 "Page.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp26_;
		const gchar* _tmp27_;
#line 155 "../src/Widgets/Page.vala"
		e = _inner_error0_;
#line 155 "../src/Widgets/Page.vala"
		_inner_error0_ = NULL;
#line 164 "../src/Widgets/Page.vala"
		_tmp26_ = e;
#line 164 "../src/Widgets/Page.vala"
		_tmp27_ = _tmp26_->message;
#line 164 "../src/Widgets/Page.vala"
		g_critical ("Page.vala:164: %s", _tmp27_);
#line 155 "../src/Widgets/Page.vala"
		_g_error_free0 (e);
#line 930 "Page.c"
	}
	__finally0:
#line 155 "../src/Widgets/Page.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "../src/Widgets/Page.vala"
		_g_free0 (rx_bytes_path);
#line 155 "../src/Widgets/Page.vala"
		_g_free0 (tx_bytes_path);
#line 155 "../src/Widgets/Page.vala"
		_g_free0 (iface);
#line 155 "../src/Widgets/Page.vala"
		_g_free0 (_vala_sent_bytes);
#line 155 "../src/Widgets/Page.vala"
		_g_free0 (_vala_received_bytes);
#line 155 "../src/Widgets/Page.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 155 "../src/Widgets/Page.vala"
		g_clear_error (&_inner_error0_);
#line 155 "../src/Widgets/Page.vala"
		return;
#line 951 "Page.c"
	}
#line 139 "../src/Widgets/Page.vala"
	_g_free0 (rx_bytes_path);
#line 139 "../src/Widgets/Page.vala"
	_g_free0 (tx_bytes_path);
#line 139 "../src/Widgets/Page.vala"
	_g_free0 (iface);
#line 139 "../src/Widgets/Page.vala"
	if (sent_bytes) {
#line 139 "../src/Widgets/Page.vala"
		*sent_bytes = _vala_sent_bytes;
#line 963 "Page.c"
	} else {
#line 139 "../src/Widgets/Page.vala"
		_g_free0 (_vala_sent_bytes);
#line 967 "Page.c"
	}
#line 139 "../src/Widgets/Page.vala"
	if (received_bytes) {
#line 139 "../src/Widgets/Page.vala"
		*received_bytes = _vala_received_bytes;
#line 973 "Page.c"
	} else {
#line 139 "../src/Widgets/Page.vala"
		_g_free0 (_vala_received_bytes);
#line 977 "Page.c"
	}
}

NetworkWidgetsPage*
network_widgets_page_construct (GType object_type)
{
	NetworkWidgetsPage * self = NULL;
#line 22 "../src/Widgets/Page.vala"
	self = (NetworkWidgetsPage*) granite_simple_settings_page_construct (object_type);
#line 22 "../src/Widgets/Page.vala"
	return self;
#line 989 "Page.c"
}

NMDeviceState
network_widgets_page_get_state (NetworkWidgetsPage* self)
{
	NMDeviceState result;
#line 23 "../src/Widgets/Page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "../src/Widgets/Page.vala"
	result = self->priv->_state;
#line 23 "../src/Widgets/Page.vala"
	return result;
#line 1002 "Page.c"
}

void
network_widgets_page_set_state (NetworkWidgetsPage* self,
                                NMDeviceState value)
{
	NMDeviceState old_value;
#line 23 "../src/Widgets/Page.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/Page.vala"
	old_value = network_widgets_page_get_state (self);
#line 23 "../src/Widgets/Page.vala"
	if (old_value != value) {
#line 23 "../src/Widgets/Page.vala"
		self->priv->_state = value;
#line 23 "../src/Widgets/Page.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_page_properties[NETWORK_WIDGETS_PAGE_STATE_PROPERTY]);
#line 1020 "Page.c"
	}
}

NMDevice*
network_widgets_page_get_device (NetworkWidgetsPage* self)
{
	NMDevice* result;
	NMDevice* _tmp0_;
#line 25 "../src/Widgets/Page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/Page.vala"
	_tmp0_ = self->priv->_device;
#line 25 "../src/Widgets/Page.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/Page.vala"
	return result;
#line 1037 "Page.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 25 "../src/Widgets/Page.vala"
	return self ? g_object_ref (self) : NULL;
#line 1045 "Page.c"
}

static void
network_widgets_page_set_device (NetworkWidgetsPage* self,
                                 NMDevice* value)
{
	NMDevice* old_value;
#line 25 "../src/Widgets/Page.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/Page.vala"
	old_value = network_widgets_page_get_device (self);
#line 25 "../src/Widgets/Page.vala"
	if (old_value != value) {
#line 1059 "Page.c"
		NMDevice* _tmp0_;
#line 25 "../src/Widgets/Page.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/Widgets/Page.vala"
		_g_object_unref0 (self->priv->_device);
#line 25 "../src/Widgets/Page.vala"
		self->priv->_device = _tmp0_;
#line 25 "../src/Widgets/Page.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_page_properties[NETWORK_WIDGETS_PAGE_DEVICE_PROPERTY]);
#line 1069 "Page.c"
	}
}

static void
_network_widgets_page_control_switch_activated_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 41 "../src/Widgets/Page.vala"
	network_widgets_page_control_switch_activated ((NetworkWidgetsPage*) self);
#line 1080 "Page.c"
}

static void
_network_widgets_page_update_network_widgets_info_box_info_changed (NetworkWidgetsInfoBox* _sender,
                                                                    gpointer self)
{
#line 49 "../src/Widgets/Page.vala"
	network_widgets_page_update ((NetworkWidgetsPage*) self);
#line 1089 "Page.c"
}

static GObject *
network_widgets_page_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsPage * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	NMDevice* _tmp4_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	NMDevice* _tmp14_;
#line 30 "../src/Widgets/Page.vala"
	parent_class = G_OBJECT_CLASS (network_widgets_page_parent_class);
#line 30 "../src/Widgets/Page.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/Widgets/Page.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPage);
#line 31 "../src/Widgets/Page.vala"
	_tmp0_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 31 "../src/Widgets/Page.vala"
	_tmp1_ = _tmp0_;
#line 31 "../src/Widgets/Page.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp1_, GTK_ORIENTATION_VERTICAL);
#line 32 "../src/Widgets/Page.vala"
	_tmp2_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 32 "../src/Widgets/Page.vala"
	_tmp3_ = _tmp2_;
#line 32 "../src/Widgets/Page.vala"
	gtk_grid_set_row_spacing (_tmp3_, 24);
#line 34 "../src/Widgets/Page.vala"
	_tmp4_ = self->priv->_device;
#line 34 "../src/Widgets/Page.vala"
	if (_tmp4_ != NULL) {
#line 1130 "Page.c"
		NMDevice* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 35 "../src/Widgets/Page.vala"
		_tmp5_ = self->priv->_device;
#line 35 "../src/Widgets/Page.vala"
		_tmp6_ = network_utils_type_to_string (nm_device_get_device_type (_tmp5_));
#line 35 "../src/Widgets/Page.vala"
		_tmp7_ = _tmp6_;
#line 35 "../src/Widgets/Page.vala"
		granite_simple_settings_page_set_title ((GraniteSimpleSettingsPage*) self, _tmp7_);
#line 35 "../src/Widgets/Page.vala"
		_g_free0 (_tmp7_);
#line 1144 "Page.c"
	} else {
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 36 "../src/Widgets/Page.vala"
		_tmp8_ = granite_simple_settings_page_get_title ((GraniteSimpleSettingsPage*) self);
#line 36 "../src/Widgets/Page.vala"
		_tmp9_ = _tmp8_;
#line 36 "../src/Widgets/Page.vala"
		if (_tmp9_ == NULL) {
#line 37 "../src/Widgets/Page.vala"
			granite_simple_settings_page_set_title ((GraniteSimpleSettingsPage*) self, _ ("Unknown Device"));
#line 1156 "Page.c"
		}
	}
#line 40 "../src/Widgets/Page.vala"
	_tmp10_ = granite_simple_settings_page_get_activatable ((GraniteSimpleSettingsPage*) self);
#line 40 "../src/Widgets/Page.vala"
	_tmp11_ = _tmp10_;
#line 40 "../src/Widgets/Page.vala"
	if (_tmp11_) {
#line 1165 "Page.c"
		GtkSwitch* _tmp12_;
		GtkSwitch* _tmp13_;
#line 41 "../src/Widgets/Page.vala"
		_tmp12_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 41 "../src/Widgets/Page.vala"
		_tmp13_ = _tmp12_;
#line 41 "../src/Widgets/Page.vala"
		g_signal_connect_object ((GObject*) _tmp13_, "notify::active", (GCallback) _network_widgets_page_control_switch_activated_g_object_notify, self, 0);
#line 1174 "Page.c"
	}
#line 44 "../src/Widgets/Page.vala"
	_tmp14_ = self->priv->_device;
#line 44 "../src/Widgets/Page.vala"
	if (_tmp14_ != NULL) {
#line 1180 "Page.c"
		NMDevice* _tmp15_;
		NetworkWidgetsInfoBox* _tmp16_ = NULL;
		NetworkWidgetsInfoBox* _tmp17_;
#line 45 "../src/Widgets/Page.vala"
		_tmp15_ = self->priv->_device;
#line 45 "../src/Widgets/Page.vala"
		_tmp16_ = network_widgets_info_box_new_from_device (_tmp15_);
#line 45 "../src/Widgets/Page.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp16_, 16);
#line 45 "../src/Widgets/Page.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp16_, TRUE);
#line 45 "../src/Widgets/Page.vala"
		g_object_ref_sink (_tmp16_);
#line 45 "../src/Widgets/Page.vala"
		_g_object_unref0 (self->info_box);
#line 45 "../src/Widgets/Page.vala"
		self->info_box = _tmp16_;
#line 49 "../src/Widgets/Page.vala"
		_tmp17_ = self->info_box;
#line 49 "../src/Widgets/Page.vala"
		g_signal_connect_object (_tmp17_, "info-changed", (GCallback) _network_widgets_page_update_network_widgets_info_box_info_changed, self, 0);
#line 1202 "Page.c"
	}
#line 52 "../src/Widgets/Page.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 30 "../src/Widgets/Page.vala"
	return obj;
#line 1208 "Page.c"
}

static void
network_widgets_page_class_init (NetworkWidgetsPageClass * klass,
                                 gpointer klass_data)
{
#line 22 "../src/Widgets/Page.vala"
	network_widgets_page_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/Page.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsPage_private_offset);
#line 22 "../src/Widgets/Page.vala"
	((NetworkWidgetsPageClass *) klass)->update = (void (*) (NetworkWidgetsPage*)) network_widgets_page_real_update;
#line 22 "../src/Widgets/Page.vala"
	((NetworkWidgetsPageClass *) klass)->update_name = (void (*) (NetworkWidgetsPage*, gint)) network_widgets_page_real_update_name;
#line 22 "../src/Widgets/Page.vala"
	((NetworkWidgetsPageClass *) klass)->update_switch = (void (*) (NetworkWidgetsPage*)) network_widgets_page_real_update_switch;
#line 22 "../src/Widgets/Page.vala"
	((NetworkWidgetsPageClass *) klass)->control_switch_activated = (void (*) (NetworkWidgetsPage*)) network_widgets_page_real_control_switch_activated;
#line 22 "../src/Widgets/Page.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_widgets_page_get_property;
#line 22 "../src/Widgets/Page.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_widgets_page_set_property;
#line 22 "../src/Widgets/Page.vala"
	G_OBJECT_CLASS (klass)->constructor = network_widgets_page_constructor;
#line 22 "../src/Widgets/Page.vala"
	G_OBJECT_CLASS (klass)->finalize = network_widgets_page_finalize;
#line 22 "../src/Widgets/Page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_PAGE_STATE_PROPERTY, network_widgets_page_properties[NETWORK_WIDGETS_PAGE_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", nm_device_state_get_type (), NM_DEVICE_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/Page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_PAGE_DEVICE_PROPERTY, network_widgets_page_properties[NETWORK_WIDGETS_PAGE_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", nm_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1239 "Page.c"
}

static void
network_widgets_page_instance_init (NetworkWidgetsPage * self,
                                    gpointer klass)
{
#line 22 "../src/Widgets/Page.vala"
	self->priv = network_widgets_page_get_instance_private (self);
#line 23 "../src/Widgets/Page.vala"
	self->priv->_state = NM_DEVICE_STATE_DISCONNECTED;
#line 28 "../src/Widgets/Page.vala"
	self->priv->switch_updating = FALSE;
#line 1252 "Page.c"
}

static void
network_widgets_page_finalize (GObject * obj)
{
	NetworkWidgetsPage * self;
#line 22 "../src/Widgets/Page.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPage);
#line 25 "../src/Widgets/Page.vala"
	_g_object_unref0 (self->priv->_device);
#line 27 "../src/Widgets/Page.vala"
	_g_object_unref0 (self->info_box);
#line 22 "../src/Widgets/Page.vala"
	G_OBJECT_CLASS (network_widgets_page_parent_class)->finalize (obj);
#line 1267 "Page.c"
}

static GType
network_widgets_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsPage), 0, (GInstanceInitFunc) network_widgets_page_instance_init, NULL };
	GType network_widgets_page_type_id;
	network_widgets_page_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "NetworkWidgetsPage", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	NetworkWidgetsPage_private_offset = g_type_add_instance_private (network_widgets_page_type_id, sizeof (NetworkWidgetsPagePrivate));
	return network_widgets_page_type_id;
}

GType
network_widgets_page_get_type (void)
{
	static volatile gsize network_widgets_page_type_id__once = 0;
	if (g_once_init_enter (&network_widgets_page_type_id__once)) {
		GType network_widgets_page_type_id;
		network_widgets_page_type_id = network_widgets_page_get_type_once ();
		g_once_init_leave (&network_widgets_page_type_id__once, network_widgets_page_type_id);
	}
	return network_widgets_page_type_id__once;
}

static void
_vala_network_widgets_page_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	NetworkWidgetsPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPage);
#line 22 "../src/Widgets/Page.vala"
	switch (property_id) {
#line 22 "../src/Widgets/Page.vala"
		case NETWORK_WIDGETS_PAGE_STATE_PROPERTY:
#line 22 "../src/Widgets/Page.vala"
		g_value_set_enum (value, network_widgets_page_get_state (self));
#line 22 "../src/Widgets/Page.vala"
		break;
#line 22 "../src/Widgets/Page.vala"
		case NETWORK_WIDGETS_PAGE_DEVICE_PROPERTY:
#line 22 "../src/Widgets/Page.vala"
		g_value_set_object (value, network_widgets_page_get_device (self));
#line 22 "../src/Widgets/Page.vala"
		break;
#line 1314 "Page.c"
		default:
#line 22 "../src/Widgets/Page.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/Page.vala"
		break;
#line 1320 "Page.c"
	}
}

static void
_vala_network_widgets_page_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	NetworkWidgetsPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPage);
#line 22 "../src/Widgets/Page.vala"
	switch (property_id) {
#line 22 "../src/Widgets/Page.vala"
		case NETWORK_WIDGETS_PAGE_STATE_PROPERTY:
#line 22 "../src/Widgets/Page.vala"
		network_widgets_page_set_state (self, g_value_get_enum (value));
#line 22 "../src/Widgets/Page.vala"
		break;
#line 22 "../src/Widgets/Page.vala"
		case NETWORK_WIDGETS_PAGE_DEVICE_PROPERTY:
#line 22 "../src/Widgets/Page.vala"
		network_widgets_page_set_device (self, g_value_get_object (value));
#line 22 "../src/Widgets/Page.vala"
		break;
#line 1346 "Page.c"
		default:
#line 22 "../src/Widgets/Page.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/Page.vala"
		break;
#line 1352 "Page.c"
	}
}

