/* VPNMenuItem.c generated by valac 0.56.14, the Vala compiler
 * generated from VPNMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "networking.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

enum  {
	NETWORK_VPN_MENU_ITEM_0_PROPERTY,
	NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY,
	NETWORK_VPN_MENU_ITEM_STATE_PROPERTY,
	NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NetworkVPNMenuItemPrivate {
	NMRemoteConnection* _connection;
	NMDeviceState _state;
	GtkButton* connect_button;
	GtkImage* vpn_state;
	GtkLabel* state_label;
	GtkLabel* vpn_label;
	NetworkWidgetsVPNInfoDialog* vpn_info_dialog;
};

static gint NetworkVPNMenuItem_private_offset;
static gpointer network_vpn_menu_item_parent_class = NULL;
static GtkSizeGroup* network_vpn_menu_item_size_group;
static GtkSizeGroup* network_vpn_menu_item_size_group = NULL;

static void network_vpn_menu_item_update (NetworkVPNMenuItem* self);
static GObject * network_vpn_menu_item_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _network_vpn_menu_item_update_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender,
                                                          gpointer self);
static void _network_vpn_menu_item___lambda23_ (NetworkVPNMenuItem* self);
static void __network_vpn_menu_item___lambda23__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _network_vpn_menu_item___lambda24_ (NetworkVPNMenuItem* self);
static void __network_vpn_menu_item___lambda24__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void network_vpn_menu_item_finalize (GObject * obj);
static GType network_vpn_menu_item_get_type_once (void);
static void _vala_network_vpn_menu_item_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_network_vpn_menu_item_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
network_vpn_menu_item_get_instance_private (NetworkVPNMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVPNMenuItem_private_offset);
}

NetworkVPNMenuItem*
network_vpn_menu_item_construct (GType object_type,
                                 NMRemoteConnection* _connection)
{
	NetworkVPNMenuItem * self = NULL;
#line 31 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_return_val_if_fail (_connection != NULL, NULL);
#line 32 "../src/Widgets/VPN/VPNMenuItem.vala"
	self = (NetworkVPNMenuItem*) g_object_new (object_type, "connection", _connection, NULL);
#line 31 "../src/Widgets/VPN/VPNMenuItem.vala"
	return self;
#line 103 "VPNMenuItem.c"
}

NetworkVPNMenuItem*
network_vpn_menu_item_new (NMRemoteConnection* _connection)
{
#line 31 "../src/Widgets/VPN/VPNMenuItem.vala"
	return network_vpn_menu_item_construct (NETWORK_TYPE_VPN_MENU_ITEM, _connection);
#line 111 "VPNMenuItem.c"
}

static void
network_vpn_menu_item_update (NetworkVPNMenuItem* self)
{
	GtkLabel* _tmp0_;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
	NMDeviceState _tmp3_;
	GtkLabel* _tmp27_;
	NMDeviceState _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	NetworkWidgetsVPNInfoDialog* _tmp33_;
	NMDeviceState _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
#line 106 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp0_ = self->priv->vpn_label;
#line 107 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp1_ = self->priv->_connection;
#line 107 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp2_ = nm_connection_get_id ((NMConnection*) _tmp1_);
#line 107 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 109 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp3_ = self->priv->_state;
#line 109 "../src/Widgets/VPN/VPNMenuItem.vala"
	switch (_tmp3_) {
#line 109 "../src/Widgets/VPN/VPNMenuItem.vala"
		case NM_DEVICE_STATE_FAILED:
#line 147 "VPNMenuItem.c"
		{
			GtkImage* _tmp4_;
			GtkButton* _tmp5_;
			GtkButton* _tmp6_;
			GtkButton* _tmp7_;
			GtkStyleContext* _tmp8_;
#line 111 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp4_ = self->priv->vpn_state;
#line 111 "../src/Widgets/VPN/VPNMenuItem.vala"
			g_object_set (_tmp4_, "icon-name", "user-busy", NULL);
#line 112 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp5_ = self->priv->connect_button;
#line 112 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_button_set_label (_tmp5_, _ ("Connect"));
#line 113 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp6_ = self->priv->connect_button;
#line 113 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
#line 114 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp7_ = self->priv->connect_button;
#line 114 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 114 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_style_context_remove_class (_tmp8_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 115 "../src/Widgets/VPN/VPNMenuItem.vala"
			break;
#line 174 "VPNMenuItem.c"
		}
#line 109 "../src/Widgets/VPN/VPNMenuItem.vala"
		case NM_DEVICE_STATE_PREPARE:
#line 178 "VPNMenuItem.c"
		{
			GtkImage* _tmp9_;
			GtkButton* _tmp10_;
			GtkButton* _tmp11_;
			GtkStyleContext* _tmp12_;
#line 117 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp9_ = self->priv->vpn_state;
#line 117 "../src/Widgets/VPN/VPNMenuItem.vala"
			g_object_set (_tmp9_, "icon-name", "user-away", NULL);
#line 118 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp10_ = self->priv->connect_button;
#line 118 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 119 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp11_ = self->priv->connect_button;
#line 119 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
#line 119 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_style_context_remove_class (_tmp12_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 120 "../src/Widgets/VPN/VPNMenuItem.vala"
			break;
#line 200 "VPNMenuItem.c"
		}
#line 109 "../src/Widgets/VPN/VPNMenuItem.vala"
		case NM_DEVICE_STATE_ACTIVATED:
#line 204 "VPNMenuItem.c"
		{
			GtkImage* _tmp13_;
			GtkButton* _tmp14_;
			GtkButton* _tmp15_;
			GtkButton* _tmp16_;
			GtkStyleContext* _tmp17_;
#line 122 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp13_ = self->priv->vpn_state;
#line 122 "../src/Widgets/VPN/VPNMenuItem.vala"
			g_object_set (_tmp13_, "icon-name", "user-available", NULL);
#line 123 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp14_ = self->priv->connect_button;
#line 123 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_button_set_label (_tmp14_, _ ("Disconnect"));
#line 124 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp15_ = self->priv->connect_button;
#line 124 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, TRUE);
#line 125 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp16_ = self->priv->connect_button;
#line 125 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
#line 125 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_style_context_add_class (_tmp17_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 126 "../src/Widgets/VPN/VPNMenuItem.vala"
			break;
#line 231 "VPNMenuItem.c"
		}
#line 109 "../src/Widgets/VPN/VPNMenuItem.vala"
		case NM_DEVICE_STATE_DISCONNECTED:
#line 235 "VPNMenuItem.c"
		{
			GtkImage* _tmp18_;
			GtkButton* _tmp19_;
			GtkButton* _tmp20_;
			GtkButton* _tmp21_;
			GtkStyleContext* _tmp22_;
#line 128 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp18_ = self->priv->vpn_state;
#line 128 "../src/Widgets/VPN/VPNMenuItem.vala"
			g_object_set (_tmp18_, "icon-name", "user-offline", NULL);
#line 129 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp19_ = self->priv->connect_button;
#line 129 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_button_set_label (_tmp19_, _ ("Connect"));
#line 130 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp20_ = self->priv->connect_button;
#line 130 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, TRUE);
#line 131 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp21_ = self->priv->connect_button;
#line 131 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
#line 131 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_style_context_remove_class (_tmp22_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 132 "../src/Widgets/VPN/VPNMenuItem.vala"
			break;
#line 262 "VPNMenuItem.c"
		}
		default:
		{
			GtkButton* _tmp23_;
			GtkButton* _tmp24_;
			GtkButton* _tmp25_;
			GtkStyleContext* _tmp26_;
#line 134 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp23_ = self->priv->connect_button;
#line 134 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_button_set_label (_tmp23_, _ ("Connect"));
#line 135 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp24_ = self->priv->connect_button;
#line 135 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, TRUE);
#line 136 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp25_ = self->priv->connect_button;
#line 136 "../src/Widgets/VPN/VPNMenuItem.vala"
			_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
#line 136 "../src/Widgets/VPN/VPNMenuItem.vala"
			gtk_style_context_remove_class (_tmp26_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 137 "../src/Widgets/VPN/VPNMenuItem.vala"
			break;
#line 286 "VPNMenuItem.c"
		}
	}
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp27_ = self->priv->state_label;
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp28_ = self->priv->_state;
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp29_ = network_utils_state_to_string (_tmp28_);
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp30_ = _tmp29_;
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp31_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp30_);
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp32_ = _tmp31_;
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_label_set_label (_tmp27_, _tmp32_);
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_free0 (_tmp32_);
#line 140 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_free0 (_tmp30_);
#line 141 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp33_ = self->priv->vpn_info_dialog;
#line 141 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp34_ = self->priv->_state;
#line 141 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp35_ = network_utils_state_to_string (_tmp34_);
#line 141 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp36_ = _tmp35_;
#line 141 "../src/Widgets/VPN/VPNMenuItem.vala"
	granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) _tmp33_, _tmp36_);
#line 141 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_free0 (_tmp36_);
#line 319 "VPNMenuItem.c"
}

NMRemoteConnection*
network_vpn_menu_item_get_connection (NetworkVPNMenuItem* self)
{
	NMRemoteConnection* result;
	NMRemoteConnection* _tmp0_;
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	result = _tmp0_;
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	return result;
#line 335 "VPNMenuItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 343 "VPNMenuItem.c"
}

static void
network_vpn_menu_item_set_connection (NetworkVPNMenuItem* self,
                                      NMRemoteConnection* value)
{
	NMRemoteConnection* old_value;
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	old_value = network_vpn_menu_item_get_connection (self);
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	if (old_value != value) {
#line 357 "VPNMenuItem.c"
		NMRemoteConnection* _tmp0_;
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
		_g_object_unref0 (self->priv->_connection);
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
		self->priv->_connection = _tmp0_;
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY]);
#line 367 "VPNMenuItem.c"
	}
}

NMDeviceState
network_vpn_menu_item_get_state (NetworkVPNMenuItem* self)
{
	NMDeviceState result;
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
	result = self->priv->_state;
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
	return result;
#line 381 "VPNMenuItem.c"
}

void
network_vpn_menu_item_set_state (NetworkVPNMenuItem* self,
                                 NMDeviceState value)
{
	NMDeviceState old_value;
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
	old_value = network_vpn_menu_item_get_state (self);
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
	if (old_value != value) {
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
		self->priv->_state = value;
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_STATE_PROPERTY]);
#line 399 "VPNMenuItem.c"
	}
}

static void
_network_vpn_menu_item_update_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 93 "../src/Widgets/VPN/VPNMenuItem.vala"
	network_vpn_menu_item_update ((NetworkVPNMenuItem*) self);
#line 410 "VPNMenuItem.c"
}

static void
_network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender,
                                                     gpointer self)
{
#line 94 "../src/Widgets/VPN/VPNMenuItem.vala"
	network_vpn_menu_item_update ((NetworkVPNMenuItem*) self);
#line 419 "VPNMenuItem.c"
}

static void
_network_vpn_menu_item___lambda23_ (NetworkVPNMenuItem* self)
{
#line 97 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_signal_emit_by_name ((GtkListBoxRow*) self, "activate");
#line 427 "VPNMenuItem.c"
}

static void
__network_vpn_menu_item___lambda23__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 97 "../src/Widgets/VPN/VPNMenuItem.vala"
	_network_vpn_menu_item___lambda23_ ((NetworkVPNMenuItem*) self);
#line 436 "VPNMenuItem.c"
}

static void
_network_vpn_menu_item___lambda24_ (NetworkVPNMenuItem* self)
{
	NetworkWidgetsVPNInfoDialog* _tmp0_;
	GtkWidget* _tmp1_;
	NetworkWidgetsVPNInfoDialog* _tmp2_;
	NetworkWidgetsVPNInfoDialog* _tmp3_;
#line 100 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp0_ = self->priv->vpn_info_dialog;
#line 100 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 100 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
#line 101 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp2_ = self->priv->vpn_info_dialog;
#line 101 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_dialog_run ((GtkDialog*) _tmp2_);
#line 102 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp3_ = self->priv->vpn_info_dialog;
#line 102 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 460 "VPNMenuItem.c"
}

static void
__network_vpn_menu_item___lambda24__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 99 "../src/Widgets/VPN/VPNMenuItem.vala"
	_network_vpn_menu_item___lambda24_ ((NetworkVPNMenuItem*) self);
#line 469 "VPNMenuItem.c"
}

static GObject *
network_vpn_menu_item_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkVPNMenuItem * self;
	GtkImage* image = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_ = NULL;
	GtkLabel* _tmp2_ = NULL;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp3_;
	GtkOverlay* _tmp4_;
	GtkImage* _tmp5_;
	GtkOverlay* _tmp6_;
	GtkImage* _tmp7_;
	NMRemoteConnection* _tmp8_;
	const gchar* _tmp9_;
	GtkLabel* _tmp10_ = NULL;
	NMRemoteConnection* _tmp11_;
	NetworkWidgetsVPNInfoDialog* _tmp12_;
	GtkButton* vpn_info_button = NULL;
	GtkImage* _tmp13_;
	GtkButton* _tmp14_ = NULL;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	gchar* _tmp17_;
	GtkButton* _tmp18_ = NULL;
	GtkSizeGroup* _tmp19_;
	GtkButton* _tmp20_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp21_ = NULL;
	GtkGrid* _tmp22_;
	GtkOverlay* _tmp23_;
	GtkGrid* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkButton* _tmp29_;
	GtkGrid* _tmp30_;
	GtkButton* _tmp31_;
	GtkGrid* _tmp32_;
	NMRemoteConnection* _tmp33_;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
#line 41 "../src/Widgets/VPN/VPNMenuItem.vala"
	parent_class = G_OBJECT_CLASS (network_vpn_menu_item_parent_class);
#line 41 "../src/Widgets/VPN/VPNMenuItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 41 "../src/Widgets/VPN/VPNMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
#line 42 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("network-vpn", (GtkIconSize) GTK_ICON_SIZE_DND);
#line 42 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 42 "../src/Widgets/VPN/VPNMenuItem.vala"
	image = _tmp0_;
#line 44 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("user-offline", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 44 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
#line 44 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
#line 44 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp1_);
#line 44 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->vpn_state);
#line 44 "../src/Widgets/VPN/VPNMenuItem.vala"
	self->priv->vpn_state = _tmp1_;
#line 49 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (NULL);
#line 49 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_label_set_xalign (_tmp2_, (gfloat) 0);
#line 49 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_label_set_use_markup (_tmp2_, TRUE);
#line 49 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp2_);
#line 49 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->state_label);
#line 49 "../src/Widgets/VPN/VPNMenuItem.vala"
	self->priv->state_label = _tmp2_;
#line 54 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp3_ = (GtkOverlay*) gtk_overlay_new ();
#line 54 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp3_);
#line 54 "../src/Widgets/VPN/VPNMenuItem.vala"
	overlay = _tmp3_;
#line 55 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp4_ = overlay;
#line 55 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp5_ = image;
#line 55 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 56 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp6_ = overlay;
#line 56 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp7_ = self->priv->vpn_state;
#line 56 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_overlay_add_overlay (_tmp6_, (GtkWidget*) _tmp7_);
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp8_ = self->priv->_connection;
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp9_ = nm_connection_get_id ((NMConnection*) _tmp8_);
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new (_tmp9_);
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_label_set_ellipsize (_tmp10_, PANGO_ELLIPSIZE_END);
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp10_, TRUE);
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp10_);
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->vpn_label);
#line 58 "../src/Widgets/VPN/VPNMenuItem.vala"
	self->priv->vpn_label = _tmp10_;
#line 64 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp11_ = self->priv->_connection;
#line 64 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp12_ = network_widgets_vpn_info_dialog_new (_tmp11_);
#line 64 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp12_);
#line 64 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->vpn_info_dialog);
#line 64 "../src/Widgets/VPN/VPNMenuItem.vala"
	self->priv->vpn_info_dialog = _tmp12_;
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp13_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp13_);
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp14_ = (GtkButton*) gtk_button_new ();
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_button_set_image (_tmp14_, (GtkWidget*) _tmp13_);
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (_tmp13_);
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp14_, 3);
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp14_);
#line 66 "../src/Widgets/VPN/VPNMenuItem.vala"
	vpn_info_button = _tmp14_;
#line 71 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp15_ = vpn_info_button;
#line 71 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
#line 71 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_FLAT);
#line 73 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp17_ = g_strdup (_ ("Connect"));
#line 73 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp18_ = (GtkButton*) gtk_button_new ();
#line 73 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
#line 73 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_button_set_label (_tmp18_, _tmp17_);
#line 73 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_free0 (_tmp17_);
#line 73 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp18_);
#line 73 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->connect_button);
#line 73 "../src/Widgets/VPN/VPNMenuItem.vala"
	self->priv->connect_button = _tmp18_;
#line 78 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp19_ = network_vpn_menu_item_size_group;
#line 78 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp20_ = self->priv->connect_button;
#line 78 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_size_group_add_widget (_tmp19_, (GtkWidget*) _tmp20_);
#line 80 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
#line 80 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_set ((GtkWidget*) _tmp21_, "margin", 6, NULL);
#line 80 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_grid_set_column_spacing (_tmp21_, 6);
#line 80 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_ref_sink (_tmp21_);
#line 80 "../src/Widgets/VPN/VPNMenuItem.vala"
	grid = _tmp21_;
#line 84 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp22_ = grid;
#line 84 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp23_ = overlay;
#line 84 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 0, 0, 1, 2);
#line 85 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp24_ = grid;
#line 85 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp25_ = self->priv->vpn_label;
#line 85 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 1, 0, 1, 1);
#line 86 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp26_ = grid;
#line 86 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp27_ = self->priv->state_label;
#line 86 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_grid_attach (_tmp26_, (GtkWidget*) _tmp27_, 1, 1, 1, 1);
#line 87 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp28_ = grid;
#line 87 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp29_ = vpn_info_button;
#line 87 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 2, 0, 1, 2);
#line 88 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp30_ = grid;
#line 88 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp31_ = self->priv->connect_button;
#line 88 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 3, 0, 1, 2);
#line 90 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp32_ = grid;
#line 90 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
#line 91 "../src/Widgets/VPN/VPNMenuItem.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 93 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
#line 94 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp33_ = self->priv->_connection;
#line 94 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_signal_connect_object ((NMConnection*) _tmp33_, "changed", (GCallback) _network_vpn_menu_item_update_nm_connection_changed, self, 0);
#line 95 "../src/Widgets/VPN/VPNMenuItem.vala"
	network_vpn_menu_item_update (self);
#line 97 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp34_ = self->priv->connect_button;
#line 97 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_signal_connect_object (_tmp34_, "clicked", (GCallback) __network_vpn_menu_item___lambda23__gtk_button_clicked, self, 0);
#line 99 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp35_ = vpn_info_button;
#line 99 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_signal_connect_object (_tmp35_, "clicked", (GCallback) __network_vpn_menu_item___lambda24__gtk_button_clicked, self, 0);
#line 41 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (grid);
#line 41 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (vpn_info_button);
#line 41 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (overlay);
#line 41 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (image);
#line 41 "../src/Widgets/VPN/VPNMenuItem.vala"
	return obj;
#line 720 "VPNMenuItem.c"
}

static void
network_vpn_menu_item_class_init (NetworkVPNMenuItemClass * klass,
                                  gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	network_vpn_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkVPNMenuItem_private_offset);
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_menu_item_get_property;
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_menu_item_set_property;
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	G_OBJECT_CLASS (klass)->constructor = network_vpn_menu_item_constructor;
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_vpn_menu_item_finalize;
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", nm_remote_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_STATE_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", nm_device_state_get_type (), NM_DEVICE_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 38 "../src/Widgets/VPN/VPNMenuItem.vala"
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 38 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (network_vpn_menu_item_size_group);
#line 38 "../src/Widgets/VPN/VPNMenuItem.vala"
	network_vpn_menu_item_size_group = _tmp0_;
#line 750 "VPNMenuItem.c"
}

static void
network_vpn_menu_item_instance_init (NetworkVPNMenuItem * self,
                                     gpointer klass)
{
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	self->priv = network_vpn_menu_item_get_instance_private (self);
#line 21 "../src/Widgets/VPN/VPNMenuItem.vala"
	self->priv->_state = NM_DEVICE_STATE_DISCONNECTED;
#line 761 "VPNMenuItem.c"
}

static void
network_vpn_menu_item_finalize (GObject * obj)
{
	NetworkVPNMenuItem * self;
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
#line 19 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->_connection);
#line 25 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->connect_button);
#line 26 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->vpn_state);
#line 27 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->state_label);
#line 28 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->vpn_label);
#line 29 "../src/Widgets/VPN/VPNMenuItem.vala"
	_g_object_unref0 (self->priv->vpn_info_dialog);
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	G_OBJECT_CLASS (network_vpn_menu_item_parent_class)->finalize (obj);
#line 784 "VPNMenuItem.c"
}

static GType
network_vpn_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkVPNMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVPNMenuItem), 0, (GInstanceInitFunc) network_vpn_menu_item_instance_init, NULL };
	GType network_vpn_menu_item_type_id;
	network_vpn_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkVPNMenuItem", &g_define_type_info, 0);
	NetworkVPNMenuItem_private_offset = g_type_add_instance_private (network_vpn_menu_item_type_id, sizeof (NetworkVPNMenuItemPrivate));
	return network_vpn_menu_item_type_id;
}

GType
network_vpn_menu_item_get_type (void)
{
	static volatile gsize network_vpn_menu_item_type_id__once = 0;
	if (g_once_init_enter (&network_vpn_menu_item_type_id__once)) {
		GType network_vpn_menu_item_type_id;
		network_vpn_menu_item_type_id = network_vpn_menu_item_get_type_once ();
		g_once_init_leave (&network_vpn_menu_item_type_id__once, network_vpn_menu_item_type_id);
	}
	return network_vpn_menu_item_type_id__once;
}

static void
_vala_network_vpn_menu_item_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVPNMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	switch (property_id) {
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_connection (self));
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		break;
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_STATE_PROPERTY:
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		g_value_set_enum (value, network_vpn_menu_item_get_state (self));
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		break;
#line 831 "VPNMenuItem.c"
		default:
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		break;
#line 837 "VPNMenuItem.c"
	}
}

static void
_vala_network_vpn_menu_item_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVPNMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem);
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
	switch (property_id) {
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		network_vpn_menu_item_set_connection (self, g_value_get_object (value));
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		break;
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_STATE_PROPERTY:
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		network_vpn_menu_item_set_state (self, g_value_get_enum (value));
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		break;
#line 863 "VPNMenuItem.c"
		default:
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/VPN/VPNMenuItem.vala"
		break;
#line 869 "VPNMenuItem.c"
	}
}

