/* WifiMenuItem.c generated by valac 0.56.14, the Vala compiler
 * generated from WifiMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "networking.h"
#include <glib.h>
#include <NetworkManager.h>
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	NETWORK_WIFI_MENU_ITEM_0_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_IS_SECURED_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_AP_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS
};
static guint network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkWifiMenuItemPrivate {
	gboolean _is_secured;
	gboolean _active;
	NMDeviceState _state;
	NMAccessPoint* _tmp_ap;
	GeeLinkedList* _ap;
	GtkImage* img_strength;
	GtkImage* lock_img;
	GtkImage* error_img;
	GtkLabel* ssid_label;
	GtkLabel* status_label;
	GtkRevealer* connect_button_revealer;
	GtkSpinner* spinner;
};

static gint NetworkWifiMenuItem_private_offset;
static gpointer network_wifi_menu_item_parent_class = NULL;

static void network_wifi_menu_item_update (NetworkWifiMenuItem* self);
static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void __lambda9_ (NetworkWifiMenuItem* self);
static void ___lambda9__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self);
static gchar* network_wifi_menu_item_strength_to_string (NetworkWifiMenuItem* self,
                                                  guint8 strength);
static guint8 network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_set_is_secured (NetworkWifiMenuItem* self,
                                            gboolean value);
static void network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
static void network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
static void network_wifi_menu_item_finalize (GObject * obj);
static GType network_wifi_menu_item_get_type_once (void);
static void _vala_network_wifi_menu_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_menu_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_menu_item_get_instance_private (NetworkWifiMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiMenuItem_private_offset);
}

static void
_network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 110 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update ((NetworkWifiMenuItem*) self);
#line 112 "WifiMenuItem.c"
}

static void
__lambda9_ (NetworkWifiMenuItem* self)
{
#line 114 "../src/Widgets/WifiMenuItem.vala"
	g_signal_emit (self, network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL], 0);
#line 120 "WifiMenuItem.c"
}

static void
___lambda9__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 113 "../src/Widgets/WifiMenuItem.vala"
	__lambda9_ ((NetworkWifiMenuItem*) self);
#line 129 "WifiMenuItem.c"
}

NetworkWifiMenuItem*
network_wifi_menu_item_construct (GType object_type,
                                  NMAccessPoint* ap)
{
	NetworkWifiMenuItem * self = NULL;
	GtkImage* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	GtkLabel* _tmp2_ = NULL;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkSpinner* _tmp5_;
	GtkButton* connect_button = NULL;
	GtkButton* _tmp6_ = NULL;
	GtkRevealer* _tmp7_ = NULL;
	GtkRevealer* _tmp8_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp9_ = NULL;
	GtkImage* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkSpinner* _tmp15_;
	GtkRevealer* _tmp16_;
	GeeLinkedList* _tmp17_;
#line 57 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, NULL);
#line 57 "../src/Widgets/WifiMenuItem.vala"
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
#line 58 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = (GtkImage*) gtk_image_new ();
#line 58 "../src/Widgets/WifiMenuItem.vala"
	g_object_set (_tmp0_, "icon-size", (gint) GTK_ICON_SIZE_DND, NULL);
#line 58 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 58 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 58 "../src/Widgets/WifiMenuItem.vala"
	self->priv->img_strength = _tmp0_;
#line 62 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	gtk_label_set_ellipsize (_tmp1_, PANGO_ELLIPSIZE_END);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	gtk_label_set_xalign (_tmp1_, (gfloat) 0);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp1_);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->ssid_label);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	self->priv->ssid_label = _tmp1_;
#line 67 "../src/Widgets/WifiMenuItem.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (NULL);
#line 67 "../src/Widgets/WifiMenuItem.vala"
	gtk_label_set_use_markup (_tmp2_, TRUE);
#line 67 "../src/Widgets/WifiMenuItem.vala"
	gtk_label_set_xalign (_tmp2_, (gfloat) 0);
#line 67 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp2_);
#line 67 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->status_label);
#line 67 "../src/Widgets/WifiMenuItem.vala"
	self->priv->status_label = _tmp2_;
#line 72 "../src/Widgets/WifiMenuItem.vala"
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("channel-insecure-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 72 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp3_);
#line 72 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 72 "../src/Widgets/WifiMenuItem.vala"
	self->priv->lock_img = _tmp3_;
#line 75 "../src/Widgets/WifiMenuItem.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 75 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp4_);
#line 75 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 75 "../src/Widgets/WifiMenuItem.vala"
	self->priv->error_img = _tmp4_;
#line 77 "../src/Widgets/WifiMenuItem.vala"
	_tmp5_ = (GtkSpinner*) gtk_spinner_new ();
#line 77 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp5_);
#line 77 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 77 "../src/Widgets/WifiMenuItem.vala"
	self->priv->spinner = _tmp5_;
#line 79 "../src/Widgets/WifiMenuItem.vala"
	_tmp6_ = (GtkButton*) gtk_button_new_with_label (_ ("Connect"));
#line 79 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_END);
#line 79 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp6_, TRUE);
#line 79 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 79 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp6_);
#line 79 "../src/Widgets/WifiMenuItem.vala"
	connect_button = _tmp6_;
#line 85 "../src/Widgets/WifiMenuItem.vala"
	_tmp7_ = (GtkRevealer*) gtk_revealer_new ();
#line 85 "../src/Widgets/WifiMenuItem.vala"
	gtk_revealer_set_reveal_child (_tmp7_, TRUE);
#line 85 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp7_);
#line 85 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->connect_button_revealer);
#line 85 "../src/Widgets/WifiMenuItem.vala"
	self->priv->connect_button_revealer = _tmp7_;
#line 88 "../src/Widgets/WifiMenuItem.vala"
	_tmp8_ = self->priv->connect_button_revealer;
#line 88 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) connect_button);
#line 90 "../src/Widgets/WifiMenuItem.vala"
	_tmp9_ = (GtkGrid*) gtk_grid_new ();
#line 90 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 90 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_set_column_spacing (_tmp9_, 6);
#line 90 "../src/Widgets/WifiMenuItem.vala"
	g_object_set ((GtkWidget*) _tmp9_, "margin", 6, NULL);
#line 90 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp9_);
#line 90 "../src/Widgets/WifiMenuItem.vala"
	grid = _tmp9_;
#line 95 "../src/Widgets/WifiMenuItem.vala"
	_tmp10_ = self->priv->img_strength;
#line 95 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp10_, 0, 0, 1, 2);
#line 96 "../src/Widgets/WifiMenuItem.vala"
	_tmp11_ = self->priv->ssid_label;
#line 96 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp11_, 1, 0, 1, 1);
#line 97 "../src/Widgets/WifiMenuItem.vala"
	_tmp12_ = self->priv->status_label;
#line 97 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp12_, 1, 1, 2, 1);
#line 98 "../src/Widgets/WifiMenuItem.vala"
	_tmp13_ = self->priv->lock_img;
#line 98 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp13_, 2, 0, 1, 1);
#line 99 "../src/Widgets/WifiMenuItem.vala"
	_tmp14_ = self->priv->error_img;
#line 99 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp14_, 3, 0, 1, 2);
#line 100 "../src/Widgets/WifiMenuItem.vala"
	_tmp15_ = self->priv->spinner;
#line 100 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp15_, 4, 0, 1, 2);
#line 101 "../src/Widgets/WifiMenuItem.vala"
	_tmp16_ = self->priv->connect_button_revealer;
#line 101 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp16_, 5, 0, 1, 2);
#line 103 "../src/Widgets/WifiMenuItem.vala"
	_tmp17_ = gee_linked_list_new (nm_access_point_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 103 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->_ap);
#line 103 "../src/Widgets/WifiMenuItem.vala"
	self->priv->_ap = _tmp17_;
#line 106 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_add_ap (self, ap);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) grid);
#line 110 "../src/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 111 "../src/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::active", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 113 "../src/Widgets/WifiMenuItem.vala"
	g_signal_connect_object (connect_button, "clicked", (GCallback) ___lambda9__gtk_button_clicked, self, 0);
#line 117 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update (self);
#line 57 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (grid);
#line 57 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (connect_button);
#line 57 "../src/Widgets/WifiMenuItem.vala"
	return self;
#line 309 "WifiMenuItem.c"
}

NetworkWifiMenuItem*
network_wifi_menu_item_new (NMAccessPoint* ap)
{
#line 57 "../src/Widgets/WifiMenuItem.vala"
	return network_wifi_menu_item_construct (NETWORK_TYPE_WIFI_MENU_ITEM, ap);
#line 317 "WifiMenuItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 123 "../src/Widgets/WifiMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 325 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self)
{
	guint8 strength = 0U;
#line 120 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/Widgets/WifiMenuItem.vala"
	strength = (guint8) 0;
#line 336 "WifiMenuItem.c"
	{
		GeeLinkedList* _ap_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _ap_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _ap_index = 0;
#line 122 "../src/Widgets/WifiMenuItem.vala"
		_tmp0_ = self->priv->_ap;
#line 122 "../src/Widgets/WifiMenuItem.vala"
		_ap_list = _tmp0_;
#line 122 "../src/Widgets/WifiMenuItem.vala"
		_tmp1_ = _ap_list;
#line 122 "../src/Widgets/WifiMenuItem.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 122 "../src/Widgets/WifiMenuItem.vala"
		_tmp3_ = _tmp2_;
#line 122 "../src/Widgets/WifiMenuItem.vala"
		_ap_size = _tmp3_;
#line 122 "../src/Widgets/WifiMenuItem.vala"
		_ap_index = -1;
#line 122 "../src/Widgets/WifiMenuItem.vala"
		while (TRUE) {
#line 361 "WifiMenuItem.c"
			gint _tmp4_;
			gint _tmp5_;
			NMAccessPoint* ap = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			NMAccessPoint* _tmp8_ = NULL;
			NMAccessPoint* _tmp9_;
			guint8 _tmp10_;
			guint8 _tmp11_;
			NMAccessPoint* _tmp14_;
			NMAccessPoint* _tmp15_;
			guint8 _tmp16_;
			guint8 _tmp17_;
#line 122 "../src/Widgets/WifiMenuItem.vala"
			_ap_index = _ap_index + 1;
#line 122 "../src/Widgets/WifiMenuItem.vala"
			_tmp4_ = _ap_index;
#line 122 "../src/Widgets/WifiMenuItem.vala"
			_tmp5_ = _ap_size;
#line 122 "../src/Widgets/WifiMenuItem.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 122 "../src/Widgets/WifiMenuItem.vala"
				break;
#line 385 "WifiMenuItem.c"
			}
#line 122 "../src/Widgets/WifiMenuItem.vala"
			_tmp6_ = _ap_list;
#line 122 "../src/Widgets/WifiMenuItem.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _ap_index);
#line 122 "../src/Widgets/WifiMenuItem.vala"
			ap = (NMAccessPoint*) _tmp7_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
			_tmp9_ = ap;
#line 123 "../src/Widgets/WifiMenuItem.vala"
			_tmp10_ = nm_access_point_get_strength (_tmp9_);
#line 123 "../src/Widgets/WifiMenuItem.vala"
			_tmp11_ = _tmp10_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
			if (strength > _tmp11_) {
#line 401 "WifiMenuItem.c"
				NMAccessPoint* _tmp12_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
				_tmp12_ = self->priv->_tmp_ap;
#line 123 "../src/Widgets/WifiMenuItem.vala"
				_tmp8_ = _tmp12_;
#line 407 "WifiMenuItem.c"
			} else {
				NMAccessPoint* _tmp13_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
				_tmp13_ = ap;
#line 123 "../src/Widgets/WifiMenuItem.vala"
				_tmp8_ = _tmp13_;
#line 414 "WifiMenuItem.c"
			}
#line 123 "../src/Widgets/WifiMenuItem.vala"
			_tmp14_ = _g_object_ref0 (_tmp8_);
#line 123 "../src/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (self->priv->_tmp_ap);
#line 123 "../src/Widgets/WifiMenuItem.vala"
			self->priv->_tmp_ap = _tmp14_;
#line 124 "../src/Widgets/WifiMenuItem.vala"
			_tmp15_ = ap;
#line 124 "../src/Widgets/WifiMenuItem.vala"
			_tmp16_ = nm_access_point_get_strength (_tmp15_);
#line 124 "../src/Widgets/WifiMenuItem.vala"
			_tmp17_ = _tmp16_;
#line 124 "../src/Widgets/WifiMenuItem.vala"
			strength = MAX (strength, _tmp17_);
#line 122 "../src/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (ap);
#line 432 "WifiMenuItem.c"
		}
	}
}

static void
network_wifi_menu_item_update (NetworkWifiMenuItem* self)
{
	GtkLabel* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	GBytes* _tmp3_;
	gsize _tmp4_ = 0;
	guint8* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* state_string = NULL;
	GtkImage* _tmp8_;
	guint8 _tmp9_;
	guint8 _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkImage* _tmp15_;
	NM80211ApSecurityFlags flags = 0U;
	NMAccessPoint* _tmp16_;
	NMAccessPoint* _tmp17_;
	NMAccessPoint* _tmp18_;
	NMAccessPoint* _tmp19_;
	GtkImage* _tmp20_;
	gboolean _tmp21_;
	GtkImage* _tmp22_;
	GtkImage* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	GtkImage* _tmp26_;
	GtkSpinner* _tmp27_;
	GtkRevealer* _tmp28_;
	NMDeviceState _tmp29_;
	GtkLabel* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
#line 128 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->ssid_label;
#line 129 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = network_wifi_menu_item_get_ap (self);
#line 129 "../src/Widgets/WifiMenuItem.vala"
	_tmp2_ = _tmp1_;
#line 129 "../src/Widgets/WifiMenuItem.vala"
	_tmp3_ = nm_access_point_get_ssid (_tmp2_);
#line 129 "../src/Widgets/WifiMenuItem.vala"
	_tmp5_ = g_bytes_get_data (_tmp3_, &_tmp4_);
#line 129 "../src/Widgets/WifiMenuItem.vala"
	_tmp6_ = nm_utils_ssid_to_utf8 (_tmp5_, (gsize) _tmp4_);
#line 129 "../src/Widgets/WifiMenuItem.vala"
	_tmp7_ = _tmp6_;
#line 129 "../src/Widgets/WifiMenuItem.vala"
	gtk_label_set_label (_tmp0_, _tmp7_);
#line 129 "../src/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp7_);
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_tmp8_ = self->priv->img_strength;
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_tmp9_ = network_wifi_menu_item_get_strength (self);
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_tmp10_ = _tmp9_;
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_tmp11_ = network_wifi_menu_item_strength_to_string (self, _tmp10_);
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_tmp12_ = _tmp11_;
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_tmp13_ = g_strconcat ("network-wireless-signal-", _tmp12_, NULL);
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_tmp14_ = _tmp13_;
#line 132 "../src/Widgets/WifiMenuItem.vala"
	g_object_set (_tmp8_, "icon-name", _tmp14_, NULL);
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp14_);
#line 132 "../src/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp12_);
#line 133 "../src/Widgets/WifiMenuItem.vala"
	_tmp15_ = self->priv->img_strength;
#line 133 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 135 "../src/Widgets/WifiMenuItem.vala"
	_tmp16_ = network_wifi_menu_item_get_ap (self);
#line 135 "../src/Widgets/WifiMenuItem.vala"
	_tmp17_ = _tmp16_;
#line 135 "../src/Widgets/WifiMenuItem.vala"
	_tmp18_ = network_wifi_menu_item_get_ap (self);
#line 135 "../src/Widgets/WifiMenuItem.vala"
	_tmp19_ = _tmp18_;
#line 135 "../src/Widgets/WifiMenuItem.vala"
	flags = nm_access_point_get_wpa_flags (_tmp17_) | nm_access_point_get_rsn_flags (_tmp19_);
#line 136 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_set_is_secured (self, FALSE);
#line 137 "../src/Widgets/WifiMenuItem.vala"
	if ((flags & NM_802_11_AP_SEC_GROUP_WEP40) == NM_802_11_AP_SEC_GROUP_WEP40) {
#line 138 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_is_secured (self, TRUE);
#line 139 "../src/Widgets/WifiMenuItem.vala"
		state_string = _ ("40/64-bit WEP encrypted");
#line 538 "WifiMenuItem.c"
	} else {
#line 140 "../src/Widgets/WifiMenuItem.vala"
		if ((flags & NM_802_11_AP_SEC_GROUP_WEP104) == NM_802_11_AP_SEC_GROUP_WEP104) {
#line 141 "../src/Widgets/WifiMenuItem.vala"
			network_wifi_menu_item_set_is_secured (self, TRUE);
#line 142 "../src/Widgets/WifiMenuItem.vala"
			state_string = _ ("104/128-bit WEP encrypted");
#line 546 "WifiMenuItem.c"
		} else {
#line 143 "../src/Widgets/WifiMenuItem.vala"
			if ((flags & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE) {
#line 144 "../src/Widgets/WifiMenuItem.vala"
				network_wifi_menu_item_set_is_secured (self, TRUE);
#line 145 "../src/Widgets/WifiMenuItem.vala"
				state_string = _ ("WPA3 encrypted");
#line 554 "WifiMenuItem.c"
			} else {
#line 146 "../src/Widgets/WifiMenuItem.vala"
				if ((flags & NM_802_11_AP_SEC_KEY_MGMT_PSK) == NM_802_11_AP_SEC_KEY_MGMT_PSK) {
#line 147 "../src/Widgets/WifiMenuItem.vala"
					network_wifi_menu_item_set_is_secured (self, TRUE);
#line 148 "../src/Widgets/WifiMenuItem.vala"
					state_string = _ ("WPA encrypted");
#line 562 "WifiMenuItem.c"
				} else {
#line 149 "../src/Widgets/WifiMenuItem.vala"
					if ((flags & NM_802_11_AP_SEC_KEY_MGMT_OWE) == NM_802_11_AP_SEC_KEY_MGMT_OWE) {
#line 150 "../src/Widgets/WifiMenuItem.vala"
						network_wifi_menu_item_set_is_secured (self, TRUE);
#line 151 "../src/Widgets/WifiMenuItem.vala"
						state_string = _ ("Passwordless encrypted");
#line 570 "WifiMenuItem.c"
					} else {
#line 152 "../src/Widgets/WifiMenuItem.vala"
						if (flags != NM_802_11_AP_SEC_NONE) {
#line 153 "../src/Widgets/WifiMenuItem.vala"
							network_wifi_menu_item_set_is_secured (self, TRUE);
#line 154 "../src/Widgets/WifiMenuItem.vala"
							state_string = _ ("Encrypted");
#line 578 "WifiMenuItem.c"
						} else {
#line 156 "../src/Widgets/WifiMenuItem.vala"
							state_string = _ ("Unsecured");
#line 582 "WifiMenuItem.c"
						}
					}
				}
			}
		}
	}
#line 159 "../src/Widgets/WifiMenuItem.vala"
	_tmp20_ = self->priv->lock_img;
#line 159 "../src/Widgets/WifiMenuItem.vala"
	_tmp21_ = self->priv->_is_secured;
#line 159 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp20_, !_tmp21_);
#line 160 "../src/Widgets/WifiMenuItem.vala"
	_tmp22_ = self->priv->lock_img;
#line 160 "../src/Widgets/WifiMenuItem.vala"
	_tmp23_ = self->priv->lock_img;
#line 160 "../src/Widgets/WifiMenuItem.vala"
	_tmp24_ = gtk_widget_get_visible ((GtkWidget*) _tmp23_);
#line 160 "../src/Widgets/WifiMenuItem.vala"
	_tmp25_ = _tmp24_;
#line 160 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp22_, !_tmp25_);
#line 162 "../src/Widgets/WifiMenuItem.vala"
	_tmp26_ = self->priv->error_img;
#line 162 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp26_);
#line 163 "../src/Widgets/WifiMenuItem.vala"
	_tmp27_ = self->priv->spinner;
#line 163 "../src/Widgets/WifiMenuItem.vala"
	g_object_set (_tmp27_, "active", FALSE, NULL);
#line 165 "../src/Widgets/WifiMenuItem.vala"
	_tmp28_ = self->priv->connect_button_revealer;
#line 165 "../src/Widgets/WifiMenuItem.vala"
	gtk_revealer_set_reveal_child (_tmp28_, TRUE);
#line 167 "../src/Widgets/WifiMenuItem.vala"
	_tmp29_ = self->priv->_state;
#line 167 "../src/Widgets/WifiMenuItem.vala"
	switch (_tmp29_) {
#line 167 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_FAILED:
#line 623 "WifiMenuItem.c"
		{
			GtkImage* _tmp30_;
#line 169 "../src/Widgets/WifiMenuItem.vala"
			_tmp30_ = self->priv->error_img;
#line 169 "../src/Widgets/WifiMenuItem.vala"
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp30_);
#line 170 "../src/Widgets/WifiMenuItem.vala"
			state_string = _ ("Could not be connected to");
#line 171 "../src/Widgets/WifiMenuItem.vala"
			break;
#line 634 "WifiMenuItem.c"
		}
#line 167 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_PREPARE:
#line 638 "WifiMenuItem.c"
		{
			GtkSpinner* _tmp31_;
#line 173 "../src/Widgets/WifiMenuItem.vala"
			_tmp31_ = self->priv->spinner;
#line 173 "../src/Widgets/WifiMenuItem.vala"
			g_object_set (_tmp31_, "active", TRUE, NULL);
#line 174 "../src/Widgets/WifiMenuItem.vala"
			state_string = _ ("Connecting");
#line 175 "../src/Widgets/WifiMenuItem.vala"
			break;
#line 649 "WifiMenuItem.c"
		}
#line 167 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_ACTIVATED:
#line 653 "WifiMenuItem.c"
		{
			GtkRevealer* _tmp32_;
#line 177 "../src/Widgets/WifiMenuItem.vala"
			_tmp32_ = self->priv->connect_button_revealer;
#line 177 "../src/Widgets/WifiMenuItem.vala"
			gtk_revealer_set_reveal_child (_tmp32_, FALSE);
#line 178 "../src/Widgets/WifiMenuItem.vala"
			break;
#line 662 "WifiMenuItem.c"
		}
		default:
#line 167 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 667 "WifiMenuItem.c"
	}
#line 181 "../src/Widgets/WifiMenuItem.vala"
	_tmp33_ = self->priv->status_label;
#line 181 "../src/Widgets/WifiMenuItem.vala"
	_tmp34_ = state_string;
#line 181 "../src/Widgets/WifiMenuItem.vala"
	_tmp35_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp34_);
#line 181 "../src/Widgets/WifiMenuItem.vala"
	_tmp36_ = _tmp35_;
#line 181 "../src/Widgets/WifiMenuItem.vala"
	gtk_label_set_label (_tmp33_, _tmp36_);
#line 181 "../src/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp36_);
#line 681 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 184 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 185 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible (w, TRUE);
#line 186 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 186 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 186 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all (w, !_tmp1_);
#line 702 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 189 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 190 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible (w, FALSE);
#line 191 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 191 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all (w, !_tmp1_);
#line 723 "WifiMenuItem.c"
}

void
network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                               NMAccessPoint* ap)
{
	GeeLinkedList* _tmp0_;
#line 194 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (ap != NULL);
#line 195 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ap;
#line 195 "../src/Widgets/WifiMenuItem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, ap);
#line 196 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update_tmp_ap (self);
#line 197 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update (self);
#line 743 "WifiMenuItem.c"
}

static gchar*
network_wifi_menu_item_strength_to_string (NetworkWifiMenuItem* self,
                                           guint8 strength)
{
	gchar* result;
#line 200 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "../src/Widgets/WifiMenuItem.vala"
	if (((gint) strength) < 30) {
#line 755 "WifiMenuItem.c"
		gchar* _tmp0_;
#line 202 "../src/Widgets/WifiMenuItem.vala"
		_tmp0_ = g_strdup ("weak");
#line 202 "../src/Widgets/WifiMenuItem.vala"
		result = _tmp0_;
#line 202 "../src/Widgets/WifiMenuItem.vala"
		return result;
#line 763 "WifiMenuItem.c"
	} else {
#line 203 "../src/Widgets/WifiMenuItem.vala"
		if (((gint) strength) < 55) {
#line 767 "WifiMenuItem.c"
			gchar* _tmp1_;
#line 204 "../src/Widgets/WifiMenuItem.vala"
			_tmp1_ = g_strdup ("ok");
#line 204 "../src/Widgets/WifiMenuItem.vala"
			result = _tmp1_;
#line 204 "../src/Widgets/WifiMenuItem.vala"
			return result;
#line 775 "WifiMenuItem.c"
		} else {
#line 205 "../src/Widgets/WifiMenuItem.vala"
			if (((gint) strength) < 80) {
#line 779 "WifiMenuItem.c"
				gchar* _tmp2_;
#line 206 "../src/Widgets/WifiMenuItem.vala"
				_tmp2_ = g_strdup ("good");
#line 206 "../src/Widgets/WifiMenuItem.vala"
				result = _tmp2_;
#line 206 "../src/Widgets/WifiMenuItem.vala"
				return result;
#line 787 "WifiMenuItem.c"
			} else {
				gchar* _tmp3_;
#line 208 "../src/Widgets/WifiMenuItem.vala"
				_tmp3_ = g_strdup ("excellent");
#line 208 "../src/Widgets/WifiMenuItem.vala"
				result = _tmp3_;
#line 208 "../src/Widgets/WifiMenuItem.vala"
				return result;
#line 796 "WifiMenuItem.c"
			}
		}
	}
}

gboolean
network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                  NMAccessPoint* ap)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 212 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 212 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, FALSE);
#line 213 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ap;
#line 213 "../src/Widgets/WifiMenuItem.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, ap);
#line 214 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update_tmp_ap (self);
#line 215 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = self->priv->_ap;
#line 215 "../src/Widgets/WifiMenuItem.vala"
	_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
#line 215 "../src/Widgets/WifiMenuItem.vala"
	_tmp3_ = _tmp2_;
#line 215 "../src/Widgets/WifiMenuItem.vala"
	result = !_tmp3_;
#line 215 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 831 "WifiMenuItem.c"
}

gboolean
network_wifi_menu_item_get_is_secured (NetworkWifiMenuItem* self)
{
	gboolean result;
#line 21 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 21 "../src/Widgets/WifiMenuItem.vala"
	result = self->priv->_is_secured;
#line 21 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 844 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_set_is_secured (NetworkWifiMenuItem* self,
                                       gboolean value)
{
	gboolean old_value;
#line 21 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/WifiMenuItem.vala"
	old_value = network_wifi_menu_item_get_is_secured (self);
#line 21 "../src/Widgets/WifiMenuItem.vala"
	if (old_value != value) {
#line 21 "../src/Widgets/WifiMenuItem.vala"
		self->priv->_is_secured = value;
#line 21 "../src/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_IS_SECURED_PROPERTY]);
#line 862 "WifiMenuItem.c"
	}
}

gboolean
network_wifi_menu_item_get_active (NetworkWifiMenuItem* self)
{
	gboolean result;
#line 22 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "../src/Widgets/WifiMenuItem.vala"
	result = self->priv->_active;
#line 22 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 876 "WifiMenuItem.c"
}

void
network_wifi_menu_item_set_active (NetworkWifiMenuItem* self,
                                   gboolean value)
{
	gboolean old_value;
#line 22 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Widgets/WifiMenuItem.vala"
	old_value = network_wifi_menu_item_get_active (self);
#line 22 "../src/Widgets/WifiMenuItem.vala"
	if (old_value != value) {
#line 22 "../src/Widgets/WifiMenuItem.vala"
		self->priv->_active = value;
#line 22 "../src/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY]);
#line 894 "WifiMenuItem.c"
	}
}

NMDeviceState
network_wifi_menu_item_get_state (NetworkWifiMenuItem* self)
{
	NMDeviceState result;
#line 23 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "../src/Widgets/WifiMenuItem.vala"
	result = self->priv->_state;
#line 23 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 908 "WifiMenuItem.c"
}

void
network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                  NMDeviceState value)
{
	NMDeviceState old_value;
#line 23 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/WifiMenuItem.vala"
	old_value = network_wifi_menu_item_get_state (self);
#line 23 "../src/Widgets/WifiMenuItem.vala"
	if (old_value != value) {
#line 23 "../src/Widgets/WifiMenuItem.vala"
		self->priv->_state = value;
#line 23 "../src/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY]);
#line 926 "WifiMenuItem.c"
	}
}

NMAccessPoint*
network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self)
{
	NMAccessPoint* result;
	NMAccessPoint* _tmp0_;
#line 27 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_tmp_ap;
#line 28 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp0_;
#line 28 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 943 "WifiMenuItem.c"
}

GBytes*
network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self)
{
	GBytes* result;
	NMAccessPoint* _tmp0_;
	GBytes* _tmp1_;
#line 33 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_tmp_ap;
#line 34 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = nm_access_point_get_ssid (_tmp0_);
#line 34 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp1_;
#line 34 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 962 "WifiMenuItem.c"
}

static guint8
network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self)
{
	guint8 result;
	guint8 strength = 0U;
#line 40 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 41 "../src/Widgets/WifiMenuItem.vala"
	strength = (guint8) 0;
#line 974 "WifiMenuItem.c"
	{
		GeeLinkedList* _ap_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _ap_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _ap_index = 0;
#line 42 "../src/Widgets/WifiMenuItem.vala"
		_tmp0_ = self->priv->_ap;
#line 42 "../src/Widgets/WifiMenuItem.vala"
		_ap_list = _tmp0_;
#line 42 "../src/Widgets/WifiMenuItem.vala"
		_tmp1_ = _ap_list;
#line 42 "../src/Widgets/WifiMenuItem.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 42 "../src/Widgets/WifiMenuItem.vala"
		_tmp3_ = _tmp2_;
#line 42 "../src/Widgets/WifiMenuItem.vala"
		_ap_size = _tmp3_;
#line 42 "../src/Widgets/WifiMenuItem.vala"
		_ap_index = -1;
#line 42 "../src/Widgets/WifiMenuItem.vala"
		while (TRUE) {
#line 999 "WifiMenuItem.c"
			gint _tmp4_;
			gint _tmp5_;
			NMAccessPoint* ap = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			NMAccessPoint* _tmp8_;
#line 42 "../src/Widgets/WifiMenuItem.vala"
			_ap_index = _ap_index + 1;
#line 42 "../src/Widgets/WifiMenuItem.vala"
			_tmp4_ = _ap_index;
#line 42 "../src/Widgets/WifiMenuItem.vala"
			_tmp5_ = _ap_size;
#line 42 "../src/Widgets/WifiMenuItem.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 42 "../src/Widgets/WifiMenuItem.vala"
				break;
#line 1016 "WifiMenuItem.c"
			}
#line 42 "../src/Widgets/WifiMenuItem.vala"
			_tmp6_ = _ap_list;
#line 42 "../src/Widgets/WifiMenuItem.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _ap_index);
#line 42 "../src/Widgets/WifiMenuItem.vala"
			ap = (NMAccessPoint*) _tmp7_;
#line 43 "../src/Widgets/WifiMenuItem.vala"
			_tmp8_ = ap;
#line 43 "../src/Widgets/WifiMenuItem.vala"
			strength = MAX (strength, nm_access_point_get_strength (_tmp8_));
#line 42 "../src/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (ap);
#line 1030 "WifiMenuItem.c"
		}
	}
#line 45 "../src/Widgets/WifiMenuItem.vala"
	result = strength;
#line 45 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 1037 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_class_init (NetworkWifiMenuItemClass * klass,
                                   gpointer klass_data)
{
#line 18 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWifiMenuItem_private_offset);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_menu_item_get_property;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_menu_item_set_property;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_wifi_menu_item_finalize;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_IS_SECURED_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_IS_SECURED_PROPERTY] = g_param_spec_boolean ("is-secured", "is-secured", "is-secured", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", nm_device_state_get_type (), NM_DEVICE_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_AP_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_AP_PROPERTY] = g_param_spec_object ("ap", "ap", "ap", nm_access_point_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY] = g_param_spec_boxed ("ssid", "ssid", "ssid", G_TYPE_BYTES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_WIFI_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1066 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_instance_init (NetworkWifiMenuItem * self,
                                      gpointer klass)
{
#line 18 "../src/Widgets/WifiMenuItem.vala"
	self->priv = network_wifi_menu_item_get_instance_private (self);
#line 23 "../src/Widgets/WifiMenuItem.vala"
	self->priv->_state = NM_DEVICE_STATE_DISCONNECTED;
#line 1077 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_finalize (GObject * obj)
{
	NetworkWifiMenuItem * self;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 25 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->_tmp_ap);
#line 38 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->_ap);
#line 49 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 50 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 51 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 52 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->ssid_label);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->status_label);
#line 54 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->connect_button_revealer);
#line 55 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (network_wifi_menu_item_parent_class)->finalize (obj);
#line 1106 "WifiMenuItem.c"
}

static GType
network_wifi_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiMenuItem), 0, (GInstanceInitFunc) network_wifi_menu_item_instance_init, NULL };
	GType network_wifi_menu_item_type_id;
	network_wifi_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWifiMenuItem", &g_define_type_info, 0);
	NetworkWifiMenuItem_private_offset = g_type_add_instance_private (network_wifi_menu_item_type_id, sizeof (NetworkWifiMenuItemPrivate));
	return network_wifi_menu_item_type_id;
}

GType
network_wifi_menu_item_get_type (void)
{
	static volatile gsize network_wifi_menu_item_type_id__once = 0;
	if (g_once_init_enter (&network_wifi_menu_item_type_id__once)) {
		GType network_wifi_menu_item_type_id;
		network_wifi_menu_item_type_id = network_wifi_menu_item_get_type_once ();
		g_once_init_leave (&network_wifi_menu_item_type_id__once, network_wifi_menu_item_type_id);
	}
	return network_wifi_menu_item_type_id__once;
}

static void
_vala_network_wifi_menu_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_IS_SECURED_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_boolean (value, network_wifi_menu_item_get_is_secured (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_boolean (value, network_wifi_menu_item_get_active (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_enum (value, network_wifi_menu_item_get_state (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_AP_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_object (value, network_wifi_menu_item_get_ap (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_boxed (value, network_wifi_menu_item_get_ssid (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1171 "WifiMenuItem.c"
		default:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1177 "WifiMenuItem.c"
	}
}

static void
_vala_network_wifi_menu_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_IS_SECURED_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_is_secured (self, g_value_get_boolean (value));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_active (self, g_value_get_boolean (value));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_state (self, g_value_get_enum (value));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1209 "WifiMenuItem.c"
		default:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1215 "WifiMenuItem.c"
	}
}

